/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c10_carsim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c10_debug_family_names[10] = { "u", "v", "nargin", "nargout",
  "v_body", "C_air", "rho_air", "A_front", "A_side", "F_air" };

/* Function Declarations */
static void initialize_c10_carsim(SFc10_carsimInstanceStruct *chartInstance);
static void initialize_params_c10_carsim(SFc10_carsimInstanceStruct
  *chartInstance);
static void enable_c10_carsim(SFc10_carsimInstanceStruct *chartInstance);
static void disable_c10_carsim(SFc10_carsimInstanceStruct *chartInstance);
static void c10_update_debugger_state_c10_carsim(SFc10_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c10_carsim(SFc10_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c10_carsim(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_st);
static void finalize_c10_carsim(SFc10_carsimInstanceStruct *chartInstance);
static void sf_c10_carsim(SFc10_carsimInstanceStruct *chartInstance);
static void initSimStructsc10_carsim(SFc10_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber);
static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_F_air, const char_T *c10_identifier, real_T c10_y[3]);
static void c10_b_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[3]);
static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static real_T c10_c_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static real_T c10_mpower(SFc10_carsimInstanceStruct *chartInstance, real_T c10_a);
static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static int32_T c10_d_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static uint8_T c10_e_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_b_is_active_c10_carsim, const char_T *c10_identifier);
static uint8_T c10_f_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void init_dsm_address_info(SFc10_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c10_carsim(SFc10_carsimInstanceStruct *chartInstance)
{
  chartInstance->c10_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c10_is_active_c10_carsim = 0U;
}

static void initialize_params_c10_carsim(SFc10_carsimInstanceStruct
  *chartInstance)
{
  real_T c10_d0;
  real_T c10_d1;
  real_T c10_d2;
  real_T c10_d3;
  sf_set_error_prefix_string(
    "Error evaluating data 'C_air' in the parent workspace.\n");
  sf_mex_import_named("C_air", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c10_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c10_C_air = c10_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'rho_air' in the parent workspace.\n");
  sf_mex_import_named("rho_air", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c10_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c10_rho_air = c10_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'A_front' in the parent workspace.\n");
  sf_mex_import_named("A_front", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c10_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c10_A_front = c10_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'A_side' in the parent workspace.\n");
  sf_mex_import_named("A_side", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c10_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c10_A_side = c10_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c10_carsim(SFc10_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c10_carsim(SFc10_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c10_update_debugger_state_c10_carsim(SFc10_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c10_carsim(SFc10_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c10_st;
  const mxArray *c10_y = NULL;
  int32_T c10_i0;
  real_T c10_u[3];
  const mxArray *c10_b_y = NULL;
  uint8_T c10_hoistedGlobal;
  uint8_T c10_b_u;
  const mxArray *c10_c_y = NULL;
  real_T (*c10_F_air)[3];
  c10_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_st = NULL;
  c10_st = NULL;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_createcellarray(2), FALSE);
  for (c10_i0 = 0; c10_i0 < 3; c10_i0++) {
    c10_u[c10_i0] = (*c10_F_air)[c10_i0];
  }

  c10_b_y = NULL;
  sf_mex_assign(&c10_b_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c10_y, 0, c10_b_y);
  c10_hoistedGlobal = chartInstance->c10_is_active_c10_carsim;
  c10_b_u = c10_hoistedGlobal;
  c10_c_y = NULL;
  sf_mex_assign(&c10_c_y, sf_mex_create("y", &c10_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c10_y, 1, c10_c_y);
  sf_mex_assign(&c10_st, c10_y, FALSE);
  return c10_st;
}

static void set_sim_state_c10_carsim(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_st)
{
  const mxArray *c10_u;
  real_T c10_dv0[3];
  int32_T c10_i1;
  real_T (*c10_F_air)[3];
  c10_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c10_doneDoubleBufferReInit = TRUE;
  c10_u = sf_mex_dup(c10_st);
  c10_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 0)),
                       "F_air", c10_dv0);
  for (c10_i1 = 0; c10_i1 < 3; c10_i1++) {
    (*c10_F_air)[c10_i1] = c10_dv0[c10_i1];
  }

  chartInstance->c10_is_active_c10_carsim = c10_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c10_u, 1)), "is_active_c10_carsim");
  sf_mex_destroy(&c10_u);
  c10_update_debugger_state_c10_carsim(chartInstance);
  sf_mex_destroy(&c10_st);
}

static void finalize_c10_carsim(SFc10_carsimInstanceStruct *chartInstance)
{
}

static void sf_c10_carsim(SFc10_carsimInstanceStruct *chartInstance)
{
  int32_T c10_i2;
  int32_T c10_i3;
  real_T c10_hoistedGlobal;
  real_T c10_b_hoistedGlobal;
  real_T c10_c_hoistedGlobal;
  real_T c10_d_hoistedGlobal;
  int32_T c10_i4;
  real_T c10_v_body[3];
  real_T c10_b_C_air;
  real_T c10_b_rho_air;
  real_T c10_b_A_front;
  real_T c10_b_A_side;
  uint32_T c10_debug_family_var_map[10];
  real_T c10_u;
  real_T c10_v;
  real_T c10_nargin = 5.0;
  real_T c10_nargout = 1.0;
  real_T c10_F_air[3];
  real_T c10_b;
  real_T c10_y;
  real_T c10_a;
  real_T c10_b_b;
  real_T c10_b_y;
  real_T c10_b_a;
  real_T c10_c_b;
  real_T c10_c_y;
  real_T c10_c_a;
  real_T c10_d_b;
  real_T c10_d_y;
  real_T c10_x;
  real_T c10_b_x;
  real_T c10_d_a;
  real_T c10_e_b;
  real_T c10_e_y;
  real_T c10_f_b;
  real_T c10_f_y;
  real_T c10_e_a;
  real_T c10_g_b;
  real_T c10_g_y;
  real_T c10_f_a;
  real_T c10_h_b;
  real_T c10_h_y;
  real_T c10_g_a;
  real_T c10_i_b;
  real_T c10_i_y;
  real_T c10_c_x;
  real_T c10_d_x;
  real_T c10_h_a;
  real_T c10_j_b;
  real_T c10_j_y;
  int32_T c10_i5;
  real_T (*c10_b_F_air)[3];
  real_T (*c10_b_v_body)[3];
  c10_b_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_b_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 6U, chartInstance->c10_sfEvent);
  for (c10_i2 = 0; c10_i2 < 3; c10_i2++) {
    _SFD_DATA_RANGE_CHECK((*c10_b_v_body)[c10_i2], 0U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c10_C_air, 1U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c10_rho_air, 2U);
  for (c10_i3 = 0; c10_i3 < 3; c10_i3++) {
    _SFD_DATA_RANGE_CHECK((*c10_b_F_air)[c10_i3], 3U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c10_A_front, 4U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c10_A_side, 5U);
  chartInstance->c10_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 6U, chartInstance->c10_sfEvent);
  c10_hoistedGlobal = chartInstance->c10_C_air;
  c10_b_hoistedGlobal = chartInstance->c10_rho_air;
  c10_c_hoistedGlobal = chartInstance->c10_A_front;
  c10_d_hoistedGlobal = chartInstance->c10_A_side;
  for (c10_i4 = 0; c10_i4 < 3; c10_i4++) {
    c10_v_body[c10_i4] = (*c10_b_v_body)[c10_i4];
  }

  c10_b_C_air = c10_hoistedGlobal;
  c10_b_rho_air = c10_b_hoistedGlobal;
  c10_b_A_front = c10_c_hoistedGlobal;
  c10_b_A_side = c10_d_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c10_debug_family_names,
    c10_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c10_u, 0U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_v, 1U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargin, 2U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargout, 3U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c10_v_body, 4U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c10_b_C_air, 5U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_b_rho_air, 6U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_b_A_front, 7U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_b_A_side, 8U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_F_air, 9U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 3);
  c10_u = c10_v_body[0];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 4);
  c10_v = c10_v_body[1];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 7);
  c10_b = c10_b_C_air;
  c10_y = 0.5 * c10_b;
  c10_a = c10_y;
  c10_b_b = c10_b_A_front;
  c10_b_y = c10_a * c10_b_b;
  c10_b_a = c10_b_y;
  c10_c_b = c10_b_rho_air;
  c10_c_y = c10_b_a * c10_c_b;
  c10_c_a = c10_c_y;
  c10_d_b = c10_mpower(chartInstance, c10_u);
  c10_d_y = c10_c_a * c10_d_b;
  c10_x = c10_u;
  c10_b_x = c10_x;
  if (c10_b_x > 0.0) {
    c10_b_x = 1.0;
  } else if (c10_b_x < 0.0) {
    c10_b_x = -1.0;
  } else {
    if (c10_b_x == 0.0) {
      c10_b_x = 0.0;
    }
  }

  c10_d_a = c10_d_y;
  c10_e_b = c10_b_x;
  c10_e_y = c10_d_a * c10_e_b;
  c10_f_b = c10_b_C_air;
  c10_f_y = 0.5 * c10_f_b;
  c10_e_a = c10_f_y;
  c10_g_b = c10_b_A_side;
  c10_g_y = c10_e_a * c10_g_b;
  c10_f_a = c10_g_y;
  c10_h_b = c10_b_rho_air;
  c10_h_y = c10_f_a * c10_h_b;
  c10_g_a = c10_h_y;
  c10_i_b = c10_mpower(chartInstance, c10_v);
  c10_i_y = c10_g_a * c10_i_b;
  c10_c_x = c10_v;
  c10_d_x = c10_c_x;
  if (c10_d_x > 0.0) {
    c10_d_x = 1.0;
  } else if (c10_d_x < 0.0) {
    c10_d_x = -1.0;
  } else {
    if (c10_d_x == 0.0) {
      c10_d_x = 0.0;
    }
  }

  c10_h_a = c10_i_y;
  c10_j_b = c10_d_x;
  c10_j_y = c10_h_a * c10_j_b;
  c10_F_air[0] = c10_e_y;
  c10_F_air[1] = c10_j_y;
  c10_F_air[2] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, -7);
  sf_debug_symbol_scope_pop();
  for (c10_i5 = 0; c10_i5 < 3; c10_i5++) {
    (*c10_b_F_air)[c10_i5] = c10_F_air[c10_i5];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 6U, chartInstance->c10_sfEvent);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc10_carsim(SFc10_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber)
{
}

static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i6;
  real_T c10_b_inData[3];
  int32_T c10_i7;
  real_T c10_u[3];
  const mxArray *c10_y = NULL;
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i6 = 0; c10_i6 < 3; c10_i6++) {
    c10_b_inData[c10_i6] = (*(real_T (*)[3])c10_inData)[c10_i6];
  }

  for (c10_i7 = 0; c10_i7 < 3; c10_i7++) {
    c10_u[c10_i7] = c10_b_inData[c10_i7];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_F_air, const char_T *c10_identifier, real_T c10_y[3])
{
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_F_air), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_F_air);
}

static void c10_b_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[3])
{
  real_T c10_dv1[3];
  int32_T c10_i8;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv1, 1, 0, 0U, 1, 0U, 1, 3);
  for (c10_i8 = 0; c10_i8 < 3; c10_i8++) {
    c10_y[c10_i8] = c10_dv1[c10_i8];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_F_air;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[3];
  int32_T c10_i9;
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)chartInstanceVoid;
  c10_F_air = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_F_air), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_F_air);
  for (c10_i9 = 0; c10_i9 < 3; c10_i9++) {
    (*(real_T (*)[3])c10_outData)[c10_i9] = c10_y[c10_i9];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  real_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(real_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static real_T c10_c_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  real_T c10_y;
  real_T c10_d4;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_d4, 1, 0, 0U, 0, 0U, 0);
  c10_y = c10_d4;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_A_side;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y;
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)chartInstanceVoid;
  c10_b_A_side = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_A_side),
    &c10_thisId);
  sf_mex_destroy(&c10_b_A_side);
  *(real_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

const mxArray *sf_c10_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c10_nameCaptureInfo;
  c10_ResolvedFunctionInfo c10_info[8];
  c10_ResolvedFunctionInfo (*c10_b_info)[8];
  const mxArray *c10_m0 = NULL;
  int32_T c10_i10;
  c10_ResolvedFunctionInfo *c10_r0;
  c10_nameCaptureInfo = NULL;
  c10_nameCaptureInfo = NULL;
  c10_b_info = (c10_ResolvedFunctionInfo (*)[8])c10_info;
  (*c10_b_info)[0].context = "";
  (*c10_b_info)[0].name = "mtimes";
  (*c10_b_info)[0].dominantType = "double";
  (*c10_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c10_b_info)[0].fileTimeLo = 1289519692U;
  (*c10_b_info)[0].fileTimeHi = 0U;
  (*c10_b_info)[0].mFileTimeLo = 0U;
  (*c10_b_info)[0].mFileTimeHi = 0U;
  (*c10_b_info)[1].context = "";
  (*c10_b_info)[1].name = "mpower";
  (*c10_b_info)[1].dominantType = "double";
  (*c10_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c10_b_info)[1].fileTimeLo = 1286818842U;
  (*c10_b_info)[1].fileTimeHi = 0U;
  (*c10_b_info)[1].mFileTimeLo = 0U;
  (*c10_b_info)[1].mFileTimeHi = 0U;
  (*c10_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c10_b_info)[2].name = "power";
  (*c10_b_info)[2].dominantType = "double";
  (*c10_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c10_b_info)[2].fileTimeLo = 1294067944U;
  (*c10_b_info)[2].fileTimeHi = 0U;
  (*c10_b_info)[2].mFileTimeLo = 0U;
  (*c10_b_info)[2].mFileTimeHi = 0U;
  (*c10_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c10_b_info)[3].name = "eml_scalar_eg";
  (*c10_b_info)[3].dominantType = "double";
  (*c10_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c10_b_info)[3].fileTimeLo = 1286818796U;
  (*c10_b_info)[3].fileTimeHi = 0U;
  (*c10_b_info)[3].mFileTimeLo = 0U;
  (*c10_b_info)[3].mFileTimeHi = 0U;
  (*c10_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c10_b_info)[4].name = "eml_scalexp_alloc";
  (*c10_b_info)[4].dominantType = "double";
  (*c10_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  (*c10_b_info)[4].fileTimeLo = 1286818796U;
  (*c10_b_info)[4].fileTimeHi = 0U;
  (*c10_b_info)[4].mFileTimeLo = 0U;
  (*c10_b_info)[4].mFileTimeHi = 0U;
  (*c10_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c10_b_info)[5].name = "eml_scalar_floor";
  (*c10_b_info)[5].dominantType = "double";
  (*c10_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c10_b_info)[5].fileTimeLo = 1286818726U;
  (*c10_b_info)[5].fileTimeHi = 0U;
  (*c10_b_info)[5].mFileTimeLo = 0U;
  (*c10_b_info)[5].mFileTimeHi = 0U;
  (*c10_b_info)[6].context = "";
  (*c10_b_info)[6].name = "sign";
  (*c10_b_info)[6].dominantType = "double";
  (*c10_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  (*c10_b_info)[6].fileTimeLo = 1286818750U;
  (*c10_b_info)[6].fileTimeHi = 0U;
  (*c10_b_info)[6].mFileTimeLo = 0U;
  (*c10_b_info)[6].mFileTimeHi = 0U;
  (*c10_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  (*c10_b_info)[7].name = "eml_scalar_sign";
  (*c10_b_info)[7].dominantType = "double";
  (*c10_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  (*c10_b_info)[7].fileTimeLo = 1286818736U;
  (*c10_b_info)[7].fileTimeHi = 0U;
  (*c10_b_info)[7].mFileTimeLo = 0U;
  (*c10_b_info)[7].mFileTimeHi = 0U;
  sf_mex_assign(&c10_m0, sf_mex_createstruct("nameCaptureInfo", 1, 8), FALSE);
  for (c10_i10 = 0; c10_i10 < 8; c10_i10++) {
    c10_r0 = &c10_info[c10_i10];
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->context)), "context", "nameCaptureInfo",
                    c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->name)), "name", "nameCaptureInfo",
                    c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      c10_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->resolved)), "resolved",
                    "nameCaptureInfo", c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c10_i10);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c10_i10);
  }

  sf_mex_assign(&c10_nameCaptureInfo, c10_m0, FALSE);
  return c10_nameCaptureInfo;
}

static real_T c10_mpower(SFc10_carsimInstanceStruct *chartInstance, real_T c10_a)
{
  real_T c10_b_a;
  real_T c10_ak;
  c10_b_a = c10_a;
  c10_ak = c10_b_a;
  return muDoubleScalarPower(c10_ak, 2.0);
}

static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(int32_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static int32_T c10_d_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  int32_T c10_y;
  int32_T c10_i11;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_i11, 1, 6, 0U, 0, 0U, 0);
  c10_y = c10_i11;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_sfEvent;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  int32_T c10_y;
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)chartInstanceVoid;
  c10_b_sfEvent = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_sfEvent),
    &c10_thisId);
  sf_mex_destroy(&c10_b_sfEvent);
  *(int32_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static uint8_T c10_e_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_b_is_active_c10_carsim, const char_T *c10_identifier)
{
  uint8_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c10_b_is_active_c10_carsim), &c10_thisId);
  sf_mex_destroy(&c10_b_is_active_c10_carsim);
  return c10_y;
}

static uint8_T c10_f_emlrt_marshallIn(SFc10_carsimInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  uint8_T c10_y;
  uint8_T c10_u0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_u0, 1, 3, 0U, 0, 0U, 0);
  c10_y = c10_u0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void init_dsm_address_info(SFc10_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c10_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(4138211576U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1425213250U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4132467710U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1085359176U);
}

mxArray *sf_c10_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("A48Zq4FsonNnMIXZSTJ0gF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c10_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"F_air\",},{M[8],M[0],T\"is_active_c10_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c10_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc10_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc10_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          10,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_body");
          _SFD_SET_DATA_PROPS(1,10,0,0,"C_air");
          _SFD_SET_DATA_PROPS(2,10,0,0,"rho_air");
          _SFD_SET_DATA_PROPS(3,2,0,1,"F_air");
          _SFD_SET_DATA_PROPS(4,10,0,0,"A_front");
          _SFD_SET_DATA_PROPS(5,10,0,0,"A_side");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,226);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)
          c10_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)
          c10_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)
            c10_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)
          c10_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)
          c10_b_sf_marshallIn);

        {
          real_T (*c10_v_body)[3];
          real_T (*c10_F_air)[3];
          c10_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c10_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c10_v_body);
          _SFD_SET_DATA_VALUE_PTR(1U, &chartInstance->c10_C_air);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c10_rho_air);
          _SFD_SET_DATA_VALUE_PTR(3U, *c10_F_air);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c10_A_front);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c10_A_side);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c10_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc10_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
  initialize_c10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c10_carsim(void *chartInstanceVar)
{
  enable_c10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c10_carsim(void *chartInstanceVar)
{
  disable_c10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c10_carsim(void *chartInstanceVar)
{
  sf_c10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c10_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c10_carsim((SFc10_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c10_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c10_carsim((SFc10_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c10_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c10_carsim(S);
}

static void sf_opaque_set_sim_state_c10_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c10_carsim(S, st);
}

static void sf_opaque_terminate_c10_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc10_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc10_carsim((SFc10_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c10_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c10_carsim((SFc10_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c10_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     A_front A_side C_air rho_air
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for A_front*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for A_side*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for C_air*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for rho_air*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,10,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,10,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,10,1);
      sf_mark_chart_reusable_outputs(S,infoStruct,10,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,10);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2122825898U));
  ssSetChecksum1(S,(517043981U));
  ssSetChecksum2(S,(1205324112U));
  ssSetChecksum3(S,(590977577U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c10_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c10_carsim(SimStruct *S)
{
  SFc10_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc10_carsimInstanceStruct *)malloc(sizeof
    (SFc10_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc10_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c10_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c10_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c10_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c10_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c10_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c10_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c10_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c10_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c10_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c10_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c10_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c10_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c10_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
