/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c24_carsim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c24_debug_family_names[26] = { "V", "ratio_long_fl",
  "ratio_long_fr", "ratio_long_rl", "ratio_long_rr", "ratio_lat_fl",
  "ratio_lat_fr", "ratio_lat_rl", "ratio_lat_rr", "c1", "c2", "c3", "c4",
  "my_fl", "my_fr", "my_rl", "my_rr", "nargin", "nargout", "v_body",
  "sigma_long", "sigma_lat", "sigma_res", "road_condition", "my_long", "my_lat"
};

/* Function Declarations */
static void initialize_c24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void initialize_params_c24_carsim(SFc24_carsimInstanceStruct
  *chartInstance);
static void enable_c24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void disable_c24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void c24_update_debugger_state_c24_carsim(SFc24_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c24_carsim(SFc24_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c24_carsim(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_st);
static void finalize_c24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void sf_c24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void c24_chartstep_c24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void initSimStructsc24_carsim(SFc24_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c24_machineNumber, uint32_T
  c24_chartNumber);
static const mxArray *c24_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static void c24_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_my_lat, const char_T *c24_identifier, real_T c24_y[4]);
static void c24_b_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[4]);
static void c24_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_b_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static real_T c24_c_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_c_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static void c24_info_helper(c24_ResolvedFunctionInfo c24_info[23]);
static real_T c24_norm(SFc24_carsimInstanceStruct *chartInstance, real_T c24_x[2]);
static real_T c24_mrdivide(SFc24_carsimInstanceStruct *chartInstance, real_T
  c24_A, real_T c24_B);
static const mxArray *c24_d_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static int32_T c24_d_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static uint8_T c24_e_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_b_is_active_c24_carsim, const char_T *c24_identifier);
static uint8_T c24_f_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void init_dsm_address_info(SFc24_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
  chartInstance->c24_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c24_is_active_c24_carsim = 0U;
}

static void initialize_params_c24_carsim(SFc24_carsimInstanceStruct
  *chartInstance)
{
  real_T c24_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'road_condition' in the parent workspace.\n");
  sf_mex_import_named("road_condition", sf_mex_get_sfun_param(chartInstance->S,
    0, 0), &c24_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c24_road_condition = c24_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c24_update_debugger_state_c24_carsim(SFc24_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c24_carsim(SFc24_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c24_st;
  const mxArray *c24_y = NULL;
  int32_T c24_i0;
  real_T c24_u[4];
  const mxArray *c24_b_y = NULL;
  int32_T c24_i1;
  real_T c24_b_u[4];
  const mxArray *c24_c_y = NULL;
  uint8_T c24_hoistedGlobal;
  uint8_T c24_c_u;
  const mxArray *c24_d_y = NULL;
  real_T (*c24_my_long)[4];
  real_T (*c24_my_lat)[4];
  c24_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c24_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c24_st = NULL;
  c24_st = NULL;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_createcellarray(3), FALSE);
  for (c24_i0 = 0; c24_i0 < 4; c24_i0++) {
    c24_u[c24_i0] = (*c24_my_lat)[c24_i0];
  }

  c24_b_y = NULL;
  sf_mex_assign(&c24_b_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c24_y, 0, c24_b_y);
  for (c24_i1 = 0; c24_i1 < 4; c24_i1++) {
    c24_b_u[c24_i1] = (*c24_my_long)[c24_i1];
  }

  c24_c_y = NULL;
  sf_mex_assign(&c24_c_y, sf_mex_create("y", c24_b_u, 0, 0U, 1U, 0U, 1, 4),
                FALSE);
  sf_mex_setcell(c24_y, 1, c24_c_y);
  c24_hoistedGlobal = chartInstance->c24_is_active_c24_carsim;
  c24_c_u = c24_hoistedGlobal;
  c24_d_y = NULL;
  sf_mex_assign(&c24_d_y, sf_mex_create("y", &c24_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c24_y, 2, c24_d_y);
  sf_mex_assign(&c24_st, c24_y, FALSE);
  return c24_st;
}

static void set_sim_state_c24_carsim(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_st)
{
  const mxArray *c24_u;
  real_T c24_dv0[4];
  int32_T c24_i2;
  real_T c24_dv1[4];
  int32_T c24_i3;
  real_T (*c24_my_lat)[4];
  real_T (*c24_my_long)[4];
  c24_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c24_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c24_doneDoubleBufferReInit = TRUE;
  c24_u = sf_mex_dup(c24_st);
  c24_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c24_u, 0)),
                       "my_lat", c24_dv0);
  for (c24_i2 = 0; c24_i2 < 4; c24_i2++) {
    (*c24_my_lat)[c24_i2] = c24_dv0[c24_i2];
  }

  c24_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c24_u, 1)),
                       "my_long", c24_dv1);
  for (c24_i3 = 0; c24_i3 < 4; c24_i3++) {
    (*c24_my_long)[c24_i3] = c24_dv1[c24_i3];
  }

  chartInstance->c24_is_active_c24_carsim = c24_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c24_u, 2)), "is_active_c24_carsim");
  sf_mex_destroy(&c24_u);
  c24_update_debugger_state_c24_carsim(chartInstance);
  sf_mex_destroy(&c24_st);
}

static void finalize_c24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
}

static void sf_c24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
  int32_T c24_i4;
  int32_T c24_i5;
  int32_T c24_i6;
  int32_T c24_i7;
  int32_T c24_i8;
  int32_T c24_i9;
  real_T (*c24_my_lat)[4];
  real_T (*c24_my_long)[4];
  real_T (*c24_sigma_res)[4];
  real_T (*c24_sigma_lat)[4];
  real_T (*c24_sigma_long)[4];
  real_T (*c24_v_body)[3];
  c24_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c24_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c24_sigma_res = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c24_sigma_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c24_sigma_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c24_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 12U, chartInstance->c24_sfEvent);
  for (c24_i4 = 0; c24_i4 < 3; c24_i4++) {
    _SFD_DATA_RANGE_CHECK((*c24_v_body)[c24_i4], 0U);
  }

  for (c24_i5 = 0; c24_i5 < 4; c24_i5++) {
    _SFD_DATA_RANGE_CHECK((*c24_sigma_long)[c24_i5], 1U);
  }

  for (c24_i6 = 0; c24_i6 < 4; c24_i6++) {
    _SFD_DATA_RANGE_CHECK((*c24_sigma_lat)[c24_i6], 2U);
  }

  for (c24_i7 = 0; c24_i7 < 4; c24_i7++) {
    _SFD_DATA_RANGE_CHECK((*c24_sigma_res)[c24_i7], 3U);
  }

  for (c24_i8 = 0; c24_i8 < 4; c24_i8++) {
    _SFD_DATA_RANGE_CHECK((*c24_my_long)[c24_i8], 4U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c24_road_condition, 5U);
  for (c24_i9 = 0; c24_i9 < 4; c24_i9++) {
    _SFD_DATA_RANGE_CHECK((*c24_my_lat)[c24_i9], 6U);
  }

  chartInstance->c24_sfEvent = CALL_EVENT;
  c24_chartstep_c24_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c24_chartstep_c24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
  real_T c24_hoistedGlobal;
  int32_T c24_i10;
  real_T c24_v_body[3];
  int32_T c24_i11;
  real_T c24_sigma_long[4];
  int32_T c24_i12;
  real_T c24_sigma_lat[4];
  int32_T c24_i13;
  real_T c24_sigma_res[4];
  real_T c24_b_road_condition;
  uint32_T c24_debug_family_var_map[26];
  real_T c24_V;
  real_T c24_ratio_long_fl;
  real_T c24_ratio_long_fr;
  real_T c24_ratio_long_rl;
  real_T c24_ratio_long_rr;
  real_T c24_ratio_lat_fl;
  real_T c24_ratio_lat_fr;
  real_T c24_ratio_lat_rl;
  real_T c24_ratio_lat_rr;
  real_T c24_c1;
  real_T c24_c2;
  real_T c24_c3;
  real_T c24_c4;
  real_T c24_my_fl;
  real_T c24_my_fr;
  real_T c24_my_rl;
  real_T c24_my_rr;
  real_T c24_nargin = 5.0;
  real_T c24_nargout = 2.0;
  real_T c24_my_long[4];
  real_T c24_my_lat[4];
  real_T c24_b_v_body[2];
  real_T c24_x;
  boolean_T c24_b;
  real_T c24_b_x;
  boolean_T c24_b_b;
  real_T c24_c_x;
  boolean_T c24_c_b;
  real_T c24_d_x;
  boolean_T c24_d_b;
  real_T c24_e_x;
  boolean_T c24_e_b;
  real_T c24_f_x;
  boolean_T c24_f_b;
  real_T c24_g_x;
  boolean_T c24_g_b;
  real_T c24_h_x;
  boolean_T c24_h_b;
  real_T c24_a;
  real_T c24_i_b;
  real_T c24_y;
  real_T c24_i_x;
  real_T c24_j_x;
  real_T c24_b_a;
  real_T c24_j_b;
  real_T c24_b_y;
  real_T c24_c_a;
  real_T c24_k_b;
  real_T c24_c_y;
  real_T c24_d_a;
  real_T c24_l_b;
  real_T c24_d_y;
  real_T c24_e_a;
  real_T c24_m_b;
  real_T c24_e_y;
  real_T c24_k_x;
  real_T c24_l_x;
  real_T c24_f_a;
  real_T c24_n_b;
  real_T c24_g_a;
  real_T c24_o_b;
  real_T c24_f_y;
  real_T c24_m_x;
  real_T c24_n_x;
  real_T c24_h_a;
  real_T c24_p_b;
  real_T c24_g_y;
  real_T c24_i_a;
  real_T c24_q_b;
  real_T c24_h_y;
  real_T c24_j_a;
  real_T c24_r_b;
  real_T c24_i_y;
  real_T c24_k_a;
  real_T c24_s_b;
  real_T c24_j_y;
  real_T c24_o_x;
  real_T c24_p_x;
  real_T c24_l_a;
  real_T c24_t_b;
  real_T c24_m_a;
  real_T c24_u_b;
  real_T c24_k_y;
  real_T c24_q_x;
  real_T c24_r_x;
  real_T c24_n_a;
  real_T c24_v_b;
  real_T c24_l_y;
  real_T c24_o_a;
  real_T c24_w_b;
  real_T c24_m_y;
  real_T c24_p_a;
  real_T c24_x_b;
  real_T c24_n_y;
  real_T c24_q_a;
  real_T c24_y_b;
  real_T c24_o_y;
  real_T c24_s_x;
  real_T c24_t_x;
  real_T c24_r_a;
  real_T c24_ab_b;
  real_T c24_s_a;
  real_T c24_bb_b;
  real_T c24_p_y;
  real_T c24_u_x;
  real_T c24_v_x;
  real_T c24_t_a;
  real_T c24_cb_b;
  real_T c24_q_y;
  real_T c24_u_a;
  real_T c24_db_b;
  real_T c24_r_y;
  real_T c24_v_a;
  real_T c24_eb_b;
  real_T c24_s_y;
  real_T c24_w_a;
  real_T c24_fb_b;
  real_T c24_t_y;
  real_T c24_w_x;
  real_T c24_x_x;
  real_T c24_x_a;
  real_T c24_gb_b;
  real_T c24_y_a;
  real_T c24_hb_b;
  real_T c24_u_y;
  real_T c24_ab_a;
  real_T c24_ib_b;
  real_T c24_v_y;
  real_T c24_bb_a;
  real_T c24_jb_b;
  real_T c24_w_y;
  real_T c24_cb_a;
  real_T c24_kb_b;
  real_T c24_x_y;
  real_T c24_db_a;
  real_T c24_lb_b;
  real_T c24_y_y;
  real_T c24_eb_a;
  real_T c24_mb_b;
  real_T c24_ab_y;
  real_T c24_fb_a;
  real_T c24_nb_b;
  real_T c24_bb_y;
  real_T c24_gb_a;
  real_T c24_ob_b;
  real_T c24_cb_y;
  int32_T c24_i14;
  int32_T c24_i15;
  real_T (*c24_b_my_long)[4];
  real_T (*c24_b_my_lat)[4];
  real_T (*c24_b_sigma_res)[4];
  real_T (*c24_b_sigma_lat)[4];
  real_T (*c24_b_sigma_long)[4];
  real_T (*c24_c_v_body)[3];
  c24_b_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c24_b_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c24_b_sigma_res = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c24_b_sigma_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c24_b_sigma_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c24_c_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 12U, chartInstance->c24_sfEvent);
  c24_hoistedGlobal = chartInstance->c24_road_condition;
  for (c24_i10 = 0; c24_i10 < 3; c24_i10++) {
    c24_v_body[c24_i10] = (*c24_c_v_body)[c24_i10];
  }

  for (c24_i11 = 0; c24_i11 < 4; c24_i11++) {
    c24_sigma_long[c24_i11] = (*c24_b_sigma_long)[c24_i11];
  }

  for (c24_i12 = 0; c24_i12 < 4; c24_i12++) {
    c24_sigma_lat[c24_i12] = (*c24_b_sigma_lat)[c24_i12];
  }

  for (c24_i13 = 0; c24_i13 < 4; c24_i13++) {
    c24_sigma_res[c24_i13] = (*c24_b_sigma_res)[c24_i13];
  }

  c24_b_road_condition = c24_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 26U, 26U, c24_debug_family_names,
    c24_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c24_V, 0U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_long_fl, 1U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_long_fr, 2U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_long_rl, 3U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_long_rr, 4U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_lat_fl, 5U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_lat_fr, 6U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_lat_rl, 7U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_ratio_lat_rr, 8U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_c1, 9U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_c2, 10U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_c3, 11U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_c4, 12U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_my_fl, 13U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_my_fr, 14U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_my_rl, 15U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_my_rr, 16U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_nargin, 17U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_nargout, 18U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c24_v_body, 19U, c24_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c24_sigma_long, 20U, c24_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c24_sigma_lat, 21U, c24_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c24_sigma_res, 22U, c24_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c24_b_road_condition, 23U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c24_my_long, 24U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c24_my_lat, 25U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 4);
  c24_b_v_body[0] = c24_v_body[0];
  c24_b_v_body[1] = c24_v_body[1];
  c24_V = c24_norm(chartInstance, c24_b_v_body);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 7);
  c24_ratio_long_fl = c24_mrdivide(chartInstance, c24_sigma_long[0],
    c24_sigma_res[0]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 8);
  c24_ratio_long_fr = c24_mrdivide(chartInstance, c24_sigma_long[1],
    c24_sigma_res[1]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 9);
  c24_ratio_long_rl = c24_mrdivide(chartInstance, c24_sigma_long[2],
    c24_sigma_res[2]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 10);
  c24_ratio_long_rr = c24_mrdivide(chartInstance, c24_sigma_long[3],
    c24_sigma_res[3]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 11);
  c24_ratio_lat_fl = c24_mrdivide(chartInstance, c24_sigma_lat[0],
    c24_sigma_res[0]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 12);
  c24_ratio_lat_fr = c24_mrdivide(chartInstance, c24_sigma_lat[1],
    c24_sigma_res[1]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 13);
  c24_ratio_lat_rl = c24_mrdivide(chartInstance, c24_sigma_lat[2],
    c24_sigma_res[2]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 14);
  c24_ratio_lat_rr = c24_mrdivide(chartInstance, c24_sigma_lat[3],
    c24_sigma_res[3]);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 16);
  c24_x = c24_ratio_long_fl;
  c24_b = muDoubleScalarIsNaN(c24_x);
  if (CV_EML_IF(0, 1, 0, c24_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 16);
    c24_ratio_long_fl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 17);
  c24_b_x = c24_ratio_long_fr;
  c24_b_b = muDoubleScalarIsNaN(c24_b_x);
  if (CV_EML_IF(0, 1, 1, c24_b_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 17);
    c24_ratio_long_fr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 18);
  c24_c_x = c24_ratio_long_rl;
  c24_c_b = muDoubleScalarIsNaN(c24_c_x);
  if (CV_EML_IF(0, 1, 2, c24_c_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 18);
    c24_ratio_long_rl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 19);
  c24_d_x = c24_ratio_long_rr;
  c24_d_b = muDoubleScalarIsNaN(c24_d_x);
  if (CV_EML_IF(0, 1, 3, c24_d_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 19);
    c24_ratio_long_rr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 20);
  c24_e_x = c24_ratio_lat_fl;
  c24_e_b = muDoubleScalarIsNaN(c24_e_x);
  if (CV_EML_IF(0, 1, 4, c24_e_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 20);
    c24_ratio_lat_fl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 21);
  c24_f_x = c24_ratio_lat_fr;
  c24_f_b = muDoubleScalarIsNaN(c24_f_x);
  if (CV_EML_IF(0, 1, 5, c24_f_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 21);
    c24_ratio_lat_fr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 22);
  c24_g_x = c24_ratio_lat_rl;
  c24_g_b = muDoubleScalarIsNaN(c24_g_x);
  if (CV_EML_IF(0, 1, 6, c24_g_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 22);
    c24_ratio_lat_rl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 23);
  c24_h_x = c24_ratio_lat_rr;
  c24_h_b = muDoubleScalarIsNaN(c24_h_x);
  if (CV_EML_IF(0, 1, 7, c24_h_b)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 23);
    c24_ratio_lat_rr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 25);
  switch ((int32_T)_SFD_INTEGER_CHECK("road_condition", c24_b_road_condition)) {
   case 1:
    CV_EML_SWITCH(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 28);
    c24_c1 = 1.2801;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 29);
    c24_c2 = 23.99;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 30);
    c24_c3 = 0.52;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 31);
    c24_c4 = 0.03;
    break;

   case 2:
    CV_EML_SWITCH(0, 1, 0, 2);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 35);
    c24_c1 = 0.857;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 36);
    c24_c2 = 33.822;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 37);
    c24_c3 = 0.347;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 38);
    c24_c4 = 0.03;
    break;

   case 3:
    CV_EML_SWITCH(0, 1, 0, 3);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 42);
    c24_c1 = 1.1973;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 43);
    c24_c2 = 25.168;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 44);
    c24_c3 = 0.5373;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 45);
    c24_c4 = 0.03;
    break;

   case 4:
    CV_EML_SWITCH(0, 1, 0, 4);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 49);
    c24_c1 = 1.3713;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 50);
    c24_c2 = 6.4565;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 51);
    c24_c3 = 0.6691;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 52);
    c24_c4 = 0.03;
    break;

   case 5:
    CV_EML_SWITCH(0, 1, 0, 5);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 56);
    c24_c1 = 0.4004;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 57);
    c24_c2 = 33.708;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 58);
    c24_c3 = 0.1204;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 59);
    c24_c4 = 0.03;
    break;

   case 6:
    CV_EML_SWITCH(0, 1, 0, 6);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 63);
    c24_c1 = 0.1946;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 64);
    c24_c2 = 94.129;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 65);
    c24_c3 = 0.0646;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 66);
    c24_c4 = 0.03;
    break;

   case 7:
    CV_EML_SWITCH(0, 1, 0, 7);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 70);
    c24_c1 = 0.05;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 71);
    c24_c2 = 306.39;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 72);
    c24_c3 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 73);
    c24_c4 = 0.03;
    break;

   default:
    CV_EML_SWITCH(0, 1, 0, 0);
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 76);
    c24_c1 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 77);
    c24_c2 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 78);
    c24_c3 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 79);
    c24_c4 = 0.0;
    break;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 84);
  c24_a = -c24_c2;
  c24_i_b = c24_sigma_res[0];
  c24_y = c24_a * c24_i_b;
  c24_i_x = c24_y;
  c24_j_x = c24_i_x;
  c24_j_x = muDoubleScalarExp(c24_j_x);
  c24_b_a = c24_c1;
  c24_j_b = 1.0 - c24_j_x;
  c24_b_y = c24_b_a * c24_j_b;
  c24_c_a = c24_c3;
  c24_k_b = c24_sigma_res[0];
  c24_c_y = c24_c_a * c24_k_b;
  c24_d_a = -c24_c4;
  c24_l_b = c24_sigma_res[0];
  c24_d_y = c24_d_a * c24_l_b;
  c24_e_a = c24_d_y;
  c24_m_b = c24_V;
  c24_e_y = c24_e_a * c24_m_b;
  c24_k_x = c24_e_y;
  c24_l_x = c24_k_x;
  c24_l_x = muDoubleScalarExp(c24_l_x);
  c24_f_a = c24_b_y - c24_c_y;
  c24_n_b = c24_l_x;
  c24_my_fl = c24_f_a * c24_n_b;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 85);
  c24_g_a = -c24_c2;
  c24_o_b = c24_sigma_res[1];
  c24_f_y = c24_g_a * c24_o_b;
  c24_m_x = c24_f_y;
  c24_n_x = c24_m_x;
  c24_n_x = muDoubleScalarExp(c24_n_x);
  c24_h_a = c24_c1;
  c24_p_b = 1.0 - c24_n_x;
  c24_g_y = c24_h_a * c24_p_b;
  c24_i_a = c24_c3;
  c24_q_b = c24_sigma_res[1];
  c24_h_y = c24_i_a * c24_q_b;
  c24_j_a = -c24_c4;
  c24_r_b = c24_sigma_res[1];
  c24_i_y = c24_j_a * c24_r_b;
  c24_k_a = c24_i_y;
  c24_s_b = c24_V;
  c24_j_y = c24_k_a * c24_s_b;
  c24_o_x = c24_j_y;
  c24_p_x = c24_o_x;
  c24_p_x = muDoubleScalarExp(c24_p_x);
  c24_l_a = c24_g_y - c24_h_y;
  c24_t_b = c24_p_x;
  c24_my_fr = c24_l_a * c24_t_b;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 86);
  c24_m_a = -c24_c2;
  c24_u_b = c24_sigma_res[2];
  c24_k_y = c24_m_a * c24_u_b;
  c24_q_x = c24_k_y;
  c24_r_x = c24_q_x;
  c24_r_x = muDoubleScalarExp(c24_r_x);
  c24_n_a = c24_c1;
  c24_v_b = 1.0 - c24_r_x;
  c24_l_y = c24_n_a * c24_v_b;
  c24_o_a = c24_c3;
  c24_w_b = c24_sigma_res[2];
  c24_m_y = c24_o_a * c24_w_b;
  c24_p_a = -c24_c4;
  c24_x_b = c24_sigma_res[2];
  c24_n_y = c24_p_a * c24_x_b;
  c24_q_a = c24_n_y;
  c24_y_b = c24_V;
  c24_o_y = c24_q_a * c24_y_b;
  c24_s_x = c24_o_y;
  c24_t_x = c24_s_x;
  c24_t_x = muDoubleScalarExp(c24_t_x);
  c24_r_a = c24_l_y - c24_m_y;
  c24_ab_b = c24_t_x;
  c24_my_rl = c24_r_a * c24_ab_b;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 87);
  c24_s_a = -c24_c2;
  c24_bb_b = c24_sigma_res[3];
  c24_p_y = c24_s_a * c24_bb_b;
  c24_u_x = c24_p_y;
  c24_v_x = c24_u_x;
  c24_v_x = muDoubleScalarExp(c24_v_x);
  c24_t_a = c24_c1;
  c24_cb_b = 1.0 - c24_v_x;
  c24_q_y = c24_t_a * c24_cb_b;
  c24_u_a = c24_c3;
  c24_db_b = c24_sigma_res[3];
  c24_r_y = c24_u_a * c24_db_b;
  c24_v_a = -c24_c4;
  c24_eb_b = c24_sigma_res[3];
  c24_s_y = c24_v_a * c24_eb_b;
  c24_w_a = c24_s_y;
  c24_fb_b = c24_V;
  c24_t_y = c24_w_a * c24_fb_b;
  c24_w_x = c24_t_y;
  c24_x_x = c24_w_x;
  c24_x_x = muDoubleScalarExp(c24_x_x);
  c24_x_a = c24_q_y - c24_r_y;
  c24_gb_b = c24_x_x;
  c24_my_rr = c24_x_a * c24_gb_b;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 90);
  c24_y_a = c24_my_fl;
  c24_hb_b = c24_ratio_long_fl;
  c24_u_y = c24_y_a * c24_hb_b;
  c24_ab_a = c24_my_fr;
  c24_ib_b = c24_ratio_long_fr;
  c24_v_y = c24_ab_a * c24_ib_b;
  c24_bb_a = c24_my_rl;
  c24_jb_b = c24_ratio_long_rl;
  c24_w_y = c24_bb_a * c24_jb_b;
  c24_cb_a = c24_my_rr;
  c24_kb_b = c24_ratio_long_rr;
  c24_x_y = c24_cb_a * c24_kb_b;
  c24_my_long[0] = c24_u_y;
  c24_my_long[1] = c24_v_y;
  c24_my_long[2] = c24_w_y;
  c24_my_long[3] = c24_x_y;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 96);
  c24_db_a = c24_my_fl;
  c24_lb_b = c24_ratio_lat_fl;
  c24_y_y = c24_db_a * c24_lb_b;
  c24_eb_a = c24_my_fr;
  c24_mb_b = c24_ratio_lat_fr;
  c24_ab_y = c24_eb_a * c24_mb_b;
  c24_fb_a = c24_my_rl;
  c24_nb_b = c24_ratio_lat_rl;
  c24_bb_y = c24_fb_a * c24_nb_b;
  c24_gb_a = c24_my_rr;
  c24_ob_b = c24_ratio_lat_rr;
  c24_cb_y = c24_gb_a * c24_ob_b;
  c24_my_lat[0] = c24_y_y;
  c24_my_lat[1] = c24_ab_y;
  c24_my_lat[2] = c24_bb_y;
  c24_my_lat[3] = c24_cb_y;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, -96);
  sf_debug_symbol_scope_pop();
  for (c24_i14 = 0; c24_i14 < 4; c24_i14++) {
    (*c24_b_my_long)[c24_i14] = c24_my_long[c24_i14];
  }

  for (c24_i15 = 0; c24_i15 < 4; c24_i15++) {
    (*c24_b_my_lat)[c24_i15] = c24_my_lat[c24_i15];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 12U, chartInstance->c24_sfEvent);
}

static void initSimStructsc24_carsim(SFc24_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c24_machineNumber, uint32_T
  c24_chartNumber)
{
}

static const mxArray *c24_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_i16;
  real_T c24_b_inData[4];
  int32_T c24_i17;
  real_T c24_u[4];
  const mxArray *c24_y = NULL;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  for (c24_i16 = 0; c24_i16 < 4; c24_i16++) {
    c24_b_inData[c24_i16] = (*(real_T (*)[4])c24_inData)[c24_i16];
  }

  for (c24_i17 = 0; c24_i17 < 4; c24_i17++) {
    c24_u[c24_i17] = c24_b_inData[c24_i17];
  }

  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static void c24_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_my_lat, const char_T *c24_identifier, real_T c24_y[4])
{
  emlrtMsgIdentifier c24_thisId;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_my_lat), &c24_thisId,
    c24_y);
  sf_mex_destroy(&c24_my_lat);
}

static void c24_b_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[4])
{
  real_T c24_dv2[4];
  int32_T c24_i18;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), c24_dv2, 1, 0, 0U, 1, 0U, 1, 4);
  for (c24_i18 = 0; c24_i18 < 4; c24_i18++) {
    c24_y[c24_i18] = c24_dv2[c24_i18];
  }

  sf_mex_destroy(&c24_u);
}

static void c24_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_my_lat;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y[4];
  int32_T c24_i19;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_my_lat = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_my_lat), &c24_thisId,
    c24_y);
  sf_mex_destroy(&c24_my_lat);
  for (c24_i19 = 0; c24_i19 < 4; c24_i19++) {
    (*(real_T (*)[4])c24_outData)[c24_i19] = c24_y[c24_i19];
  }

  sf_mex_destroy(&c24_mxArrayInData);
}

static const mxArray *c24_b_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  real_T c24_u;
  const mxArray *c24_y = NULL;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_u = *(real_T *)c24_inData;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", &c24_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static real_T c24_c_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  real_T c24_y;
  real_T c24_d1;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_d1, 1, 0, 0U, 0, 0U, 0);
  c24_y = c24_d1;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_b_road_condition;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_b_road_condition = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_b_road_condition),
    &c24_thisId);
  sf_mex_destroy(&c24_b_road_condition);
  *(real_T *)c24_outData = c24_y;
  sf_mex_destroy(&c24_mxArrayInData);
}

static const mxArray *c24_c_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_i20;
  real_T c24_b_inData[3];
  int32_T c24_i21;
  real_T c24_u[3];
  const mxArray *c24_y = NULL;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  for (c24_i20 = 0; c24_i20 < 3; c24_i20++) {
    c24_b_inData[c24_i20] = (*(real_T (*)[3])c24_inData)[c24_i20];
  }

  for (c24_i21 = 0; c24_i21 < 3; c24_i21++) {
    c24_u[c24_i21] = c24_b_inData[c24_i21];
  }

  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

const mxArray *sf_c24_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c24_nameCaptureInfo;
  c24_ResolvedFunctionInfo c24_info[23];
  const mxArray *c24_m0 = NULL;
  int32_T c24_i22;
  c24_ResolvedFunctionInfo *c24_r0;
  c24_nameCaptureInfo = NULL;
  c24_nameCaptureInfo = NULL;
  c24_info_helper(c24_info);
  sf_mex_assign(&c24_m0, sf_mex_createstruct("nameCaptureInfo", 1, 23), FALSE);
  for (c24_i22 = 0; c24_i22 < 23; c24_i22++) {
    c24_r0 = &c24_info[c24_i22];
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", c24_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c24_r0->context)), "context", "nameCaptureInfo",
                    c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", c24_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c24_r0->name)), "name", "nameCaptureInfo",
                    c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo",
      c24_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c24_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", c24_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c24_r0->resolved)), "resolved",
                    "nameCaptureInfo", c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", &c24_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", &c24_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo",
      &c24_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c24_i22);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo",
      &c24_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c24_i22);
  }

  sf_mex_assign(&c24_nameCaptureInfo, c24_m0, FALSE);
  return c24_nameCaptureInfo;
}

static void c24_info_helper(c24_ResolvedFunctionInfo c24_info[23])
{
  c24_info[0].context = "";
  c24_info[0].name = "norm";
  c24_info[0].dominantType = "double";
  c24_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c24_info[0].fileTimeLo = 1286818826U;
  c24_info[0].fileTimeHi = 0U;
  c24_info[0].mFileTimeLo = 0U;
  c24_info[0].mFileTimeHi = 0U;
  c24_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c24_info[1].name = "eml_index_class";
  c24_info[1].dominantType = "";
  c24_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c24_info[1].fileTimeLo = 1286818778U;
  c24_info[1].fileTimeHi = 0U;
  c24_info[1].mFileTimeLo = 0U;
  c24_info[1].mFileTimeHi = 0U;
  c24_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c24_info[2].name = "eml_xnrm2";
  c24_info[2].dominantType = "int32";
  c24_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c24_info[2].fileTimeLo = 1299076776U;
  c24_info[2].fileTimeHi = 0U;
  c24_info[2].mFileTimeLo = 0U;
  c24_info[2].mFileTimeHi = 0U;
  c24_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c24_info[3].name = "eml_blas_inline";
  c24_info[3].dominantType = "";
  c24_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c24_info[3].fileTimeLo = 1299076768U;
  c24_info[3].fileTimeHi = 0U;
  c24_info[3].mFileTimeLo = 0U;
  c24_info[3].mFileTimeHi = 0U;
  c24_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c24_info[4].name = "eml_refblas_xnrm2";
  c24_info[4].dominantType = "int32";
  c24_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[4].fileTimeLo = 1299076784U;
  c24_info[4].fileTimeHi = 0U;
  c24_info[4].mFileTimeLo = 0U;
  c24_info[4].mFileTimeHi = 0U;
  c24_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[5].name = "realmin";
  c24_info[5].dominantType = "char";
  c24_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c24_info[5].fileTimeLo = 1286818768U;
  c24_info[5].fileTimeHi = 0U;
  c24_info[5].mFileTimeLo = 0U;
  c24_info[5].mFileTimeHi = 0U;
  c24_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c24_info[6].name = "mpower";
  c24_info[6].dominantType = "double";
  c24_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c24_info[6].fileTimeLo = 1286818842U;
  c24_info[6].fileTimeHi = 0U;
  c24_info[6].mFileTimeLo = 0U;
  c24_info[6].mFileTimeHi = 0U;
  c24_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c24_info[7].name = "power";
  c24_info[7].dominantType = "double";
  c24_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c24_info[7].fileTimeLo = 1294067944U;
  c24_info[7].fileTimeHi = 0U;
  c24_info[7].mFileTimeLo = 0U;
  c24_info[7].mFileTimeHi = 0U;
  c24_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c24_info[8].name = "eml_scalar_eg";
  c24_info[8].dominantType = "double";
  c24_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c24_info[8].fileTimeLo = 1286818796U;
  c24_info[8].fileTimeHi = 0U;
  c24_info[8].mFileTimeLo = 0U;
  c24_info[8].mFileTimeHi = 0U;
  c24_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c24_info[9].name = "eml_scalexp_alloc";
  c24_info[9].dominantType = "double";
  c24_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c24_info[9].fileTimeLo = 1286818796U;
  c24_info[9].fileTimeHi = 0U;
  c24_info[9].mFileTimeLo = 0U;
  c24_info[9].mFileTimeHi = 0U;
  c24_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c24_info[10].name = "eml_scalar_floor";
  c24_info[10].dominantType = "double";
  c24_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c24_info[10].fileTimeLo = 1286818726U;
  c24_info[10].fileTimeHi = 0U;
  c24_info[10].mFileTimeLo = 0U;
  c24_info[10].mFileTimeHi = 0U;
  c24_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[11].name = "eml_index_minus";
  c24_info[11].dominantType = "int32";
  c24_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c24_info[11].fileTimeLo = 1286818778U;
  c24_info[11].fileTimeHi = 0U;
  c24_info[11].mFileTimeLo = 0U;
  c24_info[11].mFileTimeHi = 0U;
  c24_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[12].name = "eml_index_times";
  c24_info[12].dominantType = "int32";
  c24_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c24_info[12].fileTimeLo = 1286818780U;
  c24_info[12].fileTimeHi = 0U;
  c24_info[12].mFileTimeLo = 0U;
  c24_info[12].mFileTimeHi = 0U;
  c24_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[13].name = "eml_index_plus";
  c24_info[13].dominantType = "int32";
  c24_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c24_info[13].fileTimeLo = 1286818778U;
  c24_info[13].fileTimeHi = 0U;
  c24_info[13].mFileTimeLo = 0U;
  c24_info[13].mFileTimeHi = 0U;
  c24_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[14].name = "abs";
  c24_info[14].dominantType = "double";
  c24_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c24_info[14].fileTimeLo = 1286818694U;
  c24_info[14].fileTimeHi = 0U;
  c24_info[14].mFileTimeLo = 0U;
  c24_info[14].mFileTimeHi = 0U;
  c24_info[15].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c24_info[15].name = "eml_scalar_abs";
  c24_info[15].dominantType = "double";
  c24_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c24_info[15].fileTimeLo = 1286818712U;
  c24_info[15].fileTimeHi = 0U;
  c24_info[15].mFileTimeLo = 0U;
  c24_info[15].mFileTimeHi = 0U;
  c24_info[16].context = "";
  c24_info[16].name = "mrdivide";
  c24_info[16].dominantType = "double";
  c24_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c24_info[16].fileTimeLo = 1310137456U;
  c24_info[16].fileTimeHi = 0U;
  c24_info[16].mFileTimeLo = 1289519692U;
  c24_info[16].mFileTimeHi = 0U;
  c24_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c24_info[17].name = "rdivide";
  c24_info[17].dominantType = "double";
  c24_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c24_info[17].fileTimeLo = 1286818844U;
  c24_info[17].fileTimeHi = 0U;
  c24_info[17].mFileTimeLo = 0U;
  c24_info[17].mFileTimeHi = 0U;
  c24_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c24_info[18].name = "eml_div";
  c24_info[18].dominantType = "double";
  c24_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c24_info[18].fileTimeLo = 1305318000U;
  c24_info[18].fileTimeHi = 0U;
  c24_info[18].mFileTimeLo = 0U;
  c24_info[18].mFileTimeHi = 0U;
  c24_info[19].context = "";
  c24_info[19].name = "isnan";
  c24_info[19].dominantType = "double";
  c24_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c24_info[19].fileTimeLo = 1286818760U;
  c24_info[19].fileTimeHi = 0U;
  c24_info[19].mFileTimeLo = 0U;
  c24_info[19].mFileTimeHi = 0U;
  c24_info[20].context = "";
  c24_info[20].name = "mtimes";
  c24_info[20].dominantType = "double";
  c24_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c24_info[20].fileTimeLo = 1289519692U;
  c24_info[20].fileTimeHi = 0U;
  c24_info[20].mFileTimeLo = 0U;
  c24_info[20].mFileTimeHi = 0U;
  c24_info[21].context = "";
  c24_info[21].name = "exp";
  c24_info[21].dominantType = "double";
  c24_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c24_info[21].fileTimeLo = 1286818740U;
  c24_info[21].fileTimeHi = 0U;
  c24_info[21].mFileTimeLo = 0U;
  c24_info[21].mFileTimeHi = 0U;
  c24_info[22].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c24_info[22].name = "eml_scalar_exp";
  c24_info[22].dominantType = "double";
  c24_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  c24_info[22].fileTimeLo = 1301328464U;
  c24_info[22].fileTimeHi = 0U;
  c24_info[22].mFileTimeLo = 0U;
  c24_info[22].mFileTimeHi = 0U;
}

static real_T c24_norm(SFc24_carsimInstanceStruct *chartInstance, real_T c24_x[2])
{
  real_T c24_y;
  real_T c24_scale;
  int32_T c24_k;
  int32_T c24_b_k;
  real_T c24_b_x;
  real_T c24_c_x;
  real_T c24_absxk;
  real_T c24_t;
  c24_y = 0.0;
  c24_scale = 2.2250738585072014E-308;
  for (c24_k = 1; c24_k < 3; c24_k++) {
    c24_b_k = c24_k;
    c24_b_x = c24_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
      "", (real_T)c24_b_k), 1, 2, 1, 0) - 1];
    c24_c_x = c24_b_x;
    c24_absxk = muDoubleScalarAbs(c24_c_x);
    if (c24_absxk > c24_scale) {
      c24_t = c24_scale / c24_absxk;
      c24_y = 1.0 + c24_y * c24_t * c24_t;
      c24_scale = c24_absxk;
    } else {
      c24_t = c24_absxk / c24_scale;
      c24_y += c24_t * c24_t;
    }
  }

  return c24_scale * muDoubleScalarSqrt(c24_y);
}

static real_T c24_mrdivide(SFc24_carsimInstanceStruct *chartInstance, real_T
  c24_A, real_T c24_B)
{
  real_T c24_x;
  real_T c24_b_y;
  real_T c24_b_x;
  real_T c24_c_y;
  c24_x = c24_A;
  c24_b_y = c24_B;
  c24_b_x = c24_x;
  c24_c_y = c24_b_y;
  return c24_b_x / c24_c_y;
}

static const mxArray *c24_d_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_u;
  const mxArray *c24_y = NULL;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_u = *(int32_T *)c24_inData;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", &c24_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static int32_T c24_d_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  int32_T c24_y;
  int32_T c24_i23;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_i23, 1, 6, 0U, 0, 0U, 0);
  c24_y = c24_i23;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_b_sfEvent;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  int32_T c24_y;
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)chartInstanceVoid;
  c24_b_sfEvent = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_b_sfEvent),
    &c24_thisId);
  sf_mex_destroy(&c24_b_sfEvent);
  *(int32_T *)c24_outData = c24_y;
  sf_mex_destroy(&c24_mxArrayInData);
}

static uint8_T c24_e_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_b_is_active_c24_carsim, const char_T *c24_identifier)
{
  uint8_T c24_y;
  emlrtMsgIdentifier c24_thisId;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c24_b_is_active_c24_carsim), &c24_thisId);
  sf_mex_destroy(&c24_b_is_active_c24_carsim);
  return c24_y;
}

static uint8_T c24_f_emlrt_marshallIn(SFc24_carsimInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  uint8_T c24_y;
  uint8_T c24_u0;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_u0, 1, 3, 0U, 0, 0U, 0);
  c24_y = c24_u0;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void init_dsm_address_info(SFc24_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c24_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(611498313U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2705029559U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(346229231U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3515226785U);
}

mxArray *sf_c24_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("h9lGyKaIQOYm6d1iAUcXYH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c24_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[10],T\"my_lat\",},{M[1],M[5],T\"my_long\",},{M[8],M[0],T\"is_active_c24_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c24_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc24_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc24_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          24,
          1,
          1,
          7,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_body");
          _SFD_SET_DATA_PROPS(1,1,1,0,"sigma_long");
          _SFD_SET_DATA_PROPS(2,1,1,0,"sigma_lat");
          _SFD_SET_DATA_PROPS(3,1,1,0,"sigma_res");
          _SFD_SET_DATA_PROPS(4,2,0,1,"my_long");
          _SFD_SET_DATA_PROPS(5,10,0,0,"road_condition");
          _SFD_SET_DATA_PROPS(6,2,0,1,"my_lat");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,8,0,1,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,2576);
        _SFD_CV_INIT_EML_IF(0,1,0,576,599,-1,623);
        _SFD_CV_INIT_EML_IF(0,1,1,624,647,-1,671);
        _SFD_CV_INIT_EML_IF(0,1,2,672,695,-1,719);
        _SFD_CV_INIT_EML_IF(0,1,3,720,743,-1,767);
        _SFD_CV_INIT_EML_IF(0,1,4,768,790,-1,813);
        _SFD_CV_INIT_EML_IF(0,1,5,814,836,-1,859);
        _SFD_CV_INIT_EML_IF(0,1,6,860,882,-1,905);
        _SFD_CV_INIT_EML_IF(0,1,7,906,928,-1,951);

        {
          static int caseStart[] = { 1787, 979, 1092, 1206, 1323, 1444, 1565,
            1674 };

          static int caseExprEnd[] = { 1796, 985, 1098, 1212, 1329, 1450, 1571,
            1680 };

          _SFD_CV_INIT_EML_SWITCH(0,1,0,953,975,1865,8,&(caseStart[0]),
            &(caseExprEnd[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)
            c24_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_b_sf_marshallOut,(MexInFcnForType)
          c24_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)
            c24_sf_marshallIn);
        }

        {
          real_T (*c24_v_body)[3];
          real_T (*c24_sigma_long)[4];
          real_T (*c24_sigma_lat)[4];
          real_T (*c24_sigma_res)[4];
          real_T (*c24_my_long)[4];
          real_T (*c24_my_lat)[4];
          c24_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
          c24_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
          c24_sigma_res = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S,
            3);
          c24_sigma_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S,
            2);
          c24_sigma_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S,
            1);
          c24_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c24_v_body);
          _SFD_SET_DATA_VALUE_PTR(1U, *c24_sigma_long);
          _SFD_SET_DATA_VALUE_PTR(2U, *c24_sigma_lat);
          _SFD_SET_DATA_VALUE_PTR(3U, *c24_sigma_res);
          _SFD_SET_DATA_VALUE_PTR(4U, *c24_my_long);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c24_road_condition);
          _SFD_SET_DATA_VALUE_PTR(6U, *c24_my_lat);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c24_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc24_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
  initialize_c24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c24_carsim(void *chartInstanceVar)
{
  enable_c24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c24_carsim(void *chartInstanceVar)
{
  disable_c24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c24_carsim(void *chartInstanceVar)
{
  sf_c24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c24_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c24_carsim((SFc24_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c24_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c24_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c24_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c24_carsim((SFc24_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c24_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c24_carsim(S);
}

static void sf_opaque_set_sim_state_c24_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c24_carsim(S, st);
}

static void sf_opaque_terminate_c24_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc24_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc24_carsim((SFc24_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c24_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c24_carsim((SFc24_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c24_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     road_condition
   */
  const char_T *rtParamNames[] = { "p1" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for road_condition*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,24);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,24,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,24,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,24,4);
      sf_mark_chart_reusable_outputs(S,infoStruct,24,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,24);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1498369734U));
  ssSetChecksum1(S,(1272159186U));
  ssSetChecksum2(S,(176117567U));
  ssSetChecksum3(S,(1467380376U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c24_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c24_carsim(SimStruct *S)
{
  SFc24_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc24_carsimInstanceStruct *)malloc(sizeof
    (SFc24_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc24_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c24_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c24_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c24_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c24_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c24_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c24_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c24_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c24_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c24_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c24_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c24_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c24_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c24_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c24_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c24_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c24_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
