/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c28_carsim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c28_debug_family_names[28] = { "Fx_fl", "Fx_fr", "Fx_rl",
  "Fx_rr", "omega_wheel_fl", "omega_wheel_fr", "omega_wheel_rl",
  "omega_wheel_rr", "Fx_front", "Fx_rear", "omega_wheel_dot_front",
  "omega_wheel_dot_fl", "omega_wheel_dot_fr", "omega_wheel_dot_rl",
  "omega_wheel_dot_rr", "omega_wheel_dot_rear", "nargin", "nargout", "T_m",
  "diff_lock", "wheel_drive", "r_wheel", "I_motor", "I_wheel", "Fx_wheel",
  "omega_wheel", "omega_m", "omega_wheel_dot" };

/* Function Declarations */
static void initialize_c28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void initialize_params_c28_carsim(SFc28_carsimInstanceStruct
  *chartInstance);
static void enable_c28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void disable_c28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void c28_update_debugger_state_c28_carsim(SFc28_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c28_carsim(SFc28_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c28_carsim(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_st);
static void finalize_c28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void sf_c28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void c28_chartstep_c28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void initSimStructsc28_carsim(SFc28_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c28_machineNumber, uint32_T
  c28_chartNumber);
static const mxArray *c28_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_omega_wheel_dot, const char_T *c28_identifier, real_T
  c28_y[4]);
static void c28_b_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[4]);
static void c28_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_b_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static real_T c28_c_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_omega_m, const char_T *c28_identifier);
static real_T c28_d_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void c28_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static real_T c28_mrdivide(SFc28_carsimInstanceStruct *chartInstance, real_T
  c28_A, real_T c28_B);
static const mxArray *c28_c_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static int32_T c28_e_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void c28_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static uint8_T c28_f_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_b_is_active_c28_carsim, const char_T *c28_identifier);
static uint8_T c28_g_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void init_dsm_address_info(SFc28_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
  chartInstance->c28_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c28_is_active_c28_carsim = 0U;
}

static void initialize_params_c28_carsim(SFc28_carsimInstanceStruct
  *chartInstance)
{
  real_T c28_d0;
  real_T c28_d1;
  real_T c28_d2;
  real_T c28_d3;
  real_T c28_d4;
  sf_set_error_prefix_string(
    "Error evaluating data 'diff_lock' in the parent workspace.\n");
  sf_mex_import_named("diff_lock", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c28_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_diff_lock = c28_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'wheel_drive' in the parent workspace.\n");
  sf_mex_import_named("wheel_drive", sf_mex_get_sfun_param(chartInstance->S, 4,
    0), &c28_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_wheel_drive = c28_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'r_wheel' in the parent workspace.\n");
  sf_mex_import_named("r_wheel", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c28_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_r_wheel = c28_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_motor' in the parent workspace.\n");
  sf_mex_import_named("I_motor", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c28_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_I_motor = c28_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_wheel' in the parent workspace.\n");
  sf_mex_import_named("I_wheel", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c28_d4, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_I_wheel = c28_d4;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c28_update_debugger_state_c28_carsim(SFc28_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c28_carsim(SFc28_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c28_st;
  const mxArray *c28_y = NULL;
  real_T c28_hoistedGlobal;
  real_T c28_u;
  const mxArray *c28_b_y = NULL;
  int32_T c28_i0;
  real_T c28_b_u[4];
  const mxArray *c28_c_y = NULL;
  uint8_T c28_b_hoistedGlobal;
  uint8_T c28_c_u;
  const mxArray *c28_d_y = NULL;
  real_T *c28_omega_m;
  real_T (*c28_omega_wheel_dot)[4];
  c28_omega_wheel_dot = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c28_omega_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c28_st = NULL;
  c28_st = NULL;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_createcellarray(3), FALSE);
  c28_hoistedGlobal = *c28_omega_m;
  c28_u = c28_hoistedGlobal;
  c28_b_y = NULL;
  sf_mex_assign(&c28_b_y, sf_mex_create("y", &c28_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 0, c28_b_y);
  for (c28_i0 = 0; c28_i0 < 4; c28_i0++) {
    c28_b_u[c28_i0] = (*c28_omega_wheel_dot)[c28_i0];
  }

  c28_c_y = NULL;
  sf_mex_assign(&c28_c_y, sf_mex_create("y", c28_b_u, 0, 0U, 1U, 0U, 1, 4),
                FALSE);
  sf_mex_setcell(c28_y, 1, c28_c_y);
  c28_b_hoistedGlobal = chartInstance->c28_is_active_c28_carsim;
  c28_c_u = c28_b_hoistedGlobal;
  c28_d_y = NULL;
  sf_mex_assign(&c28_d_y, sf_mex_create("y", &c28_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 2, c28_d_y);
  sf_mex_assign(&c28_st, c28_y, FALSE);
  return c28_st;
}

static void set_sim_state_c28_carsim(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_st)
{
  const mxArray *c28_u;
  real_T c28_dv0[4];
  int32_T c28_i1;
  real_T *c28_omega_m;
  real_T (*c28_omega_wheel_dot)[4];
  c28_omega_wheel_dot = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c28_omega_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c28_doneDoubleBufferReInit = TRUE;
  c28_u = sf_mex_dup(c28_st);
  *c28_omega_m = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c28_u, 0)), "omega_m");
  c28_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c28_u, 1)),
                       "omega_wheel_dot", c28_dv0);
  for (c28_i1 = 0; c28_i1 < 4; c28_i1++) {
    (*c28_omega_wheel_dot)[c28_i1] = c28_dv0[c28_i1];
  }

  chartInstance->c28_is_active_c28_carsim = c28_f_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c28_u, 2)), "is_active_c28_carsim");
  sf_mex_destroy(&c28_u);
  c28_update_debugger_state_c28_carsim(chartInstance);
  sf_mex_destroy(&c28_st);
}

static void finalize_c28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
}

static void sf_c28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
  int32_T c28_i2;
  int32_T c28_i3;
  int32_T c28_i4;
  real_T *c28_omega_m;
  real_T *c28_T_m;
  real_T (*c28_omega_wheel)[4];
  real_T (*c28_omega_wheel_dot)[4];
  real_T (*c28_Fx_wheel)[4];
  c28_omega_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c28_omega_wheel_dot = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c28_Fx_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c28_T_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c28_omega_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 16U, chartInstance->c28_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c28_omega_m, 0U);
  _SFD_DATA_RANGE_CHECK(*c28_T_m, 1U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c28_diff_lock, 2U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c28_wheel_drive, 3U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c28_r_wheel, 4U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c28_I_motor, 5U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c28_I_wheel, 6U);
  for (c28_i2 = 0; c28_i2 < 4; c28_i2++) {
    _SFD_DATA_RANGE_CHECK((*c28_Fx_wheel)[c28_i2], 7U);
  }

  for (c28_i3 = 0; c28_i3 < 4; c28_i3++) {
    _SFD_DATA_RANGE_CHECK((*c28_omega_wheel_dot)[c28_i3], 8U);
  }

  for (c28_i4 = 0; c28_i4 < 4; c28_i4++) {
    _SFD_DATA_RANGE_CHECK((*c28_omega_wheel)[c28_i4], 9U);
  }

  chartInstance->c28_sfEvent = CALL_EVENT;
  c28_chartstep_c28_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c28_chartstep_c28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
  real_T c28_hoistedGlobal;
  real_T c28_b_hoistedGlobal;
  real_T c28_c_hoistedGlobal;
  real_T c28_d_hoistedGlobal;
  real_T c28_e_hoistedGlobal;
  real_T c28_f_hoistedGlobal;
  real_T c28_T_m;
  real_T c28_b_diff_lock;
  real_T c28_b_wheel_drive;
  real_T c28_b_r_wheel;
  real_T c28_b_I_motor;
  real_T c28_b_I_wheel;
  int32_T c28_i5;
  real_T c28_Fx_wheel[4];
  int32_T c28_i6;
  real_T c28_omega_wheel[4];
  uint32_T c28_debug_family_var_map[28];
  real_T c28_Fx_fl;
  real_T c28_Fx_fr;
  real_T c28_Fx_rl;
  real_T c28_Fx_rr;
  real_T c28_omega_wheel_fl;
  real_T c28_omega_wheel_fr;
  real_T c28_omega_wheel_rl;
  real_T c28_omega_wheel_rr;
  real_T c28_Fx_front;
  real_T c28_Fx_rear;
  real_T c28_omega_wheel_dot_front;
  real_T c28_omega_wheel_dot_fl;
  real_T c28_omega_wheel_dot_fr;
  real_T c28_omega_wheel_dot_rl;
  real_T c28_omega_wheel_dot_rr;
  real_T c28_omega_wheel_dot_rear;
  real_T c28_nargin = 8.0;
  real_T c28_nargout = 2.0;
  real_T c28_omega_m;
  real_T c28_omega_wheel_dot[4];
  real_T c28_a;
  real_T c28_b;
  real_T c28_y;
  real_T c28_b_b;
  real_T c28_b_y;
  real_T c28_b_a;
  real_T c28_c_b;
  real_T c28_c_y;
  real_T c28_c_a;
  real_T c28_d_b;
  real_T c28_d_y;
  real_T c28_d_a;
  real_T c28_e_b;
  real_T c28_e_y;
  real_T c28_f_b;
  real_T c28_f_y;
  real_T c28_e_a;
  real_T c28_g_b;
  real_T c28_g_y;
  real_T c28_f_a;
  real_T c28_h_b;
  real_T c28_h_y;
  real_T c28_A;
  real_T c28_x;
  real_T c28_b_x;
  real_T c28_i_y;
  real_T c28_g_a;
  real_T c28_i_b;
  real_T c28_j_y;
  real_T c28_b_A;
  real_T c28_c_x;
  real_T c28_d_x;
  real_T c28_k_y;
  real_T c28_c_A;
  real_T c28_B;
  real_T c28_e_x;
  real_T c28_l_y;
  real_T c28_f_x;
  real_T c28_m_y;
  real_T c28_d_A;
  real_T c28_g_x;
  real_T c28_h_x;
  real_T c28_n_y;
  real_T c28_h_a;
  real_T c28_j_b;
  real_T c28_o_y;
  real_T c28_e_A;
  real_T c28_i_x;
  real_T c28_j_x;
  real_T c28_p_y;
  real_T c28_f_A;
  real_T c28_b_B;
  real_T c28_k_x;
  real_T c28_q_y;
  real_T c28_l_x;
  real_T c28_r_y;
  real_T c28_i_a;
  real_T c28_k_b;
  real_T c28_s_y;
  real_T c28_g_A;
  real_T c28_c_B;
  real_T c28_m_x;
  real_T c28_t_y;
  real_T c28_n_x;
  real_T c28_u_y;
  real_T c28_j_a;
  real_T c28_l_b;
  real_T c28_v_y;
  real_T c28_h_A;
  real_T c28_d_B;
  real_T c28_o_x;
  real_T c28_w_y;
  real_T c28_p_x;
  real_T c28_x_y;
  real_T c28_i_A;
  real_T c28_q_x;
  real_T c28_r_x;
  real_T c28_k_a;
  real_T c28_m_b;
  real_T c28_y_y;
  real_T c28_l_a;
  real_T c28_n_b;
  real_T c28_ab_y;
  real_T c28_m_a;
  real_T c28_o_b;
  real_T c28_bb_y;
  real_T c28_j_A;
  real_T c28_s_x;
  real_T c28_t_x;
  real_T c28_cb_y;
  real_T c28_n_a;
  real_T c28_p_b;
  real_T c28_db_y;
  real_T c28_k_A;
  real_T c28_e_B;
  real_T c28_u_x;
  real_T c28_eb_y;
  real_T c28_v_x;
  real_T c28_fb_y;
  real_T c28_l_A;
  real_T c28_w_x;
  real_T c28_x_x;
  real_T c28_b_omega_wheel_dot_fl[4];
  int32_T c28_i7;
  int32_T c28_i8;
  real_T c28_gb_y;
  real_T c28_m_A;
  real_T c28_hb_y;
  real_T c28_o_a;
  real_T c28_q_b;
  real_T c28_ib_y;
  real_T c28_n_A;
  real_T c28_o_A;
  real_T c28_f_B;
  real_T c28_jb_y;
  real_T c28_p_A;
  real_T c28_kb_y;
  real_T c28_p_a;
  real_T c28_r_b;
  real_T c28_lb_y;
  real_T c28_q_A;
  real_T c28_r_A;
  real_T c28_g_B;
  real_T c28_mb_y;
  real_T c28_s_A;
  real_T c28_nb_y;
  real_T c28_q_a;
  real_T c28_s_b;
  real_T c28_ob_y;
  real_T c28_t_A;
  real_T c28_u_A;
  real_T c28_h_B;
  real_T c28_pb_y;
  real_T c28_v_A;
  real_T c28_qb_y;
  real_T c28_r_a;
  real_T c28_t_b;
  real_T c28_rb_y;
  real_T c28_w_A;
  real_T c28_x_A;
  real_T c28_i_B;
  real_T c28_y_A;
  real_T c28_sb_y;
  real_T c28_s_a;
  real_T c28_u_b;
  real_T c28_tb_y;
  real_T c28_v_b;
  real_T c28_ub_y;
  real_T c28_t_a;
  real_T c28_w_b;
  real_T c28_vb_y;
  real_T c28_x_b;
  real_T c28_y_x;
  real_T c28_ab_x;
  real_T c28_bb_x;
  real_T c28_cb_x;
  real_T c28_db_x;
  real_T c28_wb_y;
  real_T c28_eb_x;
  real_T c28_xb_y;
  real_T c28_fb_x;
  real_T c28_gb_x;
  real_T c28_hb_x;
  real_T c28_ib_x;
  real_T c28_jb_x;
  real_T c28_yb_y;
  real_T c28_kb_x;
  real_T c28_ac_y;
  real_T c28_lb_x;
  real_T c28_mb_x;
  real_T c28_nb_x;
  real_T c28_ob_x;
  real_T c28_pb_x;
  real_T c28_bc_y;
  real_T c28_qb_x;
  real_T c28_cc_y;
  real_T c28_rb_x;
  real_T c28_sb_x;
  real_T c28_tb_x;
  real_T c28_ub_x;
  real_T c28_vb_x;
  real_T c28_dc_y;
  real_T c28_wb_x;
  real_T c28_ec_y;
  real_T c28_xb_x;
  real_T c28_yb_x;
  real_T *c28_b_omega_m;
  real_T *c28_b_T_m;
  real_T (*c28_b_omega_wheel_dot)[4];
  real_T (*c28_b_omega_wheel)[4];
  real_T (*c28_b_Fx_wheel)[4];
  c28_b_omega_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c28_b_omega_wheel_dot = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
    2);
  c28_b_Fx_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c28_b_T_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c28_b_omega_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 16U, chartInstance->c28_sfEvent);
  c28_hoistedGlobal = *c28_b_T_m;
  c28_b_hoistedGlobal = chartInstance->c28_diff_lock;
  c28_c_hoistedGlobal = chartInstance->c28_wheel_drive;
  c28_d_hoistedGlobal = chartInstance->c28_r_wheel;
  c28_e_hoistedGlobal = chartInstance->c28_I_motor;
  c28_f_hoistedGlobal = chartInstance->c28_I_wheel;
  c28_T_m = c28_hoistedGlobal;
  c28_b_diff_lock = c28_b_hoistedGlobal;
  c28_b_wheel_drive = c28_c_hoistedGlobal;
  c28_b_r_wheel = c28_d_hoistedGlobal;
  c28_b_I_motor = c28_e_hoistedGlobal;
  c28_b_I_wheel = c28_f_hoistedGlobal;
  for (c28_i5 = 0; c28_i5 < 4; c28_i5++) {
    c28_Fx_wheel[c28_i5] = (*c28_b_Fx_wheel)[c28_i5];
  }

  for (c28_i6 = 0; c28_i6 < 4; c28_i6++) {
    c28_omega_wheel[c28_i6] = (*c28_b_omega_wheel)[c28_i6];
  }

  sf_debug_symbol_scope_push_eml(0U, 28U, 28U, c28_debug_family_names,
    c28_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c28_Fx_fl, 0U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_Fx_fr, 1U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_Fx_rl, 2U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_Fx_rr, 3U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_fl, 4U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_fr, 5U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_rl, 6U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_rr, 7U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_Fx_front, 8U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_Fx_rear, 9U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_dot_front, 10U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_dot_fl, 11U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_dot_fr, 12U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_dot_rl, 13U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_dot_rr, 14U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_wheel_dot_rear, 15U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_nargin, 16U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_nargout, 17U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c28_T_m, 18U, c28_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c28_b_diff_lock, 19U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_b_wheel_drive, 20U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_b_r_wheel, 21U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_b_I_motor, 22U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_b_I_wheel, 23U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c28_Fx_wheel, 24U, c28_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c28_omega_wheel, 25U, c28_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c28_omega_m, 26U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c28_omega_wheel_dot, 27U,
    c28_sf_marshallOut, c28_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 4);
  c28_Fx_fl = c28_Fx_wheel[0];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 5);
  c28_Fx_fr = c28_Fx_wheel[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 6);
  c28_Fx_rl = c28_Fx_wheel[2];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 7);
  c28_Fx_rr = c28_Fx_wheel[3];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 10);
  c28_omega_wheel_fl = c28_omega_wheel[0];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 11);
  c28_omega_wheel_fr = c28_omega_wheel[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 12);
  c28_omega_wheel_rl = c28_omega_wheel[2];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 13);
  c28_omega_wheel_rr = c28_omega_wheel[3];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 15);
  if (CV_EML_IF(0, 1, 0, c28_b_diff_lock != 0.0) != 0.0) {
    _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 17);
    c28_Fx_front = c28_Fx_fl + c28_Fx_fr;
    _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 18);
    c28_Fx_rear = c28_Fx_rl + c28_Fx_rr;
    _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 20);
    switch ((int32_T)_SFD_INTEGER_CHECK("wheel_drive", c28_b_wheel_drive)) {
     case 1:
      CV_EML_SWITCH(0, 1, 0, 1);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 23);
      c28_a = c28_b_r_wheel;
      c28_b = c28_Fx_front;
      c28_y = c28_a * c28_b;
      c28_b_b = c28_b_I_wheel;
      c28_b_y = 2.0 * c28_b_b;
      c28_omega_wheel_dot_front = c28_mrdivide(chartInstance, c28_T_m - c28_y,
        c28_b_y + c28_b_I_motor);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 25);
      c28_omega_wheel_dot_fl = c28_omega_wheel_dot_front;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 26);
      c28_omega_wheel_dot_fr = c28_omega_wheel_dot_front;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 27);
      c28_b_a = -c28_b_r_wheel;
      c28_c_b = c28_Fx_rl;
      c28_c_y = c28_b_a * c28_c_b;
      c28_omega_wheel_dot_rl = c28_mrdivide(chartInstance, c28_c_y,
        c28_b_I_wheel);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 28);
      c28_c_a = -c28_b_r_wheel;
      c28_d_b = c28_Fx_rr;
      c28_d_y = c28_c_a * c28_d_b;
      c28_omega_wheel_dot_rr = c28_mrdivide(chartInstance, c28_d_y,
        c28_b_I_wheel);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 30);
      c28_omega_m = c28_mrdivide(chartInstance, c28_omega_wheel_fl +
        c28_omega_wheel_fr, 2.0);
      break;

     case 2:
      CV_EML_SWITCH(0, 1, 0, 2);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 34);
      c28_d_a = c28_b_r_wheel;
      c28_e_b = c28_Fx_rear;
      c28_e_y = c28_d_a * c28_e_b;
      c28_f_b = c28_b_I_wheel;
      c28_f_y = 2.0 * c28_f_b;
      c28_omega_wheel_dot_rear = c28_mrdivide(chartInstance, c28_T_m - c28_e_y,
        c28_f_y + c28_b_I_motor);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 36);
      c28_e_a = -c28_b_r_wheel;
      c28_g_b = c28_Fx_fl;
      c28_g_y = c28_e_a * c28_g_b;
      c28_omega_wheel_dot_fl = c28_mrdivide(chartInstance, c28_g_y,
        c28_b_I_wheel);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 37);
      c28_f_a = -c28_b_r_wheel;
      c28_h_b = c28_Fx_fr;
      c28_h_y = c28_f_a * c28_h_b;
      c28_omega_wheel_dot_fr = c28_mrdivide(chartInstance, c28_h_y,
        c28_b_I_wheel);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 38);
      c28_omega_wheel_dot_rl = c28_omega_wheel_dot_rear;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 39);
      c28_omega_wheel_dot_rr = c28_omega_wheel_dot_rear;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 41);
      c28_omega_m = c28_mrdivide(chartInstance, c28_omega_wheel_rl +
        c28_omega_wheel_rr, 2.0);
      break;

     default:
      CV_EML_SWITCH(0, 1, 0, 0);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 45);
      c28_s_a = c28_b_r_wheel;
      c28_u_b = c28_Fx_front;
      c28_sb_y = c28_s_a * c28_u_b;
      c28_v_b = c28_b_I_wheel;
      c28_tb_y = 2.0 * c28_v_b;
      c28_omega_wheel_dot_front = c28_mrdivide(chartInstance, c28_mrdivide
        (chartInstance, c28_T_m, 2.0) - c28_sb_y, c28_tb_y + c28_mrdivide
        (chartInstance, c28_b_I_motor, 2.0));
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 46);
      c28_t_a = c28_b_r_wheel;
      c28_w_b = c28_Fx_rear;
      c28_ub_y = c28_t_a * c28_w_b;
      c28_x_b = c28_b_I_wheel;
      c28_vb_y = 2.0 * c28_x_b;
      c28_omega_wheel_dot_rear = c28_mrdivide(chartInstance, c28_mrdivide
        (chartInstance, c28_T_m, 2.0) - c28_ub_y, c28_vb_y + c28_mrdivide
        (chartInstance, c28_b_I_motor, 2.0));
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 48);
      c28_omega_wheel_dot_fl = c28_omega_wheel_dot_front;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 49);
      c28_omega_wheel_dot_fr = c28_omega_wheel_dot_front;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 50);
      c28_omega_wheel_dot_rl = c28_omega_wheel_dot_rear;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 51);
      c28_omega_wheel_dot_rr = c28_omega_wheel_dot_rear;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 53);
      c28_omega_m = c28_mrdivide(chartInstance, ((c28_omega_wheel_fl +
        c28_omega_wheel_fr) + c28_omega_wheel_rl) + c28_omega_wheel_rr, 4.0);
      break;
    }
  } else {
    _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 57);
    switch ((int32_T)_SFD_INTEGER_CHECK("wheel_drive", c28_b_wheel_drive)) {
     case 1:
      CV_EML_SWITCH(0, 1, 1, 1);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 60);
      c28_A = c28_T_m;
      c28_x = c28_A;
      c28_b_x = c28_x;
      c28_i_y = c28_b_x / 2.0;
      c28_g_a = c28_b_r_wheel;
      c28_i_b = c28_Fx_fl;
      c28_j_y = c28_g_a * c28_i_b;
      c28_b_A = c28_b_I_motor;
      c28_c_x = c28_b_A;
      c28_d_x = c28_c_x;
      c28_k_y = c28_d_x / 2.0;
      c28_c_A = c28_i_y - c28_j_y;
      c28_B = c28_b_I_wheel + c28_k_y;
      c28_e_x = c28_c_A;
      c28_l_y = c28_B;
      c28_f_x = c28_e_x;
      c28_m_y = c28_l_y;
      c28_omega_wheel_dot_fl = c28_f_x / c28_m_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 61);
      c28_d_A = c28_T_m;
      c28_g_x = c28_d_A;
      c28_h_x = c28_g_x;
      c28_n_y = c28_h_x / 2.0;
      c28_h_a = c28_b_r_wheel;
      c28_j_b = c28_Fx_fr;
      c28_o_y = c28_h_a * c28_j_b;
      c28_e_A = c28_b_I_motor;
      c28_i_x = c28_e_A;
      c28_j_x = c28_i_x;
      c28_p_y = c28_j_x / 2.0;
      c28_f_A = c28_n_y - c28_o_y;
      c28_b_B = c28_b_I_wheel + c28_p_y;
      c28_k_x = c28_f_A;
      c28_q_y = c28_b_B;
      c28_l_x = c28_k_x;
      c28_r_y = c28_q_y;
      c28_omega_wheel_dot_fr = c28_l_x / c28_r_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 62);
      c28_i_a = -c28_b_r_wheel;
      c28_k_b = c28_Fx_rl;
      c28_s_y = c28_i_a * c28_k_b;
      c28_g_A = c28_s_y;
      c28_c_B = c28_b_I_wheel;
      c28_m_x = c28_g_A;
      c28_t_y = c28_c_B;
      c28_n_x = c28_m_x;
      c28_u_y = c28_t_y;
      c28_omega_wheel_dot_rl = c28_n_x / c28_u_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 63);
      c28_j_a = -c28_b_r_wheel;
      c28_l_b = c28_Fx_rr;
      c28_v_y = c28_j_a * c28_l_b;
      c28_h_A = c28_v_y;
      c28_d_B = c28_b_I_wheel;
      c28_o_x = c28_h_A;
      c28_w_y = c28_d_B;
      c28_p_x = c28_o_x;
      c28_x_y = c28_w_y;
      c28_omega_wheel_dot_rr = c28_p_x / c28_x_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 65);
      c28_i_A = c28_omega_wheel_fl + c28_omega_wheel_fr;
      c28_q_x = c28_i_A;
      c28_r_x = c28_q_x;
      c28_omega_m = c28_r_x / 2.0;
      break;

     case 2:
      CV_EML_SWITCH(0, 1, 1, 2);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 69);
      c28_k_a = -c28_b_r_wheel;
      c28_m_b = c28_Fx_fl;
      c28_y_y = c28_k_a * c28_m_b;
      c28_omega_wheel_dot_fl = c28_mrdivide(chartInstance, c28_y_y,
        c28_b_I_wheel + c28_mrdivide(chartInstance, c28_b_I_motor, 2.0));
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 70);
      c28_l_a = -c28_b_r_wheel;
      c28_n_b = c28_Fx_fr;
      c28_ab_y = c28_l_a * c28_n_b;
      c28_omega_wheel_dot_fr = c28_mrdivide(chartInstance, c28_ab_y,
        c28_b_I_wheel + c28_mrdivide(chartInstance, c28_b_I_motor, 2.0));
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 71);
      c28_m_a = c28_b_r_wheel;
      c28_o_b = c28_Fx_rl;
      c28_bb_y = c28_m_a * c28_o_b;
      c28_omega_wheel_dot_rl = c28_mrdivide(chartInstance, c28_mrdivide
        (chartInstance, c28_T_m, 2.0) - c28_bb_y, c28_b_I_wheel);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 72);
      c28_j_A = c28_T_m;
      c28_s_x = c28_j_A;
      c28_t_x = c28_s_x;
      c28_cb_y = c28_t_x / 2.0;
      c28_n_a = c28_b_r_wheel;
      c28_p_b = c28_Fx_rr;
      c28_db_y = c28_n_a * c28_p_b;
      c28_k_A = c28_cb_y - c28_db_y;
      c28_e_B = c28_b_I_wheel;
      c28_u_x = c28_k_A;
      c28_eb_y = c28_e_B;
      c28_v_x = c28_u_x;
      c28_fb_y = c28_eb_y;
      c28_omega_wheel_dot_rr = c28_v_x / c28_fb_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 74);
      c28_l_A = c28_omega_wheel_rl + c28_omega_wheel_rr;
      c28_w_x = c28_l_A;
      c28_x_x = c28_w_x;
      c28_omega_m = c28_x_x / 2.0;
      break;

     default:
      CV_EML_SWITCH(0, 1, 1, 0);
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 78);
      c28_m_A = c28_T_m;
      c28_y_x = c28_m_A;
      c28_ab_x = c28_y_x;
      c28_gb_y = c28_ab_x / 4.0;
      c28_o_a = c28_b_r_wheel;
      c28_q_b = c28_Fx_fl;
      c28_hb_y = c28_o_a * c28_q_b;
      c28_n_A = c28_b_I_motor;
      c28_bb_x = c28_n_A;
      c28_cb_x = c28_bb_x;
      c28_ib_y = c28_cb_x / 4.0;
      c28_o_A = c28_gb_y - c28_hb_y;
      c28_f_B = c28_b_I_wheel + c28_ib_y;
      c28_db_x = c28_o_A;
      c28_wb_y = c28_f_B;
      c28_eb_x = c28_db_x;
      c28_xb_y = c28_wb_y;
      c28_omega_wheel_dot_fl = c28_eb_x / c28_xb_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 79);
      c28_p_A = c28_T_m;
      c28_fb_x = c28_p_A;
      c28_gb_x = c28_fb_x;
      c28_jb_y = c28_gb_x / 4.0;
      c28_p_a = c28_b_r_wheel;
      c28_r_b = c28_Fx_fr;
      c28_kb_y = c28_p_a * c28_r_b;
      c28_q_A = c28_b_I_motor;
      c28_hb_x = c28_q_A;
      c28_ib_x = c28_hb_x;
      c28_lb_y = c28_ib_x / 4.0;
      c28_r_A = c28_jb_y - c28_kb_y;
      c28_g_B = c28_b_I_wheel + c28_lb_y;
      c28_jb_x = c28_r_A;
      c28_yb_y = c28_g_B;
      c28_kb_x = c28_jb_x;
      c28_ac_y = c28_yb_y;
      c28_omega_wheel_dot_fr = c28_kb_x / c28_ac_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 80);
      c28_s_A = c28_T_m;
      c28_lb_x = c28_s_A;
      c28_mb_x = c28_lb_x;
      c28_mb_y = c28_mb_x / 4.0;
      c28_q_a = c28_b_r_wheel;
      c28_s_b = c28_Fx_rl;
      c28_nb_y = c28_q_a * c28_s_b;
      c28_t_A = c28_b_I_motor;
      c28_nb_x = c28_t_A;
      c28_ob_x = c28_nb_x;
      c28_ob_y = c28_ob_x / 4.0;
      c28_u_A = c28_mb_y - c28_nb_y;
      c28_h_B = c28_b_I_wheel + c28_ob_y;
      c28_pb_x = c28_u_A;
      c28_bc_y = c28_h_B;
      c28_qb_x = c28_pb_x;
      c28_cc_y = c28_bc_y;
      c28_omega_wheel_dot_rl = c28_qb_x / c28_cc_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 81);
      c28_v_A = c28_T_m;
      c28_rb_x = c28_v_A;
      c28_sb_x = c28_rb_x;
      c28_pb_y = c28_sb_x / 4.0;
      c28_r_a = c28_b_r_wheel;
      c28_t_b = c28_Fx_rr;
      c28_qb_y = c28_r_a * c28_t_b;
      c28_w_A = c28_b_I_motor;
      c28_tb_x = c28_w_A;
      c28_ub_x = c28_tb_x;
      c28_rb_y = c28_ub_x / 4.0;
      c28_x_A = c28_pb_y - c28_qb_y;
      c28_i_B = c28_b_I_wheel + c28_rb_y;
      c28_vb_x = c28_x_A;
      c28_dc_y = c28_i_B;
      c28_wb_x = c28_vb_x;
      c28_ec_y = c28_dc_y;
      c28_omega_wheel_dot_rr = c28_wb_x / c28_ec_y;
      _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 83);
      c28_y_A = ((c28_omega_wheel_fl + c28_omega_wheel_fr) + c28_omega_wheel_rl)
        + c28_omega_wheel_rr;
      c28_xb_x = c28_y_A;
      c28_yb_x = c28_xb_x;
      c28_omega_m = c28_yb_x / 4.0;
      break;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 88);
  c28_b_omega_wheel_dot_fl[0] = c28_omega_wheel_dot_fl;
  c28_b_omega_wheel_dot_fl[1] = c28_omega_wheel_dot_fr;
  c28_b_omega_wheel_dot_fl[2] = c28_omega_wheel_dot_rl;
  c28_b_omega_wheel_dot_fl[3] = c28_omega_wheel_dot_rr;
  for (c28_i7 = 0; c28_i7 < 4; c28_i7++) {
    c28_omega_wheel_dot[c28_i7] = c28_b_omega_wheel_dot_fl[c28_i7];
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, -88);
  sf_debug_symbol_scope_pop();
  *c28_b_omega_m = c28_omega_m;
  for (c28_i8 = 0; c28_i8 < 4; c28_i8++) {
    (*c28_b_omega_wheel_dot)[c28_i8] = c28_omega_wheel_dot[c28_i8];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 16U, chartInstance->c28_sfEvent);
}

static void initSimStructsc28_carsim(SFc28_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c28_machineNumber, uint32_T
  c28_chartNumber)
{
}

static const mxArray *c28_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i9;
  real_T c28_b_inData[4];
  int32_T c28_i10;
  real_T c28_u[4];
  const mxArray *c28_y = NULL;
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  for (c28_i9 = 0; c28_i9 < 4; c28_i9++) {
    c28_b_inData[c28_i9] = (*(real_T (*)[4])c28_inData)[c28_i9];
  }

  for (c28_i10 = 0; c28_i10 < 4; c28_i10++) {
    c28_u[c28_i10] = c28_b_inData[c28_i10];
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_omega_wheel_dot, const char_T *c28_identifier, real_T
  c28_y[4])
{
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_omega_wheel_dot),
    &c28_thisId, c28_y);
  sf_mex_destroy(&c28_omega_wheel_dot);
}

static void c28_b_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[4])
{
  real_T c28_dv1[4];
  int32_T c28_i11;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv1, 1, 0, 0U, 1, 0U, 1, 4);
  for (c28_i11 = 0; c28_i11 < 4; c28_i11++) {
    c28_y[c28_i11] = c28_dv1[c28_i11];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_omega_wheel_dot;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[4];
  int32_T c28_i12;
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)chartInstanceVoid;
  c28_omega_wheel_dot = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_omega_wheel_dot),
    &c28_thisId, c28_y);
  sf_mex_destroy(&c28_omega_wheel_dot);
  for (c28_i12 = 0; c28_i12 < 4; c28_i12++) {
    (*(real_T (*)[4])c28_outData)[c28_i12] = c28_y[c28_i12];
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_b_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  real_T c28_u;
  const mxArray *c28_y = NULL;
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_u = *(real_T *)c28_inData;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", &c28_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static real_T c28_c_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_omega_m, const char_T *c28_identifier)
{
  real_T c28_y;
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_omega_m),
    &c28_thisId);
  sf_mex_destroy(&c28_omega_m);
  return c28_y;
}

static real_T c28_d_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  real_T c28_y;
  real_T c28_d5;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_d5, 1, 0, 0U, 0, 0U, 0);
  c28_y = c28_d5;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void c28_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_omega_m;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y;
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)chartInstanceVoid;
  c28_omega_m = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_omega_m),
    &c28_thisId);
  sf_mex_destroy(&c28_omega_m);
  *(real_T *)c28_outData = c28_y;
  sf_mex_destroy(&c28_mxArrayInData);
}

const mxArray *sf_c28_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c28_nameCaptureInfo;
  c28_ResolvedFunctionInfo c28_info[4];
  c28_ResolvedFunctionInfo (*c28_b_info)[4];
  const mxArray *c28_m0 = NULL;
  int32_T c28_i13;
  c28_ResolvedFunctionInfo *c28_r0;
  c28_nameCaptureInfo = NULL;
  c28_nameCaptureInfo = NULL;
  c28_b_info = (c28_ResolvedFunctionInfo (*)[4])c28_info;
  (*c28_b_info)[0].context = "";
  (*c28_b_info)[0].name = "mtimes";
  (*c28_b_info)[0].dominantType = "double";
  (*c28_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c28_b_info)[0].fileTimeLo = 1289519692U;
  (*c28_b_info)[0].fileTimeHi = 0U;
  (*c28_b_info)[0].mFileTimeLo = 0U;
  (*c28_b_info)[0].mFileTimeHi = 0U;
  (*c28_b_info)[1].context = "";
  (*c28_b_info)[1].name = "mrdivide";
  (*c28_b_info)[1].dominantType = "double";
  (*c28_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c28_b_info)[1].fileTimeLo = 1310137456U;
  (*c28_b_info)[1].fileTimeHi = 0U;
  (*c28_b_info)[1].mFileTimeLo = 1289519692U;
  (*c28_b_info)[1].mFileTimeHi = 0U;
  (*c28_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c28_b_info)[2].name = "rdivide";
  (*c28_b_info)[2].dominantType = "double";
  (*c28_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c28_b_info)[2].fileTimeLo = 1286818844U;
  (*c28_b_info)[2].fileTimeHi = 0U;
  (*c28_b_info)[2].mFileTimeLo = 0U;
  (*c28_b_info)[2].mFileTimeHi = 0U;
  (*c28_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c28_b_info)[3].name = "eml_div";
  (*c28_b_info)[3].dominantType = "double";
  (*c28_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c28_b_info)[3].fileTimeLo = 1305318000U;
  (*c28_b_info)[3].fileTimeHi = 0U;
  (*c28_b_info)[3].mFileTimeLo = 0U;
  (*c28_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c28_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4), FALSE);
  for (c28_i13 = 0; c28_i13 < 4; c28_i13++) {
    c28_r0 = &c28_info[c28_i13];
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c28_r0->context)), "context", "nameCaptureInfo",
                    c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c28_r0->name)), "name", "nameCaptureInfo",
                    c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      c28_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c28_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c28_r0->resolved)), "resolved",
                    "nameCaptureInfo", c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", &c28_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", &c28_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      &c28_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c28_i13);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      &c28_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c28_i13);
  }

  sf_mex_assign(&c28_nameCaptureInfo, c28_m0, FALSE);
  return c28_nameCaptureInfo;
}

static real_T c28_mrdivide(SFc28_carsimInstanceStruct *chartInstance, real_T
  c28_A, real_T c28_B)
{
  real_T c28_x;
  real_T c28_b_y;
  real_T c28_b_x;
  real_T c28_c_y;
  c28_x = c28_A;
  c28_b_y = c28_B;
  c28_b_x = c28_x;
  c28_c_y = c28_b_y;
  return c28_b_x / c28_c_y;
}

static const mxArray *c28_c_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_u;
  const mxArray *c28_y = NULL;
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_u = *(int32_T *)c28_inData;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", &c28_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static int32_T c28_e_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  int32_T c28_y;
  int32_T c28_i14;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_i14, 1, 6, 0U, 0, 0U, 0);
  c28_y = c28_i14;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void c28_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_b_sfEvent;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  int32_T c28_y;
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)chartInstanceVoid;
  c28_b_sfEvent = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_b_sfEvent),
    &c28_thisId);
  sf_mex_destroy(&c28_b_sfEvent);
  *(int32_T *)c28_outData = c28_y;
  sf_mex_destroy(&c28_mxArrayInData);
}

static uint8_T c28_f_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_b_is_active_c28_carsim, const char_T *c28_identifier)
{
  uint8_T c28_y;
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c28_b_is_active_c28_carsim), &c28_thisId);
  sf_mex_destroy(&c28_b_is_active_c28_carsim);
  return c28_y;
}

static uint8_T c28_g_emlrt_marshallIn(SFc28_carsimInstanceStruct *chartInstance,
  const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  uint8_T c28_y;
  uint8_T c28_u0;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_u0, 1, 3, 0U, 0, 0U, 0);
  c28_y = c28_u0;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void init_dsm_address_info(SFc28_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c28_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2263877460U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3068116357U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(274470656U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2583358264U);
}

mxArray *sf_c28_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("uH0H1uXIdxe70zeNQ4JLHE");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c28_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[28],T\"omega_m\",},{M[1],M[5],T\"omega_wheel_dot\",},{M[8],M[0],T\"is_active_c28_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c28_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc28_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc28_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          28,
          1,
          1,
          10,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"omega_m");
          _SFD_SET_DATA_PROPS(1,1,1,0,"T_m");
          _SFD_SET_DATA_PROPS(2,10,0,0,"diff_lock");
          _SFD_SET_DATA_PROPS(3,10,0,0,"wheel_drive");
          _SFD_SET_DATA_PROPS(4,10,0,0,"r_wheel");
          _SFD_SET_DATA_PROPS(5,10,0,0,"I_motor");
          _SFD_SET_DATA_PROPS(6,10,0,0,"I_wheel");
          _SFD_SET_DATA_PROPS(7,1,1,0,"Fx_wheel");
          _SFD_SET_DATA_PROPS(8,2,0,1,"omega_wheel_dot");
          _SFD_SET_DATA_PROPS(9,1,1,0,"omega_wheel");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,2,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,3525);
        _SFD_CV_INIT_EML_IF(0,1,0,400,412,2026,3409);

        {
          static int caseStart[] = { 1446, 537, 1000 };

          static int caseExprEnd[] = { 1455, 543, 1006 };

          _SFD_CV_INIT_EML_SWITCH(0,1,0,510,529,2025,3,&(caseStart[0]),
            &(caseExprEnd[0]));
        }

        {
          static int caseStart[] = { 2921, 2094, 2506 };

          static int caseExprEnd[] = { 2930, 2100, 2512 };

          _SFD_CV_INIT_EML_SWITCH(0,1,1,2067,2086,3405,3,&(caseStart[0]),
            &(caseExprEnd[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)
            c28_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T *c28_omega_m;
          real_T *c28_T_m;
          real_T (*c28_Fx_wheel)[4];
          real_T (*c28_omega_wheel_dot)[4];
          real_T (*c28_omega_wheel)[4];
          c28_omega_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S,
            2);
          c28_omega_wheel_dot = (real_T (*)[4])ssGetOutputPortSignal
            (chartInstance->S, 2);
          c28_Fx_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c28_T_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          c28_omega_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c28_omega_m);
          _SFD_SET_DATA_VALUE_PTR(1U, c28_T_m);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c28_diff_lock);
          _SFD_SET_DATA_VALUE_PTR(3U, &chartInstance->c28_wheel_drive);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c28_r_wheel);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c28_I_motor);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance->c28_I_wheel);
          _SFD_SET_DATA_VALUE_PTR(7U, *c28_Fx_wheel);
          _SFD_SET_DATA_VALUE_PTR(8U, *c28_omega_wheel_dot);
          _SFD_SET_DATA_VALUE_PTR(9U, *c28_omega_wheel);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c28_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc28_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
  initialize_c28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c28_carsim(void *chartInstanceVar)
{
  enable_c28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c28_carsim(void *chartInstanceVar)
{
  disable_c28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c28_carsim(void *chartInstanceVar)
{
  sf_c28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c28_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c28_carsim((SFc28_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c28_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c28_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c28_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c28_carsim((SFc28_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c28_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c28_carsim(S);
}

static void sf_opaque_set_sim_state_c28_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c28_carsim(S, st);
}

static void sf_opaque_terminate_c28_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc28_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc28_carsim((SFc28_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c28_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c28_carsim((SFc28_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c28_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     I_motor I_wheel diff_lock r_wheel wheel_drive
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4", "p5" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for I_motor*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for I_wheel*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for diff_lock*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for r_wheel*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for wheel_drive*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,28);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,28,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,28,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,28,3);
      sf_mark_chart_reusable_outputs(S,infoStruct,28,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,28);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(346435227U));
  ssSetChecksum1(S,(2969465334U));
  ssSetChecksum2(S,(237108885U));
  ssSetChecksum3(S,(2791844614U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c28_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c28_carsim(SimStruct *S)
{
  SFc28_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc28_carsimInstanceStruct *)malloc(sizeof
    (SFc28_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc28_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c28_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c28_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c28_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c28_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c28_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c28_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c28_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c28_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c28_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c28_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c28_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c28_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c28_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c28_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c28_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c28_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
