#ifndef __c7_carsim_h__
#define __c7_carsim_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c7_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  real_T c7_betaprev_d;
  real_T c7_chiprev;
  real_T c7_chiprev_d;
  real_T c7_psi0;
  real_T c7_psidotprev_d;
  int32_T c7_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c7_betaprev_d_not_empty;
  boolean_T c7_chiprev_d_not_empty;
  boolean_T c7_chiprev_not_empty;
  boolean_T c7_doneDoubleBufferReInit;
  boolean_T c7_isStable;
  boolean_T c7_psidotprev_d_not_empty;
  uint8_T c7_is_active_c7_carsim;
  ChartInfoStruct chartInfo;
} SFc7_carsimInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c7_carsim_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c7_carsim_get_check_sum(mxArray *plhs[]);
extern void c7_carsim_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
