/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c9_carsim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c9_debug_family_names[38] = { "rollrate", "pitchrate",
  "psidot", "betadot_d", "chidot_d", "chidot", "psiddot_d", "psidot_e", "k1",
  "k2", "p", "k_p", "k_i", "z1", "a1", "a1dot", "z2", "nargin", "nargout",
  "speed", "beta", "rates", "beta_d", "I_x", "I_y", "I_z", "speed_d",
  "derivatives", "psidot_ff", "intV_e", "thetahat", "X", "N", "psidot_d",
  "toWorkspace", "V_e", "thetahat_dot", "a1prev" };

/* Function Declarations */
static void initialize_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void initialize_params_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void enable_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void disable_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void c9_update_debugger_state_c9_carsim(SFc9_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c9_carsim(SFc9_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c9_carsim(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_st);
static void finalize_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void sf_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void c9_chartstep_c9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void initSimStructsc9_carsim(SFc9_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c9_machineNumber, uint32_T
  c9_chartNumber);
static const mxArray *c9_sf_marshallOut(void *chartInstanceVoid, void *c9_inData);
static real_T c9_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_b_a1prev, const char_T *c9_identifier);
static real_T c9_b_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void c9_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static const mxArray *c9_b_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData);
static real_T c9_c_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_thetahat_dot, const char_T *c9_identifier);
static real_T c9_d_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void c9_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static const mxArray *c9_c_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData);
static void c9_e_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_toWorkspace, const char_T *c9_identifier, real_T c9_y[4]);
static void c9_f_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId, real_T c9_y[4]);
static void c9_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static const mxArray *c9_d_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData);
static const mxArray *c9_e_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData);
static int32_T c9_g_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void c9_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static uint8_T c9_h_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_b_is_active_c9_carsim, const char_T *c9_identifier);
static uint8_T c9_i_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void init_dsm_address_info(SFc9_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
  chartInstance->c9_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c9_a1prev_not_empty = FALSE;
  chartInstance->c9_is_active_c9_carsim = 0U;
}

static void initialize_params_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
  real_T c9_d0;
  real_T c9_d1;
  real_T c9_d2;
  sf_set_error_prefix_string(
    "Error evaluating data 'I_x' in the parent workspace.\n");
  sf_mex_import_named("I_x", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c9_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c9_I_x = c9_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_y' in the parent workspace.\n");
  sf_mex_import_named("I_y", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c9_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c9_I_y = c9_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_z' in the parent workspace.\n");
  sf_mex_import_named("I_z", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c9_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c9_I_z = c9_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c9_update_debugger_state_c9_carsim(SFc9_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c9_carsim(SFc9_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c9_st;
  const mxArray *c9_y = NULL;
  real_T c9_hoistedGlobal;
  real_T c9_u;
  const mxArray *c9_b_y = NULL;
  real_T c9_b_hoistedGlobal;
  real_T c9_b_u;
  const mxArray *c9_c_y = NULL;
  real_T c9_c_hoistedGlobal;
  real_T c9_c_u;
  const mxArray *c9_d_y = NULL;
  real_T c9_d_hoistedGlobal;
  real_T c9_d_u;
  const mxArray *c9_e_y = NULL;
  real_T c9_e_hoistedGlobal;
  real_T c9_e_u;
  const mxArray *c9_f_y = NULL;
  int32_T c9_i0;
  real_T c9_f_u[4];
  const mxArray *c9_g_y = NULL;
  real_T c9_f_hoistedGlobal;
  real_T c9_g_u;
  const mxArray *c9_h_y = NULL;
  uint8_T c9_g_hoistedGlobal;
  uint8_T c9_h_u;
  const mxArray *c9_i_y = NULL;
  real_T *c9_N;
  real_T *c9_V_e;
  real_T *c9_X;
  real_T *c9_psidot_d;
  real_T *c9_thetahat_dot;
  real_T (*c9_toWorkspace)[4];
  c9_thetahat_dot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c9_V_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c9_toWorkspace = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c9_psidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_N = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_X = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c9_st = NULL;
  c9_st = NULL;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_createcellarray(8), FALSE);
  c9_hoistedGlobal = *c9_N;
  c9_u = c9_hoistedGlobal;
  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 0, c9_b_y);
  c9_b_hoistedGlobal = *c9_V_e;
  c9_b_u = c9_b_hoistedGlobal;
  c9_c_y = NULL;
  sf_mex_assign(&c9_c_y, sf_mex_create("y", &c9_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 1, c9_c_y);
  c9_c_hoistedGlobal = *c9_X;
  c9_c_u = c9_c_hoistedGlobal;
  c9_d_y = NULL;
  sf_mex_assign(&c9_d_y, sf_mex_create("y", &c9_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 2, c9_d_y);
  c9_d_hoistedGlobal = *c9_psidot_d;
  c9_d_u = c9_d_hoistedGlobal;
  c9_e_y = NULL;
  sf_mex_assign(&c9_e_y, sf_mex_create("y", &c9_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 3, c9_e_y);
  c9_e_hoistedGlobal = *c9_thetahat_dot;
  c9_e_u = c9_e_hoistedGlobal;
  c9_f_y = NULL;
  sf_mex_assign(&c9_f_y, sf_mex_create("y", &c9_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 4, c9_f_y);
  for (c9_i0 = 0; c9_i0 < 4; c9_i0++) {
    c9_f_u[c9_i0] = (*c9_toWorkspace)[c9_i0];
  }

  c9_g_y = NULL;
  sf_mex_assign(&c9_g_y, sf_mex_create("y", c9_f_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c9_y, 5, c9_g_y);
  c9_f_hoistedGlobal = chartInstance->c9_a1prev;
  c9_g_u = c9_f_hoistedGlobal;
  c9_h_y = NULL;
  if (!chartInstance->c9_a1prev_not_empty) {
    sf_mex_assign(&c9_h_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c9_h_y, sf_mex_create("y", &c9_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c9_y, 6, c9_h_y);
  c9_g_hoistedGlobal = chartInstance->c9_is_active_c9_carsim;
  c9_h_u = c9_g_hoistedGlobal;
  c9_i_y = NULL;
  sf_mex_assign(&c9_i_y, sf_mex_create("y", &c9_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 7, c9_i_y);
  sf_mex_assign(&c9_st, c9_y, FALSE);
  return c9_st;
}

static void set_sim_state_c9_carsim(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_st)
{
  const mxArray *c9_u;
  real_T c9_dv0[4];
  int32_T c9_i1;
  real_T *c9_N;
  real_T *c9_V_e;
  real_T *c9_X;
  real_T *c9_psidot_d;
  real_T *c9_thetahat_dot;
  real_T (*c9_toWorkspace)[4];
  c9_thetahat_dot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c9_V_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c9_toWorkspace = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c9_psidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_N = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_X = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c9_doneDoubleBufferReInit = TRUE;
  c9_u = sf_mex_dup(c9_st);
  *c9_N = c9_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u, 0)),
    "N");
  *c9_V_e = c9_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u,
    1)), "V_e");
  *c9_X = c9_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u, 2)),
    "X");
  *c9_psidot_d = c9_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c9_u, 3)), "psidot_d");
  *c9_thetahat_dot = c9_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c9_u, 4)), "thetahat_dot");
  c9_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u, 5)),
                        "toWorkspace", c9_dv0);
  for (c9_i1 = 0; c9_i1 < 4; c9_i1++) {
    (*c9_toWorkspace)[c9_i1] = c9_dv0[c9_i1];
  }

  chartInstance->c9_a1prev = c9_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c9_u, 6)), "a1prev");
  chartInstance->c9_is_active_c9_carsim = c9_h_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c9_u, 7)), "is_active_c9_carsim");
  sf_mex_destroy(&c9_u);
  c9_update_debugger_state_c9_carsim(chartInstance);
  sf_mex_destroy(&c9_st);
}

static void finalize_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
}

static void sf_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
  int32_T c9_i2;
  int32_T c9_i3;
  int32_T c9_i4;
  real_T *c9_X;
  real_T *c9_N;
  real_T *c9_psidot_d;
  real_T *c9_V_e;
  real_T *c9_speed;
  real_T *c9_beta;
  real_T *c9_beta_d;
  real_T *c9_speed_d;
  real_T *c9_psidot_ff;
  real_T *c9_intV_e;
  real_T *c9_thetahat_dot;
  real_T *c9_thetahat;
  real_T (*c9_derivatives)[4];
  real_T (*c9_rates)[3];
  real_T (*c9_toWorkspace)[4];
  c9_thetahat = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c9_thetahat_dot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c9_intV_e = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c9_psidot_ff = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c9_derivatives = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 5);
  c9_speed_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c9_beta_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c9_rates = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c9_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c9_speed = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c9_V_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c9_toWorkspace = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c9_psidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_N = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_X = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 5U, chartInstance->c9_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c9_X, 0U);
  _SFD_DATA_RANGE_CHECK(*c9_N, 1U);
  _SFD_DATA_RANGE_CHECK(*c9_psidot_d, 2U);
  for (c9_i2 = 0; c9_i2 < 4; c9_i2++) {
    _SFD_DATA_RANGE_CHECK((*c9_toWorkspace)[c9_i2], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c9_V_e, 4U);
  _SFD_DATA_RANGE_CHECK(*c9_speed, 5U);
  _SFD_DATA_RANGE_CHECK(*c9_beta, 6U);
  for (c9_i3 = 0; c9_i3 < 3; c9_i3++) {
    _SFD_DATA_RANGE_CHECK((*c9_rates)[c9_i3], 7U);
  }

  _SFD_DATA_RANGE_CHECK(*c9_beta_d, 8U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c9_I_x, 9U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c9_I_y, 10U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c9_I_z, 11U);
  _SFD_DATA_RANGE_CHECK(*c9_speed_d, 12U);
  for (c9_i4 = 0; c9_i4 < 4; c9_i4++) {
    _SFD_DATA_RANGE_CHECK((*c9_derivatives)[c9_i4], 13U);
  }

  _SFD_DATA_RANGE_CHECK(*c9_psidot_ff, 14U);
  _SFD_DATA_RANGE_CHECK(*c9_intV_e, 15U);
  _SFD_DATA_RANGE_CHECK(*c9_thetahat_dot, 16U);
  _SFD_DATA_RANGE_CHECK(*c9_thetahat, 17U);
  chartInstance->c9_sfEvent = CALL_EVENT;
  c9_chartstep_c9_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c9_chartstep_c9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
  real_T c9_hoistedGlobal;
  real_T c9_b_hoistedGlobal;
  real_T c9_c_hoistedGlobal;
  real_T c9_d_hoistedGlobal;
  real_T c9_e_hoistedGlobal;
  real_T c9_f_hoistedGlobal;
  real_T c9_g_hoistedGlobal;
  real_T c9_h_hoistedGlobal;
  real_T c9_i_hoistedGlobal;
  real_T c9_j_hoistedGlobal;
  real_T c9_speed;
  real_T c9_beta;
  int32_T c9_i5;
  real_T c9_rates[3];
  real_T c9_beta_d;
  real_T c9_b_I_x;
  real_T c9_b_I_y;
  real_T c9_b_I_z;
  real_T c9_speed_d;
  int32_T c9_i6;
  real_T c9_derivatives[4];
  real_T c9_psidot_ff;
  real_T c9_intV_e;
  real_T c9_thetahat;
  uint32_T c9_debug_family_var_map[38];
  real_T c9_rollrate;
  real_T c9_pitchrate;
  real_T c9_psidot;
  real_T c9_betadot_d;
  real_T c9_chidot_d;
  real_T c9_chidot;
  real_T c9_psiddot_d;
  real_T c9_psidot_e;
  real_T c9_k1;
  real_T c9_k2;
  real_T c9_p;
  real_T c9_k_p;
  real_T c9_k_i;
  real_T c9_z1;
  real_T c9_a1;
  real_T c9_a1dot;
  real_T c9_z2;
  real_T c9_nargin = 12.0;
  real_T c9_nargout = 6.0;
  real_T c9_X;
  real_T c9_N;
  real_T c9_psidot_d;
  real_T c9_toWorkspace[4];
  real_T c9_V_e;
  real_T c9_thetahat_dot;
  real_T c9_b;
  real_T c9_y;
  real_T c9_k_hoistedGlobal;
  real_T c9_A;
  real_T c9_x;
  real_T c9_b_x;
  real_T c9_b_b;
  real_T c9_a;
  real_T c9_c_b;
  real_T c9_b_y;
  real_T c9_b_a;
  real_T c9_d_b;
  real_T c9_c_y;
  real_T c9_c_a;
  real_T c9_e_b;
  real_T c9_d_y;
  real_T c9_d_a;
  real_T c9_f_b;
  real_T c9_e_y;
  real_T c9_g_b;
  real_T c9_f_y;
  real_T c9_h_b;
  real_T c9_g_y;
  real_T c9_i_b;
  real_T c9_h_y;
  int32_T c9_i7;
  real_T *c9_b_thetahat_dot;
  real_T *c9_b_V_e;
  real_T *c9_b_psidot_d;
  real_T *c9_b_N;
  real_T *c9_b_X;
  real_T *c9_b_thetahat;
  real_T *c9_b_intV_e;
  real_T *c9_b_psidot_ff;
  real_T *c9_b_speed_d;
  real_T *c9_b_beta_d;
  real_T *c9_b_beta;
  real_T *c9_b_speed;
  real_T (*c9_b_toWorkspace)[4];
  real_T (*c9_b_derivatives)[4];
  real_T (*c9_b_rates)[3];
  c9_b_thetahat = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c9_b_thetahat_dot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c9_b_intV_e = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c9_b_psidot_ff = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c9_b_derivatives = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 5);
  c9_b_speed_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c9_b_beta_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c9_b_rates = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c9_b_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c9_b_speed = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c9_b_V_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c9_b_toWorkspace = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c9_b_psidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_b_N = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_b_X = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 5U, chartInstance->c9_sfEvent);
  c9_hoistedGlobal = *c9_b_speed;
  c9_b_hoistedGlobal = *c9_b_beta;
  c9_c_hoistedGlobal = *c9_b_beta_d;
  c9_d_hoistedGlobal = chartInstance->c9_I_x;
  c9_e_hoistedGlobal = chartInstance->c9_I_y;
  c9_f_hoistedGlobal = chartInstance->c9_I_z;
  c9_g_hoistedGlobal = *c9_b_speed_d;
  c9_h_hoistedGlobal = *c9_b_psidot_ff;
  c9_i_hoistedGlobal = *c9_b_intV_e;
  c9_j_hoistedGlobal = *c9_b_thetahat;
  c9_speed = c9_hoistedGlobal;
  c9_beta = c9_b_hoistedGlobal;
  for (c9_i5 = 0; c9_i5 < 3; c9_i5++) {
    c9_rates[c9_i5] = (*c9_b_rates)[c9_i5];
  }

  c9_beta_d = c9_c_hoistedGlobal;
  c9_b_I_x = c9_d_hoistedGlobal;
  c9_b_I_y = c9_e_hoistedGlobal;
  c9_b_I_z = c9_f_hoistedGlobal;
  c9_speed_d = c9_g_hoistedGlobal;
  for (c9_i6 = 0; c9_i6 < 4; c9_i6++) {
    c9_derivatives[c9_i6] = (*c9_b_derivatives)[c9_i6];
  }

  c9_psidot_ff = c9_h_hoistedGlobal;
  c9_intV_e = c9_i_hoistedGlobal;
  c9_thetahat = c9_j_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 38U, 38U, c9_debug_family_names,
    c9_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c9_rollrate, 0U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_pitchrate, 1U,
    c9_b_sf_marshallOut, c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_psidot, 2U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_betadot_d, 3U,
    c9_b_sf_marshallOut, c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_chidot_d, 4U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_chidot, 5U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_psiddot_d, 6U,
    c9_b_sf_marshallOut, c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_psidot_e, 7U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c9_k1, 8U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_k2, 9U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_p, 10U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_k_p, 11U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_k_i, 12U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c9_z1, 13U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_a1, 14U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_a1dot, 15U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_z2, 16U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_nargin, 17U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_nargout, 18U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c9_speed, 19U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_beta, 20U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c9_rates, 21U, c9_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_beta_d, 22U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c9_b_I_x, 23U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_b_I_y, 24U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_b_I_z, 25U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c9_speed_d, 26U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c9_derivatives, 27U, c9_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_psidot_ff, 28U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_intV_e, 29U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c9_thetahat, 30U, c9_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c9_X, 31U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_N, 32U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_psidot_d, 33U,
    c9_b_sf_marshallOut, c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c9_toWorkspace, 34U,
    c9_c_sf_marshallOut, c9_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_V_e, 35U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c9_thetahat_dot, 36U,
    c9_b_sf_marshallOut, c9_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c9_a1prev, 37U,
    c9_sf_marshallOut, c9_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 4);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c9_a1prev_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 5);
    chartInstance->c9_a1prev = 0.0;
    chartInstance->c9_a1prev_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 9);
  c9_rollrate = c9_rates[0];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 10);
  c9_pitchrate = c9_rates[1];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 11);
  c9_psidot = c9_rates[2];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 14);
  c9_betadot_d = c9_derivatives[0];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 15);
  c9_chidot_d = c9_derivatives[1];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 16);
  c9_chidot = c9_derivatives[2];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 17);
  c9_psiddot_d = c9_derivatives[3];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 19);
  c9_psidot_d = c9_chidot_d - c9_betadot_d;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 22);
  c9_V_e = c9_speed - c9_speed_d;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 23);
  c9_psidot_e = c9_psidot - c9_psidot_d;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 26);
  c9_k1 = 7.0;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 27);
  c9_k2 = 300.0;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 28);
  c9_p = 41.0;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 29);
  c9_k_p = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 30);
  c9_k_i = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 33);
  c9_z1 = c9_beta - c9_beta_d;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 34);
  c9_b = c9_z1;
  c9_y = 7.0 * c9_b;
  c9_a1 = (((c9_chidot - c9_psidot_d) - c9_betadot_d) + c9_y) + c9_psidot_ff;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 36);
  c9_k_hoistedGlobal = chartInstance->c9_a1prev;
  c9_A = c9_a1 - c9_k_hoistedGlobal;
  c9_x = c9_A;
  c9_b_x = c9_x;
  c9_a1dot = c9_b_x / 0.001;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 38);
  c9_z2 = c9_psidot_e - c9_a1;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 39);
  c9_b_b = c9_z2;
  c9_thetahat_dot = 41.0 * c9_b_b;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 41);
  c9_a = c9_b_I_x - c9_b_I_y;
  c9_c_b = c9_rollrate;
  c9_b_y = c9_a * c9_c_b;
  c9_b_a = c9_b_y;
  c9_d_b = c9_pitchrate;
  c9_c_y = c9_b_a * c9_d_b;
  c9_c_a = c9_b_I_z;
  c9_e_b = c9_psiddot_d;
  c9_d_y = c9_c_a * c9_e_b;
  c9_d_a = c9_b_I_z;
  c9_f_b = c9_a1dot;
  c9_e_y = c9_d_a * c9_f_b;
  c9_g_b = c9_z2;
  c9_f_y = 300.0 * c9_g_b;
  c9_N = ((((c9_z1 - c9_c_y) - c9_thetahat) + c9_d_y) + c9_e_y) - c9_f_y;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 43);
  c9_toWorkspace[0] = c9_z1;
  c9_toWorkspace[1] = c9_z2;
  c9_toWorkspace[2] = c9_a1;
  c9_toWorkspace[3] = c9_a1dot;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 45);
  chartInstance->c9_a1prev = c9_a1;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 48);
  c9_h_b = c9_V_e;
  c9_g_y = -100.0 * c9_h_b;
  c9_i_b = c9_intV_e;
  c9_h_y = 100.0 * c9_i_b;
  c9_X = c9_g_y - c9_h_y;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, -48);
  sf_debug_symbol_scope_pop();
  *c9_b_X = c9_X;
  *c9_b_N = c9_N;
  *c9_b_psidot_d = c9_psidot_d;
  for (c9_i7 = 0; c9_i7 < 4; c9_i7++) {
    (*c9_b_toWorkspace)[c9_i7] = c9_toWorkspace[c9_i7];
  }

  *c9_b_V_e = c9_V_e;
  *c9_b_thetahat_dot = c9_thetahat_dot;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 5U, chartInstance->c9_sfEvent);
}

static void initSimStructsc9_carsim(SFc9_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c9_machineNumber, uint32_T
  c9_chartNumber)
{
}

static const mxArray *c9_sf_marshallOut(void *chartInstanceVoid, void *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  real_T c9_u;
  const mxArray *c9_y = NULL;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  c9_u = *(real_T *)c9_inData;
  c9_y = NULL;
  if (!chartInstance->c9_a1prev_not_empty) {
    sf_mex_assign(&c9_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static real_T c9_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_b_a1prev, const char_T *c9_identifier)
{
  real_T c9_y;
  emlrtMsgIdentifier c9_thisId;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_b_a1prev),
    &c9_thisId);
  sf_mex_destroy(&c9_b_a1prev);
  return c9_y;
}

static real_T c9_b_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  real_T c9_y;
  real_T c9_d3;
  if (mxIsEmpty(c9_u)) {
    chartInstance->c9_a1prev_not_empty = FALSE;
  } else {
    chartInstance->c9_a1prev_not_empty = TRUE;
    sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_d3, 1, 0, 0U, 0, 0U, 0);
    c9_y = c9_d3;
  }

  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void c9_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_b_a1prev;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  real_T c9_y;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_b_a1prev = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_b_a1prev),
    &c9_thisId);
  sf_mex_destroy(&c9_b_a1prev);
  *(real_T *)c9_outData = c9_y;
  sf_mex_destroy(&c9_mxArrayInData);
}

static const mxArray *c9_b_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  real_T c9_u;
  const mxArray *c9_y = NULL;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  c9_u = *(real_T *)c9_inData;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static real_T c9_c_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_thetahat_dot, const char_T *c9_identifier)
{
  real_T c9_y;
  emlrtMsgIdentifier c9_thisId;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_thetahat_dot),
    &c9_thisId);
  sf_mex_destroy(&c9_thetahat_dot);
  return c9_y;
}

static real_T c9_d_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  real_T c9_y;
  real_T c9_d4;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_d4, 1, 0, 0U, 0, 0U, 0);
  c9_y = c9_d4;
  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void c9_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_thetahat_dot;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  real_T c9_y;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_thetahat_dot = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_thetahat_dot),
    &c9_thisId);
  sf_mex_destroy(&c9_thetahat_dot);
  *(real_T *)c9_outData = c9_y;
  sf_mex_destroy(&c9_mxArrayInData);
}

static const mxArray *c9_c_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  int32_T c9_i8;
  real_T c9_b_inData[4];
  int32_T c9_i9;
  real_T c9_u[4];
  const mxArray *c9_y = NULL;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  for (c9_i8 = 0; c9_i8 < 4; c9_i8++) {
    c9_b_inData[c9_i8] = (*(real_T (*)[4])c9_inData)[c9_i8];
  }

  for (c9_i9 = 0; c9_i9 < 4; c9_i9++) {
    c9_u[c9_i9] = c9_b_inData[c9_i9];
  }

  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", c9_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static void c9_e_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_toWorkspace, const char_T *c9_identifier, real_T c9_y[4])
{
  emlrtMsgIdentifier c9_thisId;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_toWorkspace), &c9_thisId,
                        c9_y);
  sf_mex_destroy(&c9_toWorkspace);
}

static void c9_f_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId, real_T c9_y[4])
{
  real_T c9_dv1[4];
  int32_T c9_i10;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), c9_dv1, 1, 0, 0U, 1, 0U, 1, 4);
  for (c9_i10 = 0; c9_i10 < 4; c9_i10++) {
    c9_y[c9_i10] = c9_dv1[c9_i10];
  }

  sf_mex_destroy(&c9_u);
}

static void c9_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_toWorkspace;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  real_T c9_y[4];
  int32_T c9_i11;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_toWorkspace = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_toWorkspace), &c9_thisId,
                        c9_y);
  sf_mex_destroy(&c9_toWorkspace);
  for (c9_i11 = 0; c9_i11 < 4; c9_i11++) {
    (*(real_T (*)[4])c9_outData)[c9_i11] = c9_y[c9_i11];
  }

  sf_mex_destroy(&c9_mxArrayInData);
}

static const mxArray *c9_d_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  int32_T c9_i12;
  real_T c9_b_inData[3];
  int32_T c9_i13;
  real_T c9_u[3];
  const mxArray *c9_y = NULL;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  for (c9_i12 = 0; c9_i12 < 3; c9_i12++) {
    c9_b_inData[c9_i12] = (*(real_T (*)[3])c9_inData)[c9_i12];
  }

  for (c9_i13 = 0; c9_i13 < 3; c9_i13++) {
    c9_u[c9_i13] = c9_b_inData[c9_i13];
  }

  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", c9_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

const mxArray *sf_c9_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c9_nameCaptureInfo;
  c9_ResolvedFunctionInfo c9_info[4];
  c9_ResolvedFunctionInfo (*c9_b_info)[4];
  const mxArray *c9_m0 = NULL;
  int32_T c9_i14;
  c9_ResolvedFunctionInfo *c9_r0;
  c9_nameCaptureInfo = NULL;
  c9_nameCaptureInfo = NULL;
  c9_b_info = (c9_ResolvedFunctionInfo (*)[4])c9_info;
  (*c9_b_info)[0].context = "";
  (*c9_b_info)[0].name = "mtimes";
  (*c9_b_info)[0].dominantType = "double";
  (*c9_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c9_b_info)[0].fileTimeLo = 1289519692U;
  (*c9_b_info)[0].fileTimeHi = 0U;
  (*c9_b_info)[0].mFileTimeLo = 0U;
  (*c9_b_info)[0].mFileTimeHi = 0U;
  (*c9_b_info)[1].context = "";
  (*c9_b_info)[1].name = "mrdivide";
  (*c9_b_info)[1].dominantType = "double";
  (*c9_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c9_b_info)[1].fileTimeLo = 1310137456U;
  (*c9_b_info)[1].fileTimeHi = 0U;
  (*c9_b_info)[1].mFileTimeLo = 1289519692U;
  (*c9_b_info)[1].mFileTimeHi = 0U;
  (*c9_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c9_b_info)[2].name = "rdivide";
  (*c9_b_info)[2].dominantType = "double";
  (*c9_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c9_b_info)[2].fileTimeLo = 1286818844U;
  (*c9_b_info)[2].fileTimeHi = 0U;
  (*c9_b_info)[2].mFileTimeLo = 0U;
  (*c9_b_info)[2].mFileTimeHi = 0U;
  (*c9_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c9_b_info)[3].name = "eml_div";
  (*c9_b_info)[3].dominantType = "double";
  (*c9_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c9_b_info)[3].fileTimeLo = 1305318000U;
  (*c9_b_info)[3].fileTimeHi = 0U;
  (*c9_b_info)[3].mFileTimeLo = 0U;
  (*c9_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c9_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4), FALSE);
  for (c9_i14 = 0; c9_i14 < 4; c9_i14++) {
    c9_r0 = &c9_info[c9_i14];
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c9_r0->context)), "context", "nameCaptureInfo",
                    c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c9_r0->name)), "name", "nameCaptureInfo", c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c9_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c9_r0->resolved)), "resolved", "nameCaptureInfo",
                    c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c9_i14);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c9_i14);
  }

  sf_mex_assign(&c9_nameCaptureInfo, c9_m0, FALSE);
  return c9_nameCaptureInfo;
}

static const mxArray *c9_e_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  int32_T c9_u;
  const mxArray *c9_y = NULL;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  c9_u = *(int32_T *)c9_inData;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static int32_T c9_g_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  int32_T c9_y;
  int32_T c9_i15;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_i15, 1, 6, 0U, 0, 0U, 0);
  c9_y = c9_i15;
  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void c9_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_b_sfEvent;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  int32_T c9_y;
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)chartInstanceVoid;
  c9_b_sfEvent = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_b_sfEvent),
    &c9_thisId);
  sf_mex_destroy(&c9_b_sfEvent);
  *(int32_T *)c9_outData = c9_y;
  sf_mex_destroy(&c9_mxArrayInData);
}

static uint8_T c9_h_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_b_is_active_c9_carsim, const char_T *c9_identifier)
{
  uint8_T c9_y;
  emlrtMsgIdentifier c9_thisId;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c9_b_is_active_c9_carsim), &c9_thisId);
  sf_mex_destroy(&c9_b_is_active_c9_carsim);
  return c9_y;
}

static uint8_T c9_i_emlrt_marshallIn(SFc9_carsimInstanceStruct *chartInstance,
  const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  uint8_T c9_y;
  uint8_T c9_u0;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_u0, 1, 3, 0U, 0, 0U, 0);
  c9_y = c9_u0;
  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void init_dsm_address_info(SFc9_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c9_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3760095404U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1718998296U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2560989560U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1342598080U);
}

mxArray *sf_c9_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("0dWz7jRdeO6nlWNrCOJuk");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,9,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c9_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[33],T\"N\",},{M[1],M[83],T\"V_e\",},{M[1],M[78],T\"X\",},{M[1],M[99],T\"psidot_d\",},{M[1],M[92],T\"thetahat_dot\",},{M[1],M[93],T\"toWorkspace\",},{M[4],M[0],T\"a1prev\",S'l','i','p'{{M1x2[164 170],M[0],}}},{M[8],M[0],T\"is_active_c9_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c9_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc9_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc9_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          9,
          1,
          1,
          18,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"X");
          _SFD_SET_DATA_PROPS(1,2,0,1,"N");
          _SFD_SET_DATA_PROPS(2,2,0,1,"psidot_d");
          _SFD_SET_DATA_PROPS(3,2,0,1,"toWorkspace");
          _SFD_SET_DATA_PROPS(4,2,0,1,"V_e");
          _SFD_SET_DATA_PROPS(5,1,1,0,"speed");
          _SFD_SET_DATA_PROPS(6,1,1,0,"beta");
          _SFD_SET_DATA_PROPS(7,1,1,0,"rates");
          _SFD_SET_DATA_PROPS(8,1,1,0,"beta_d");
          _SFD_SET_DATA_PROPS(9,10,0,0,"I_x");
          _SFD_SET_DATA_PROPS(10,10,0,0,"I_y");
          _SFD_SET_DATA_PROPS(11,10,0,0,"I_z");
          _SFD_SET_DATA_PROPS(12,1,1,0,"speed_d");
          _SFD_SET_DATA_PROPS(13,1,1,0,"derivatives");
          _SFD_SET_DATA_PROPS(14,1,1,0,"psidot_ff");
          _SFD_SET_DATA_PROPS(15,1,1,0,"intV_e");
          _SFD_SET_DATA_PROPS(16,2,0,1,"thetahat_dot");
          _SFD_SET_DATA_PROPS(17,1,1,0,"thetahat");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,968);
        _SFD_CV_INIT_EML_IF(0,1,0,171,189,-1,209);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_c_sf_marshallOut,(MexInFcnForType)
            c9_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)c9_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c9_X;
          real_T *c9_N;
          real_T *c9_psidot_d;
          real_T *c9_V_e;
          real_T *c9_speed;
          real_T *c9_beta;
          real_T *c9_beta_d;
          real_T *c9_speed_d;
          real_T *c9_psidot_ff;
          real_T *c9_intV_e;
          real_T *c9_thetahat_dot;
          real_T *c9_thetahat;
          real_T (*c9_toWorkspace)[4];
          real_T (*c9_rates)[3];
          real_T (*c9_derivatives)[4];
          c9_thetahat = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
          c9_thetahat_dot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c9_intV_e = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
          c9_psidot_ff = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
          c9_derivatives = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S,
            5);
          c9_speed_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c9_beta_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c9_rates = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
          c9_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c9_speed = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          c9_V_e = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c9_toWorkspace = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
            4);
          c9_psidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c9_N = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c9_X = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c9_X);
          _SFD_SET_DATA_VALUE_PTR(1U, c9_N);
          _SFD_SET_DATA_VALUE_PTR(2U, c9_psidot_d);
          _SFD_SET_DATA_VALUE_PTR(3U, *c9_toWorkspace);
          _SFD_SET_DATA_VALUE_PTR(4U, c9_V_e);
          _SFD_SET_DATA_VALUE_PTR(5U, c9_speed);
          _SFD_SET_DATA_VALUE_PTR(6U, c9_beta);
          _SFD_SET_DATA_VALUE_PTR(7U, *c9_rates);
          _SFD_SET_DATA_VALUE_PTR(8U, c9_beta_d);
          _SFD_SET_DATA_VALUE_PTR(9U, &chartInstance->c9_I_x);
          _SFD_SET_DATA_VALUE_PTR(10U, &chartInstance->c9_I_y);
          _SFD_SET_DATA_VALUE_PTR(11U, &chartInstance->c9_I_z);
          _SFD_SET_DATA_VALUE_PTR(12U, c9_speed_d);
          _SFD_SET_DATA_VALUE_PTR(13U, *c9_derivatives);
          _SFD_SET_DATA_VALUE_PTR(14U, c9_psidot_ff);
          _SFD_SET_DATA_VALUE_PTR(15U, c9_intV_e);
          _SFD_SET_DATA_VALUE_PTR(16U, c9_thetahat_dot);
          _SFD_SET_DATA_VALUE_PTR(17U, c9_thetahat);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c9_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc9_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
  initialize_c9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c9_carsim(void *chartInstanceVar)
{
  enable_c9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c9_carsim(void *chartInstanceVar)
{
  disable_c9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c9_carsim(void *chartInstanceVar)
{
  sf_c9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c9_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c9_carsim((SFc9_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c9_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c9_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c9_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c9_carsim((SFc9_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c9_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c9_carsim(S);
}

static void sf_opaque_set_sim_state_c9_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c9_carsim(S, st);
}

static void sf_opaque_terminate_c9_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc9_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc9_carsim((SFc9_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c9_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c9_carsim((SFc9_carsimInstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c9_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     I_x I_y I_z
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for I_x*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for I_y*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for I_z*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,9);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,9,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,9,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,9,9);
      sf_mark_chart_reusable_outputs(S,infoStruct,9,6);
    }

    sf_set_rtw_dwork_info(S,infoStruct,9);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1205189408U));
  ssSetChecksum1(S,(2608539993U));
  ssSetChecksum2(S,(3595151211U));
  ssSetChecksum3(S,(3985209645U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c9_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c9_carsim(SimStruct *S)
{
  SFc9_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc9_carsimInstanceStruct *)malloc(sizeof
    (SFc9_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc9_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c9_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c9_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c9_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c9_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c9_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c9_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c9_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c9_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c9_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c9_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c9_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c9_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c9_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c9_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c9_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c9_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
