/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c11_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c11_debug_family_names[10] = { "u", "v", "nargin", "nargout",
  "v_body", "C_air", "rho_air", "A_front", "A_side", "F_air" };

/* Function Declarations */
static void initialize_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance);
static void initialize_params_c11_ref_gen(SFc11_ref_genInstanceStruct
  *chartInstance);
static void enable_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance);
static void disable_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance);
static void c11_update_debugger_state_c11_ref_gen(SFc11_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c11_ref_gen(SFc11_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_st);
static void finalize_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance);
static void sf_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance);
static void initSimStructsc11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c11_machineNumber, uint32_T
  c11_chartNumber);
static const mxArray *c11_sf_marshallOut(void *chartInstanceVoid, void
  *c11_inData);
static void c11_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_F_air, const char_T *c11_identifier, real_T c11_y[3]);
static void c11_b_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId, real_T c11_y[3]);
static void c11_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c11_mxArrayInData, const char_T *c11_varName, void *c11_outData);
static const mxArray *c11_b_sf_marshallOut(void *chartInstanceVoid, void
  *c11_inData);
static real_T c11_c_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId);
static void c11_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c11_mxArrayInData, const char_T *c11_varName, void *c11_outData);
static real_T c11_mpower(SFc11_ref_genInstanceStruct *chartInstance, real_T
  c11_a);
static const mxArray *c11_c_sf_marshallOut(void *chartInstanceVoid, void
  *c11_inData);
static int32_T c11_d_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId);
static void c11_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c11_mxArrayInData, const char_T *c11_varName, void *c11_outData);
static uint8_T c11_e_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_b_is_active_c11_ref_gen, const char_T *c11_identifier);
static uint8_T c11_f_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId);
static void init_dsm_address_info(SFc11_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c11_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c11_is_active_c11_ref_gen = 0U;
}

static void initialize_params_c11_ref_gen(SFc11_ref_genInstanceStruct
  *chartInstance)
{
  real_T c11_d0;
  real_T c11_d1;
  real_T c11_d2;
  real_T c11_d3;
  sf_set_error_prefix_string(
    "Error evaluating data 'C_air' in the parent workspace.\n");
  sf_mex_import_named("C_air", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c11_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c11_C_air = c11_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'rho_air' in the parent workspace.\n");
  sf_mex_import_named("rho_air", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c11_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c11_rho_air = c11_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'A_front' in the parent workspace.\n");
  sf_mex_import_named("A_front", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c11_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c11_A_front = c11_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'A_side' in the parent workspace.\n");
  sf_mex_import_named("A_side", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c11_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c11_A_side = c11_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c11_update_debugger_state_c11_ref_gen(SFc11_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c11_ref_gen(SFc11_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c11_st;
  const mxArray *c11_y = NULL;
  int32_T c11_i0;
  real_T c11_u[3];
  const mxArray *c11_b_y = NULL;
  uint8_T c11_hoistedGlobal;
  uint8_T c11_b_u;
  const mxArray *c11_c_y = NULL;
  real_T (*c11_F_air)[3];
  c11_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c11_st = NULL;
  c11_st = NULL;
  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_createcellarray(2), FALSE);
  for (c11_i0 = 0; c11_i0 < 3; c11_i0++) {
    c11_u[c11_i0] = (*c11_F_air)[c11_i0];
  }

  c11_b_y = NULL;
  sf_mex_assign(&c11_b_y, sf_mex_create("y", c11_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c11_y, 0, c11_b_y);
  c11_hoistedGlobal = chartInstance->c11_is_active_c11_ref_gen;
  c11_b_u = c11_hoistedGlobal;
  c11_c_y = NULL;
  sf_mex_assign(&c11_c_y, sf_mex_create("y", &c11_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c11_y, 1, c11_c_y);
  sf_mex_assign(&c11_st, c11_y, FALSE);
  return c11_st;
}

static void set_sim_state_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_st)
{
  const mxArray *c11_u;
  real_T c11_dv0[3];
  int32_T c11_i1;
  real_T (*c11_F_air)[3];
  c11_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c11_doneDoubleBufferReInit = TRUE;
  c11_u = sf_mex_dup(c11_st);
  c11_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c11_u, 0)),
                       "F_air", c11_dv0);
  for (c11_i1 = 0; c11_i1 < 3; c11_i1++) {
    (*c11_F_air)[c11_i1] = c11_dv0[c11_i1];
  }

  chartInstance->c11_is_active_c11_ref_gen = c11_e_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c11_u, 1)),
     "is_active_c11_ref_gen");
  sf_mex_destroy(&c11_u);
  c11_update_debugger_state_c11_ref_gen(chartInstance);
  sf_mex_destroy(&c11_st);
}

static void finalize_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance)
{
  int32_T c11_i2;
  int32_T c11_i3;
  real_T c11_hoistedGlobal;
  real_T c11_b_hoistedGlobal;
  real_T c11_c_hoistedGlobal;
  real_T c11_d_hoistedGlobal;
  int32_T c11_i4;
  real_T c11_v_body[3];
  real_T c11_b_C_air;
  real_T c11_b_rho_air;
  real_T c11_b_A_front;
  real_T c11_b_A_side;
  uint32_T c11_debug_family_var_map[10];
  real_T c11_u;
  real_T c11_v;
  real_T c11_nargin = 5.0;
  real_T c11_nargout = 1.0;
  real_T c11_F_air[3];
  real_T c11_b;
  real_T c11_y;
  real_T c11_a;
  real_T c11_b_b;
  real_T c11_b_y;
  real_T c11_b_a;
  real_T c11_c_b;
  real_T c11_c_y;
  real_T c11_c_a;
  real_T c11_d_b;
  real_T c11_d_y;
  real_T c11_x;
  real_T c11_b_x;
  real_T c11_d_a;
  real_T c11_e_b;
  real_T c11_e_y;
  real_T c11_f_b;
  real_T c11_f_y;
  real_T c11_e_a;
  real_T c11_g_b;
  real_T c11_g_y;
  real_T c11_f_a;
  real_T c11_h_b;
  real_T c11_h_y;
  real_T c11_g_a;
  real_T c11_i_b;
  real_T c11_i_y;
  real_T c11_c_x;
  real_T c11_d_x;
  real_T c11_h_a;
  real_T c11_j_b;
  real_T c11_j_y;
  real_T c11_i_a;
  real_T c11_k_y;
  int32_T c11_i5;
  real_T (*c11_b_F_air)[3];
  real_T (*c11_b_v_body)[3];
  c11_b_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c11_b_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 9U, chartInstance->c11_sfEvent);
  for (c11_i2 = 0; c11_i2 < 3; c11_i2++) {
    _SFD_DATA_RANGE_CHECK((*c11_b_v_body)[c11_i2], 0U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c11_C_air, 1U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c11_rho_air, 2U);
  for (c11_i3 = 0; c11_i3 < 3; c11_i3++) {
    _SFD_DATA_RANGE_CHECK((*c11_b_F_air)[c11_i3], 3U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c11_A_front, 4U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c11_A_side, 5U);
  chartInstance->c11_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 9U, chartInstance->c11_sfEvent);
  c11_hoistedGlobal = chartInstance->c11_C_air;
  c11_b_hoistedGlobal = chartInstance->c11_rho_air;
  c11_c_hoistedGlobal = chartInstance->c11_A_front;
  c11_d_hoistedGlobal = chartInstance->c11_A_side;
  for (c11_i4 = 0; c11_i4 < 3; c11_i4++) {
    c11_v_body[c11_i4] = (*c11_b_v_body)[c11_i4];
  }

  c11_b_C_air = c11_hoistedGlobal;
  c11_b_rho_air = c11_b_hoistedGlobal;
  c11_b_A_front = c11_c_hoistedGlobal;
  c11_b_A_side = c11_d_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c11_debug_family_names,
    c11_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c11_u, 0U, c11_b_sf_marshallOut,
    c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c11_v, 1U, c11_b_sf_marshallOut,
    c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c11_nargin, 2U, c11_b_sf_marshallOut,
    c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c11_nargout, 3U,
    c11_b_sf_marshallOut, c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c11_v_body, 4U, c11_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c11_b_C_air, 5U,
    c11_b_sf_marshallOut, c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c11_b_rho_air, 6U,
    c11_b_sf_marshallOut, c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c11_b_A_front, 7U,
    c11_b_sf_marshallOut, c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c11_b_A_side, 8U,
    c11_b_sf_marshallOut, c11_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c11_F_air, 9U, c11_sf_marshallOut,
    c11_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c11_sfEvent, 3);
  c11_u = c11_v_body[0];
  _SFD_EML_CALL(0U, chartInstance->c11_sfEvent, 4);
  c11_v = c11_v_body[1];
  _SFD_EML_CALL(0U, chartInstance->c11_sfEvent, 7);
  c11_b = c11_b_C_air;
  c11_y = 0.5 * c11_b;
  c11_a = c11_y;
  c11_b_b = c11_b_A_front;
  c11_b_y = c11_a * c11_b_b;
  c11_b_a = c11_b_y;
  c11_c_b = c11_b_rho_air;
  c11_c_y = c11_b_a * c11_c_b;
  c11_c_a = c11_c_y;
  c11_d_b = c11_mpower(chartInstance, c11_u);
  c11_d_y = c11_c_a * c11_d_b;
  c11_x = c11_u;
  c11_b_x = c11_x;
  if (c11_b_x > 0.0) {
    c11_b_x = 1.0;
  } else if (c11_b_x < 0.0) {
    c11_b_x = -1.0;
  } else {
    if (c11_b_x == 0.0) {
      c11_b_x = 0.0;
    }
  }

  c11_d_a = c11_d_y;
  c11_e_b = c11_b_x;
  c11_e_y = c11_d_a * c11_e_b;
  c11_f_b = c11_b_C_air;
  c11_f_y = 0.5 * c11_f_b;
  c11_e_a = c11_f_y;
  c11_g_b = c11_b_A_side;
  c11_g_y = c11_e_a * c11_g_b;
  c11_f_a = c11_g_y;
  c11_h_b = c11_b_rho_air;
  c11_h_y = c11_f_a * c11_h_b;
  c11_g_a = c11_h_y;
  c11_i_b = c11_mpower(chartInstance, c11_v);
  c11_i_y = c11_g_a * c11_i_b;
  c11_c_x = c11_v;
  c11_d_x = c11_c_x;
  if (c11_d_x > 0.0) {
    c11_d_x = 1.0;
  } else if (c11_d_x < 0.0) {
    c11_d_x = -1.0;
  } else {
    if (c11_d_x == 0.0) {
      c11_d_x = 0.0;
    }
  }

  c11_h_a = c11_i_y;
  c11_j_b = c11_d_x;
  c11_j_y = c11_h_a * c11_j_b;
  c11_i_a = c11_j_y;
  c11_k_y = c11_i_a * 0.0;
  c11_F_air[0] = c11_e_y;
  c11_F_air[1] = c11_k_y;
  c11_F_air[2] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c11_sfEvent, -7);
  sf_debug_symbol_scope_pop();
  for (c11_i5 = 0; c11_i5 < 3; c11_i5++) {
    (*c11_b_F_air)[c11_i5] = c11_F_air[c11_i5];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 9U, chartInstance->c11_sfEvent);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc11_ref_gen(SFc11_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c11_machineNumber, uint32_T
  c11_chartNumber)
{
}

static const mxArray *c11_sf_marshallOut(void *chartInstanceVoid, void
  *c11_inData)
{
  const mxArray *c11_mxArrayOutData = NULL;
  int32_T c11_i6;
  real_T c11_b_inData[3];
  int32_T c11_i7;
  real_T c11_u[3];
  const mxArray *c11_y = NULL;
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)chartInstanceVoid;
  c11_mxArrayOutData = NULL;
  for (c11_i6 = 0; c11_i6 < 3; c11_i6++) {
    c11_b_inData[c11_i6] = (*(real_T (*)[3])c11_inData)[c11_i6];
  }

  for (c11_i7 = 0; c11_i7 < 3; c11_i7++) {
    c11_u[c11_i7] = c11_b_inData[c11_i7];
  }

  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_create("y", c11_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c11_mxArrayOutData, c11_y, FALSE);
  return c11_mxArrayOutData;
}

static void c11_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_F_air, const char_T *c11_identifier, real_T c11_y[3])
{
  emlrtMsgIdentifier c11_thisId;
  c11_thisId.fIdentifier = c11_identifier;
  c11_thisId.fParent = NULL;
  c11_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c11_F_air), &c11_thisId,
    c11_y);
  sf_mex_destroy(&c11_F_air);
}

static void c11_b_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId, real_T c11_y[3])
{
  real_T c11_dv1[3];
  int32_T c11_i8;
  sf_mex_import(c11_parentId, sf_mex_dup(c11_u), c11_dv1, 1, 0, 0U, 1, 0U, 1, 3);
  for (c11_i8 = 0; c11_i8 < 3; c11_i8++) {
    c11_y[c11_i8] = c11_dv1[c11_i8];
  }

  sf_mex_destroy(&c11_u);
}

static void c11_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c11_mxArrayInData, const char_T *c11_varName, void *c11_outData)
{
  const mxArray *c11_F_air;
  const char_T *c11_identifier;
  emlrtMsgIdentifier c11_thisId;
  real_T c11_y[3];
  int32_T c11_i9;
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)chartInstanceVoid;
  c11_F_air = sf_mex_dup(c11_mxArrayInData);
  c11_identifier = c11_varName;
  c11_thisId.fIdentifier = c11_identifier;
  c11_thisId.fParent = NULL;
  c11_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c11_F_air), &c11_thisId,
    c11_y);
  sf_mex_destroy(&c11_F_air);
  for (c11_i9 = 0; c11_i9 < 3; c11_i9++) {
    (*(real_T (*)[3])c11_outData)[c11_i9] = c11_y[c11_i9];
  }

  sf_mex_destroy(&c11_mxArrayInData);
}

static const mxArray *c11_b_sf_marshallOut(void *chartInstanceVoid, void
  *c11_inData)
{
  const mxArray *c11_mxArrayOutData = NULL;
  real_T c11_u;
  const mxArray *c11_y = NULL;
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)chartInstanceVoid;
  c11_mxArrayOutData = NULL;
  c11_u = *(real_T *)c11_inData;
  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_create("y", &c11_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c11_mxArrayOutData, c11_y, FALSE);
  return c11_mxArrayOutData;
}

static real_T c11_c_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId)
{
  real_T c11_y;
  real_T c11_d4;
  sf_mex_import(c11_parentId, sf_mex_dup(c11_u), &c11_d4, 1, 0, 0U, 0, 0U, 0);
  c11_y = c11_d4;
  sf_mex_destroy(&c11_u);
  return c11_y;
}

static void c11_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c11_mxArrayInData, const char_T *c11_varName, void *c11_outData)
{
  const mxArray *c11_b_A_side;
  const char_T *c11_identifier;
  emlrtMsgIdentifier c11_thisId;
  real_T c11_y;
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)chartInstanceVoid;
  c11_b_A_side = sf_mex_dup(c11_mxArrayInData);
  c11_identifier = c11_varName;
  c11_thisId.fIdentifier = c11_identifier;
  c11_thisId.fParent = NULL;
  c11_y = c11_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c11_b_A_side),
    &c11_thisId);
  sf_mex_destroy(&c11_b_A_side);
  *(real_T *)c11_outData = c11_y;
  sf_mex_destroy(&c11_mxArrayInData);
}

const mxArray *sf_c11_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c11_nameCaptureInfo;
  c11_ResolvedFunctionInfo c11_info[8];
  c11_ResolvedFunctionInfo (*c11_b_info)[8];
  const mxArray *c11_m0 = NULL;
  int32_T c11_i10;
  c11_ResolvedFunctionInfo *c11_r0;
  c11_nameCaptureInfo = NULL;
  c11_nameCaptureInfo = NULL;
  c11_b_info = (c11_ResolvedFunctionInfo (*)[8])c11_info;
  (*c11_b_info)[0].context = "";
  (*c11_b_info)[0].name = "mtimes";
  (*c11_b_info)[0].dominantType = "double";
  (*c11_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c11_b_info)[0].fileTimeLo = 1289519692U;
  (*c11_b_info)[0].fileTimeHi = 0U;
  (*c11_b_info)[0].mFileTimeLo = 0U;
  (*c11_b_info)[0].mFileTimeHi = 0U;
  (*c11_b_info)[1].context = "";
  (*c11_b_info)[1].name = "mpower";
  (*c11_b_info)[1].dominantType = "double";
  (*c11_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c11_b_info)[1].fileTimeLo = 1286818842U;
  (*c11_b_info)[1].fileTimeHi = 0U;
  (*c11_b_info)[1].mFileTimeLo = 0U;
  (*c11_b_info)[1].mFileTimeHi = 0U;
  (*c11_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c11_b_info)[2].name = "power";
  (*c11_b_info)[2].dominantType = "double";
  (*c11_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c11_b_info)[2].fileTimeLo = 1294067944U;
  (*c11_b_info)[2].fileTimeHi = 0U;
  (*c11_b_info)[2].mFileTimeLo = 0U;
  (*c11_b_info)[2].mFileTimeHi = 0U;
  (*c11_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c11_b_info)[3].name = "eml_scalar_eg";
  (*c11_b_info)[3].dominantType = "double";
  (*c11_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c11_b_info)[3].fileTimeLo = 1286818796U;
  (*c11_b_info)[3].fileTimeHi = 0U;
  (*c11_b_info)[3].mFileTimeLo = 0U;
  (*c11_b_info)[3].mFileTimeHi = 0U;
  (*c11_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c11_b_info)[4].name = "eml_scalexp_alloc";
  (*c11_b_info)[4].dominantType = "double";
  (*c11_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  (*c11_b_info)[4].fileTimeLo = 1286818796U;
  (*c11_b_info)[4].fileTimeHi = 0U;
  (*c11_b_info)[4].mFileTimeLo = 0U;
  (*c11_b_info)[4].mFileTimeHi = 0U;
  (*c11_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c11_b_info)[5].name = "eml_scalar_floor";
  (*c11_b_info)[5].dominantType = "double";
  (*c11_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c11_b_info)[5].fileTimeLo = 1286818726U;
  (*c11_b_info)[5].fileTimeHi = 0U;
  (*c11_b_info)[5].mFileTimeLo = 0U;
  (*c11_b_info)[5].mFileTimeHi = 0U;
  (*c11_b_info)[6].context = "";
  (*c11_b_info)[6].name = "sign";
  (*c11_b_info)[6].dominantType = "double";
  (*c11_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  (*c11_b_info)[6].fileTimeLo = 1286818750U;
  (*c11_b_info)[6].fileTimeHi = 0U;
  (*c11_b_info)[6].mFileTimeLo = 0U;
  (*c11_b_info)[6].mFileTimeHi = 0U;
  (*c11_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  (*c11_b_info)[7].name = "eml_scalar_sign";
  (*c11_b_info)[7].dominantType = "double";
  (*c11_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  (*c11_b_info)[7].fileTimeLo = 1286818736U;
  (*c11_b_info)[7].fileTimeHi = 0U;
  (*c11_b_info)[7].mFileTimeLo = 0U;
  (*c11_b_info)[7].mFileTimeHi = 0U;
  sf_mex_assign(&c11_m0, sf_mex_createstruct("nameCaptureInfo", 1, 8), FALSE);
  for (c11_i10 = 0; c11_i10 < 8; c11_i10++) {
    c11_r0 = &c11_info[c11_i10];
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", c11_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c11_r0->context)), "context", "nameCaptureInfo",
                    c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", c11_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c11_r0->name)), "name", "nameCaptureInfo",
                    c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo",
      c11_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c11_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", c11_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c11_r0->resolved)), "resolved",
                    "nameCaptureInfo", c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", &c11_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", &c11_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo",
      &c11_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c11_i10);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo",
      &c11_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c11_i10);
  }

  sf_mex_assign(&c11_nameCaptureInfo, c11_m0, FALSE);
  return c11_nameCaptureInfo;
}

static real_T c11_mpower(SFc11_ref_genInstanceStruct *chartInstance, real_T
  c11_a)
{
  real_T c11_b_a;
  real_T c11_ak;
  c11_b_a = c11_a;
  c11_ak = c11_b_a;
  return muDoubleScalarPower(c11_ak, 2.0);
}

static const mxArray *c11_c_sf_marshallOut(void *chartInstanceVoid, void
  *c11_inData)
{
  const mxArray *c11_mxArrayOutData = NULL;
  int32_T c11_u;
  const mxArray *c11_y = NULL;
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)chartInstanceVoid;
  c11_mxArrayOutData = NULL;
  c11_u = *(int32_T *)c11_inData;
  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_create("y", &c11_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c11_mxArrayOutData, c11_y, FALSE);
  return c11_mxArrayOutData;
}

static int32_T c11_d_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId)
{
  int32_T c11_y;
  int32_T c11_i11;
  sf_mex_import(c11_parentId, sf_mex_dup(c11_u), &c11_i11, 1, 6, 0U, 0, 0U, 0);
  c11_y = c11_i11;
  sf_mex_destroy(&c11_u);
  return c11_y;
}

static void c11_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c11_mxArrayInData, const char_T *c11_varName, void *c11_outData)
{
  const mxArray *c11_b_sfEvent;
  const char_T *c11_identifier;
  emlrtMsgIdentifier c11_thisId;
  int32_T c11_y;
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)chartInstanceVoid;
  c11_b_sfEvent = sf_mex_dup(c11_mxArrayInData);
  c11_identifier = c11_varName;
  c11_thisId.fIdentifier = c11_identifier;
  c11_thisId.fParent = NULL;
  c11_y = c11_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c11_b_sfEvent),
    &c11_thisId);
  sf_mex_destroy(&c11_b_sfEvent);
  *(int32_T *)c11_outData = c11_y;
  sf_mex_destroy(&c11_mxArrayInData);
}

static uint8_T c11_e_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_b_is_active_c11_ref_gen, const char_T *c11_identifier)
{
  uint8_T c11_y;
  emlrtMsgIdentifier c11_thisId;
  c11_thisId.fIdentifier = c11_identifier;
  c11_thisId.fParent = NULL;
  c11_y = c11_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c11_b_is_active_c11_ref_gen), &c11_thisId);
  sf_mex_destroy(&c11_b_is_active_c11_ref_gen);
  return c11_y;
}

static uint8_T c11_f_emlrt_marshallIn(SFc11_ref_genInstanceStruct *chartInstance,
  const mxArray *c11_u, const emlrtMsgIdentifier *c11_parentId)
{
  uint8_T c11_y;
  uint8_T c11_u0;
  sf_mex_import(c11_parentId, sf_mex_dup(c11_u), &c11_u0, 1, 3, 0U, 0, 0U, 0);
  c11_y = c11_u0;
  sf_mex_destroy(&c11_u);
  return c11_y;
}

static void init_dsm_address_info(SFc11_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c11_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1236646821U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(948011166U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2091836151U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(609588538U);
}

mxArray *sf_c11_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("uT7sqyOj8IkitnZIAnhBR");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c11_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"F_air\",},{M[8],M[0],T\"is_active_c11_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c11_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc11_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc11_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          11,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_body");
          _SFD_SET_DATA_PROPS(1,10,0,0,"C_air");
          _SFD_SET_DATA_PROPS(2,10,0,0,"rho_air");
          _SFD_SET_DATA_PROPS(3,2,0,1,"F_air");
          _SFD_SET_DATA_PROPS(4,10,0,0,"A_front");
          _SFD_SET_DATA_PROPS(5,10,0,0,"A_side");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,228);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c11_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c11_b_sf_marshallOut,(MexInFcnForType)
          c11_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c11_b_sf_marshallOut,(MexInFcnForType)
          c11_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c11_sf_marshallOut,(MexInFcnForType)
            c11_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c11_b_sf_marshallOut,(MexInFcnForType)
          c11_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c11_b_sf_marshallOut,(MexInFcnForType)
          c11_b_sf_marshallIn);

        {
          real_T (*c11_v_body)[3];
          real_T (*c11_F_air)[3];
          c11_F_air = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c11_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c11_v_body);
          _SFD_SET_DATA_VALUE_PTR(1U, &chartInstance->c11_C_air);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c11_rho_air);
          _SFD_SET_DATA_VALUE_PTR(3U, *c11_F_air);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c11_A_front);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c11_A_side);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c11_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc11_ref_genInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c11_ref_gen(void *chartInstanceVar)
{
  enable_c11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c11_ref_gen(void *chartInstanceVar)
{
  disable_c11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c11_ref_gen(void *chartInstanceVar)
{
  sf_c11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c11_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c11_ref_gen((SFc11_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c11_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c11_ref_gen(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c11_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c11_ref_gen((SFc11_ref_genInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c11_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c11_ref_gen(S);
}

static void sf_opaque_set_sim_state_c11_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c11_ref_gen(S, st);
}

static void sf_opaque_terminate_c11_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc11_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc11_ref_gen((SFc11_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c11_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c11_ref_gen((SFc11_ref_genInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c11_ref_gen(SimStruct *S)
{
  /* Actual parameters from chart:
     A_front A_side C_air rho_air
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for A_front*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for A_side*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for C_air*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for rho_air*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,11);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,11,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,11,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,11,1);
      sf_mark_chart_reusable_outputs(S,infoStruct,11,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,11);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2225135085U));
  ssSetChecksum1(S,(4012205762U));
  ssSetChecksum2(S,(1449561827U));
  ssSetChecksum3(S,(1781979445U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c11_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c11_ref_gen(SimStruct *S)
{
  SFc11_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc11_ref_genInstanceStruct *)malloc(sizeof
    (SFc11_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc11_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c11_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c11_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c11_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c11_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c11_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c11_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c11_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c11_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c11_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c11_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c11_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c11_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c11_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c11_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c11_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c11_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
