/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c24_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c24_debug_family_names[8] = { "R_z", "v_body", "nargin",
  "nargout", "v_inertial", "psi", "speed", "beta" };

/* Function Declarations */
static void initialize_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void initialize_params_c24_ref_gen(SFc24_ref_genInstanceStruct
  *chartInstance);
static void enable_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void disable_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void c24_update_debugger_state_c24_ref_gen(SFc24_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c24_ref_gen(SFc24_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_st);
static void finalize_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void sf_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void c24_chartstep_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void initSimStructsc24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c24_machineNumber, uint32_T
  c24_chartNumber);
static const mxArray *c24_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static real_T c24_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_beta, const char_T *c24_identifier);
static real_T c24_b_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_b_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static void c24_c_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[3]);
static void c24_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_c_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static void c24_d_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[9]);
static void c24_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static void c24_info_helper(c24_ResolvedFunctionInfo c24_info[32]);
static real_T c24_cosd(SFc24_ref_genInstanceStruct *chartInstance, real_T c24_x);
static real_T c24_eml_scalar_round(SFc24_ref_genInstanceStruct *chartInstance,
  real_T c24_x);
static real_T c24_eml_scalar_mod(SFc24_ref_genInstanceStruct *chartInstance,
  real_T c24_x, real_T c24_y);
static void c24_eml_scalar_eg(SFc24_ref_genInstanceStruct *chartInstance);
static real_T c24_sind(SFc24_ref_genInstanceStruct *chartInstance, real_T c24_x);
static void c24_b_eml_scalar_eg(SFc24_ref_genInstanceStruct *chartInstance);
static const mxArray *c24_d_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static int32_T c24_e_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static uint8_T c24_f_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_b_is_active_c24_ref_gen, const char_T *c24_identifier);
static uint8_T c24_g_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_b_cosd(SFc24_ref_genInstanceStruct *chartInstance, real_T *c24_x);
static void c24_b_eml_scalar_round(SFc24_ref_genInstanceStruct *chartInstance,
  real_T *c24_x);
static void c24_b_sind(SFc24_ref_genInstanceStruct *chartInstance, real_T *c24_x);
static void init_dsm_address_info(SFc24_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c24_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c24_is_active_c24_ref_gen = 0U;
}

static void initialize_params_c24_ref_gen(SFc24_ref_genInstanceStruct
  *chartInstance)
{
}

static void enable_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c24_update_debugger_state_c24_ref_gen(SFc24_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c24_ref_gen(SFc24_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c24_st;
  const mxArray *c24_y = NULL;
  real_T c24_hoistedGlobal;
  real_T c24_u;
  const mxArray *c24_b_y = NULL;
  real_T c24_b_hoistedGlobal;
  real_T c24_b_u;
  const mxArray *c24_c_y = NULL;
  uint8_T c24_c_hoistedGlobal;
  uint8_T c24_c_u;
  const mxArray *c24_d_y = NULL;
  real_T *c24_beta;
  real_T *c24_speed;
  c24_beta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c24_speed = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c24_st = NULL;
  c24_st = NULL;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_createcellarray(3), FALSE);
  c24_hoistedGlobal = *c24_beta;
  c24_u = c24_hoistedGlobal;
  c24_b_y = NULL;
  sf_mex_assign(&c24_b_y, sf_mex_create("y", &c24_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c24_y, 0, c24_b_y);
  c24_b_hoistedGlobal = *c24_speed;
  c24_b_u = c24_b_hoistedGlobal;
  c24_c_y = NULL;
  sf_mex_assign(&c24_c_y, sf_mex_create("y", &c24_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c24_y, 1, c24_c_y);
  c24_c_hoistedGlobal = chartInstance->c24_is_active_c24_ref_gen;
  c24_c_u = c24_c_hoistedGlobal;
  c24_d_y = NULL;
  sf_mex_assign(&c24_d_y, sf_mex_create("y", &c24_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c24_y, 2, c24_d_y);
  sf_mex_assign(&c24_st, c24_y, FALSE);
  return c24_st;
}

static void set_sim_state_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_st)
{
  const mxArray *c24_u;
  real_T *c24_beta;
  real_T *c24_speed;
  c24_beta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c24_speed = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c24_doneDoubleBufferReInit = TRUE;
  c24_u = sf_mex_dup(c24_st);
  *c24_beta = c24_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c24_u, 0)), "beta");
  *c24_speed = c24_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c24_u, 1)), "speed");
  chartInstance->c24_is_active_c24_ref_gen = c24_f_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c24_u, 2)),
     "is_active_c24_ref_gen");
  sf_mex_destroy(&c24_u);
  c24_update_debugger_state_c24_ref_gen(chartInstance);
  sf_mex_destroy(&c24_st);
}

static void finalize_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
  int32_T c24_i0;
  real_T *c24_speed;
  real_T *c24_psi;
  real_T *c24_beta;
  real_T (*c24_v_inertial)[3];
  c24_beta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c24_psi = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c24_v_inertial = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c24_speed = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 16U, chartInstance->c24_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c24_speed, 0U);
  for (c24_i0 = 0; c24_i0 < 3; c24_i0++) {
    _SFD_DATA_RANGE_CHECK((*c24_v_inertial)[c24_i0], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c24_psi, 2U);
  _SFD_DATA_RANGE_CHECK(*c24_beta, 3U);
  chartInstance->c24_sfEvent = CALL_EVENT;
  c24_chartstep_c24_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c24_chartstep_c24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
  real_T c24_hoistedGlobal;
  int32_T c24_i1;
  real_T c24_v_inertial[3];
  real_T c24_psi;
  uint32_T c24_debug_family_var_map[8];
  real_T c24_R_z[9];
  real_T c24_v_body[3];
  real_T c24_nargin = 2.0;
  real_T c24_nargout = 2.0;
  real_T c24_speed;
  real_T c24_beta;
  real_T c24_d0;
  real_T c24_d1;
  real_T c24_d2;
  real_T c24_d3;
  int32_T c24_i2;
  int32_T c24_i3;
  real_T c24_a[9];
  int32_T c24_i4;
  real_T c24_b[3];
  int32_T c24_i5;
  int32_T c24_i6;
  int32_T c24_i7;
  real_T c24_C[3];
  int32_T c24_i8;
  int32_T c24_i9;
  int32_T c24_i10;
  int32_T c24_i11;
  int32_T c24_i12;
  int32_T c24_i13;
  real_T c24_y;
  real_T c24_x;
  real_T c24_b_y;
  real_T c24_b_x;
  int32_T c24_i14;
  real_T c24_scale;
  int32_T c24_k;
  int32_T c24_b_k;
  real_T c24_c_x;
  real_T c24_d_x;
  real_T c24_absxk;
  real_T c24_t;
  real_T *c24_b_psi;
  real_T *c24_b_speed;
  real_T *c24_b_beta;
  real_T (*c24_b_v_inertial)[3];
  c24_b_beta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c24_b_psi = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c24_b_v_inertial = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c24_b_speed = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 16U, chartInstance->c24_sfEvent);
  c24_hoistedGlobal = *c24_b_psi;
  for (c24_i1 = 0; c24_i1 < 3; c24_i1++) {
    c24_v_inertial[c24_i1] = (*c24_b_v_inertial)[c24_i1];
  }

  c24_psi = c24_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 8U, 8U, c24_debug_family_names,
    c24_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c24_R_z, 0U, c24_c_sf_marshallOut,
    c24_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c24_v_body, 1U, c24_b_sf_marshallOut,
    c24_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_nargin, 2U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_nargout, 3U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c24_v_inertial, 4U, c24_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c24_psi, 5U, c24_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c24_speed, 6U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c24_beta, 7U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 4);
  c24_d0 = c24_psi;
  c24_b_cosd(chartInstance, &c24_d0);
  c24_d1 = c24_psi;
  c24_b_sind(chartInstance, &c24_d1);
  c24_d2 = c24_psi;
  c24_b_sind(chartInstance, &c24_d2);
  c24_d3 = c24_psi;
  c24_b_cosd(chartInstance, &c24_d3);
  c24_R_z[0] = c24_d0;
  c24_R_z[1] = -c24_d1;
  c24_R_z[2] = 0.0;
  c24_R_z[3] = c24_d2;
  c24_R_z[4] = c24_d3;
  c24_R_z[5] = 0.0;
  for (c24_i2 = 0; c24_i2 < 3; c24_i2++) {
    c24_R_z[c24_i2 + 6] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 9);
  for (c24_i3 = 0; c24_i3 < 9; c24_i3++) {
    c24_a[c24_i3] = c24_R_z[c24_i3];
  }

  for (c24_i4 = 0; c24_i4 < 3; c24_i4++) {
    c24_b[c24_i4] = c24_v_inertial[c24_i4];
  }

  c24_b_eml_scalar_eg(chartInstance);
  c24_b_eml_scalar_eg(chartInstance);
  for (c24_i5 = 0; c24_i5 < 3; c24_i5++) {
    c24_v_body[c24_i5] = 0.0;
  }

  for (c24_i6 = 0; c24_i6 < 3; c24_i6++) {
    c24_v_body[c24_i6] = 0.0;
  }

  for (c24_i7 = 0; c24_i7 < 3; c24_i7++) {
    c24_C[c24_i7] = c24_v_body[c24_i7];
  }

  for (c24_i8 = 0; c24_i8 < 3; c24_i8++) {
    c24_v_body[c24_i8] = c24_C[c24_i8];
  }

  for (c24_i9 = 0; c24_i9 < 3; c24_i9++) {
    c24_C[c24_i9] = c24_v_body[c24_i9];
  }

  for (c24_i10 = 0; c24_i10 < 3; c24_i10++) {
    c24_v_body[c24_i10] = c24_C[c24_i10];
  }

  for (c24_i11 = 0; c24_i11 < 3; c24_i11++) {
    c24_v_body[c24_i11] = 0.0;
    c24_i12 = 0;
    for (c24_i13 = 0; c24_i13 < 3; c24_i13++) {
      c24_v_body[c24_i11] += c24_a[c24_i12 + c24_i11] * c24_b[c24_i13];
      c24_i12 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 12);
  c24_y = c24_v_body[1];
  c24_x = c24_v_body[0];
  c24_eml_scalar_eg(chartInstance);
  c24_b_y = c24_y;
  c24_b_x = c24_x;
  c24_beta = muDoubleScalarAtan2(c24_b_y, c24_b_x);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 15);
  for (c24_i14 = 0; c24_i14 < 3; c24_i14++) {
    c24_b[c24_i14] = c24_v_body[c24_i14];
  }

  c24_speed = 0.0;
  c24_scale = 2.2250738585072014E-308;
  for (c24_k = 1; c24_k < 4; c24_k++) {
    c24_b_k = c24_k;
    c24_c_x = c24_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
      "", (real_T)c24_b_k), 1, 3, 1, 0) - 1];
    c24_d_x = c24_c_x;
    c24_absxk = muDoubleScalarAbs(c24_d_x);
    if (c24_absxk > c24_scale) {
      c24_t = c24_scale / c24_absxk;
      c24_speed = 1.0 + c24_speed * c24_t * c24_t;
      c24_scale = c24_absxk;
    } else {
      c24_t = c24_absxk / c24_scale;
      c24_speed += c24_t * c24_t;
    }
  }

  c24_speed = c24_scale * muDoubleScalarSqrt(c24_speed);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, -15);
  sf_debug_symbol_scope_pop();
  *c24_b_speed = c24_speed;
  *c24_b_beta = c24_beta;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 16U, chartInstance->c24_sfEvent);
}

static void initSimStructsc24_ref_gen(SFc24_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c24_machineNumber, uint32_T
  c24_chartNumber)
{
}

static const mxArray *c24_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  real_T c24_u;
  const mxArray *c24_y = NULL;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_u = *(real_T *)c24_inData;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", &c24_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static real_T c24_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_beta, const char_T *c24_identifier)
{
  real_T c24_y;
  emlrtMsgIdentifier c24_thisId;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_beta),
    &c24_thisId);
  sf_mex_destroy(&c24_beta);
  return c24_y;
}

static real_T c24_b_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  real_T c24_y;
  real_T c24_d4;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_d4, 1, 0, 0U, 0, 0U, 0);
  c24_y = c24_d4;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_beta;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_beta = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_beta),
    &c24_thisId);
  sf_mex_destroy(&c24_beta);
  *(real_T *)c24_outData = c24_y;
  sf_mex_destroy(&c24_mxArrayInData);
}

static const mxArray *c24_b_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_i15;
  real_T c24_b_inData[3];
  int32_T c24_i16;
  real_T c24_u[3];
  const mxArray *c24_y = NULL;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  for (c24_i15 = 0; c24_i15 < 3; c24_i15++) {
    c24_b_inData[c24_i15] = (*(real_T (*)[3])c24_inData)[c24_i15];
  }

  for (c24_i16 = 0; c24_i16 < 3; c24_i16++) {
    c24_u[c24_i16] = c24_b_inData[c24_i16];
  }

  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static void c24_c_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[3])
{
  real_T c24_dv0[3];
  int32_T c24_i17;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), c24_dv0, 1, 0, 0U, 1, 0U, 1, 3);
  for (c24_i17 = 0; c24_i17 < 3; c24_i17++) {
    c24_y[c24_i17] = c24_dv0[c24_i17];
  }

  sf_mex_destroy(&c24_u);
}

static void c24_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_v_body;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y[3];
  int32_T c24_i18;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_v_body = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_v_body), &c24_thisId,
    c24_y);
  sf_mex_destroy(&c24_v_body);
  for (c24_i18 = 0; c24_i18 < 3; c24_i18++) {
    (*(real_T (*)[3])c24_outData)[c24_i18] = c24_y[c24_i18];
  }

  sf_mex_destroy(&c24_mxArrayInData);
}

static const mxArray *c24_c_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_i19;
  int32_T c24_i20;
  int32_T c24_i21;
  real_T c24_b_inData[9];
  int32_T c24_i22;
  int32_T c24_i23;
  int32_T c24_i24;
  real_T c24_u[9];
  const mxArray *c24_y = NULL;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_i19 = 0;
  for (c24_i20 = 0; c24_i20 < 3; c24_i20++) {
    for (c24_i21 = 0; c24_i21 < 3; c24_i21++) {
      c24_b_inData[c24_i21 + c24_i19] = (*(real_T (*)[9])c24_inData)[c24_i21 +
        c24_i19];
    }

    c24_i19 += 3;
  }

  c24_i22 = 0;
  for (c24_i23 = 0; c24_i23 < 3; c24_i23++) {
    for (c24_i24 = 0; c24_i24 < 3; c24_i24++) {
      c24_u[c24_i24 + c24_i22] = c24_b_inData[c24_i24 + c24_i22];
    }

    c24_i22 += 3;
  }

  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static void c24_d_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[9])
{
  real_T c24_dv1[9];
  int32_T c24_i25;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), c24_dv1, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c24_i25 = 0; c24_i25 < 9; c24_i25++) {
    c24_y[c24_i25] = c24_dv1[c24_i25];
  }

  sf_mex_destroy(&c24_u);
}

static void c24_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_R_z;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y[9];
  int32_T c24_i26;
  int32_T c24_i27;
  int32_T c24_i28;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_R_z = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_R_z), &c24_thisId, c24_y);
  sf_mex_destroy(&c24_R_z);
  c24_i26 = 0;
  for (c24_i27 = 0; c24_i27 < 3; c24_i27++) {
    for (c24_i28 = 0; c24_i28 < 3; c24_i28++) {
      (*(real_T (*)[9])c24_outData)[c24_i28 + c24_i26] = c24_y[c24_i28 + c24_i26];
    }

    c24_i26 += 3;
  }

  sf_mex_destroy(&c24_mxArrayInData);
}

const mxArray *sf_c24_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c24_nameCaptureInfo;
  c24_ResolvedFunctionInfo c24_info[32];
  const mxArray *c24_m0 = NULL;
  int32_T c24_i29;
  c24_ResolvedFunctionInfo *c24_r0;
  c24_nameCaptureInfo = NULL;
  c24_nameCaptureInfo = NULL;
  c24_info_helper(c24_info);
  sf_mex_assign(&c24_m0, sf_mex_createstruct("nameCaptureInfo", 1, 32), FALSE);
  for (c24_i29 = 0; c24_i29 < 32; c24_i29++) {
    c24_r0 = &c24_info[c24_i29];
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", c24_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c24_r0->context)), "context", "nameCaptureInfo",
                    c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", c24_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c24_r0->name)), "name", "nameCaptureInfo",
                    c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo",
      c24_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c24_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", c24_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c24_r0->resolved)), "resolved",
                    "nameCaptureInfo", c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", &c24_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo", &c24_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo",
      &c24_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c24_i29);
    sf_mex_addfield(c24_m0, sf_mex_create("nameCaptureInfo",
      &c24_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c24_i29);
  }

  sf_mex_assign(&c24_nameCaptureInfo, c24_m0, FALSE);
  return c24_nameCaptureInfo;
}

static void c24_info_helper(c24_ResolvedFunctionInfo c24_info[32])
{
  c24_info[0].context = "";
  c24_info[0].name = "cosd";
  c24_info[0].dominantType = "double";
  c24_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cosd.m";
  c24_info[0].fileTimeLo = 1286818706U;
  c24_info[0].fileTimeHi = 0U;
  c24_info[0].mFileTimeLo = 0U;
  c24_info[0].mFileTimeHi = 0U;
  c24_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cosd.m";
  c24_info[1].name = "eml_scalar_cosd";
  c24_info[1].dominantType = "double";
  c24_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cosd.m";
  c24_info[1].fileTimeLo = 1286818722U;
  c24_info[1].fileTimeHi = 0U;
  c24_info[1].mFileTimeLo = 0U;
  c24_info[1].mFileTimeHi = 0U;
  c24_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cosd.m";
  c24_info[2].name = "eml_scalar_round";
  c24_info[2].dominantType = "double";
  c24_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_round.m";
  c24_info[2].fileTimeLo = 1289519628U;
  c24_info[2].fileTimeHi = 0U;
  c24_info[2].mFileTimeLo = 0U;
  c24_info[2].mFileTimeHi = 0U;
  c24_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_round.m!scalar_round";
  c24_info[3].name = "eps";
  c24_info[3].dominantType = "char";
  c24_info[3].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c24_info[3].fileTimeLo = 1286818686U;
  c24_info[3].fileTimeHi = 0U;
  c24_info[3].mFileTimeLo = 0U;
  c24_info[3].mFileTimeHi = 0U;
  c24_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c24_info[4].name = "eml_is_float_class";
  c24_info[4].dominantType = "char";
  c24_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c24_info[4].fileTimeLo = 1286818782U;
  c24_info[4].fileTimeHi = 0U;
  c24_info[4].mFileTimeLo = 0U;
  c24_info[4].mFileTimeHi = 0U;
  c24_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_round.m!scalar_round";
  c24_info[5].name = "mrdivide";
  c24_info[5].dominantType = "double";
  c24_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c24_info[5].fileTimeLo = 1310137456U;
  c24_info[5].fileTimeHi = 0U;
  c24_info[5].mFileTimeLo = 1289519692U;
  c24_info[5].mFileTimeHi = 0U;
  c24_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c24_info[6].name = "rdivide";
  c24_info[6].dominantType = "double";
  c24_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c24_info[6].fileTimeLo = 1286818844U;
  c24_info[6].fileTimeHi = 0U;
  c24_info[6].mFileTimeLo = 0U;
  c24_info[6].mFileTimeHi = 0U;
  c24_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c24_info[7].name = "eml_div";
  c24_info[7].dominantType = "double";
  c24_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c24_info[7].fileTimeLo = 1305318000U;
  c24_info[7].fileTimeHi = 0U;
  c24_info[7].mFileTimeLo = 0U;
  c24_info[7].mFileTimeHi = 0U;
  c24_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cosd.m";
  c24_info[8].name = "eml_scalar_mod";
  c24_info[8].dominantType = "double";
  c24_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_mod.m";
  c24_info[8].fileTimeLo = 1286818730U;
  c24_info[8].fileTimeHi = 0U;
  c24_info[8].mFileTimeLo = 0U;
  c24_info[8].mFileTimeHi = 0U;
  c24_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_mod.m";
  c24_info[9].name = "eml_scalar_eg";
  c24_info[9].dominantType = "double";
  c24_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c24_info[9].fileTimeLo = 1286818796U;
  c24_info[9].fileTimeHi = 0U;
  c24_info[9].mFileTimeLo = 0U;
  c24_info[9].mFileTimeHi = 0U;
  c24_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_mod.m";
  c24_info[10].name = "eml_scalar_floor";
  c24_info[10].dominantType = "double";
  c24_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c24_info[10].fileTimeLo = 1286818726U;
  c24_info[10].fileTimeHi = 0U;
  c24_info[10].mFileTimeLo = 0U;
  c24_info[10].mFileTimeHi = 0U;
  c24_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_mod.m";
  c24_info[11].name = "eml_scalar_abs";
  c24_info[11].dominantType = "double";
  c24_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c24_info[11].fileTimeLo = 1286818712U;
  c24_info[11].fileTimeHi = 0U;
  c24_info[11].mFileTimeLo = 0U;
  c24_info[11].mFileTimeHi = 0U;
  c24_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_mod.m";
  c24_info[12].name = "mtimes";
  c24_info[12].dominantType = "double";
  c24_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c24_info[12].fileTimeLo = 1289519692U;
  c24_info[12].fileTimeHi = 0U;
  c24_info[12].mFileTimeLo = 0U;
  c24_info[12].mFileTimeHi = 0U;
  c24_info[13].context = "";
  c24_info[13].name = "sind";
  c24_info[13].dominantType = "double";
  c24_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sind.m";
  c24_info[13].fileTimeLo = 1286818750U;
  c24_info[13].fileTimeHi = 0U;
  c24_info[13].mFileTimeLo = 0U;
  c24_info[13].mFileTimeHi = 0U;
  c24_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sind.m";
  c24_info[14].name = "eml_scalar_sind";
  c24_info[14].dominantType = "double";
  c24_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sind.m";
  c24_info[14].fileTimeLo = 1286818738U;
  c24_info[14].fileTimeHi = 0U;
  c24_info[14].mFileTimeLo = 0U;
  c24_info[14].mFileTimeHi = 0U;
  c24_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c24_info[15].name = "eml_index_class";
  c24_info[15].dominantType = "";
  c24_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c24_info[15].fileTimeLo = 1286818778U;
  c24_info[15].fileTimeHi = 0U;
  c24_info[15].mFileTimeLo = 0U;
  c24_info[15].mFileTimeHi = 0U;
  c24_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c24_info[16].name = "eml_xgemm";
  c24_info[16].dominantType = "int32";
  c24_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c24_info[16].fileTimeLo = 1299076772U;
  c24_info[16].fileTimeHi = 0U;
  c24_info[16].mFileTimeLo = 0U;
  c24_info[16].mFileTimeHi = 0U;
  c24_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c24_info[17].name = "eml_blas_inline";
  c24_info[17].dominantType = "";
  c24_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c24_info[17].fileTimeLo = 1299076768U;
  c24_info[17].fileTimeHi = 0U;
  c24_info[17].mFileTimeLo = 0U;
  c24_info[17].mFileTimeHi = 0U;
  c24_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c24_info[18].name = "eml_refblas_xgemm";
  c24_info[18].dominantType = "int32";
  c24_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c24_info[18].fileTimeLo = 1299076774U;
  c24_info[18].fileTimeHi = 0U;
  c24_info[18].mFileTimeLo = 0U;
  c24_info[18].mFileTimeHi = 0U;
  c24_info[19].context = "";
  c24_info[19].name = "atan2";
  c24_info[19].dominantType = "double";
  c24_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c24_info[19].fileTimeLo = 1286818704U;
  c24_info[19].fileTimeHi = 0U;
  c24_info[19].mFileTimeLo = 0U;
  c24_info[19].mFileTimeHi = 0U;
  c24_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c24_info[20].name = "eml_scalexp_alloc";
  c24_info[20].dominantType = "double";
  c24_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c24_info[20].fileTimeLo = 1286818796U;
  c24_info[20].fileTimeHi = 0U;
  c24_info[20].mFileTimeLo = 0U;
  c24_info[20].mFileTimeHi = 0U;
  c24_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c24_info[21].name = "eml_scalar_atan2";
  c24_info[21].dominantType = "double";
  c24_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c24_info[21].fileTimeLo = 1286818720U;
  c24_info[21].fileTimeHi = 0U;
  c24_info[21].mFileTimeLo = 0U;
  c24_info[21].mFileTimeHi = 0U;
  c24_info[22].context = "";
  c24_info[22].name = "norm";
  c24_info[22].dominantType = "double";
  c24_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c24_info[22].fileTimeLo = 1286818826U;
  c24_info[22].fileTimeHi = 0U;
  c24_info[22].mFileTimeLo = 0U;
  c24_info[22].mFileTimeHi = 0U;
  c24_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c24_info[23].name = "eml_xnrm2";
  c24_info[23].dominantType = "int32";
  c24_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c24_info[23].fileTimeLo = 1299076776U;
  c24_info[23].fileTimeHi = 0U;
  c24_info[23].mFileTimeLo = 0U;
  c24_info[23].mFileTimeHi = 0U;
  c24_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c24_info[24].name = "eml_refblas_xnrm2";
  c24_info[24].dominantType = "int32";
  c24_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[24].fileTimeLo = 1299076784U;
  c24_info[24].fileTimeHi = 0U;
  c24_info[24].mFileTimeLo = 0U;
  c24_info[24].mFileTimeHi = 0U;
  c24_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[25].name = "realmin";
  c24_info[25].dominantType = "char";
  c24_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c24_info[25].fileTimeLo = 1286818768U;
  c24_info[25].fileTimeHi = 0U;
  c24_info[25].mFileTimeLo = 0U;
  c24_info[25].mFileTimeHi = 0U;
  c24_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c24_info[26].name = "mpower";
  c24_info[26].dominantType = "double";
  c24_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c24_info[26].fileTimeLo = 1286818842U;
  c24_info[26].fileTimeHi = 0U;
  c24_info[26].mFileTimeLo = 0U;
  c24_info[26].mFileTimeHi = 0U;
  c24_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c24_info[27].name = "power";
  c24_info[27].dominantType = "double";
  c24_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c24_info[27].fileTimeLo = 1294067944U;
  c24_info[27].fileTimeHi = 0U;
  c24_info[27].mFileTimeLo = 0U;
  c24_info[27].mFileTimeHi = 0U;
  c24_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[28].name = "eml_index_minus";
  c24_info[28].dominantType = "int32";
  c24_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c24_info[28].fileTimeLo = 1286818778U;
  c24_info[28].fileTimeHi = 0U;
  c24_info[28].mFileTimeLo = 0U;
  c24_info[28].mFileTimeHi = 0U;
  c24_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[29].name = "eml_index_times";
  c24_info[29].dominantType = "int32";
  c24_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c24_info[29].fileTimeLo = 1286818780U;
  c24_info[29].fileTimeHi = 0U;
  c24_info[29].mFileTimeLo = 0U;
  c24_info[29].mFileTimeHi = 0U;
  c24_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[30].name = "eml_index_plus";
  c24_info[30].dominantType = "int32";
  c24_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c24_info[30].fileTimeLo = 1286818778U;
  c24_info[30].fileTimeHi = 0U;
  c24_info[30].mFileTimeLo = 0U;
  c24_info[30].mFileTimeHi = 0U;
  c24_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c24_info[31].name = "abs";
  c24_info[31].dominantType = "double";
  c24_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c24_info[31].fileTimeLo = 1286818694U;
  c24_info[31].fileTimeHi = 0U;
  c24_info[31].mFileTimeLo = 0U;
  c24_info[31].mFileTimeHi = 0U;
}

static real_T c24_cosd(SFc24_ref_genInstanceStruct *chartInstance, real_T c24_x)
{
  real_T c24_b_x;
  c24_b_x = c24_x;
  c24_b_cosd(chartInstance, &c24_b_x);
  return c24_b_x;
}

static real_T c24_eml_scalar_round(SFc24_ref_genInstanceStruct *chartInstance,
  real_T c24_x)
{
  real_T c24_b_x;
  c24_b_x = c24_x;
  c24_b_eml_scalar_round(chartInstance, &c24_b_x);
  return c24_b_x;
}

static real_T c24_eml_scalar_mod(SFc24_ref_genInstanceStruct *chartInstance,
  real_T c24_x, real_T c24_y)
{
  real_T c24_r;
  real_T c24_b_x;
  real_T c24_c_x;
  real_T c24_d_x;
  real_T c24_e_x;
  real_T c24_d5;
  real_T c24_f_x;
  real_T c24_b_y;
  real_T c24_g_x;
  real_T c24_c_y;
  real_T c24_b;
  real_T c24_d_y;
  real_T c24_h_x;
  real_T c24_i_x;
  c24_eml_scalar_eg(chartInstance);
  if (c24_y == 0.0) {
    c24_r = c24_x;
  } else {
    c24_b_x = c24_y;
    c24_c_x = c24_b_x;
    c24_c_x = muDoubleScalarFloor(c24_c_x);
    if (c24_y == c24_c_x) {
      c24_d_x = c24_x / c24_y;
      c24_e_x = c24_d_x;
      c24_e_x = muDoubleScalarFloor(c24_e_x);
      c24_r = c24_x - c24_e_x * c24_y;
    } else {
      c24_r = c24_x / c24_y;
      c24_d5 = c24_r;
      c24_b_eml_scalar_round(chartInstance, &c24_d5);
      c24_f_x = c24_r - c24_d5;
      c24_b_y = muDoubleScalarAbs(c24_f_x);
      c24_g_x = c24_r;
      c24_c_y = muDoubleScalarAbs(c24_g_x);
      c24_b = c24_c_y;
      c24_d_y = 2.2204460492503131E-16 * c24_b;
      if (c24_b_y <= c24_d_y) {
        c24_r = 0.0;
      } else {
        c24_h_x = c24_r;
        c24_i_x = c24_h_x;
        c24_i_x = muDoubleScalarFloor(c24_i_x);
        c24_r = (c24_r - c24_i_x) * c24_y;
      }
    }
  }

  return c24_r;
}

static void c24_eml_scalar_eg(SFc24_ref_genInstanceStruct *chartInstance)
{
}

static real_T c24_sind(SFc24_ref_genInstanceStruct *chartInstance, real_T c24_x)
{
  real_T c24_b_x;
  c24_b_x = c24_x;
  c24_b_sind(chartInstance, &c24_b_x);
  return c24_b_x;
}

static void c24_b_eml_scalar_eg(SFc24_ref_genInstanceStruct *chartInstance)
{
}

static const mxArray *c24_d_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_u;
  const mxArray *c24_y = NULL;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_u = *(int32_T *)c24_inData;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", &c24_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static int32_T c24_e_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  int32_T c24_y;
  int32_T c24_i30;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_i30, 1, 6, 0U, 0, 0U, 0);
  c24_y = c24_i30;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_b_sfEvent;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  int32_T c24_y;
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)chartInstanceVoid;
  c24_b_sfEvent = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_b_sfEvent),
    &c24_thisId);
  sf_mex_destroy(&c24_b_sfEvent);
  *(int32_T *)c24_outData = c24_y;
  sf_mex_destroy(&c24_mxArrayInData);
}

static uint8_T c24_f_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_b_is_active_c24_ref_gen, const char_T *c24_identifier)
{
  uint8_T c24_y;
  emlrtMsgIdentifier c24_thisId;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c24_b_is_active_c24_ref_gen), &c24_thisId);
  sf_mex_destroy(&c24_b_is_active_c24_ref_gen);
  return c24_y;
}

static uint8_T c24_g_emlrt_marshallIn(SFc24_ref_genInstanceStruct *chartInstance,
  const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  uint8_T c24_y;
  uint8_T c24_u0;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_u0, 1, 3, 0U, 0, 0U, 0);
  c24_y = c24_u0;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_b_cosd(SFc24_ref_genInstanceStruct *chartInstance, real_T *c24_x)
{
  real_T c24_n;
  real_T c24_m;
  c24_n = *c24_x / 90.0;
  c24_b_eml_scalar_round(chartInstance, &c24_n);
  *c24_x -= c24_n * 90.0;
  c24_m = c24_eml_scalar_mod(chartInstance, c24_n, 4.0);
  c24_b_eml_scalar_round(chartInstance, &c24_m);
  if (c24_m < 2.0) {
    if (c24_m < 1.0) {
      *c24_x = muDoubleScalarCos(0.017453292519943295 * *c24_x);
    } else {
      *c24_x = -muDoubleScalarSin(0.017453292519943295 * *c24_x);
    }
  } else if (c24_m < 3.0) {
    *c24_x = -muDoubleScalarCos(0.017453292519943295 * *c24_x);
  } else {
    *c24_x = muDoubleScalarSin(0.017453292519943295 * *c24_x);
  }
}

static void c24_b_eml_scalar_round(SFc24_ref_genInstanceStruct *chartInstance,
  real_T *c24_x)
{
  real_T c24_b_x;
  c24_b_x = *c24_x;
  if (muDoubleScalarAbs(c24_b_x) > 4.503599627370496E+15) {
  } else if (c24_b_x >= 0.5) {
    *c24_x = muDoubleScalarFloor(c24_b_x + 0.5);
  } else if (c24_b_x > -0.5) {
    *c24_x = c24_b_x * 0.0;
  } else {
    *c24_x = muDoubleScalarCeil(c24_b_x - 0.5);
  }
}

static void c24_b_sind(SFc24_ref_genInstanceStruct *chartInstance, real_T *c24_x)
{
  real_T c24_n;
  real_T c24_m;
  c24_n = *c24_x / 90.0;
  c24_b_eml_scalar_round(chartInstance, &c24_n);
  *c24_x -= c24_n * 90.0;
  c24_m = c24_eml_scalar_mod(chartInstance, c24_n, 4.0);
  c24_b_eml_scalar_round(chartInstance, &c24_m);
  if (c24_m < 2.0) {
    if (c24_m < 1.0) {
      *c24_x = muDoubleScalarSin(0.017453292519943295 * *c24_x);
    } else {
      *c24_x = muDoubleScalarCos(0.017453292519943295 * *c24_x);
    }
  } else if (c24_m < 3.0) {
    *c24_x = -muDoubleScalarSin(0.017453292519943295 * *c24_x);
  } else {
    *c24_x = -muDoubleScalarCos(0.017453292519943295 * *c24_x);
  }
}

static void init_dsm_address_info(SFc24_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c24_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3985911939U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(403368628U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2600357272U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2094587399U);
}

mxArray *sf_c24_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("JOTF6Di6g8PNwCzTChPRqH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c24_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[20],T\"beta\",},{M[1],M[19],T\"speed\",},{M[8],M[0],T\"is_active_c24_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c24_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc24_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc24_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          24,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"speed");
          _SFD_SET_DATA_PROPS(1,1,1,0,"v_inertial");
          _SFD_SET_DATA_PROPS(2,1,1,0,"psi");
          _SFD_SET_DATA_PROPS(3,2,0,1,"beta");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,341);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)c24_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)c24_sf_marshallIn);

        {
          real_T *c24_speed;
          real_T *c24_psi;
          real_T *c24_beta;
          real_T (*c24_v_inertial)[3];
          c24_beta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c24_psi = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c24_v_inertial = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S,
            0);
          c24_speed = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c24_speed);
          _SFD_SET_DATA_VALUE_PTR(1U, *c24_v_inertial);
          _SFD_SET_DATA_VALUE_PTR(2U, c24_psi);
          _SFD_SET_DATA_VALUE_PTR(3U, c24_beta);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c24_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc24_ref_genInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c24_ref_gen(void *chartInstanceVar)
{
  enable_c24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c24_ref_gen(void *chartInstanceVar)
{
  disable_c24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c24_ref_gen(void *chartInstanceVar)
{
  sf_c24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c24_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c24_ref_gen((SFc24_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c24_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c24_ref_gen(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c24_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c24_ref_gen((SFc24_ref_genInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c24_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c24_ref_gen(S);
}

static void sf_opaque_set_sim_state_c24_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c24_ref_gen(S, st);
}

static void sf_opaque_terminate_c24_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc24_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc24_ref_gen((SFc24_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c24_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c24_ref_gen((SFc24_ref_genInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c24_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,24);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,24,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,24,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,24,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,24,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,24);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2367838445U));
  ssSetChecksum1(S,(1297287860U));
  ssSetChecksum2(S,(1453721931U));
  ssSetChecksum3(S,(4020362079U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c24_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c24_ref_gen(SimStruct *S)
{
  SFc24_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc24_ref_genInstanceStruct *)malloc(sizeof
    (SFc24_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc24_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c24_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c24_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c24_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c24_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c24_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c24_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c24_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c24_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c24_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c24_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c24_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c24_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c24_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c24_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c24_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c24_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
