/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c2_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c2_debug_family_names[13] = { "phi", "theta", "psi", "R_x",
  "R_y", "R_z", "T", "rot", "nargin", "nargout", "nu_body", "eta", "eta_dot" };

/* Function Declarations */
static void initialize_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void initialize_params_c2_ref_gen(SFc2_ref_genInstanceStruct
  *chartInstance);
static void enable_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void disable_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_ref_gen(SFc2_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c2_ref_gen(SFc2_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_st);
static void finalize_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void sf_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void c2_chartstep_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void initSimStructsc2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData);
static void c2_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance, const
  mxArray *c2_eta_dot, const char_T *c2_identifier, real_T c2_y[6]);
static void c2_b_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[6]);
static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static real_T c2_c_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_d_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[36]);
static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_e_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[9]);
static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[15]);
static void c2_eml_scalar_eg(SFc2_ref_genInstanceStruct *chartInstance);
static void c2_eml_xgemm(SFc2_ref_genInstanceStruct *chartInstance, real_T c2_A
  [9], real_T c2_B[9], real_T c2_C[9], real_T c2_b_C[9]);
static void c2_b_eml_scalar_eg(SFc2_ref_genInstanceStruct *chartInstance);
static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static int32_T c2_f_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static uint8_T c2_g_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_b_is_active_c2_ref_gen, const char_T *c2_identifier);
static uint8_T c2_h_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_b_eml_xgemm(SFc2_ref_genInstanceStruct *chartInstance, real_T
  c2_A[9], real_T c2_B[9], real_T c2_C[9]);
static void init_dsm_address_info(SFc2_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c2_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_is_active_c2_ref_gen = 0U;
}

static void initialize_params_c2_ref_gen(SFc2_ref_genInstanceStruct
  *chartInstance)
{
}

static void enable_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_ref_gen(SFc2_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c2_ref_gen(SFc2_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c2_st;
  const mxArray *c2_y = NULL;
  int32_T c2_i0;
  real_T c2_u[6];
  const mxArray *c2_b_y = NULL;
  uint8_T c2_hoistedGlobal;
  uint8_T c2_b_u;
  const mxArray *c2_c_y = NULL;
  real_T (*c2_eta_dot)[6];
  c2_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(2), FALSE);
  for (c2_i0 = 0; c2_i0 < 6; c2_i0++) {
    c2_u[c2_i0] = (*c2_eta_dot)[c2_i0];
  }

  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c2_y, 0, c2_b_y);
  c2_hoistedGlobal = chartInstance->c2_is_active_c2_ref_gen;
  c2_b_u = c2_hoistedGlobal;
  c2_c_y = NULL;
  sf_mex_assign(&c2_c_y, sf_mex_create("y", &c2_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 1, c2_c_y);
  sf_mex_assign(&c2_st, c2_y, FALSE);
  return c2_st;
}

static void set_sim_state_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_st)
{
  const mxArray *c2_u;
  real_T c2_dv0[6];
  int32_T c2_i1;
  real_T (*c2_eta_dot)[6];
  c2_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 0)),
                      "eta_dot", c2_dv0);
  for (c2_i1 = 0; c2_i1 < 6; c2_i1++) {
    (*c2_eta_dot)[c2_i1] = c2_dv0[c2_i1];
  }

  chartInstance->c2_is_active_c2_ref_gen = c2_g_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c2_u, 1)), "is_active_c2_ref_gen");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_ref_gen(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
  int32_T c2_i2;
  int32_T c2_i3;
  int32_T c2_i4;
  real_T (*c2_eta)[6];
  real_T (*c2_eta_dot)[6];
  real_T (*c2_nu_body)[6];
  c2_eta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c2_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  for (c2_i2 = 0; c2_i2 < 6; c2_i2++) {
    _SFD_DATA_RANGE_CHECK((*c2_nu_body)[c2_i2], 0U);
  }

  for (c2_i3 = 0; c2_i3 < 6; c2_i3++) {
    _SFD_DATA_RANGE_CHECK((*c2_eta_dot)[c2_i3], 1U);
  }

  for (c2_i4 = 0; c2_i4 < 6; c2_i4++) {
    _SFD_DATA_RANGE_CHECK((*c2_eta)[c2_i4], 2U);
  }

  chartInstance->c2_sfEvent = CALL_EVENT;
  c2_chartstep_c2_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c2_chartstep_c2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
  int32_T c2_i5;
  real_T c2_nu_body[6];
  int32_T c2_i6;
  real_T c2_eta[6];
  uint32_T c2_debug_family_var_map[13];
  real_T c2_phi;
  real_T c2_theta;
  real_T c2_psi;
  real_T c2_R_x[9];
  real_T c2_R_y[9];
  real_T c2_R_z[9];
  real_T c2_T[9];
  real_T c2_rot[36];
  real_T c2_nargin = 2.0;
  real_T c2_nargout = 1.0;
  real_T c2_eta_dot[6];
  int32_T c2_i7;
  static real_T c2_b[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, -0.0, 1.0 };

  int32_T c2_i8;
  static real_T c2_b_b[9] = { 1.0, 0.0, -0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0 };

  real_T c2_x;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_h_x;
  int32_T c2_i9;
  int32_T c2_i10;
  static real_T c2_dv1[3] = { 0.0, 0.0, 1.0 };

  int32_T c2_i11;
  static real_T c2_dv2[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, -0.0, 1.0 };

  int32_T c2_i12;
  real_T c2_a[9];
  int32_T c2_i13;
  real_T c2_y[9];
  int32_T c2_i14;
  real_T c2_b_a[9];
  int32_T c2_i15;
  real_T c2_c_b[9];
  int32_T c2_i16;
  int32_T c2_i17;
  real_T c2_b_y[9];
  int32_T c2_i18;
  real_T c2_d_b[9];
  int32_T c2_i19;
  int32_T c2_i20;
  int32_T c2_i21;
  int32_T c2_i22;
  int32_T c2_i23;
  int32_T c2_i24;
  int32_T c2_i25;
  int32_T c2_i26;
  int32_T c2_i27;
  int32_T c2_i28;
  int32_T c2_i29;
  int32_T c2_i30;
  int32_T c2_i31;
  int32_T c2_i32;
  int32_T c2_i33;
  real_T c2_c_a[36];
  int32_T c2_i34;
  real_T c2_e_b[6];
  int32_T c2_i35;
  int32_T c2_i36;
  int32_T c2_i37;
  real_T c2_C[6];
  int32_T c2_i38;
  int32_T c2_i39;
  int32_T c2_i40;
  int32_T c2_i41;
  int32_T c2_i42;
  int32_T c2_i43;
  int32_T c2_i44;
  real_T (*c2_b_eta_dot)[6];
  real_T (*c2_b_eta)[6];
  real_T (*c2_b_nu_body)[6];
  c2_b_eta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c2_b_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_b_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  for (c2_i5 = 0; c2_i5 < 6; c2_i5++) {
    c2_nu_body[c2_i5] = (*c2_b_nu_body)[c2_i5];
  }

  for (c2_i6 = 0; c2_i6 < 6; c2_i6++) {
    c2_eta[c2_i6] = (*c2_b_eta)[c2_i6];
  }

  sf_debug_symbol_scope_push_eml(0U, 13U, 13U, c2_debug_family_names,
    c2_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c2_phi, 0U, c2_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_theta, 1U, c2_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c2_psi, 2U, c2_b_sf_marshallOut,
    c2_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c2_R_x, 3U, c2_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c2_R_y, 4U, c2_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c2_R_z, 5U, c2_d_sf_marshallOut,
    c2_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_T, 6U, c2_d_sf_marshallOut,
    c2_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c2_rot, 7U, c2_c_sf_marshallOut,
    c2_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nargin, 8U, c2_b_sf_marshallOut,
    c2_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nargout, 9U, c2_b_sf_marshallOut,
    c2_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c2_nu_body, 10U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c2_eta, 11U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c2_eta_dot, 12U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 3);
  c2_phi = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 4);
  c2_theta = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 5);
  c2_psi = c2_eta[5];
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 8);
  for (c2_i7 = 0; c2_i7 < 9; c2_i7++) {
    c2_R_x[c2_i7] = c2_b[c2_i7];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 12);
  for (c2_i8 = 0; c2_i8 < 9; c2_i8++) {
    c2_R_y[c2_i8] = c2_b_b[c2_i8];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 16);
  c2_x = c2_psi;
  c2_b_x = c2_x;
  c2_b_x = muDoubleScalarCos(c2_b_x);
  c2_c_x = c2_psi;
  c2_d_x = c2_c_x;
  c2_d_x = muDoubleScalarSin(c2_d_x);
  c2_e_x = c2_psi;
  c2_f_x = c2_e_x;
  c2_f_x = muDoubleScalarSin(c2_f_x);
  c2_g_x = c2_psi;
  c2_h_x = c2_g_x;
  c2_h_x = muDoubleScalarCos(c2_h_x);
  c2_R_z[0] = c2_b_x;
  c2_R_z[3] = -c2_d_x;
  c2_R_z[6] = 0.0;
  c2_R_z[1] = c2_f_x;
  c2_R_z[4] = c2_h_x;
  c2_R_z[7] = 0.0;
  c2_i9 = 0;
  for (c2_i10 = 0; c2_i10 < 3; c2_i10++) {
    c2_R_z[c2_i9 + 2] = c2_dv1[c2_i10];
    c2_i9 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 21);
  for (c2_i11 = 0; c2_i11 < 9; c2_i11++) {
    c2_T[c2_i11] = c2_dv2[c2_i11];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 26);
  for (c2_i12 = 0; c2_i12 < 9; c2_i12++) {
    c2_a[c2_i12] = c2_R_z[c2_i12];
  }

  c2_eml_scalar_eg(chartInstance);
  c2_eml_scalar_eg(chartInstance);
  for (c2_i13 = 0; c2_i13 < 9; c2_i13++) {
    c2_y[c2_i13] = 0.0;
  }

  for (c2_i14 = 0; c2_i14 < 9; c2_i14++) {
    c2_b_a[c2_i14] = c2_a[c2_i14];
  }

  for (c2_i15 = 0; c2_i15 < 9; c2_i15++) {
    c2_c_b[c2_i15] = c2_b_b[c2_i15];
  }

  c2_b_eml_xgemm(chartInstance, c2_b_a, c2_c_b, c2_y);
  c2_eml_scalar_eg(chartInstance);
  c2_eml_scalar_eg(chartInstance);
  for (c2_i16 = 0; c2_i16 < 9; c2_i16++) {
    c2_a[c2_i16] = 0.0;
  }

  for (c2_i17 = 0; c2_i17 < 9; c2_i17++) {
    c2_b_y[c2_i17] = c2_y[c2_i17];
  }

  for (c2_i18 = 0; c2_i18 < 9; c2_i18++) {
    c2_d_b[c2_i18] = c2_b[c2_i18];
  }

  c2_b_eml_xgemm(chartInstance, c2_b_y, c2_d_b, c2_a);
  c2_i19 = 0;
  c2_i20 = 0;
  for (c2_i21 = 0; c2_i21 < 3; c2_i21++) {
    for (c2_i22 = 0; c2_i22 < 3; c2_i22++) {
      c2_rot[c2_i22 + c2_i19] = c2_a[c2_i22 + c2_i20];
    }

    c2_i19 += 6;
    c2_i20 += 3;
  }

  c2_i23 = 0;
  for (c2_i24 = 0; c2_i24 < 3; c2_i24++) {
    for (c2_i25 = 0; c2_i25 < 3; c2_i25++) {
      c2_rot[(c2_i25 + c2_i23) + 18] = 0.0;
    }

    c2_i23 += 6;
  }

  c2_i26 = 0;
  for (c2_i27 = 0; c2_i27 < 3; c2_i27++) {
    for (c2_i28 = 0; c2_i28 < 3; c2_i28++) {
      c2_rot[(c2_i28 + c2_i26) + 3] = 0.0;
    }

    c2_i26 += 6;
  }

  c2_i29 = 0;
  c2_i30 = 0;
  for (c2_i31 = 0; c2_i31 < 3; c2_i31++) {
    for (c2_i32 = 0; c2_i32 < 3; c2_i32++) {
      c2_rot[(c2_i32 + c2_i29) + 21] = c2_T[c2_i32 + c2_i30];
    }

    c2_i29 += 6;
    c2_i30 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 29);
  for (c2_i33 = 0; c2_i33 < 36; c2_i33++) {
    c2_c_a[c2_i33] = c2_rot[c2_i33];
  }

  for (c2_i34 = 0; c2_i34 < 6; c2_i34++) {
    c2_e_b[c2_i34] = c2_nu_body[c2_i34];
  }

  c2_b_eml_scalar_eg(chartInstance);
  c2_b_eml_scalar_eg(chartInstance);
  for (c2_i35 = 0; c2_i35 < 6; c2_i35++) {
    c2_eta_dot[c2_i35] = 0.0;
  }

  for (c2_i36 = 0; c2_i36 < 6; c2_i36++) {
    c2_eta_dot[c2_i36] = 0.0;
  }

  for (c2_i37 = 0; c2_i37 < 6; c2_i37++) {
    c2_C[c2_i37] = c2_eta_dot[c2_i37];
  }

  for (c2_i38 = 0; c2_i38 < 6; c2_i38++) {
    c2_eta_dot[c2_i38] = c2_C[c2_i38];
  }

  for (c2_i39 = 0; c2_i39 < 6; c2_i39++) {
    c2_C[c2_i39] = c2_eta_dot[c2_i39];
  }

  for (c2_i40 = 0; c2_i40 < 6; c2_i40++) {
    c2_eta_dot[c2_i40] = c2_C[c2_i40];
  }

  for (c2_i41 = 0; c2_i41 < 6; c2_i41++) {
    c2_eta_dot[c2_i41] = 0.0;
    c2_i42 = 0;
    for (c2_i43 = 0; c2_i43 < 6; c2_i43++) {
      c2_eta_dot[c2_i41] += c2_c_a[c2_i42 + c2_i41] * c2_e_b[c2_i43];
      c2_i42 += 6;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, -29);
  sf_debug_symbol_scope_pop();
  for (c2_i44 = 0; c2_i44 < 6; c2_i44++) {
    (*c2_b_eta_dot)[c2_i44] = c2_eta_dot[c2_i44];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
}

static void initSimStructsc2_ref_gen(SFc2_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i45;
  real_T c2_b_inData[6];
  int32_T c2_i46;
  real_T c2_u[6];
  const mxArray *c2_y = NULL;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i45 = 0; c2_i45 < 6; c2_i45++) {
    c2_b_inData[c2_i45] = (*(real_T (*)[6])c2_inData)[c2_i45];
  }

  for (c2_i46 = 0; c2_i46 < 6; c2_i46++) {
    c2_u[c2_i46] = c2_b_inData[c2_i46];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance, const
  mxArray *c2_eta_dot, const char_T *c2_identifier, real_T c2_y[6])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_eta_dot), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_eta_dot);
}

static void c2_b_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[6])
{
  real_T c2_dv3[6];
  int32_T c2_i47;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv3, 1, 0, 0U, 1, 0U, 1, 6);
  for (c2_i47 = 0; c2_i47 < 6; c2_i47++) {
    c2_y[c2_i47] = c2_dv3[c2_i47];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_eta_dot;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[6];
  int32_T c2_i48;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_eta_dot = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_eta_dot), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_eta_dot);
  for (c2_i48 = 0; c2_i48 < 6; c2_i48++) {
    (*(real_T (*)[6])c2_outData)[c2_i48] = c2_y[c2_i48];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_c_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d0, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_nargout;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_nargout = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_nargout), &c2_thisId);
  sf_mex_destroy(&c2_nargout);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i49;
  int32_T c2_i50;
  int32_T c2_i51;
  real_T c2_b_inData[36];
  int32_T c2_i52;
  int32_T c2_i53;
  int32_T c2_i54;
  real_T c2_u[36];
  const mxArray *c2_y = NULL;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i49 = 0;
  for (c2_i50 = 0; c2_i50 < 6; c2_i50++) {
    for (c2_i51 = 0; c2_i51 < 6; c2_i51++) {
      c2_b_inData[c2_i51 + c2_i49] = (*(real_T (*)[36])c2_inData)[c2_i51 +
        c2_i49];
    }

    c2_i49 += 6;
  }

  c2_i52 = 0;
  for (c2_i53 = 0; c2_i53 < 6; c2_i53++) {
    for (c2_i54 = 0; c2_i54 < 6; c2_i54++) {
      c2_u[c2_i54 + c2_i52] = c2_b_inData[c2_i54 + c2_i52];
    }

    c2_i52 += 6;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_d_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[36])
{
  real_T c2_dv4[36];
  int32_T c2_i55;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv4, 1, 0, 0U, 1, 0U, 2, 6, 6);
  for (c2_i55 = 0; c2_i55 < 36; c2_i55++) {
    c2_y[c2_i55] = c2_dv4[c2_i55];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_rot;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[36];
  int32_T c2_i56;
  int32_T c2_i57;
  int32_T c2_i58;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_rot = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_rot), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_rot);
  c2_i56 = 0;
  for (c2_i57 = 0; c2_i57 < 6; c2_i57++) {
    for (c2_i58 = 0; c2_i58 < 6; c2_i58++) {
      (*(real_T (*)[36])c2_outData)[c2_i58 + c2_i56] = c2_y[c2_i58 + c2_i56];
    }

    c2_i56 += 6;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i59;
  int32_T c2_i60;
  int32_T c2_i61;
  real_T c2_b_inData[9];
  int32_T c2_i62;
  int32_T c2_i63;
  int32_T c2_i64;
  real_T c2_u[9];
  const mxArray *c2_y = NULL;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i59 = 0;
  for (c2_i60 = 0; c2_i60 < 3; c2_i60++) {
    for (c2_i61 = 0; c2_i61 < 3; c2_i61++) {
      c2_b_inData[c2_i61 + c2_i59] = (*(real_T (*)[9])c2_inData)[c2_i61 + c2_i59];
    }

    c2_i59 += 3;
  }

  c2_i62 = 0;
  for (c2_i63 = 0; c2_i63 < 3; c2_i63++) {
    for (c2_i64 = 0; c2_i64 < 3; c2_i64++) {
      c2_u[c2_i64 + c2_i62] = c2_b_inData[c2_i64 + c2_i62];
    }

    c2_i62 += 3;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_e_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[9])
{
  real_T c2_dv5[9];
  int32_T c2_i65;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv5, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c2_i65 = 0; c2_i65 < 9; c2_i65++) {
    c2_y[c2_i65] = c2_dv5[c2_i65];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_T;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[9];
  int32_T c2_i66;
  int32_T c2_i67;
  int32_T c2_i68;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_T = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_T), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_T);
  c2_i66 = 0;
  for (c2_i67 = 0; c2_i67 < 3; c2_i67++) {
    for (c2_i68 = 0; c2_i68 < 3; c2_i68++) {
      (*(real_T (*)[9])c2_outData)[c2_i68 + c2_i66] = c2_y[c2_i68 + c2_i66];
    }

    c2_i66 += 3;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

const mxArray *sf_c2_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c2_nameCaptureInfo;
  c2_ResolvedFunctionInfo c2_info[15];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i69;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_nameCaptureInfo = NULL;
  c2_info_helper(c2_info);
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 15), FALSE);
  for (c2_i69 = 0; c2_i69 < 15; c2_i69++) {
    c2_r0 = &c2_info[c2_i69];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context", "nameCaptureInfo",
                    c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name", "nameCaptureInfo", c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved", "nameCaptureInfo",
                    c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c2_i69);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c2_i69);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0, FALSE);
  return c2_nameCaptureInfo;
}

static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[15])
{
  c2_info[0].context = "";
  c2_info[0].name = "cos";
  c2_info[0].dominantType = "double";
  c2_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c2_info[0].fileTimeLo = 1286818706U;
  c2_info[0].fileTimeHi = 0U;
  c2_info[0].mFileTimeLo = 0U;
  c2_info[0].mFileTimeHi = 0U;
  c2_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c2_info[1].name = "eml_scalar_cos";
  c2_info[1].dominantType = "double";
  c2_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c2_info[1].fileTimeLo = 1286818722U;
  c2_info[1].fileTimeHi = 0U;
  c2_info[1].mFileTimeLo = 0U;
  c2_info[1].mFileTimeHi = 0U;
  c2_info[2].context = "";
  c2_info[2].name = "sin";
  c2_info[2].dominantType = "double";
  c2_info[2].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c2_info[2].fileTimeLo = 1286818750U;
  c2_info[2].fileTimeHi = 0U;
  c2_info[2].mFileTimeLo = 0U;
  c2_info[2].mFileTimeHi = 0U;
  c2_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c2_info[3].name = "eml_scalar_sin";
  c2_info[3].dominantType = "double";
  c2_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c2_info[3].fileTimeLo = 1286818736U;
  c2_info[3].fileTimeHi = 0U;
  c2_info[3].mFileTimeLo = 0U;
  c2_info[3].mFileTimeHi = 0U;
  c2_info[4].context = "";
  c2_info[4].name = "tan";
  c2_info[4].dominantType = "double";
  c2_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/tan.m";
  c2_info[4].fileTimeLo = 1286818752U;
  c2_info[4].fileTimeHi = 0U;
  c2_info[4].mFileTimeLo = 0U;
  c2_info[4].mFileTimeHi = 0U;
  c2_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/tan.m";
  c2_info[5].name = "eml_scalar_tan";
  c2_info[5].dominantType = "double";
  c2_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_tan.m";
  c2_info[5].fileTimeLo = 1286818738U;
  c2_info[5].fileTimeHi = 0U;
  c2_info[5].mFileTimeLo = 0U;
  c2_info[5].mFileTimeHi = 0U;
  c2_info[6].context = "";
  c2_info[6].name = "mtimes";
  c2_info[6].dominantType = "double";
  c2_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[6].fileTimeLo = 1289519692U;
  c2_info[6].fileTimeHi = 0U;
  c2_info[6].mFileTimeLo = 0U;
  c2_info[6].mFileTimeHi = 0U;
  c2_info[7].context = "";
  c2_info[7].name = "mrdivide";
  c2_info[7].dominantType = "double";
  c2_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c2_info[7].fileTimeLo = 1310137456U;
  c2_info[7].fileTimeHi = 0U;
  c2_info[7].mFileTimeLo = 1289519692U;
  c2_info[7].mFileTimeHi = 0U;
  c2_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c2_info[8].name = "rdivide";
  c2_info[8].dominantType = "double";
  c2_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[8].fileTimeLo = 1286818844U;
  c2_info[8].fileTimeHi = 0U;
  c2_info[8].mFileTimeLo = 0U;
  c2_info[8].mFileTimeHi = 0U;
  c2_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[9].name = "eml_div";
  c2_info[9].dominantType = "double";
  c2_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c2_info[9].fileTimeLo = 1305318000U;
  c2_info[9].fileTimeHi = 0U;
  c2_info[9].mFileTimeLo = 0U;
  c2_info[9].mFileTimeHi = 0U;
  c2_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[10].name = "eml_index_class";
  c2_info[10].dominantType = "";
  c2_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[10].fileTimeLo = 1286818778U;
  c2_info[10].fileTimeHi = 0U;
  c2_info[10].mFileTimeLo = 0U;
  c2_info[10].mFileTimeHi = 0U;
  c2_info[11].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[11].name = "eml_scalar_eg";
  c2_info[11].dominantType = "double";
  c2_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[11].fileTimeLo = 1286818796U;
  c2_info[11].fileTimeHi = 0U;
  c2_info[11].mFileTimeLo = 0U;
  c2_info[11].mFileTimeHi = 0U;
  c2_info[12].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[12].name = "eml_xgemm";
  c2_info[12].dominantType = "int32";
  c2_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c2_info[12].fileTimeLo = 1299076772U;
  c2_info[12].fileTimeHi = 0U;
  c2_info[12].mFileTimeLo = 0U;
  c2_info[12].mFileTimeHi = 0U;
  c2_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c2_info[13].name = "eml_blas_inline";
  c2_info[13].dominantType = "";
  c2_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c2_info[13].fileTimeLo = 1299076768U;
  c2_info[13].fileTimeHi = 0U;
  c2_info[13].mFileTimeLo = 0U;
  c2_info[13].mFileTimeHi = 0U;
  c2_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[14].name = "eml_refblas_xgemm";
  c2_info[14].dominantType = "int32";
  c2_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c2_info[14].fileTimeLo = 1299076774U;
  c2_info[14].fileTimeHi = 0U;
  c2_info[14].mFileTimeLo = 0U;
  c2_info[14].mFileTimeHi = 0U;
}

static void c2_eml_scalar_eg(SFc2_ref_genInstanceStruct *chartInstance)
{
}

static void c2_eml_xgemm(SFc2_ref_genInstanceStruct *chartInstance, real_T c2_A
  [9], real_T c2_B[9], real_T c2_C[9], real_T c2_b_C[9])
{
  int32_T c2_i70;
  int32_T c2_i71;
  real_T c2_b_A[9];
  int32_T c2_i72;
  real_T c2_b_B[9];
  for (c2_i70 = 0; c2_i70 < 9; c2_i70++) {
    c2_b_C[c2_i70] = c2_C[c2_i70];
  }

  for (c2_i71 = 0; c2_i71 < 9; c2_i71++) {
    c2_b_A[c2_i71] = c2_A[c2_i71];
  }

  for (c2_i72 = 0; c2_i72 < 9; c2_i72++) {
    c2_b_B[c2_i72] = c2_B[c2_i72];
  }

  c2_b_eml_xgemm(chartInstance, c2_b_A, c2_b_B, c2_b_C);
}

static void c2_b_eml_scalar_eg(SFc2_ref_genInstanceStruct *chartInstance)
{
}

static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(int32_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static int32_T c2_f_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  int32_T c2_y;
  int32_T c2_i73;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_i73, 1, 6, 0U, 0, 0U, 0);
  c2_y = c2_i73;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_sfEvent;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  int32_T c2_y;
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)chartInstanceVoid;
  c2_b_sfEvent = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_sfEvent),
    &c2_thisId);
  sf_mex_destroy(&c2_b_sfEvent);
  *(int32_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static uint8_T c2_g_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_b_is_active_c2_ref_gen, const char_T *c2_identifier)
{
  uint8_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c2_b_is_active_c2_ref_gen), &c2_thisId);
  sf_mex_destroy(&c2_b_is_active_c2_ref_gen);
  return c2_y;
}

static uint8_T c2_h_emlrt_marshallIn(SFc2_ref_genInstanceStruct *chartInstance,
  const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_u0, 1, 3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_b_eml_xgemm(SFc2_ref_genInstanceStruct *chartInstance, real_T
  c2_A[9], real_T c2_B[9], real_T c2_C[9])
{
  int32_T c2_i74;
  int32_T c2_i75;
  int32_T c2_i76;
  int32_T c2_i77;
  int32_T c2_i78;
  for (c2_i74 = 0; c2_i74 < 3; c2_i74++) {
    c2_i75 = 0;
    for (c2_i76 = 0; c2_i76 < 3; c2_i76++) {
      c2_C[c2_i75 + c2_i74] = 0.0;
      c2_i77 = 0;
      for (c2_i78 = 0; c2_i78 < 3; c2_i78++) {
        c2_C[c2_i75 + c2_i74] += c2_A[c2_i77 + c2_i74] * c2_B[c2_i78 + c2_i75];
        c2_i77 += 3;
      }

      c2_i75 += 3;
    }
  }
}

static void init_dsm_address_info(SFc2_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c2_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1231324432U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1655134602U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3881213252U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2809551279U);
}

mxArray *sf_c2_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("JyLy41slfgfsXBI8jFct5");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c2_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[10],T\"eta_dot\",},{M[8],M[0],T\"is_active_c2_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc2_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          2,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"nu_body");
          _SFD_SET_DATA_PROPS(1,2,0,1,"eta_dot");
          _SFD_SET_DATA_PROPS(2,1,1,0,"eta");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,690);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)
            c2_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c2_nu_body)[6];
          real_T (*c2_eta_dot)[6];
          real_T (*c2_eta)[6];
          c2_eta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
          c2_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          c2_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c2_nu_body);
          _SFD_SET_DATA_VALUE_PTR(1U, *c2_eta_dot);
          _SFD_SET_DATA_VALUE_PTR(2U, *c2_eta);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c2_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc2_ref_genInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c2_ref_gen(void *chartInstanceVar)
{
  enable_c2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c2_ref_gen(void *chartInstanceVar)
{
  disable_c2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c2_ref_gen(void *chartInstanceVar)
{
  sf_c2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c2_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_ref_gen((SFc2_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c2_ref_gen(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_ref_gen((SFc2_ref_genInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c2_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c2_ref_gen(S);
}

static void sf_opaque_set_sim_state_c2_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c2_ref_gen(S, st);
}

static void sf_opaque_terminate_c2_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc2_ref_gen((SFc2_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_ref_gen((SFc2_ref_genInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,2,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,2,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,2,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1894179882U));
  ssSetChecksum1(S,(3397239648U));
  ssSetChecksum2(S,(920743664U));
  ssSetChecksum3(S,(2649933951U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c2_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_ref_gen(SimStruct *S)
{
  SFc2_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc2_ref_genInstanceStruct *)malloc(sizeof
    (SFc2_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc2_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c2_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c2_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c2_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c2_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c2_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c2_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c2_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c2_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c2_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c2_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c2_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
