/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c4_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c4_debug_family_names[45] = { "a_x", "a_y", "Fx_fl", "Fx_fr",
  "Fx_rl", "Fx_rr", "Fy_fl", "Fy_fr", "Fy_rl", "Fy_rr", "Fz_fl", "Fz_fr",
  "Fz_rl", "Fz_rr", "r_fl", "r_fr", "r_rl", "r_rr", "R", "F_fl", "M_fl", "F_fr",
  "M_fr", "F_rl", "M_rl", "F_rr", "M_rr", "nargin", "nargout", "F_rolling",
  "F_air", "Fx_wheel", "Fy_wheel", "Fz_wheel", "delta", "a_xyz", "h_cg", "m_car",
  "l_front", "l_rear", "l_tread", "tau", "F_CG", "M_CG", "F_Y" };

/* Function Declarations */
static void initialize_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void initialize_params_c4_ref_gen(SFc4_ref_genInstanceStruct
  *chartInstance);
static void enable_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void disable_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void c4_update_debugger_state_c4_ref_gen(SFc4_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c4_ref_gen(SFc4_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_st);
static void finalize_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void sf_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void c4_chartstep_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void initSimStructsc4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData);
static void c4_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance, const
  mxArray *c4_F_Y, const char_T *c4_identifier, real_T c4_y[4]);
static void c4_b_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[4]);
static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_c_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_M_CG, const char_T *c4_identifier, real_T c4_y[3]);
static void c4_d_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[3]);
static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_e_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_tau, const char_T *c4_identifier, real_T c4_y[6]);
static void c4_f_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[6]);
static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_d_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static real_T c4_g_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_e_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_h_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[9]);
static void c4_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[14]);
static real_T c4_mrdivide(SFc4_ref_genInstanceStruct *chartInstance, real_T c4_A,
  real_T c4_B);
static void c4_eml_scalar_eg(SFc4_ref_genInstanceStruct *chartInstance);
static void c4_cross(SFc4_ref_genInstanceStruct *chartInstance, real_T c4_a[3],
                     real_T c4_b[3], real_T c4_c[3]);
static const mxArray *c4_f_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static int32_T c4_i_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static uint8_T c4_j_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_b_is_active_c4_ref_gen, const char_T *c4_identifier);
static uint8_T c4_k_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void init_dsm_address_info(SFc4_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c4_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c4_is_active_c4_ref_gen = 0U;
}

static void initialize_params_c4_ref_gen(SFc4_ref_genInstanceStruct
  *chartInstance)
{
  real_T c4_d0;
  real_T c4_d1;
  real_T c4_d2;
  real_T c4_d3;
  real_T c4_d4;
  sf_set_error_prefix_string(
    "Error evaluating data 'h_cg' in the parent workspace.\n");
  sf_mex_import_named("h_cg", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c4_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c4_h_cg = c4_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      &c4_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c4_m_car = c4_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_front' in the parent workspace.\n");
  sf_mex_import_named("l_front", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c4_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c4_l_front = c4_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_rear' in the parent workspace.\n");
  sf_mex_import_named("l_rear", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c4_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c4_l_rear = c4_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_tread' in the parent workspace.\n");
  sf_mex_import_named("l_tread", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c4_d4, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c4_l_tread = c4_d4;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c4_update_debugger_state_c4_ref_gen(SFc4_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c4_ref_gen(SFc4_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c4_st;
  const mxArray *c4_y = NULL;
  int32_T c4_i0;
  real_T c4_u[3];
  const mxArray *c4_b_y = NULL;
  int32_T c4_i1;
  real_T c4_b_u[4];
  const mxArray *c4_c_y = NULL;
  int32_T c4_i2;
  real_T c4_c_u[3];
  const mxArray *c4_d_y = NULL;
  int32_T c4_i3;
  real_T c4_d_u[6];
  const mxArray *c4_e_y = NULL;
  uint8_T c4_hoistedGlobal;
  uint8_T c4_e_u;
  const mxArray *c4_f_y = NULL;
  real_T (*c4_tau)[6];
  real_T (*c4_M_CG)[3];
  real_T (*c4_F_Y)[4];
  real_T (*c4_F_CG)[3];
  c4_F_Y = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c4_M_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c4_F_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_tau = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c4_st = NULL;
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(5), FALSE);
  for (c4_i0 = 0; c4_i0 < 3; c4_i0++) {
    c4_u[c4_i0] = (*c4_F_CG)[c4_i0];
  }

  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c4_y, 0, c4_b_y);
  for (c4_i1 = 0; c4_i1 < 4; c4_i1++) {
    c4_b_u[c4_i1] = (*c4_F_Y)[c4_i1];
  }

  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", c4_b_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c4_y, 1, c4_c_y);
  for (c4_i2 = 0; c4_i2 < 3; c4_i2++) {
    c4_c_u[c4_i2] = (*c4_M_CG)[c4_i2];
  }

  c4_d_y = NULL;
  sf_mex_assign(&c4_d_y, sf_mex_create("y", c4_c_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c4_y, 2, c4_d_y);
  for (c4_i3 = 0; c4_i3 < 6; c4_i3++) {
    c4_d_u[c4_i3] = (*c4_tau)[c4_i3];
  }

  c4_e_y = NULL;
  sf_mex_assign(&c4_e_y, sf_mex_create("y", c4_d_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c4_y, 3, c4_e_y);
  c4_hoistedGlobal = chartInstance->c4_is_active_c4_ref_gen;
  c4_e_u = c4_hoistedGlobal;
  c4_f_y = NULL;
  sf_mex_assign(&c4_f_y, sf_mex_create("y", &c4_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 4, c4_f_y);
  sf_mex_assign(&c4_st, c4_y, FALSE);
  return c4_st;
}

static void set_sim_state_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T c4_dv0[3];
  int32_T c4_i4;
  real_T c4_dv1[4];
  int32_T c4_i5;
  real_T c4_dv2[3];
  int32_T c4_i6;
  real_T c4_dv3[6];
  int32_T c4_i7;
  real_T (*c4_F_CG)[3];
  real_T (*c4_F_Y)[4];
  real_T (*c4_M_CG)[3];
  real_T (*c4_tau)[6];
  c4_F_Y = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c4_M_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c4_F_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_tau = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c4_doneDoubleBufferReInit = TRUE;
  c4_u = sf_mex_dup(c4_st);
  c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 0)),
                        "F_CG", c4_dv0);
  for (c4_i4 = 0; c4_i4 < 3; c4_i4++) {
    (*c4_F_CG)[c4_i4] = c4_dv0[c4_i4];
  }

  c4_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 1)), "F_Y",
                      c4_dv1);
  for (c4_i5 = 0; c4_i5 < 4; c4_i5++) {
    (*c4_F_Y)[c4_i5] = c4_dv1[c4_i5];
  }

  c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 2)),
                        "M_CG", c4_dv2);
  for (c4_i6 = 0; c4_i6 < 3; c4_i6++) {
    (*c4_M_CG)[c4_i6] = c4_dv2[c4_i6];
  }

  c4_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 3)),
                        "tau", c4_dv3);
  for (c4_i7 = 0; c4_i7 < 6; c4_i7++) {
    (*c4_tau)[c4_i7] = c4_dv3[c4_i7];
  }

  chartInstance->c4_is_active_c4_ref_gen = c4_j_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 4)), "is_active_c4_ref_gen");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_ref_gen(chartInstance);
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
  int32_T c4_i8;
  int32_T c4_i9;
  int32_T c4_i10;
  int32_T c4_i11;
  int32_T c4_i12;
  int32_T c4_i13;
  int32_T c4_i14;
  int32_T c4_i15;
  int32_T c4_i16;
  int32_T c4_i17;
  real_T *c4_delta;
  real_T (*c4_F_Y)[4];
  real_T (*c4_M_CG)[3];
  real_T (*c4_F_CG)[3];
  real_T (*c4_tau)[6];
  real_T (*c4_a_xyz)[3];
  real_T (*c4_Fz_wheel)[4];
  real_T (*c4_Fy_wheel)[4];
  real_T (*c4_Fx_wheel)[4];
  real_T (*c4_F_air)[3];
  real_T (*c4_F_rolling)[3];
  c4_F_Y = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c4_M_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c4_F_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_tau = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c4_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c4_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c4_Fz_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 4);
  c4_Fy_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c4_Fx_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c4_F_air = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c4_F_rolling = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  for (c4_i8 = 0; c4_i8 < 3; c4_i8++) {
    _SFD_DATA_RANGE_CHECK((*c4_F_rolling)[c4_i8], 0U);
  }

  for (c4_i9 = 0; c4_i9 < 3; c4_i9++) {
    _SFD_DATA_RANGE_CHECK((*c4_F_air)[c4_i9], 1U);
  }

  for (c4_i10 = 0; c4_i10 < 4; c4_i10++) {
    _SFD_DATA_RANGE_CHECK((*c4_Fx_wheel)[c4_i10], 2U);
  }

  for (c4_i11 = 0; c4_i11 < 4; c4_i11++) {
    _SFD_DATA_RANGE_CHECK((*c4_Fy_wheel)[c4_i11], 3U);
  }

  for (c4_i12 = 0; c4_i12 < 4; c4_i12++) {
    _SFD_DATA_RANGE_CHECK((*c4_Fz_wheel)[c4_i12], 4U);
  }

  _SFD_DATA_RANGE_CHECK(*c4_delta, 5U);
  for (c4_i13 = 0; c4_i13 < 3; c4_i13++) {
    _SFD_DATA_RANGE_CHECK((*c4_a_xyz)[c4_i13], 6U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c4_h_cg, 7U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c4_m_car, 8U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c4_l_front, 9U);
  for (c4_i14 = 0; c4_i14 < 6; c4_i14++) {
    _SFD_DATA_RANGE_CHECK((*c4_tau)[c4_i14], 10U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c4_l_rear, 11U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c4_l_tread, 12U);
  for (c4_i15 = 0; c4_i15 < 3; c4_i15++) {
    _SFD_DATA_RANGE_CHECK((*c4_F_CG)[c4_i15], 13U);
  }

  for (c4_i16 = 0; c4_i16 < 3; c4_i16++) {
    _SFD_DATA_RANGE_CHECK((*c4_M_CG)[c4_i16], 14U);
  }

  for (c4_i17 = 0; c4_i17 < 4; c4_i17++) {
    _SFD_DATA_RANGE_CHECK((*c4_F_Y)[c4_i17], 15U);
  }

  chartInstance->c4_sfEvent = CALL_EVENT;
  c4_chartstep_c4_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c4_chartstep_c4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
  real_T c4_hoistedGlobal;
  real_T c4_b_hoistedGlobal;
  real_T c4_c_hoistedGlobal;
  real_T c4_d_hoistedGlobal;
  real_T c4_e_hoistedGlobal;
  real_T c4_f_hoistedGlobal;
  int32_T c4_i18;
  real_T c4_F_rolling[3];
  int32_T c4_i19;
  real_T c4_F_air[3];
  int32_T c4_i20;
  real_T c4_Fx_wheel[4];
  int32_T c4_i21;
  real_T c4_Fy_wheel[4];
  int32_T c4_i22;
  real_T c4_Fz_wheel[4];
  real_T c4_delta;
  int32_T c4_i23;
  real_T c4_a_xyz[3];
  real_T c4_b_h_cg;
  real_T c4_b_m_car;
  real_T c4_b_l_front;
  real_T c4_b_l_rear;
  real_T c4_b_l_tread;
  uint32_T c4_debug_family_var_map[45];
  real_T c4_a_x;
  real_T c4_a_y;
  real_T c4_Fx_fl;
  real_T c4_Fx_fr;
  real_T c4_Fx_rl;
  real_T c4_Fx_rr;
  real_T c4_Fy_fl;
  real_T c4_Fy_fr;
  real_T c4_Fy_rl;
  real_T c4_Fy_rr;
  real_T c4_Fz_fl;
  real_T c4_Fz_fr;
  real_T c4_Fz_rl;
  real_T c4_Fz_rr;
  real_T c4_r_fl[3];
  real_T c4_r_fr[3];
  real_T c4_r_rl[3];
  real_T c4_r_rr[3];
  real_T c4_R[9];
  real_T c4_F_fl[3];
  real_T c4_M_fl[3];
  real_T c4_F_fr[3];
  real_T c4_M_fr[3];
  real_T c4_F_rl[3];
  real_T c4_M_rl[3];
  real_T c4_F_rr[3];
  real_T c4_M_rr[3];
  real_T c4_nargin = 12.0;
  real_T c4_nargout = 4.0;
  real_T c4_tau[6];
  real_T c4_F_CG[3];
  real_T c4_M_CG[3];
  real_T c4_F_Y[4];
  real_T c4_d5;
  real_T c4_c_l_front[3];
  int32_T c4_i24;
  real_T c4_d6;
  real_T c4_d_l_front[3];
  int32_T c4_i25;
  real_T c4_d7;
  real_T c4_c_l_rear[3];
  int32_T c4_i26;
  real_T c4_d8;
  real_T c4_d_l_rear[3];
  int32_T c4_i27;
  real_T c4_x;
  real_T c4_b_x;
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_e_x;
  real_T c4_f_x;
  real_T c4_g_x;
  real_T c4_h_x;
  int32_T c4_i28;
  int32_T c4_i29;
  static real_T c4_dv4[3] = { 0.0, 0.0, 1.0 };

  int32_T c4_i30;
  int32_T c4_i31;
  int32_T c4_i32;
  int32_T c4_i33;
  real_T c4_a[9];
  real_T c4_b_Fx_fl[3];
  int32_T c4_i34;
  real_T c4_b[3];
  int32_T c4_i35;
  int32_T c4_i36;
  int32_T c4_i37;
  real_T c4_C[3];
  int32_T c4_i38;
  int32_T c4_i39;
  int32_T c4_i40;
  int32_T c4_i41;
  int32_T c4_i42;
  int32_T c4_i43;
  int32_T c4_i44;
  real_T c4_b_r_fl[3];
  int32_T c4_i45;
  real_T c4_b_F_fl[3];
  real_T c4_dv5[3];
  int32_T c4_i46;
  int32_T c4_i47;
  int32_T c4_i48;
  int32_T c4_i49;
  int32_T c4_i50;
  real_T c4_b_Fx_fr[3];
  int32_T c4_i51;
  int32_T c4_i52;
  int32_T c4_i53;
  int32_T c4_i54;
  int32_T c4_i55;
  int32_T c4_i56;
  int32_T c4_i57;
  int32_T c4_i58;
  int32_T c4_i59;
  int32_T c4_i60;
  int32_T c4_i61;
  real_T c4_b_r_fr[3];
  int32_T c4_i62;
  real_T c4_b_F_fr[3];
  real_T c4_dv6[3];
  int32_T c4_i63;
  real_T c4_b_Fx_rl[3];
  int32_T c4_i64;
  int32_T c4_i65;
  real_T c4_b_r_rl[3];
  int32_T c4_i66;
  real_T c4_b_F_rl[3];
  real_T c4_dv7[3];
  int32_T c4_i67;
  real_T c4_b_Fx_rr[3];
  int32_T c4_i68;
  int32_T c4_i69;
  real_T c4_b_r_rr[3];
  int32_T c4_i70;
  real_T c4_b_F_rr[3];
  real_T c4_dv8[3];
  int32_T c4_i71;
  int32_T c4_i72;
  real_T c4_b_a;
  real_T c4_b_b;
  real_T c4_y;
  real_T c4_c_a;
  real_T c4_c_b;
  real_T c4_b_y;
  real_T c4_d_a;
  real_T c4_d_b;
  real_T c4_c_y;
  real_T c4_e_a;
  real_T c4_e_b;
  real_T c4_d_y;
  real_T c4_e_y[3];
  int32_T c4_i73;
  int32_T c4_i74;
  int32_T c4_i75;
  int32_T c4_i76;
  int32_T c4_i77;
  int32_T c4_i78;
  int32_T c4_i79;
  real_T *c4_b_delta;
  real_T (*c4_b_tau)[6];
  real_T (*c4_b_F_CG)[3];
  real_T (*c4_b_M_CG)[3];
  real_T (*c4_b_F_Y)[4];
  real_T (*c4_b_a_xyz)[3];
  real_T (*c4_b_Fz_wheel)[4];
  real_T (*c4_b_Fy_wheel)[4];
  real_T (*c4_b_Fx_wheel)[4];
  real_T (*c4_b_F_air)[3];
  real_T (*c4_b_F_rolling)[3];
  c4_b_F_Y = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
  c4_b_M_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c4_b_F_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_b_tau = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c4_b_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c4_b_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c4_b_Fz_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 4);
  c4_b_Fy_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c4_b_Fx_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c4_b_F_air = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c4_b_F_rolling = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  c4_hoistedGlobal = *c4_b_delta;
  c4_b_hoistedGlobal = chartInstance->c4_h_cg;
  c4_c_hoistedGlobal = chartInstance->c4_m_car;
  c4_d_hoistedGlobal = chartInstance->c4_l_front;
  c4_e_hoistedGlobal = chartInstance->c4_l_rear;
  c4_f_hoistedGlobal = chartInstance->c4_l_tread;
  for (c4_i18 = 0; c4_i18 < 3; c4_i18++) {
    c4_F_rolling[c4_i18] = (*c4_b_F_rolling)[c4_i18];
  }

  for (c4_i19 = 0; c4_i19 < 3; c4_i19++) {
    c4_F_air[c4_i19] = (*c4_b_F_air)[c4_i19];
  }

  for (c4_i20 = 0; c4_i20 < 4; c4_i20++) {
    c4_Fx_wheel[c4_i20] = (*c4_b_Fx_wheel)[c4_i20];
  }

  for (c4_i21 = 0; c4_i21 < 4; c4_i21++) {
    c4_Fy_wheel[c4_i21] = (*c4_b_Fy_wheel)[c4_i21];
  }

  for (c4_i22 = 0; c4_i22 < 4; c4_i22++) {
    c4_Fz_wheel[c4_i22] = (*c4_b_Fz_wheel)[c4_i22];
  }

  c4_delta = c4_hoistedGlobal;
  for (c4_i23 = 0; c4_i23 < 3; c4_i23++) {
    c4_a_xyz[c4_i23] = (*c4_b_a_xyz)[c4_i23];
  }

  c4_b_h_cg = c4_b_hoistedGlobal;
  c4_b_m_car = c4_c_hoistedGlobal;
  c4_b_l_front = c4_d_hoistedGlobal;
  c4_b_l_rear = c4_e_hoistedGlobal;
  c4_b_l_tread = c4_f_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 45U, 45U, c4_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c4_a_x, 0U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_a_y, 1U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fx_fl, 2U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fx_fr, 3U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fx_rl, 4U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fx_rr, 5U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fy_fl, 6U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fy_fr, 7U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fy_rl, 8U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fy_rr, 9U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fz_fl, 10U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fz_fr, 11U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fz_rl, 12U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Fz_rr, 13U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_r_fl, 14U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_r_fr, 15U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_r_rl, 16U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_r_rr, 17U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_R, 18U, c4_e_sf_marshallOut,
    c4_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_F_fl, 19U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_M_fl, 20U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_F_fr, 21U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_M_fr, 22U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_F_rl, 23U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_M_rl, 24U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_F_rr, 25U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_M_rr, 26U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 27U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 28U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c4_F_rolling, 29U, c4_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_F_air, 30U, c4_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_Fx_wheel, 31U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_Fy_wheel, 32U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_Fz_wheel, 33U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_delta, 34U, c4_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c4_a_xyz, 35U, c4_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_b_h_cg, 36U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_b_m_car, 37U, c4_d_sf_marshallOut,
    c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_b_l_front, 38U,
    c4_d_sf_marshallOut, c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_b_l_rear, 39U,
    c4_d_sf_marshallOut, c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_b_l_tread, 40U,
    c4_d_sf_marshallOut, c4_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_tau, 41U, c4_c_sf_marshallOut,
    c4_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_F_CG, 42U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_M_CG, 43U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c4_F_Y, 44U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 3);
  c4_a_x = c4_a_xyz[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 4);
  c4_a_y = c4_a_xyz[1];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 7);
  c4_Fx_fl = c4_Fx_wheel[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 8);
  c4_Fx_fr = c4_Fx_wheel[1];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 9);
  c4_Fx_rl = c4_Fx_wheel[2];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 10);
  c4_Fx_rr = c4_Fx_wheel[3];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 12);
  c4_Fy_fl = c4_Fy_wheel[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 13);
  c4_Fy_fr = c4_Fy_wheel[1];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 14);
  c4_Fy_rl = c4_Fy_wheel[2];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 15);
  c4_Fy_rr = c4_Fy_wheel[3];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 17);
  c4_Fz_fl = -c4_Fz_wheel[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 18);
  c4_Fz_fr = -c4_Fz_wheel[1];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 19);
  c4_Fz_rl = -c4_Fz_wheel[2];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 20);
  c4_Fz_rr = -c4_Fz_wheel[3];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 23);
  c4_d5 = c4_mrdivide(chartInstance, c4_b_l_tread, 2.0);
  c4_c_l_front[0] = c4_b_l_front;
  c4_c_l_front[1] = c4_d5;
  c4_c_l_front[2] = -c4_b_h_cg;
  for (c4_i24 = 0; c4_i24 < 3; c4_i24++) {
    c4_r_fl[c4_i24] = c4_c_l_front[c4_i24];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 24);
  c4_d6 = c4_mrdivide(chartInstance, -c4_b_l_tread, 2.0);
  c4_d_l_front[0] = c4_b_l_front;
  c4_d_l_front[1] = c4_d6;
  c4_d_l_front[2] = -c4_b_h_cg;
  for (c4_i25 = 0; c4_i25 < 3; c4_i25++) {
    c4_r_fr[c4_i25] = c4_d_l_front[c4_i25];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 25);
  c4_d7 = c4_mrdivide(chartInstance, c4_b_l_tread, 2.0);
  c4_c_l_rear[0] = -c4_b_l_rear;
  c4_c_l_rear[1] = c4_d7;
  c4_c_l_rear[2] = -c4_b_h_cg;
  for (c4_i26 = 0; c4_i26 < 3; c4_i26++) {
    c4_r_rl[c4_i26] = c4_c_l_rear[c4_i26];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 26);
  c4_d8 = c4_mrdivide(chartInstance, -c4_b_l_tread, 2.0);
  c4_d_l_rear[0] = -c4_b_l_rear;
  c4_d_l_rear[1] = c4_d8;
  c4_d_l_rear[2] = -c4_b_h_cg;
  for (c4_i27 = 0; c4_i27 < 3; c4_i27++) {
    c4_r_rr[c4_i27] = c4_d_l_rear[c4_i27];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 29);
  c4_x = c4_delta;
  c4_b_x = c4_x;
  c4_b_x = muDoubleScalarCos(c4_b_x);
  c4_c_x = c4_delta;
  c4_d_x = c4_c_x;
  c4_d_x = muDoubleScalarSin(c4_d_x);
  c4_e_x = c4_delta;
  c4_f_x = c4_e_x;
  c4_f_x = muDoubleScalarSin(c4_f_x);
  c4_g_x = c4_delta;
  c4_h_x = c4_g_x;
  c4_h_x = muDoubleScalarCos(c4_h_x);
  c4_R[0] = c4_b_x;
  c4_R[3] = -c4_d_x;
  c4_R[6] = 0.0;
  c4_R[1] = c4_f_x;
  c4_R[4] = c4_h_x;
  c4_R[7] = 0.0;
  c4_i28 = 0;
  for (c4_i29 = 0; c4_i29 < 3; c4_i29++) {
    c4_R[c4_i28 + 2] = c4_dv4[c4_i29];
    c4_i28 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 34);
  c4_i30 = 0;
  for (c4_i31 = 0; c4_i31 < 3; c4_i31++) {
    c4_i32 = 0;
    for (c4_i33 = 0; c4_i33 < 3; c4_i33++) {
      c4_a[c4_i33 + c4_i30] = c4_R[c4_i32 + c4_i31];
      c4_i32 += 3;
    }

    c4_i30 += 3;
  }

  c4_b_Fx_fl[0] = c4_Fx_fl;
  c4_b_Fx_fl[1] = c4_Fy_fl;
  c4_b_Fx_fl[2] = c4_Fz_fl;
  for (c4_i34 = 0; c4_i34 < 3; c4_i34++) {
    c4_b[c4_i34] = c4_b_Fx_fl[c4_i34];
  }

  c4_eml_scalar_eg(chartInstance);
  c4_eml_scalar_eg(chartInstance);
  for (c4_i35 = 0; c4_i35 < 3; c4_i35++) {
    c4_F_fl[c4_i35] = 0.0;
  }

  for (c4_i36 = 0; c4_i36 < 3; c4_i36++) {
    c4_F_fl[c4_i36] = 0.0;
  }

  for (c4_i37 = 0; c4_i37 < 3; c4_i37++) {
    c4_C[c4_i37] = c4_F_fl[c4_i37];
  }

  for (c4_i38 = 0; c4_i38 < 3; c4_i38++) {
    c4_F_fl[c4_i38] = c4_C[c4_i38];
  }

  for (c4_i39 = 0; c4_i39 < 3; c4_i39++) {
    c4_C[c4_i39] = c4_F_fl[c4_i39];
  }

  for (c4_i40 = 0; c4_i40 < 3; c4_i40++) {
    c4_F_fl[c4_i40] = c4_C[c4_i40];
  }

  for (c4_i41 = 0; c4_i41 < 3; c4_i41++) {
    c4_F_fl[c4_i41] = 0.0;
    c4_i42 = 0;
    for (c4_i43 = 0; c4_i43 < 3; c4_i43++) {
      c4_F_fl[c4_i41] += c4_a[c4_i42 + c4_i41] * c4_b[c4_i43];
      c4_i42 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 35);
  for (c4_i44 = 0; c4_i44 < 3; c4_i44++) {
    c4_b_r_fl[c4_i44] = c4_r_fl[c4_i44];
  }

  for (c4_i45 = 0; c4_i45 < 3; c4_i45++) {
    c4_b_F_fl[c4_i45] = c4_F_fl[c4_i45];
  }

  c4_cross(chartInstance, c4_b_r_fl, c4_b_F_fl, c4_dv5);
  for (c4_i46 = 0; c4_i46 < 3; c4_i46++) {
    c4_M_fl[c4_i46] = c4_dv5[c4_i46];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 38);
  c4_i47 = 0;
  for (c4_i48 = 0; c4_i48 < 3; c4_i48++) {
    c4_i49 = 0;
    for (c4_i50 = 0; c4_i50 < 3; c4_i50++) {
      c4_a[c4_i50 + c4_i47] = c4_R[c4_i49 + c4_i48];
      c4_i49 += 3;
    }

    c4_i47 += 3;
  }

  c4_b_Fx_fr[0] = c4_Fx_fr;
  c4_b_Fx_fr[1] = c4_Fy_fr;
  c4_b_Fx_fr[2] = c4_Fz_fr;
  for (c4_i51 = 0; c4_i51 < 3; c4_i51++) {
    c4_b[c4_i51] = c4_b_Fx_fr[c4_i51];
  }

  c4_eml_scalar_eg(chartInstance);
  c4_eml_scalar_eg(chartInstance);
  for (c4_i52 = 0; c4_i52 < 3; c4_i52++) {
    c4_F_fr[c4_i52] = 0.0;
  }

  for (c4_i53 = 0; c4_i53 < 3; c4_i53++) {
    c4_F_fr[c4_i53] = 0.0;
  }

  for (c4_i54 = 0; c4_i54 < 3; c4_i54++) {
    c4_C[c4_i54] = c4_F_fr[c4_i54];
  }

  for (c4_i55 = 0; c4_i55 < 3; c4_i55++) {
    c4_F_fr[c4_i55] = c4_C[c4_i55];
  }

  for (c4_i56 = 0; c4_i56 < 3; c4_i56++) {
    c4_C[c4_i56] = c4_F_fr[c4_i56];
  }

  for (c4_i57 = 0; c4_i57 < 3; c4_i57++) {
    c4_F_fr[c4_i57] = c4_C[c4_i57];
  }

  for (c4_i58 = 0; c4_i58 < 3; c4_i58++) {
    c4_F_fr[c4_i58] = 0.0;
    c4_i59 = 0;
    for (c4_i60 = 0; c4_i60 < 3; c4_i60++) {
      c4_F_fr[c4_i58] += c4_a[c4_i59 + c4_i58] * c4_b[c4_i60];
      c4_i59 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 39);
  for (c4_i61 = 0; c4_i61 < 3; c4_i61++) {
    c4_b_r_fr[c4_i61] = c4_r_fr[c4_i61];
  }

  for (c4_i62 = 0; c4_i62 < 3; c4_i62++) {
    c4_b_F_fr[c4_i62] = c4_F_fr[c4_i62];
  }

  c4_cross(chartInstance, c4_b_r_fr, c4_b_F_fr, c4_dv6);
  for (c4_i63 = 0; c4_i63 < 3; c4_i63++) {
    c4_M_fr[c4_i63] = c4_dv6[c4_i63];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 42);
  c4_b_Fx_rl[0] = c4_Fx_rl;
  c4_b_Fx_rl[1] = c4_Fy_rl;
  c4_b_Fx_rl[2] = c4_Fz_rl;
  for (c4_i64 = 0; c4_i64 < 3; c4_i64++) {
    c4_F_rl[c4_i64] = c4_b_Fx_rl[c4_i64];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 43);
  for (c4_i65 = 0; c4_i65 < 3; c4_i65++) {
    c4_b_r_rl[c4_i65] = c4_r_rl[c4_i65];
  }

  for (c4_i66 = 0; c4_i66 < 3; c4_i66++) {
    c4_b_F_rl[c4_i66] = c4_F_rl[c4_i66];
  }

  c4_cross(chartInstance, c4_b_r_rl, c4_b_F_rl, c4_dv7);
  for (c4_i67 = 0; c4_i67 < 3; c4_i67++) {
    c4_M_rl[c4_i67] = c4_dv7[c4_i67];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 46);
  c4_b_Fx_rr[0] = c4_Fx_rr;
  c4_b_Fx_rr[1] = c4_Fy_rr;
  c4_b_Fx_rr[2] = c4_Fz_rr;
  for (c4_i68 = 0; c4_i68 < 3; c4_i68++) {
    c4_F_rr[c4_i68] = c4_b_Fx_rr[c4_i68];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 47);
  for (c4_i69 = 0; c4_i69 < 3; c4_i69++) {
    c4_b_r_rr[c4_i69] = c4_r_rr[c4_i69];
  }

  for (c4_i70 = 0; c4_i70 < 3; c4_i70++) {
    c4_b_F_rr[c4_i70] = c4_F_rr[c4_i70];
  }

  c4_cross(chartInstance, c4_b_r_rr, c4_b_F_rr, c4_dv8);
  for (c4_i71 = 0; c4_i71 < 3; c4_i71++) {
    c4_M_rr[c4_i71] = c4_dv8[c4_i71];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 50);
  for (c4_i72 = 0; c4_i72 < 3; c4_i72++) {
    c4_F_CG[c4_i72] = ((((c4_F_fl[c4_i72] + c4_F_fr[c4_i72]) + c4_F_rl[c4_i72])
                        + c4_F_rr[c4_i72]) - c4_F_rolling[c4_i72]) -
      c4_F_air[c4_i72];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 51);
  c4_b_a = -c4_b_m_car;
  c4_b_b = c4_a_y;
  c4_y = c4_b_a * c4_b_b;
  c4_c_a = c4_y;
  c4_c_b = c4_b_h_cg;
  c4_b_y = c4_c_a * c4_c_b;
  c4_d_a = c4_b_m_car;
  c4_d_b = c4_a_x;
  c4_c_y = c4_d_a * c4_d_b;
  c4_e_a = c4_c_y;
  c4_e_b = c4_b_h_cg;
  c4_d_y = c4_e_a * c4_e_b;
  c4_e_y[0] = c4_b_y;
  c4_e_y[1] = c4_d_y;
  c4_e_y[2] = 0.0;
  for (c4_i73 = 0; c4_i73 < 3; c4_i73++) {
    c4_M_CG[c4_i73] = (((c4_M_fl[c4_i73] + c4_M_fr[c4_i73]) + c4_M_rl[c4_i73]) +
                       c4_M_rr[c4_i73]) + c4_e_y[c4_i73];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 53);
  for (c4_i74 = 0; c4_i74 < 3; c4_i74++) {
    c4_tau[c4_i74] = c4_F_CG[c4_i74];
  }

  for (c4_i75 = 0; c4_i75 < 3; c4_i75++) {
    c4_tau[c4_i75 + 3] = c4_M_CG[c4_i75];
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 55);
  c4_F_Y[0] = c4_F_fl[1];
  c4_F_Y[1] = c4_F_fr[1];
  c4_F_Y[2] = c4_F_rl[1];
  c4_F_Y[3] = c4_F_rr[1];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -55);
  sf_debug_symbol_scope_pop();
  for (c4_i76 = 0; c4_i76 < 6; c4_i76++) {
    (*c4_b_tau)[c4_i76] = c4_tau[c4_i76];
  }

  for (c4_i77 = 0; c4_i77 < 3; c4_i77++) {
    (*c4_b_F_CG)[c4_i77] = c4_F_CG[c4_i77];
  }

  for (c4_i78 = 0; c4_i78 < 3; c4_i78++) {
    (*c4_b_M_CG)[c4_i78] = c4_M_CG[c4_i78];
  }

  for (c4_i79 = 0; c4_i79 < 4; c4_i79++) {
    (*c4_b_F_Y)[c4_i79] = c4_F_Y[c4_i79];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
}

static void initSimStructsc4_ref_gen(SFc4_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i80;
  real_T c4_b_inData[4];
  int32_T c4_i81;
  real_T c4_u[4];
  const mxArray *c4_y = NULL;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i80 = 0; c4_i80 < 4; c4_i80++) {
    c4_b_inData[c4_i80] = (*(real_T (*)[4])c4_inData)[c4_i80];
  }

  for (c4_i81 = 0; c4_i81 < 4; c4_i81++) {
    c4_u[c4_i81] = c4_b_inData[c4_i81];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance, const
  mxArray *c4_F_Y, const char_T *c4_identifier, real_T c4_y[4])
{
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_F_Y), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_F_Y);
}

static void c4_b_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[4])
{
  real_T c4_dv9[4];
  int32_T c4_i82;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv9, 1, 0, 0U, 1, 0U, 1, 4);
  for (c4_i82 = 0; c4_i82 < 4; c4_i82++) {
    c4_y[c4_i82] = c4_dv9[c4_i82];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_F_Y;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[4];
  int32_T c4_i83;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_F_Y = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_F_Y), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_F_Y);
  for (c4_i83 = 0; c4_i83 < 4; c4_i83++) {
    (*(real_T (*)[4])c4_outData)[c4_i83] = c4_y[c4_i83];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i84;
  real_T c4_b_inData[3];
  int32_T c4_i85;
  real_T c4_u[3];
  const mxArray *c4_y = NULL;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i84 = 0; c4_i84 < 3; c4_i84++) {
    c4_b_inData[c4_i84] = (*(real_T (*)[3])c4_inData)[c4_i84];
  }

  for (c4_i85 = 0; c4_i85 < 3; c4_i85++) {
    c4_u[c4_i85] = c4_b_inData[c4_i85];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_c_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_M_CG, const char_T *c4_identifier, real_T c4_y[3])
{
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_M_CG), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_M_CG);
}

static void c4_d_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[3])
{
  real_T c4_dv10[3];
  int32_T c4_i86;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv10, 1, 0, 0U, 1, 0U, 1, 3);
  for (c4_i86 = 0; c4_i86 < 3; c4_i86++) {
    c4_y[c4_i86] = c4_dv10[c4_i86];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_M_CG;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[3];
  int32_T c4_i87;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_M_CG = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_M_CG), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_M_CG);
  for (c4_i87 = 0; c4_i87 < 3; c4_i87++) {
    (*(real_T (*)[3])c4_outData)[c4_i87] = c4_y[c4_i87];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i88;
  real_T c4_b_inData[6];
  int32_T c4_i89;
  real_T c4_u[6];
  const mxArray *c4_y = NULL;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i88 = 0; c4_i88 < 6; c4_i88++) {
    c4_b_inData[c4_i88] = (*(real_T (*)[6])c4_inData)[c4_i88];
  }

  for (c4_i89 = 0; c4_i89 < 6; c4_i89++) {
    c4_u[c4_i89] = c4_b_inData[c4_i89];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_e_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_tau, const char_T *c4_identifier, real_T c4_y[6])
{
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_tau), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_tau);
}

static void c4_f_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[6])
{
  real_T c4_dv11[6];
  int32_T c4_i90;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv11, 1, 0, 0U, 1, 0U, 1, 6);
  for (c4_i90 = 0; c4_i90 < 6; c4_i90++) {
    c4_y[c4_i90] = c4_dv11[c4_i90];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_tau;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[6];
  int32_T c4_i91;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_tau = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_tau), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_tau);
  for (c4_i91 = 0; c4_i91 < 6; c4_i91++) {
    (*(real_T (*)[6])c4_outData)[c4_i91] = c4_y[c4_i91];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_d_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_g_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d9;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d9, 1, 0, 0U, 0, 0U, 0);
  c4_y = c4_d9;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_l_tread;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_b_l_tread = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_l_tread),
    &c4_thisId);
  sf_mex_destroy(&c4_b_l_tread);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_e_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i92;
  int32_T c4_i93;
  int32_T c4_i94;
  real_T c4_b_inData[9];
  int32_T c4_i95;
  int32_T c4_i96;
  int32_T c4_i97;
  real_T c4_u[9];
  const mxArray *c4_y = NULL;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_i92 = 0;
  for (c4_i93 = 0; c4_i93 < 3; c4_i93++) {
    for (c4_i94 = 0; c4_i94 < 3; c4_i94++) {
      c4_b_inData[c4_i94 + c4_i92] = (*(real_T (*)[9])c4_inData)[c4_i94 + c4_i92];
    }

    c4_i92 += 3;
  }

  c4_i95 = 0;
  for (c4_i96 = 0; c4_i96 < 3; c4_i96++) {
    for (c4_i97 = 0; c4_i97 < 3; c4_i97++) {
      c4_u[c4_i97 + c4_i95] = c4_b_inData[c4_i97 + c4_i95];
    }

    c4_i95 += 3;
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_h_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[9])
{
  real_T c4_dv12[9];
  int32_T c4_i98;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv12, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c4_i98 = 0; c4_i98 < 9; c4_i98++) {
    c4_y[c4_i98] = c4_dv12[c4_i98];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_R;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[9];
  int32_T c4_i99;
  int32_T c4_i100;
  int32_T c4_i101;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_R = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_R), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_R);
  c4_i99 = 0;
  for (c4_i100 = 0; c4_i100 < 3; c4_i100++) {
    for (c4_i101 = 0; c4_i101 < 3; c4_i101++) {
      (*(real_T (*)[9])c4_outData)[c4_i101 + c4_i99] = c4_y[c4_i101 + c4_i99];
    }

    c4_i99 += 3;
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

const mxArray *sf_c4_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo;
  c4_ResolvedFunctionInfo c4_info[14];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i102;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_nameCaptureInfo = NULL;
  c4_info_helper(c4_info);
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 14), FALSE);
  for (c4_i102 = 0; c4_i102 < 14; c4_i102++) {
    c4_r0 = &c4_info[c4_i102];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context", "nameCaptureInfo",
                    c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name", "nameCaptureInfo", c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved", "nameCaptureInfo",
                    c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c4_i102);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c4_i102);
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0, FALSE);
  return c4_nameCaptureInfo;
}

static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[14])
{
  c4_info[0].context = "";
  c4_info[0].name = "mrdivide";
  c4_info[0].dominantType = "double";
  c4_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[0].fileTimeLo = 1310137456U;
  c4_info[0].fileTimeHi = 0U;
  c4_info[0].mFileTimeLo = 1289519692U;
  c4_info[0].mFileTimeHi = 0U;
  c4_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[1].name = "rdivide";
  c4_info[1].dominantType = "double";
  c4_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[1].fileTimeLo = 1286818844U;
  c4_info[1].fileTimeHi = 0U;
  c4_info[1].mFileTimeLo = 0U;
  c4_info[1].mFileTimeHi = 0U;
  c4_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[2].name = "eml_div";
  c4_info[2].dominantType = "double";
  c4_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c4_info[2].fileTimeLo = 1305318000U;
  c4_info[2].fileTimeHi = 0U;
  c4_info[2].mFileTimeLo = 0U;
  c4_info[2].mFileTimeHi = 0U;
  c4_info[3].context = "";
  c4_info[3].name = "cos";
  c4_info[3].dominantType = "double";
  c4_info[3].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c4_info[3].fileTimeLo = 1286818706U;
  c4_info[3].fileTimeHi = 0U;
  c4_info[3].mFileTimeLo = 0U;
  c4_info[3].mFileTimeHi = 0U;
  c4_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c4_info[4].name = "eml_scalar_cos";
  c4_info[4].dominantType = "double";
  c4_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c4_info[4].fileTimeLo = 1286818722U;
  c4_info[4].fileTimeHi = 0U;
  c4_info[4].mFileTimeLo = 0U;
  c4_info[4].mFileTimeHi = 0U;
  c4_info[5].context = "";
  c4_info[5].name = "sin";
  c4_info[5].dominantType = "double";
  c4_info[5].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c4_info[5].fileTimeLo = 1286818750U;
  c4_info[5].fileTimeHi = 0U;
  c4_info[5].mFileTimeLo = 0U;
  c4_info[5].mFileTimeHi = 0U;
  c4_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c4_info[6].name = "eml_scalar_sin";
  c4_info[6].dominantType = "double";
  c4_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c4_info[6].fileTimeLo = 1286818736U;
  c4_info[6].fileTimeHi = 0U;
  c4_info[6].mFileTimeLo = 0U;
  c4_info[6].mFileTimeHi = 0U;
  c4_info[7].context = "";
  c4_info[7].name = "mtimes";
  c4_info[7].dominantType = "double";
  c4_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[7].fileTimeLo = 1289519692U;
  c4_info[7].fileTimeHi = 0U;
  c4_info[7].mFileTimeLo = 0U;
  c4_info[7].mFileTimeHi = 0U;
  c4_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[8].name = "eml_index_class";
  c4_info[8].dominantType = "";
  c4_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c4_info[8].fileTimeLo = 1286818778U;
  c4_info[8].fileTimeHi = 0U;
  c4_info[8].mFileTimeLo = 0U;
  c4_info[8].mFileTimeHi = 0U;
  c4_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[9].name = "eml_scalar_eg";
  c4_info[9].dominantType = "double";
  c4_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c4_info[9].fileTimeLo = 1286818796U;
  c4_info[9].fileTimeHi = 0U;
  c4_info[9].mFileTimeLo = 0U;
  c4_info[9].mFileTimeHi = 0U;
  c4_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[10].name = "eml_xgemm";
  c4_info[10].dominantType = "int32";
  c4_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c4_info[10].fileTimeLo = 1299076772U;
  c4_info[10].fileTimeHi = 0U;
  c4_info[10].mFileTimeLo = 0U;
  c4_info[10].mFileTimeHi = 0U;
  c4_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c4_info[11].name = "eml_blas_inline";
  c4_info[11].dominantType = "";
  c4_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c4_info[11].fileTimeLo = 1299076768U;
  c4_info[11].fileTimeHi = 0U;
  c4_info[11].mFileTimeLo = 0U;
  c4_info[11].mFileTimeHi = 0U;
  c4_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c4_info[12].name = "eml_refblas_xgemm";
  c4_info[12].dominantType = "int32";
  c4_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c4_info[12].fileTimeLo = 1299076774U;
  c4_info[12].fileTimeHi = 0U;
  c4_info[12].mFileTimeLo = 0U;
  c4_info[12].mFileTimeHi = 0U;
  c4_info[13].context = "";
  c4_info[13].name = "cross";
  c4_info[13].dominantType = "double";
  c4_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/specfun/cross.m";
  c4_info[13].fileTimeLo = 1286818842U;
  c4_info[13].fileTimeHi = 0U;
  c4_info[13].mFileTimeLo = 0U;
  c4_info[13].mFileTimeHi = 0U;
}

static real_T c4_mrdivide(SFc4_ref_genInstanceStruct *chartInstance, real_T c4_A,
  real_T c4_B)
{
  real_T c4_x;
  real_T c4_b_y;
  real_T c4_b_x;
  real_T c4_c_y;
  c4_x = c4_A;
  c4_b_y = c4_B;
  c4_b_x = c4_x;
  c4_c_y = c4_b_y;
  return c4_b_x / c4_c_y;
}

static void c4_eml_scalar_eg(SFc4_ref_genInstanceStruct *chartInstance)
{
}

static void c4_cross(SFc4_ref_genInstanceStruct *chartInstance, real_T c4_a[3],
                     real_T c4_b[3], real_T c4_c[3])
{
  real_T c4_b_a;
  real_T c4_b_b;
  real_T c4_y;
  real_T c4_c_a;
  real_T c4_c_b;
  real_T c4_b_y;
  real_T c4_c1;
  real_T c4_d_a;
  real_T c4_d_b;
  real_T c4_c_y;
  real_T c4_e_a;
  real_T c4_e_b;
  real_T c4_d_y;
  real_T c4_c2;
  real_T c4_f_a;
  real_T c4_f_b;
  real_T c4_e_y;
  real_T c4_g_a;
  real_T c4_g_b;
  real_T c4_f_y;
  real_T c4_c3;
  c4_b_a = c4_a[1];
  c4_b_b = c4_b[2];
  c4_y = c4_b_a * c4_b_b;
  c4_c_a = c4_a[2];
  c4_c_b = c4_b[1];
  c4_b_y = c4_c_a * c4_c_b;
  c4_c1 = c4_y - c4_b_y;
  c4_d_a = c4_a[2];
  c4_d_b = c4_b[0];
  c4_c_y = c4_d_a * c4_d_b;
  c4_e_a = c4_a[0];
  c4_e_b = c4_b[2];
  c4_d_y = c4_e_a * c4_e_b;
  c4_c2 = c4_c_y - c4_d_y;
  c4_f_a = c4_a[0];
  c4_f_b = c4_b[1];
  c4_e_y = c4_f_a * c4_f_b;
  c4_g_a = c4_a[1];
  c4_g_b = c4_b[0];
  c4_f_y = c4_g_a * c4_g_b;
  c4_c3 = c4_e_y - c4_f_y;
  c4_c[0] = c4_c1;
  c4_c[1] = c4_c2;
  c4_c[2] = c4_c3;
}

static const mxArray *c4_f_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(int32_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static int32_T c4_i_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  int32_T c4_y;
  int32_T c4_i103;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_i103, 1, 6, 0U, 0, 0U, 0);
  c4_y = c4_i103;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_sfEvent;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  int32_T c4_y;
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)chartInstanceVoid;
  c4_b_sfEvent = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_i_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_sfEvent),
    &c4_thisId);
  sf_mex_destroy(&c4_b_sfEvent);
  *(int32_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static uint8_T c4_j_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_b_is_active_c4_ref_gen, const char_T *c4_identifier)
{
  uint8_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_k_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c4_b_is_active_c4_ref_gen), &c4_thisId);
  sf_mex_destroy(&c4_b_is_active_c4_ref_gen);
  return c4_y;
}

static uint8_T c4_k_emlrt_marshallIn(SFc4_ref_genInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_u0, 1, 3, 0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void init_dsm_address_info(SFc4_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c4_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(136865985U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3692842875U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(60285919U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2137505866U);
}

mxArray *sf_c4_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("uLZHGHj2oIP76C2YZ5kjYD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c4_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[33],T\"F_CG\",},{M[1],M[40],T\"F_Y\",},{M[1],M[34],T\"M_CG\",},{M[1],M[5],T\"tau\",},{M[8],M[0],T\"is_active_c4_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc4_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc4_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          4,
          1,
          1,
          16,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"F_rolling");
          _SFD_SET_DATA_PROPS(1,1,1,0,"F_air");
          _SFD_SET_DATA_PROPS(2,1,1,0,"Fx_wheel");
          _SFD_SET_DATA_PROPS(3,1,1,0,"Fy_wheel");
          _SFD_SET_DATA_PROPS(4,1,1,0,"Fz_wheel");
          _SFD_SET_DATA_PROPS(5,1,1,0,"delta");
          _SFD_SET_DATA_PROPS(6,1,1,0,"a_xyz");
          _SFD_SET_DATA_PROPS(7,10,0,0,"h_cg");
          _SFD_SET_DATA_PROPS(8,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(9,10,0,0,"l_front");
          _SFD_SET_DATA_PROPS(10,2,0,1,"tau");
          _SFD_SET_DATA_PROPS(11,10,0,0,"l_rear");
          _SFD_SET_DATA_PROPS(12,10,0,0,"l_tread");
          _SFD_SET_DATA_PROPS(13,2,0,1,"F_CG");
          _SFD_SET_DATA_PROPS(14,2,0,1,"M_CG");
          _SFD_SET_DATA_PROPS(15,2,0,1,"F_Y");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1287);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)c4_d_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)c4_d_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)c4_d_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_c_sf_marshallOut,(MexInFcnForType)
            c4_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)c4_d_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_d_sf_marshallOut,(MexInFcnForType)c4_d_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)
            c4_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)
            c4_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)
            c4_sf_marshallIn);
        }

        {
          real_T *c4_delta;
          real_T (*c4_F_rolling)[3];
          real_T (*c4_F_air)[3];
          real_T (*c4_Fx_wheel)[4];
          real_T (*c4_Fy_wheel)[4];
          real_T (*c4_Fz_wheel)[4];
          real_T (*c4_a_xyz)[3];
          real_T (*c4_tau)[6];
          real_T (*c4_F_CG)[3];
          real_T (*c4_M_CG)[3];
          real_T (*c4_F_Y)[4];
          c4_F_Y = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 4);
          c4_M_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
          c4_F_CG = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 2);
          c4_tau = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          c4_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
          c4_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c4_Fz_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 4);
          c4_Fy_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
          c4_Fx_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
          c4_F_air = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c4_F_rolling = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c4_F_rolling);
          _SFD_SET_DATA_VALUE_PTR(1U, *c4_F_air);
          _SFD_SET_DATA_VALUE_PTR(2U, *c4_Fx_wheel);
          _SFD_SET_DATA_VALUE_PTR(3U, *c4_Fy_wheel);
          _SFD_SET_DATA_VALUE_PTR(4U, *c4_Fz_wheel);
          _SFD_SET_DATA_VALUE_PTR(5U, c4_delta);
          _SFD_SET_DATA_VALUE_PTR(6U, *c4_a_xyz);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance->c4_h_cg);
          _SFD_SET_DATA_VALUE_PTR(8U, &chartInstance->c4_m_car);
          _SFD_SET_DATA_VALUE_PTR(9U, &chartInstance->c4_l_front);
          _SFD_SET_DATA_VALUE_PTR(10U, *c4_tau);
          _SFD_SET_DATA_VALUE_PTR(11U, &chartInstance->c4_l_rear);
          _SFD_SET_DATA_VALUE_PTR(12U, &chartInstance->c4_l_tread);
          _SFD_SET_DATA_VALUE_PTR(13U, *c4_F_CG);
          _SFD_SET_DATA_VALUE_PTR(14U, *c4_M_CG);
          _SFD_SET_DATA_VALUE_PTR(15U, *c4_F_Y);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c4_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc4_ref_genInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c4_ref_gen(void *chartInstanceVar)
{
  enable_c4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c4_ref_gen(void *chartInstanceVar)
{
  disable_c4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c4_ref_gen(void *chartInstanceVar)
{
  sf_c4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c4_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c4_ref_gen((SFc4_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c4_ref_gen(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c4_ref_gen((SFc4_ref_genInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c4_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c4_ref_gen(S);
}

static void sf_opaque_set_sim_state_c4_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c4_ref_gen(S, st);
}

static void sf_opaque_terminate_c4_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc4_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc4_ref_gen((SFc4_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_ref_gen((SFc4_ref_genInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c4_ref_gen(SimStruct *S)
{
  /* Actual parameters from chart:
     h_cg l_front l_rear l_tread m_car
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4", "p5" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for h_cg*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for l_front*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for l_rear*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for l_tread*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,4,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,4,7);
      sf_mark_chart_reusable_outputs(S,infoStruct,4,4);
    }

    sf_set_rtw_dwork_info(S,infoStruct,4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(716719127U));
  ssSetChecksum1(S,(3624339554U));
  ssSetChecksum2(S,(3110637150U));
  ssSetChecksum3(S,(2748237588U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c4_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_ref_gen(SimStruct *S)
{
  SFc4_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc4_ref_genInstanceStruct *)malloc(sizeof
    (SFc4_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc4_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c4_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c4_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c4_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c4_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c4_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c4_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c4_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c4_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c4_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c4_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c4_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c4_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
