/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c7_ref_gen.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c7_debug_family_names[17] = { "a_x", "a_y", "g", "Fz_fl",
  "Fz_fr", "Fz_rl", "Fz_rr", "nargin", "nargout", "a_xyz", "l_front", "l_rear",
  "l_tread", "m_car", "h_cg", "l_car", "Fz_wheel" };

/* Function Declarations */
static void initialize_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void initialize_params_c7_ref_gen(SFc7_ref_genInstanceStruct
  *chartInstance);
static void enable_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void disable_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void c7_update_debugger_state_c7_ref_gen(SFc7_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c7_ref_gen(SFc7_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_st);
static void finalize_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void sf_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void c7_chartstep_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void initSimStructsc7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber);
static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData);
static void c7_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance, const
  mxArray *c7_Fz_wheel, const char_T *c7_identifier, real_T c7_y[4]);
static void c7_b_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[4]);
static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_c_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static int32_T c7_d_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static uint8_T c7_e_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_b_is_active_c7_ref_gen, const char_T *c7_identifier);
static uint8_T c7_f_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void init_dsm_address_info(SFc7_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c7_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c7_is_active_c7_ref_gen = 0U;
}

static void initialize_params_c7_ref_gen(SFc7_ref_genInstanceStruct
  *chartInstance)
{
  real_T c7_d0;
  real_T c7_d1;
  real_T c7_d2;
  real_T c7_d3;
  real_T c7_d4;
  real_T c7_d5;
  sf_set_error_prefix_string(
    "Error evaluating data 'l_front' in the parent workspace.\n");
  sf_mex_import_named("l_front", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c7_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_l_front = c7_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_rear' in the parent workspace.\n");
  sf_mex_import_named("l_rear", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c7_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_l_rear = c7_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_tread' in the parent workspace.\n");
  sf_mex_import_named("l_tread", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      &c7_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_l_tread = c7_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 5, 0),
                      &c7_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_m_car = c7_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'h_cg' in the parent workspace.\n");
  sf_mex_import_named("h_cg", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c7_d4, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_h_cg = c7_d4;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_car' in the parent workspace.\n");
  sf_mex_import_named("l_car", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c7_d5, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_l_car = c7_d5;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c7_update_debugger_state_c7_ref_gen(SFc7_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c7_ref_gen(SFc7_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c7_st;
  const mxArray *c7_y = NULL;
  int32_T c7_i0;
  real_T c7_u[4];
  const mxArray *c7_b_y = NULL;
  uint8_T c7_hoistedGlobal;
  uint8_T c7_b_u;
  const mxArray *c7_c_y = NULL;
  real_T (*c7_Fz_wheel)[4];
  c7_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_st = NULL;
  c7_st = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_createcellarray(2), FALSE);
  for (c7_i0 = 0; c7_i0 < 4; c7_i0++) {
    c7_u[c7_i0] = (*c7_Fz_wheel)[c7_i0];
  }

  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c7_y, 0, c7_b_y);
  c7_hoistedGlobal = chartInstance->c7_is_active_c7_ref_gen;
  c7_b_u = c7_hoistedGlobal;
  c7_c_y = NULL;
  sf_mex_assign(&c7_c_y, sf_mex_create("y", &c7_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 1, c7_c_y);
  sf_mex_assign(&c7_st, c7_y, FALSE);
  return c7_st;
}

static void set_sim_state_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_st)
{
  const mxArray *c7_u;
  real_T c7_dv0[4];
  int32_T c7_i1;
  real_T (*c7_Fz_wheel)[4];
  c7_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c7_doneDoubleBufferReInit = TRUE;
  c7_u = sf_mex_dup(c7_st);
  c7_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 0)),
                      "Fz_wheel", c7_dv0);
  for (c7_i1 = 0; c7_i1 < 4; c7_i1++) {
    (*c7_Fz_wheel)[c7_i1] = c7_dv0[c7_i1];
  }

  chartInstance->c7_is_active_c7_ref_gen = c7_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c7_u, 1)), "is_active_c7_ref_gen");
  sf_mex_destroy(&c7_u);
  c7_update_debugger_state_c7_ref_gen(chartInstance);
  sf_mex_destroy(&c7_st);
}

static void finalize_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
  int32_T c7_i2;
  int32_T c7_i3;
  real_T (*c7_Fz_wheel)[4];
  real_T (*c7_a_xyz)[3];
  c7_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 6U, chartInstance->c7_sfEvent);
  for (c7_i2 = 0; c7_i2 < 3; c7_i2++) {
    _SFD_DATA_RANGE_CHECK((*c7_a_xyz)[c7_i2], 0U);
  }

  for (c7_i3 = 0; c7_i3 < 4; c7_i3++) {
    _SFD_DATA_RANGE_CHECK((*c7_Fz_wheel)[c7_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c7_l_front, 2U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_l_rear, 3U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_l_tread, 4U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_m_car, 5U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_h_cg, 6U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_l_car, 7U);
  chartInstance->c7_sfEvent = CALL_EVENT;
  c7_chartstep_c7_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c7_chartstep_c7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
  real_T c7_hoistedGlobal;
  real_T c7_b_hoistedGlobal;
  real_T c7_c_hoistedGlobal;
  real_T c7_d_hoistedGlobal;
  real_T c7_e_hoistedGlobal;
  real_T c7_f_hoistedGlobal;
  int32_T c7_i4;
  real_T c7_a_xyz[3];
  real_T c7_b_l_front;
  real_T c7_b_l_rear;
  real_T c7_b_l_tread;
  real_T c7_b_m_car;
  real_T c7_b_h_cg;
  real_T c7_b_l_car;
  uint32_T c7_debug_family_var_map[17];
  real_T c7_a_x;
  real_T c7_a_y;
  real_T c7_g;
  real_T c7_Fz_fl;
  real_T c7_Fz_fr;
  real_T c7_Fz_rl;
  real_T c7_Fz_rr;
  real_T c7_nargin = 7.0;
  real_T c7_nargout = 1.0;
  real_T c7_Fz_wheel[4];
  real_T c7_a;
  real_T c7_y;
  real_T c7_A;
  real_T c7_B;
  real_T c7_x;
  real_T c7_b_y;
  real_T c7_b_x;
  real_T c7_c_y;
  real_T c7_d_y;
  real_T c7_b_a;
  real_T c7_b;
  real_T c7_e_y;
  real_T c7_b_A;
  real_T c7_b_B;
  real_T c7_c_x;
  real_T c7_f_y;
  real_T c7_d_x;
  real_T c7_g_y;
  real_T c7_h_y;
  real_T c7_c_a;
  real_T c7_b_b;
  real_T c7_i_y;
  real_T c7_d_a;
  real_T c7_c_b;
  real_T c7_j_y;
  real_T c7_e_a;
  real_T c7_k_y;
  real_T c7_c_A;
  real_T c7_c_B;
  real_T c7_e_x;
  real_T c7_l_y;
  real_T c7_f_x;
  real_T c7_m_y;
  real_T c7_n_y;
  real_T c7_f_a;
  real_T c7_d_b;
  real_T c7_g_a;
  real_T c7_o_y;
  real_T c7_d_A;
  real_T c7_d_B;
  real_T c7_g_x;
  real_T c7_p_y;
  real_T c7_h_x;
  real_T c7_q_y;
  real_T c7_r_y;
  real_T c7_h_a;
  real_T c7_e_b;
  real_T c7_s_y;
  real_T c7_e_A;
  real_T c7_e_B;
  real_T c7_i_x;
  real_T c7_t_y;
  real_T c7_j_x;
  real_T c7_u_y;
  real_T c7_v_y;
  real_T c7_i_a;
  real_T c7_f_b;
  real_T c7_w_y;
  real_T c7_j_a;
  real_T c7_g_b;
  real_T c7_x_y;
  real_T c7_k_a;
  real_T c7_y_y;
  real_T c7_f_A;
  real_T c7_f_B;
  real_T c7_k_x;
  real_T c7_ab_y;
  real_T c7_l_x;
  real_T c7_bb_y;
  real_T c7_cb_y;
  real_T c7_l_a;
  real_T c7_h_b;
  real_T c7_m_a;
  real_T c7_db_y;
  real_T c7_g_A;
  real_T c7_g_B;
  real_T c7_m_x;
  real_T c7_eb_y;
  real_T c7_n_x;
  real_T c7_fb_y;
  real_T c7_gb_y;
  real_T c7_n_a;
  real_T c7_i_b;
  real_T c7_hb_y;
  real_T c7_h_A;
  real_T c7_h_B;
  real_T c7_o_x;
  real_T c7_ib_y;
  real_T c7_p_x;
  real_T c7_jb_y;
  real_T c7_kb_y;
  real_T c7_o_a;
  real_T c7_j_b;
  real_T c7_lb_y;
  real_T c7_p_a;
  real_T c7_k_b;
  real_T c7_mb_y;
  real_T c7_q_a;
  real_T c7_nb_y;
  real_T c7_i_A;
  real_T c7_i_B;
  real_T c7_q_x;
  real_T c7_ob_y;
  real_T c7_r_x;
  real_T c7_pb_y;
  real_T c7_qb_y;
  real_T c7_r_a;
  real_T c7_l_b;
  real_T c7_s_a;
  real_T c7_rb_y;
  real_T c7_j_A;
  real_T c7_j_B;
  real_T c7_s_x;
  real_T c7_sb_y;
  real_T c7_t_x;
  real_T c7_tb_y;
  real_T c7_ub_y;
  real_T c7_t_a;
  real_T c7_m_b;
  real_T c7_vb_y;
  real_T c7_k_A;
  real_T c7_k_B;
  real_T c7_u_x;
  real_T c7_wb_y;
  real_T c7_v_x;
  real_T c7_xb_y;
  real_T c7_yb_y;
  real_T c7_u_a;
  real_T c7_n_b;
  real_T c7_ac_y;
  real_T c7_v_a;
  real_T c7_o_b;
  real_T c7_bc_y;
  real_T c7_w_a;
  real_T c7_cc_y;
  real_T c7_l_A;
  real_T c7_l_B;
  real_T c7_w_x;
  real_T c7_dc_y;
  real_T c7_x_x;
  real_T c7_ec_y;
  real_T c7_fc_y;
  real_T c7_x_a;
  real_T c7_p_b;
  real_T c7_b_Fz_fl[4];
  int32_T c7_i5;
  int32_T c7_i6;
  real_T (*c7_b_Fz_wheel)[4];
  real_T (*c7_b_a_xyz)[3];
  c7_b_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_b_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 6U, chartInstance->c7_sfEvent);
  c7_hoistedGlobal = chartInstance->c7_l_front;
  c7_b_hoistedGlobal = chartInstance->c7_l_rear;
  c7_c_hoistedGlobal = chartInstance->c7_l_tread;
  c7_d_hoistedGlobal = chartInstance->c7_m_car;
  c7_e_hoistedGlobal = chartInstance->c7_h_cg;
  c7_f_hoistedGlobal = chartInstance->c7_l_car;
  for (c7_i4 = 0; c7_i4 < 3; c7_i4++) {
    c7_a_xyz[c7_i4] = (*c7_b_a_xyz)[c7_i4];
  }

  c7_b_l_front = c7_hoistedGlobal;
  c7_b_l_rear = c7_b_hoistedGlobal;
  c7_b_l_tread = c7_c_hoistedGlobal;
  c7_b_m_car = c7_d_hoistedGlobal;
  c7_b_h_cg = c7_e_hoistedGlobal;
  c7_b_l_car = c7_f_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 17U, 17U, c7_debug_family_names,
    c7_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c7_a_x, 0U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_a_y, 1U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c7_g, 2U, c7_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c7_Fz_fl, 3U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_Fz_fr, 4U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_Fz_rl, 5U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_Fz_rr, 6U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargin, 7U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargout, 8U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c7_a_xyz, 9U, c7_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_l_front, 10U,
    c7_b_sf_marshallOut, c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_l_rear, 11U,
    c7_b_sf_marshallOut, c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_l_tread, 12U,
    c7_b_sf_marshallOut, c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_m_car, 13U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_h_cg, 14U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_l_car, 15U, c7_b_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_Fz_wheel, 16U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 4);
  c7_a_x = -c7_a_xyz[0];
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 5);
  c7_a_y = -c7_a_xyz[1];
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 6);
  c7_g = -9.81;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 9);
  c7_a = c7_b_l_rear;
  c7_y = c7_a * -9.81;
  c7_A = c7_y;
  c7_B = c7_b_l_car;
  c7_x = c7_A;
  c7_b_y = c7_B;
  c7_b_x = c7_x;
  c7_c_y = c7_b_y;
  c7_d_y = c7_b_x / c7_c_y;
  c7_b_a = c7_b_h_cg;
  c7_b = c7_a_x;
  c7_e_y = c7_b_a * c7_b;
  c7_b_A = c7_e_y;
  c7_b_B = c7_b_l_car;
  c7_c_x = c7_b_A;
  c7_f_y = c7_b_B;
  c7_d_x = c7_c_x;
  c7_g_y = c7_f_y;
  c7_h_y = c7_d_x / c7_g_y;
  c7_c_a = -c7_b_m_car;
  c7_b_b = c7_d_y - c7_h_y;
  c7_i_y = c7_c_a * c7_b_b;
  c7_d_a = c7_b_h_cg;
  c7_c_b = c7_a_y;
  c7_j_y = c7_d_a * c7_c_b;
  c7_e_a = c7_b_l_tread;
  c7_k_y = c7_e_a * -9.81;
  c7_c_A = c7_j_y;
  c7_c_B = c7_k_y;
  c7_e_x = c7_c_A;
  c7_l_y = c7_c_B;
  c7_f_x = c7_e_x;
  c7_m_y = c7_l_y;
  c7_n_y = c7_f_x / c7_m_y;
  c7_f_a = c7_i_y;
  c7_d_b = 0.5 - c7_n_y;
  c7_Fz_fl = c7_f_a * c7_d_b;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 10);
  c7_g_a = c7_b_l_rear;
  c7_o_y = c7_g_a * -9.81;
  c7_d_A = c7_o_y;
  c7_d_B = c7_b_l_car;
  c7_g_x = c7_d_A;
  c7_p_y = c7_d_B;
  c7_h_x = c7_g_x;
  c7_q_y = c7_p_y;
  c7_r_y = c7_h_x / c7_q_y;
  c7_h_a = c7_b_h_cg;
  c7_e_b = c7_a_x;
  c7_s_y = c7_h_a * c7_e_b;
  c7_e_A = c7_s_y;
  c7_e_B = c7_b_l_car;
  c7_i_x = c7_e_A;
  c7_t_y = c7_e_B;
  c7_j_x = c7_i_x;
  c7_u_y = c7_t_y;
  c7_v_y = c7_j_x / c7_u_y;
  c7_i_a = -c7_b_m_car;
  c7_f_b = c7_r_y - c7_v_y;
  c7_w_y = c7_i_a * c7_f_b;
  c7_j_a = c7_b_h_cg;
  c7_g_b = c7_a_y;
  c7_x_y = c7_j_a * c7_g_b;
  c7_k_a = c7_b_l_tread;
  c7_y_y = c7_k_a * -9.81;
  c7_f_A = c7_x_y;
  c7_f_B = c7_y_y;
  c7_k_x = c7_f_A;
  c7_ab_y = c7_f_B;
  c7_l_x = c7_k_x;
  c7_bb_y = c7_ab_y;
  c7_cb_y = c7_l_x / c7_bb_y;
  c7_l_a = c7_w_y;
  c7_h_b = 0.5 + c7_cb_y;
  c7_Fz_fr = c7_l_a * c7_h_b;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 11);
  c7_m_a = c7_b_l_front;
  c7_db_y = c7_m_a * -9.81;
  c7_g_A = c7_db_y;
  c7_g_B = c7_b_l_car;
  c7_m_x = c7_g_A;
  c7_eb_y = c7_g_B;
  c7_n_x = c7_m_x;
  c7_fb_y = c7_eb_y;
  c7_gb_y = c7_n_x / c7_fb_y;
  c7_n_a = c7_b_h_cg;
  c7_i_b = c7_a_x;
  c7_hb_y = c7_n_a * c7_i_b;
  c7_h_A = c7_hb_y;
  c7_h_B = c7_b_l_car;
  c7_o_x = c7_h_A;
  c7_ib_y = c7_h_B;
  c7_p_x = c7_o_x;
  c7_jb_y = c7_ib_y;
  c7_kb_y = c7_p_x / c7_jb_y;
  c7_o_a = -c7_b_m_car;
  c7_j_b = c7_gb_y + c7_kb_y;
  c7_lb_y = c7_o_a * c7_j_b;
  c7_p_a = c7_b_h_cg;
  c7_k_b = c7_a_y;
  c7_mb_y = c7_p_a * c7_k_b;
  c7_q_a = c7_b_l_tread;
  c7_nb_y = c7_q_a * -9.81;
  c7_i_A = c7_mb_y;
  c7_i_B = c7_nb_y;
  c7_q_x = c7_i_A;
  c7_ob_y = c7_i_B;
  c7_r_x = c7_q_x;
  c7_pb_y = c7_ob_y;
  c7_qb_y = c7_r_x / c7_pb_y;
  c7_r_a = c7_lb_y;
  c7_l_b = 0.5 - c7_qb_y;
  c7_Fz_rl = c7_r_a * c7_l_b;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 12);
  c7_s_a = c7_b_l_front;
  c7_rb_y = c7_s_a * -9.81;
  c7_j_A = c7_rb_y;
  c7_j_B = c7_b_l_car;
  c7_s_x = c7_j_A;
  c7_sb_y = c7_j_B;
  c7_t_x = c7_s_x;
  c7_tb_y = c7_sb_y;
  c7_ub_y = c7_t_x / c7_tb_y;
  c7_t_a = c7_b_h_cg;
  c7_m_b = c7_a_x;
  c7_vb_y = c7_t_a * c7_m_b;
  c7_k_A = c7_vb_y;
  c7_k_B = c7_b_l_car;
  c7_u_x = c7_k_A;
  c7_wb_y = c7_k_B;
  c7_v_x = c7_u_x;
  c7_xb_y = c7_wb_y;
  c7_yb_y = c7_v_x / c7_xb_y;
  c7_u_a = -c7_b_m_car;
  c7_n_b = c7_ub_y + c7_yb_y;
  c7_ac_y = c7_u_a * c7_n_b;
  c7_v_a = c7_b_h_cg;
  c7_o_b = c7_a_y;
  c7_bc_y = c7_v_a * c7_o_b;
  c7_w_a = c7_b_l_tread;
  c7_cc_y = c7_w_a * -9.81;
  c7_l_A = c7_bc_y;
  c7_l_B = c7_cc_y;
  c7_w_x = c7_l_A;
  c7_dc_y = c7_l_B;
  c7_x_x = c7_w_x;
  c7_ec_y = c7_dc_y;
  c7_fc_y = c7_x_x / c7_ec_y;
  c7_x_a = c7_ac_y;
  c7_p_b = 0.5 + c7_fc_y;
  c7_Fz_rr = c7_x_a * c7_p_b;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 14);
  c7_b_Fz_fl[0] = c7_Fz_fl;
  c7_b_Fz_fl[1] = c7_Fz_fr;
  c7_b_Fz_fl[2] = c7_Fz_rl;
  c7_b_Fz_fl[3] = c7_Fz_rr;
  for (c7_i5 = 0; c7_i5 < 4; c7_i5++) {
    c7_Fz_wheel[c7_i5] = c7_b_Fz_fl[c7_i5];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, -14);
  sf_debug_symbol_scope_pop();
  for (c7_i6 = 0; c7_i6 < 4; c7_i6++) {
    (*c7_b_Fz_wheel)[c7_i6] = c7_Fz_wheel[c7_i6];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 6U, chartInstance->c7_sfEvent);
}

static void initSimStructsc7_ref_gen(SFc7_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber)
{
}

static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i7;
  real_T c7_b_inData[4];
  int32_T c7_i8;
  real_T c7_u[4];
  const mxArray *c7_y = NULL;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i7 = 0; c7_i7 < 4; c7_i7++) {
    c7_b_inData[c7_i7] = (*(real_T (*)[4])c7_inData)[c7_i7];
  }

  for (c7_i8 = 0; c7_i8 < 4; c7_i8++) {
    c7_u[c7_i8] = c7_b_inData[c7_i8];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance, const
  mxArray *c7_Fz_wheel, const char_T *c7_identifier, real_T c7_y[4])
{
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_Fz_wheel), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_Fz_wheel);
}

static void c7_b_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[4])
{
  real_T c7_dv1[4];
  int32_T c7_i9;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv1, 1, 0, 0U, 1, 0U, 1, 4);
  for (c7_i9 = 0; c7_i9 < 4; c7_i9++) {
    c7_y[c7_i9] = c7_dv1[c7_i9];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_Fz_wheel;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[4];
  int32_T c7_i10;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_Fz_wheel = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_Fz_wheel), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_Fz_wheel);
  for (c7_i10 = 0; c7_i10 < 4; c7_i10++) {
    (*(real_T (*)[4])c7_outData)[c7_i10] = c7_y[c7_i10];
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_c_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d6;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d6, 1, 0, 0U, 0, 0U, 0);
  c7_y = c7_d6;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_l_car;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_b_l_car = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_l_car), &c7_thisId);
  sf_mex_destroy(&c7_b_l_car);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i11;
  real_T c7_b_inData[3];
  int32_T c7_i12;
  real_T c7_u[3];
  const mxArray *c7_y = NULL;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i11 = 0; c7_i11 < 3; c7_i11++) {
    c7_b_inData[c7_i11] = (*(real_T (*)[3])c7_inData)[c7_i11];
  }

  for (c7_i12 = 0; c7_i12 < 3; c7_i12++) {
    c7_u[c7_i12] = c7_b_inData[c7_i12];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

const mxArray *sf_c7_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c7_nameCaptureInfo;
  c7_ResolvedFunctionInfo c7_info[4];
  c7_ResolvedFunctionInfo (*c7_b_info)[4];
  const mxArray *c7_m0 = NULL;
  int32_T c7_i13;
  c7_ResolvedFunctionInfo *c7_r0;
  c7_nameCaptureInfo = NULL;
  c7_nameCaptureInfo = NULL;
  c7_b_info = (c7_ResolvedFunctionInfo (*)[4])c7_info;
  (*c7_b_info)[0].context = "";
  (*c7_b_info)[0].name = "mtimes";
  (*c7_b_info)[0].dominantType = "double";
  (*c7_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c7_b_info)[0].fileTimeLo = 1289519692U;
  (*c7_b_info)[0].fileTimeHi = 0U;
  (*c7_b_info)[0].mFileTimeLo = 0U;
  (*c7_b_info)[0].mFileTimeHi = 0U;
  (*c7_b_info)[1].context = "";
  (*c7_b_info)[1].name = "mrdivide";
  (*c7_b_info)[1].dominantType = "double";
  (*c7_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c7_b_info)[1].fileTimeLo = 1310137456U;
  (*c7_b_info)[1].fileTimeHi = 0U;
  (*c7_b_info)[1].mFileTimeLo = 1289519692U;
  (*c7_b_info)[1].mFileTimeHi = 0U;
  (*c7_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c7_b_info)[2].name = "rdivide";
  (*c7_b_info)[2].dominantType = "double";
  (*c7_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c7_b_info)[2].fileTimeLo = 1286818844U;
  (*c7_b_info)[2].fileTimeHi = 0U;
  (*c7_b_info)[2].mFileTimeLo = 0U;
  (*c7_b_info)[2].mFileTimeHi = 0U;
  (*c7_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c7_b_info)[3].name = "eml_div";
  (*c7_b_info)[3].dominantType = "double";
  (*c7_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c7_b_info)[3].fileTimeLo = 1305318000U;
  (*c7_b_info)[3].fileTimeHi = 0U;
  (*c7_b_info)[3].mFileTimeLo = 0U;
  (*c7_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c7_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4), FALSE);
  for (c7_i13 = 0; c7_i13 < 4; c7_i13++) {
    c7_r0 = &c7_info[c7_i13];
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->context)), "context", "nameCaptureInfo",
                    c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c7_r0->name)), "name", "nameCaptureInfo", c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c7_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->resolved)), "resolved", "nameCaptureInfo",
                    c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c7_i13);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c7_i13);
  }

  sf_mex_assign(&c7_nameCaptureInfo, c7_m0, FALSE);
  return c7_nameCaptureInfo;
}

static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(int32_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static int32_T c7_d_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  int32_T c7_y;
  int32_T c7_i14;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_i14, 1, 6, 0U, 0, 0U, 0);
  c7_y = c7_i14;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_sfEvent;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  int32_T c7_y;
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)chartInstanceVoid;
  c7_b_sfEvent = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_sfEvent),
    &c7_thisId);
  sf_mex_destroy(&c7_b_sfEvent);
  *(int32_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static uint8_T c7_e_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_b_is_active_c7_ref_gen, const char_T *c7_identifier)
{
  uint8_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c7_b_is_active_c7_ref_gen), &c7_thisId);
  sf_mex_destroy(&c7_b_is_active_c7_ref_gen);
  return c7_y;
}

static uint8_T c7_f_emlrt_marshallIn(SFc7_ref_genInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  uint8_T c7_y;
  uint8_T c7_u0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_u0, 1, 3, 0U, 0, 0U, 0);
  c7_y = c7_u0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void init_dsm_address_info(SFc7_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c7_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2495189196U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(796658505U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3224883105U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(870234242U);
}

mxArray *sf_c7_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("qhHDpdbqfiIgxwS63MhXUD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c7_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"Fz_wheel\",},{M[8],M[0],T\"is_active_c7_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c7_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc7_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc7_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          7,
          1,
          1,
          8,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"a_xyz");
          _SFD_SET_DATA_PROPS(1,2,0,1,"Fz_wheel");
          _SFD_SET_DATA_PROPS(2,10,0,0,"l_front");
          _SFD_SET_DATA_PROPS(3,10,0,0,"l_rear");
          _SFD_SET_DATA_PROPS(4,10,0,0,"l_tread");
          _SFD_SET_DATA_PROPS(5,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(6,10,0,0,"h_cg");
          _SFD_SET_DATA_PROPS(7,10,0,0,"l_car");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,536);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)
            c7_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)c7_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)c7_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)c7_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)c7_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)c7_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)c7_b_sf_marshallIn);

        {
          real_T (*c7_a_xyz)[3];
          real_T (*c7_Fz_wheel)[4];
          c7_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
          c7_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c7_a_xyz);
          _SFD_SET_DATA_VALUE_PTR(1U, *c7_Fz_wheel);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c7_l_front);
          _SFD_SET_DATA_VALUE_PTR(3U, &chartInstance->c7_l_rear);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c7_l_tread);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c7_m_car);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance->c7_h_cg);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance->c7_l_car);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c7_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc7_ref_genInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c7_ref_gen(void *chartInstanceVar)
{
  enable_c7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c7_ref_gen(void *chartInstanceVar)
{
  disable_c7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c7_ref_gen(void *chartInstanceVar)
{
  sf_c7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c7_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c7_ref_gen((SFc7_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c7_ref_gen(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c7_ref_gen((SFc7_ref_genInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c7_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c7_ref_gen(S);
}

static void sf_opaque_set_sim_state_c7_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c7_ref_gen(S, st);
}

static void sf_opaque_terminate_c7_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc7_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc7_ref_gen((SFc7_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c7_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c7_ref_gen((SFc7_ref_genInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c7_ref_gen(SimStruct *S)
{
  /* Actual parameters from chart:
     h_cg l_car l_front l_rear l_tread m_car
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4", "p5", "p6" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for h_cg*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for l_car*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for l_front*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for l_rear*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for l_tread*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,7);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,7,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,7,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,7,1);
      sf_mark_chart_reusable_outputs(S,infoStruct,7,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,7);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3688920086U));
  ssSetChecksum1(S,(2896326949U));
  ssSetChecksum2(S,(544295602U));
  ssSetChecksum3(S,(2495581568U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c7_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c7_ref_gen(SimStruct *S)
{
  SFc7_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc7_ref_genInstanceStruct *)malloc(sizeof
    (SFc7_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc7_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c7_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c7_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c7_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c7_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c7_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c7_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c7_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c7_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c7_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c7_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c7_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c7_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c7_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c7_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c7_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c7_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
