/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c8_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c8_debug_family_names[26] = { "V", "ratio_long_fl",
  "ratio_long_fr", "ratio_long_rl", "ratio_long_rr", "ratio_lat_fl",
  "ratio_lat_fr", "ratio_lat_rl", "ratio_lat_rr", "c1", "c2", "c3", "c4",
  "my_fl", "my_fr", "my_rl", "my_rr", "nargin", "nargout", "v_body",
  "sigma_long", "sigma_lat", "sigma_res", "road_condition", "my_long", "my_lat"
};

/* Function Declarations */
static void initialize_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void initialize_params_c8_ref_gen(SFc8_ref_genInstanceStruct
  *chartInstance);
static void enable_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void disable_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void c8_update_debugger_state_c8_ref_gen(SFc8_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c8_ref_gen(SFc8_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_st);
static void finalize_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void sf_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void c8_chartstep_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void initSimStructsc8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber);
static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData);
static void c8_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance, const
  mxArray *c8_my_lat, const char_T *c8_identifier, real_T c8_y[4]);
static void c8_b_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[4]);
static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static real_T c8_c_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[23]);
static real_T c8_norm(SFc8_ref_genInstanceStruct *chartInstance, real_T c8_x[2]);
static real_T c8_mrdivide(SFc8_ref_genInstanceStruct *chartInstance, real_T c8_A,
  real_T c8_B);
static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static int32_T c8_d_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static uint8_T c8_e_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_b_is_active_c8_ref_gen, const char_T *c8_identifier);
static uint8_T c8_f_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void init_dsm_address_info(SFc8_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c8_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c8_is_active_c8_ref_gen = 0U;
}

static void initialize_params_c8_ref_gen(SFc8_ref_genInstanceStruct
  *chartInstance)
{
  real_T c8_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'road_condition' in the parent workspace.\n");
  sf_mex_import_named("road_condition", sf_mex_get_sfun_param(chartInstance->S,
    0, 0), &c8_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c8_road_condition = c8_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c8_update_debugger_state_c8_ref_gen(SFc8_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c8_ref_gen(SFc8_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c8_st;
  const mxArray *c8_y = NULL;
  int32_T c8_i0;
  real_T c8_u[4];
  const mxArray *c8_b_y = NULL;
  int32_T c8_i1;
  real_T c8_b_u[4];
  const mxArray *c8_c_y = NULL;
  uint8_T c8_hoistedGlobal;
  uint8_T c8_c_u;
  const mxArray *c8_d_y = NULL;
  real_T (*c8_my_long)[4];
  real_T (*c8_my_lat)[4];
  c8_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_st = NULL;
  c8_st = NULL;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_createcellarray(3), FALSE);
  for (c8_i0 = 0; c8_i0 < 4; c8_i0++) {
    c8_u[c8_i0] = (*c8_my_lat)[c8_i0];
  }

  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c8_y, 0, c8_b_y);
  for (c8_i1 = 0; c8_i1 < 4; c8_i1++) {
    c8_b_u[c8_i1] = (*c8_my_long)[c8_i1];
  }

  c8_c_y = NULL;
  sf_mex_assign(&c8_c_y, sf_mex_create("y", c8_b_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c8_y, 1, c8_c_y);
  c8_hoistedGlobal = chartInstance->c8_is_active_c8_ref_gen;
  c8_c_u = c8_hoistedGlobal;
  c8_d_y = NULL;
  sf_mex_assign(&c8_d_y, sf_mex_create("y", &c8_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c8_y, 2, c8_d_y);
  sf_mex_assign(&c8_st, c8_y, FALSE);
  return c8_st;
}

static void set_sim_state_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_st)
{
  const mxArray *c8_u;
  real_T c8_dv0[4];
  int32_T c8_i2;
  real_T c8_dv1[4];
  int32_T c8_i3;
  real_T (*c8_my_lat)[4];
  real_T (*c8_my_long)[4];
  c8_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c8_doneDoubleBufferReInit = TRUE;
  c8_u = sf_mex_dup(c8_st);
  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 0)),
                      "my_lat", c8_dv0);
  for (c8_i2 = 0; c8_i2 < 4; c8_i2++) {
    (*c8_my_lat)[c8_i2] = c8_dv0[c8_i2];
  }

  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 1)),
                      "my_long", c8_dv1);
  for (c8_i3 = 0; c8_i3 < 4; c8_i3++) {
    (*c8_my_long)[c8_i3] = c8_dv1[c8_i3];
  }

  chartInstance->c8_is_active_c8_ref_gen = c8_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c8_u, 2)), "is_active_c8_ref_gen");
  sf_mex_destroy(&c8_u);
  c8_update_debugger_state_c8_ref_gen(chartInstance);
  sf_mex_destroy(&c8_st);
}

static void finalize_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
  int32_T c8_i4;
  int32_T c8_i5;
  int32_T c8_i6;
  int32_T c8_i7;
  int32_T c8_i8;
  int32_T c8_i9;
  real_T (*c8_my_lat)[4];
  real_T (*c8_my_long)[4];
  real_T (*c8_sigma_res)[4];
  real_T (*c8_sigma_lat)[4];
  real_T (*c8_sigma_long)[4];
  real_T (*c8_v_body)[3];
  c8_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_sigma_res = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c8_sigma_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c8_sigma_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c8_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  for (c8_i4 = 0; c8_i4 < 3; c8_i4++) {
    _SFD_DATA_RANGE_CHECK((*c8_v_body)[c8_i4], 0U);
  }

  for (c8_i5 = 0; c8_i5 < 4; c8_i5++) {
    _SFD_DATA_RANGE_CHECK((*c8_sigma_long)[c8_i5], 1U);
  }

  for (c8_i6 = 0; c8_i6 < 4; c8_i6++) {
    _SFD_DATA_RANGE_CHECK((*c8_sigma_lat)[c8_i6], 2U);
  }

  for (c8_i7 = 0; c8_i7 < 4; c8_i7++) {
    _SFD_DATA_RANGE_CHECK((*c8_sigma_res)[c8_i7], 3U);
  }

  for (c8_i8 = 0; c8_i8 < 4; c8_i8++) {
    _SFD_DATA_RANGE_CHECK((*c8_my_long)[c8_i8], 4U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c8_road_condition, 5U);
  for (c8_i9 = 0; c8_i9 < 4; c8_i9++) {
    _SFD_DATA_RANGE_CHECK((*c8_my_lat)[c8_i9], 6U);
  }

  chartInstance->c8_sfEvent = CALL_EVENT;
  c8_chartstep_c8_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c8_chartstep_c8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
  real_T c8_hoistedGlobal;
  int32_T c8_i10;
  real_T c8_v_body[3];
  int32_T c8_i11;
  real_T c8_sigma_long[4];
  int32_T c8_i12;
  real_T c8_sigma_lat[4];
  int32_T c8_i13;
  real_T c8_sigma_res[4];
  real_T c8_b_road_condition;
  uint32_T c8_debug_family_var_map[26];
  real_T c8_V;
  real_T c8_ratio_long_fl;
  real_T c8_ratio_long_fr;
  real_T c8_ratio_long_rl;
  real_T c8_ratio_long_rr;
  real_T c8_ratio_lat_fl;
  real_T c8_ratio_lat_fr;
  real_T c8_ratio_lat_rl;
  real_T c8_ratio_lat_rr;
  real_T c8_c1;
  real_T c8_c2;
  real_T c8_c3;
  real_T c8_c4;
  real_T c8_my_fl;
  real_T c8_my_fr;
  real_T c8_my_rl;
  real_T c8_my_rr;
  real_T c8_nargin = 5.0;
  real_T c8_nargout = 2.0;
  real_T c8_my_long[4];
  real_T c8_my_lat[4];
  real_T c8_b_v_body[2];
  real_T c8_x;
  boolean_T c8_b;
  real_T c8_b_x;
  boolean_T c8_b_b;
  real_T c8_c_x;
  boolean_T c8_c_b;
  real_T c8_d_x;
  boolean_T c8_d_b;
  real_T c8_e_x;
  boolean_T c8_e_b;
  real_T c8_f_x;
  boolean_T c8_f_b;
  real_T c8_g_x;
  boolean_T c8_g_b;
  real_T c8_h_x;
  boolean_T c8_h_b;
  real_T c8_a;
  real_T c8_i_b;
  real_T c8_y;
  real_T c8_i_x;
  real_T c8_j_x;
  real_T c8_b_a;
  real_T c8_j_b;
  real_T c8_b_y;
  real_T c8_c_a;
  real_T c8_k_b;
  real_T c8_c_y;
  real_T c8_d_a;
  real_T c8_l_b;
  real_T c8_d_y;
  real_T c8_e_a;
  real_T c8_m_b;
  real_T c8_e_y;
  real_T c8_k_x;
  real_T c8_l_x;
  real_T c8_f_a;
  real_T c8_n_b;
  real_T c8_g_a;
  real_T c8_o_b;
  real_T c8_f_y;
  real_T c8_m_x;
  real_T c8_n_x;
  real_T c8_h_a;
  real_T c8_p_b;
  real_T c8_g_y;
  real_T c8_i_a;
  real_T c8_q_b;
  real_T c8_h_y;
  real_T c8_j_a;
  real_T c8_r_b;
  real_T c8_i_y;
  real_T c8_k_a;
  real_T c8_s_b;
  real_T c8_j_y;
  real_T c8_o_x;
  real_T c8_p_x;
  real_T c8_l_a;
  real_T c8_t_b;
  real_T c8_m_a;
  real_T c8_u_b;
  real_T c8_k_y;
  real_T c8_q_x;
  real_T c8_r_x;
  real_T c8_n_a;
  real_T c8_v_b;
  real_T c8_l_y;
  real_T c8_o_a;
  real_T c8_w_b;
  real_T c8_m_y;
  real_T c8_p_a;
  real_T c8_x_b;
  real_T c8_n_y;
  real_T c8_q_a;
  real_T c8_y_b;
  real_T c8_o_y;
  real_T c8_s_x;
  real_T c8_t_x;
  real_T c8_r_a;
  real_T c8_ab_b;
  real_T c8_s_a;
  real_T c8_bb_b;
  real_T c8_p_y;
  real_T c8_u_x;
  real_T c8_v_x;
  real_T c8_t_a;
  real_T c8_cb_b;
  real_T c8_q_y;
  real_T c8_u_a;
  real_T c8_db_b;
  real_T c8_r_y;
  real_T c8_v_a;
  real_T c8_eb_b;
  real_T c8_s_y;
  real_T c8_w_a;
  real_T c8_fb_b;
  real_T c8_t_y;
  real_T c8_w_x;
  real_T c8_x_x;
  real_T c8_x_a;
  real_T c8_gb_b;
  real_T c8_y_a;
  real_T c8_hb_b;
  real_T c8_u_y;
  real_T c8_ab_a;
  real_T c8_ib_b;
  real_T c8_v_y;
  real_T c8_bb_a;
  real_T c8_jb_b;
  real_T c8_w_y;
  real_T c8_cb_a;
  real_T c8_kb_b;
  real_T c8_x_y;
  real_T c8_db_a;
  real_T c8_lb_b;
  real_T c8_y_y;
  real_T c8_eb_a;
  real_T c8_mb_b;
  real_T c8_ab_y;
  real_T c8_fb_a;
  real_T c8_nb_b;
  real_T c8_bb_y;
  real_T c8_gb_a;
  real_T c8_ob_b;
  real_T c8_cb_y;
  int32_T c8_i14;
  int32_T c8_i15;
  real_T (*c8_b_my_long)[4];
  real_T (*c8_b_my_lat)[4];
  real_T (*c8_b_sigma_res)[4];
  real_T (*c8_b_sigma_lat)[4];
  real_T (*c8_b_sigma_long)[4];
  real_T (*c8_c_v_body)[3];
  c8_b_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_b_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_b_sigma_res = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c8_b_sigma_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c8_b_sigma_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c8_c_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  c8_hoistedGlobal = chartInstance->c8_road_condition;
  for (c8_i10 = 0; c8_i10 < 3; c8_i10++) {
    c8_v_body[c8_i10] = (*c8_c_v_body)[c8_i10];
  }

  for (c8_i11 = 0; c8_i11 < 4; c8_i11++) {
    c8_sigma_long[c8_i11] = (*c8_b_sigma_long)[c8_i11];
  }

  for (c8_i12 = 0; c8_i12 < 4; c8_i12++) {
    c8_sigma_lat[c8_i12] = (*c8_b_sigma_lat)[c8_i12];
  }

  for (c8_i13 = 0; c8_i13 < 4; c8_i13++) {
    c8_sigma_res[c8_i13] = (*c8_b_sigma_res)[c8_i13];
  }

  c8_b_road_condition = c8_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 26U, 26U, c8_debug_family_names,
    c8_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c8_V, 0U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_long_fl, 1U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_long_fr, 2U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_long_rl, 3U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_long_rr, 4U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_lat_fl, 5U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_lat_fr, 6U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_lat_rl, 7U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_ratio_lat_rr, 8U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_c1, 9U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_c2, 10U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_c3, 11U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_c4, 12U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_my_fl, 13U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_my_fr, 14U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_my_rl, 15U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_my_rr, 16U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_nargin, 17U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_nargout, 18U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c8_v_body, 19U, c8_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c8_sigma_long, 20U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c8_sigma_lat, 21U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c8_sigma_res, 22U, c8_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c8_b_road_condition, 23U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_my_long, 24U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_my_lat, 25U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 4);
  c8_b_v_body[0] = c8_v_body[0];
  c8_b_v_body[1] = c8_v_body[1];
  c8_V = c8_norm(chartInstance, c8_b_v_body);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 7);
  c8_ratio_long_fl = c8_mrdivide(chartInstance, c8_sigma_long[0], c8_sigma_res[0]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 8);
  c8_ratio_long_fr = c8_mrdivide(chartInstance, c8_sigma_long[1], c8_sigma_res[1]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 9);
  c8_ratio_long_rl = c8_mrdivide(chartInstance, c8_sigma_long[2], c8_sigma_res[2]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 10);
  c8_ratio_long_rr = c8_mrdivide(chartInstance, c8_sigma_long[3], c8_sigma_res[3]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 11);
  c8_ratio_lat_fl = c8_mrdivide(chartInstance, c8_sigma_lat[0], c8_sigma_res[0]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 12);
  c8_ratio_lat_fr = c8_mrdivide(chartInstance, c8_sigma_lat[1], c8_sigma_res[1]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 13);
  c8_ratio_lat_rl = c8_mrdivide(chartInstance, c8_sigma_lat[2], c8_sigma_res[2]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 14);
  c8_ratio_lat_rr = c8_mrdivide(chartInstance, c8_sigma_lat[3], c8_sigma_res[3]);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 16);
  c8_x = c8_ratio_long_fl;
  c8_b = muDoubleScalarIsNaN(c8_x);
  if (CV_EML_IF(0, 1, 0, c8_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 16);
    c8_ratio_long_fl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 17);
  c8_b_x = c8_ratio_long_fr;
  c8_b_b = muDoubleScalarIsNaN(c8_b_x);
  if (CV_EML_IF(0, 1, 1, c8_b_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 17);
    c8_ratio_long_fr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 18);
  c8_c_x = c8_ratio_long_rl;
  c8_c_b = muDoubleScalarIsNaN(c8_c_x);
  if (CV_EML_IF(0, 1, 2, c8_c_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 18);
    c8_ratio_long_rl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 19);
  c8_d_x = c8_ratio_long_rr;
  c8_d_b = muDoubleScalarIsNaN(c8_d_x);
  if (CV_EML_IF(0, 1, 3, c8_d_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 19);
    c8_ratio_long_rr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 20);
  c8_e_x = c8_ratio_lat_fl;
  c8_e_b = muDoubleScalarIsNaN(c8_e_x);
  if (CV_EML_IF(0, 1, 4, c8_e_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 20);
    c8_ratio_lat_fl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 21);
  c8_f_x = c8_ratio_lat_fr;
  c8_f_b = muDoubleScalarIsNaN(c8_f_x);
  if (CV_EML_IF(0, 1, 5, c8_f_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 21);
    c8_ratio_lat_fr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 22);
  c8_g_x = c8_ratio_lat_rl;
  c8_g_b = muDoubleScalarIsNaN(c8_g_x);
  if (CV_EML_IF(0, 1, 6, c8_g_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 22);
    c8_ratio_lat_rl = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 23);
  c8_h_x = c8_ratio_lat_rr;
  c8_h_b = muDoubleScalarIsNaN(c8_h_x);
  if (CV_EML_IF(0, 1, 7, c8_h_b)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 23);
    c8_ratio_lat_rr = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 25);
  switch ((int32_T)_SFD_INTEGER_CHECK("road_condition", c8_b_road_condition)) {
   case 1:
    CV_EML_SWITCH(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 28);
    c8_c1 = 1.2801;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 29);
    c8_c2 = 23.99;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 30);
    c8_c3 = 0.52;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 31);
    c8_c4 = 0.03;
    break;

   case 2:
    CV_EML_SWITCH(0, 1, 0, 2);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 35);
    c8_c1 = 0.857;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 36);
    c8_c2 = 33.822;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 37);
    c8_c3 = 0.347;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 38);
    c8_c4 = 0.03;
    break;

   case 3:
    CV_EML_SWITCH(0, 1, 0, 3);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 42);
    c8_c1 = 1.1973;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 43);
    c8_c2 = 25.168;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 44);
    c8_c3 = 0.5373;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 45);
    c8_c4 = 0.03;
    break;

   case 4:
    CV_EML_SWITCH(0, 1, 0, 4);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 49);
    c8_c1 = 1.3713;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 50);
    c8_c2 = 6.4565;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 51);
    c8_c3 = 0.6691;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 52);
    c8_c4 = 0.03;
    break;

   case 5:
    CV_EML_SWITCH(0, 1, 0, 5);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 56);
    c8_c1 = 0.4004;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 57);
    c8_c2 = 33.708;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 58);
    c8_c3 = 0.1204;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 59);
    c8_c4 = 0.03;
    break;

   case 6:
    CV_EML_SWITCH(0, 1, 0, 6);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 63);
    c8_c1 = 0.1946;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 64);
    c8_c2 = 94.129;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 65);
    c8_c3 = 0.0646;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 66);
    c8_c4 = 0.03;
    break;

   case 7:
    CV_EML_SWITCH(0, 1, 0, 7);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 70);
    c8_c1 = 0.05;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 71);
    c8_c2 = 306.39;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 72);
    c8_c3 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 73);
    c8_c4 = 0.03;
    break;

   default:
    CV_EML_SWITCH(0, 1, 0, 0);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 76);
    c8_c1 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 77);
    c8_c2 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 78);
    c8_c3 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 79);
    c8_c4 = 0.0;
    break;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 84);
  c8_a = -c8_c2;
  c8_i_b = c8_sigma_res[0];
  c8_y = c8_a * c8_i_b;
  c8_i_x = c8_y;
  c8_j_x = c8_i_x;
  c8_j_x = muDoubleScalarExp(c8_j_x);
  c8_b_a = c8_c1;
  c8_j_b = 1.0 - c8_j_x;
  c8_b_y = c8_b_a * c8_j_b;
  c8_c_a = c8_c3;
  c8_k_b = c8_sigma_res[0];
  c8_c_y = c8_c_a * c8_k_b;
  c8_d_a = -c8_c4;
  c8_l_b = c8_sigma_res[0];
  c8_d_y = c8_d_a * c8_l_b;
  c8_e_a = c8_d_y;
  c8_m_b = c8_V;
  c8_e_y = c8_e_a * c8_m_b;
  c8_k_x = c8_e_y;
  c8_l_x = c8_k_x;
  c8_l_x = muDoubleScalarExp(c8_l_x);
  c8_f_a = c8_b_y - c8_c_y;
  c8_n_b = c8_l_x;
  c8_my_fl = c8_f_a * c8_n_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 85);
  c8_g_a = -c8_c2;
  c8_o_b = c8_sigma_res[1];
  c8_f_y = c8_g_a * c8_o_b;
  c8_m_x = c8_f_y;
  c8_n_x = c8_m_x;
  c8_n_x = muDoubleScalarExp(c8_n_x);
  c8_h_a = c8_c1;
  c8_p_b = 1.0 - c8_n_x;
  c8_g_y = c8_h_a * c8_p_b;
  c8_i_a = c8_c3;
  c8_q_b = c8_sigma_res[1];
  c8_h_y = c8_i_a * c8_q_b;
  c8_j_a = -c8_c4;
  c8_r_b = c8_sigma_res[1];
  c8_i_y = c8_j_a * c8_r_b;
  c8_k_a = c8_i_y;
  c8_s_b = c8_V;
  c8_j_y = c8_k_a * c8_s_b;
  c8_o_x = c8_j_y;
  c8_p_x = c8_o_x;
  c8_p_x = muDoubleScalarExp(c8_p_x);
  c8_l_a = c8_g_y - c8_h_y;
  c8_t_b = c8_p_x;
  c8_my_fr = c8_l_a * c8_t_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 86);
  c8_m_a = -c8_c2;
  c8_u_b = c8_sigma_res[2];
  c8_k_y = c8_m_a * c8_u_b;
  c8_q_x = c8_k_y;
  c8_r_x = c8_q_x;
  c8_r_x = muDoubleScalarExp(c8_r_x);
  c8_n_a = c8_c1;
  c8_v_b = 1.0 - c8_r_x;
  c8_l_y = c8_n_a * c8_v_b;
  c8_o_a = c8_c3;
  c8_w_b = c8_sigma_res[2];
  c8_m_y = c8_o_a * c8_w_b;
  c8_p_a = -c8_c4;
  c8_x_b = c8_sigma_res[2];
  c8_n_y = c8_p_a * c8_x_b;
  c8_q_a = c8_n_y;
  c8_y_b = c8_V;
  c8_o_y = c8_q_a * c8_y_b;
  c8_s_x = c8_o_y;
  c8_t_x = c8_s_x;
  c8_t_x = muDoubleScalarExp(c8_t_x);
  c8_r_a = c8_l_y - c8_m_y;
  c8_ab_b = c8_t_x;
  c8_my_rl = c8_r_a * c8_ab_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 87);
  c8_s_a = -c8_c2;
  c8_bb_b = c8_sigma_res[3];
  c8_p_y = c8_s_a * c8_bb_b;
  c8_u_x = c8_p_y;
  c8_v_x = c8_u_x;
  c8_v_x = muDoubleScalarExp(c8_v_x);
  c8_t_a = c8_c1;
  c8_cb_b = 1.0 - c8_v_x;
  c8_q_y = c8_t_a * c8_cb_b;
  c8_u_a = c8_c3;
  c8_db_b = c8_sigma_res[3];
  c8_r_y = c8_u_a * c8_db_b;
  c8_v_a = -c8_c4;
  c8_eb_b = c8_sigma_res[3];
  c8_s_y = c8_v_a * c8_eb_b;
  c8_w_a = c8_s_y;
  c8_fb_b = c8_V;
  c8_t_y = c8_w_a * c8_fb_b;
  c8_w_x = c8_t_y;
  c8_x_x = c8_w_x;
  c8_x_x = muDoubleScalarExp(c8_x_x);
  c8_x_a = c8_q_y - c8_r_y;
  c8_gb_b = c8_x_x;
  c8_my_rr = c8_x_a * c8_gb_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 90);
  c8_y_a = c8_my_fl;
  c8_hb_b = c8_ratio_long_fl;
  c8_u_y = c8_y_a * c8_hb_b;
  c8_ab_a = c8_my_fr;
  c8_ib_b = c8_ratio_long_fr;
  c8_v_y = c8_ab_a * c8_ib_b;
  c8_bb_a = c8_my_rl;
  c8_jb_b = c8_ratio_long_rl;
  c8_w_y = c8_bb_a * c8_jb_b;
  c8_cb_a = c8_my_rr;
  c8_kb_b = c8_ratio_long_rr;
  c8_x_y = c8_cb_a * c8_kb_b;
  c8_my_long[0] = c8_u_y;
  c8_my_long[1] = c8_v_y;
  c8_my_long[2] = c8_w_y;
  c8_my_long[3] = c8_x_y;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 96);
  c8_db_a = c8_my_fl;
  c8_lb_b = c8_ratio_lat_fl;
  c8_y_y = c8_db_a * c8_lb_b;
  c8_eb_a = c8_my_fr;
  c8_mb_b = c8_ratio_lat_fr;
  c8_ab_y = c8_eb_a * c8_mb_b;
  c8_fb_a = c8_my_rl;
  c8_nb_b = c8_ratio_lat_rl;
  c8_bb_y = c8_fb_a * c8_nb_b;
  c8_gb_a = c8_my_rr;
  c8_ob_b = c8_ratio_lat_rr;
  c8_cb_y = c8_gb_a * c8_ob_b;
  c8_my_lat[0] = c8_y_y;
  c8_my_lat[1] = c8_ab_y;
  c8_my_lat[2] = c8_bb_y;
  c8_my_lat[3] = c8_cb_y;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, -96);
  sf_debug_symbol_scope_pop();
  for (c8_i14 = 0; c8_i14 < 4; c8_i14++) {
    (*c8_b_my_long)[c8_i14] = c8_my_long[c8_i14];
  }

  for (c8_i15 = 0; c8_i15 < 4; c8_i15++) {
    (*c8_b_my_lat)[c8_i15] = c8_my_lat[c8_i15];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
}

static void initSimStructsc8_ref_gen(SFc8_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber)
{
}

static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i16;
  real_T c8_b_inData[4];
  int32_T c8_i17;
  real_T c8_u[4];
  const mxArray *c8_y = NULL;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i16 = 0; c8_i16 < 4; c8_i16++) {
    c8_b_inData[c8_i16] = (*(real_T (*)[4])c8_inData)[c8_i16];
  }

  for (c8_i17 = 0; c8_i17 < 4; c8_i17++) {
    c8_u[c8_i17] = c8_b_inData[c8_i17];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance, const
  mxArray *c8_my_lat, const char_T *c8_identifier, real_T c8_y[4])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_my_lat), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_my_lat);
}

static void c8_b_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[4])
{
  real_T c8_dv2[4];
  int32_T c8_i18;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv2, 1, 0, 0U, 1, 0U, 1, 4);
  for (c8_i18 = 0; c8_i18 < 4; c8_i18++) {
    c8_y[c8_i18] = c8_dv2[c8_i18];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_my_lat;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[4];
  int32_T c8_i19;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_my_lat = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_my_lat), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_my_lat);
  for (c8_i19 = 0; c8_i19 < 4; c8_i19++) {
    (*(real_T (*)[4])c8_outData)[c8_i19] = c8_y[c8_i19];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(real_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static real_T c8_c_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  real_T c8_y;
  real_T c8_d1;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_d1, 1, 0, 0U, 0, 0U, 0);
  c8_y = c8_d1;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_road_condition;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_b_road_condition = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_road_condition),
    &c8_thisId);
  sf_mex_destroy(&c8_b_road_condition);
  *(real_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i20;
  real_T c8_b_inData[3];
  int32_T c8_i21;
  real_T c8_u[3];
  const mxArray *c8_y = NULL;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i20 = 0; c8_i20 < 3; c8_i20++) {
    c8_b_inData[c8_i20] = (*(real_T (*)[3])c8_inData)[c8_i20];
  }

  for (c8_i21 = 0; c8_i21 < 3; c8_i21++) {
    c8_u[c8_i21] = c8_b_inData[c8_i21];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

const mxArray *sf_c8_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c8_nameCaptureInfo;
  c8_ResolvedFunctionInfo c8_info[23];
  const mxArray *c8_m0 = NULL;
  int32_T c8_i22;
  c8_ResolvedFunctionInfo *c8_r0;
  c8_nameCaptureInfo = NULL;
  c8_nameCaptureInfo = NULL;
  c8_info_helper(c8_info);
  sf_mex_assign(&c8_m0, sf_mex_createstruct("nameCaptureInfo", 1, 23), FALSE);
  for (c8_i22 = 0; c8_i22 < 23; c8_i22++) {
    c8_r0 = &c8_info[c8_i22];
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->context)), "context", "nameCaptureInfo",
                    c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c8_r0->name)), "name", "nameCaptureInfo", c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c8_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->resolved)), "resolved", "nameCaptureInfo",
                    c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c8_i22);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c8_i22);
  }

  sf_mex_assign(&c8_nameCaptureInfo, c8_m0, FALSE);
  return c8_nameCaptureInfo;
}

static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[23])
{
  c8_info[0].context = "";
  c8_info[0].name = "norm";
  c8_info[0].dominantType = "double";
  c8_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c8_info[0].fileTimeLo = 1286818826U;
  c8_info[0].fileTimeHi = 0U;
  c8_info[0].mFileTimeLo = 0U;
  c8_info[0].mFileTimeHi = 0U;
  c8_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c8_info[1].name = "eml_index_class";
  c8_info[1].dominantType = "";
  c8_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[1].fileTimeLo = 1286818778U;
  c8_info[1].fileTimeHi = 0U;
  c8_info[1].mFileTimeLo = 0U;
  c8_info[1].mFileTimeHi = 0U;
  c8_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!genpnorm";
  c8_info[2].name = "eml_xnrm2";
  c8_info[2].dominantType = "int32";
  c8_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c8_info[2].fileTimeLo = 1299076776U;
  c8_info[2].fileTimeHi = 0U;
  c8_info[2].mFileTimeLo = 0U;
  c8_info[2].mFileTimeHi = 0U;
  c8_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xnrm2.m";
  c8_info[3].name = "eml_blas_inline";
  c8_info[3].dominantType = "";
  c8_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c8_info[3].fileTimeLo = 1299076768U;
  c8_info[3].fileTimeHi = 0U;
  c8_info[3].mFileTimeLo = 0U;
  c8_info[3].mFileTimeHi = 0U;
  c8_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xnrm2.m";
  c8_info[4].name = "eml_refblas_xnrm2";
  c8_info[4].dominantType = "int32";
  c8_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c8_info[4].fileTimeLo = 1299076784U;
  c8_info[4].fileTimeHi = 0U;
  c8_info[4].mFileTimeLo = 0U;
  c8_info[4].mFileTimeHi = 0U;
  c8_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c8_info[5].name = "realmin";
  c8_info[5].dominantType = "char";
  c8_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c8_info[5].fileTimeLo = 1286818768U;
  c8_info[5].fileTimeHi = 0U;
  c8_info[5].mFileTimeLo = 0U;
  c8_info[5].mFileTimeHi = 0U;
  c8_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c8_info[6].name = "mpower";
  c8_info[6].dominantType = "double";
  c8_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c8_info[6].fileTimeLo = 1286818842U;
  c8_info[6].fileTimeHi = 0U;
  c8_info[6].mFileTimeLo = 0U;
  c8_info[6].mFileTimeHi = 0U;
  c8_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c8_info[7].name = "power";
  c8_info[7].dominantType = "double";
  c8_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c8_info[7].fileTimeLo = 1294067944U;
  c8_info[7].fileTimeHi = 0U;
  c8_info[7].mFileTimeLo = 0U;
  c8_info[7].mFileTimeHi = 0U;
  c8_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c8_info[8].name = "eml_scalar_eg";
  c8_info[8].dominantType = "double";
  c8_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[8].fileTimeLo = 1286818796U;
  c8_info[8].fileTimeHi = 0U;
  c8_info[8].mFileTimeLo = 0U;
  c8_info[8].mFileTimeHi = 0U;
  c8_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c8_info[9].name = "eml_scalexp_alloc";
  c8_info[9].dominantType = "double";
  c8_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c8_info[9].fileTimeLo = 1286818796U;
  c8_info[9].fileTimeHi = 0U;
  c8_info[9].mFileTimeLo = 0U;
  c8_info[9].mFileTimeHi = 0U;
  c8_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c8_info[10].name = "eml_scalar_floor";
  c8_info[10].dominantType = "double";
  c8_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c8_info[10].fileTimeLo = 1286818726U;
  c8_info[10].fileTimeHi = 0U;
  c8_info[10].mFileTimeLo = 0U;
  c8_info[10].mFileTimeHi = 0U;
  c8_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c8_info[11].name = "eml_index_minus";
  c8_info[11].dominantType = "int32";
  c8_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c8_info[11].fileTimeLo = 1286818778U;
  c8_info[11].fileTimeHi = 0U;
  c8_info[11].mFileTimeLo = 0U;
  c8_info[11].mFileTimeHi = 0U;
  c8_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c8_info[12].name = "eml_index_times";
  c8_info[12].dominantType = "int32";
  c8_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c8_info[12].fileTimeLo = 1286818780U;
  c8_info[12].fileTimeHi = 0U;
  c8_info[12].mFileTimeLo = 0U;
  c8_info[12].mFileTimeHi = 0U;
  c8_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c8_info[13].name = "eml_index_plus";
  c8_info[13].dominantType = "int32";
  c8_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c8_info[13].fileTimeLo = 1286818778U;
  c8_info[13].fileTimeHi = 0U;
  c8_info[13].mFileTimeLo = 0U;
  c8_info[13].mFileTimeHi = 0U;
  c8_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xnrm2.m";
  c8_info[14].name = "abs";
  c8_info[14].dominantType = "double";
  c8_info[14].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[14].fileTimeLo = 1286818694U;
  c8_info[14].fileTimeHi = 0U;
  c8_info[14].mFileTimeLo = 0U;
  c8_info[14].mFileTimeHi = 0U;
  c8_info[15].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c8_info[15].name = "eml_scalar_abs";
  c8_info[15].dominantType = "double";
  c8_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c8_info[15].fileTimeLo = 1286818712U;
  c8_info[15].fileTimeHi = 0U;
  c8_info[15].mFileTimeLo = 0U;
  c8_info[15].mFileTimeHi = 0U;
  c8_info[16].context = "";
  c8_info[16].name = "mrdivide";
  c8_info[16].dominantType = "double";
  c8_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[16].fileTimeLo = 1310137456U;
  c8_info[16].fileTimeHi = 0U;
  c8_info[16].mFileTimeLo = 1289519692U;
  c8_info[16].mFileTimeHi = 0U;
  c8_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[17].name = "rdivide";
  c8_info[17].dominantType = "double";
  c8_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[17].fileTimeLo = 1286818844U;
  c8_info[17].fileTimeHi = 0U;
  c8_info[17].mFileTimeLo = 0U;
  c8_info[17].mFileTimeHi = 0U;
  c8_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[18].name = "eml_div";
  c8_info[18].dominantType = "double";
  c8_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c8_info[18].fileTimeLo = 1305318000U;
  c8_info[18].fileTimeHi = 0U;
  c8_info[18].mFileTimeLo = 0U;
  c8_info[18].mFileTimeHi = 0U;
  c8_info[19].context = "";
  c8_info[19].name = "isnan";
  c8_info[19].dominantType = "double";
  c8_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c8_info[19].fileTimeLo = 1286818760U;
  c8_info[19].fileTimeHi = 0U;
  c8_info[19].mFileTimeLo = 0U;
  c8_info[19].mFileTimeHi = 0U;
  c8_info[20].context = "";
  c8_info[20].name = "mtimes";
  c8_info[20].dominantType = "double";
  c8_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[20].fileTimeLo = 1289519692U;
  c8_info[20].fileTimeHi = 0U;
  c8_info[20].mFileTimeLo = 0U;
  c8_info[20].mFileTimeHi = 0U;
  c8_info[21].context = "";
  c8_info[21].name = "exp";
  c8_info[21].dominantType = "double";
  c8_info[21].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c8_info[21].fileTimeLo = 1286818740U;
  c8_info[21].fileTimeHi = 0U;
  c8_info[21].mFileTimeLo = 0U;
  c8_info[21].mFileTimeHi = 0U;
  c8_info[22].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c8_info[22].name = "eml_scalar_exp";
  c8_info[22].dominantType = "double";
  c8_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  c8_info[22].fileTimeLo = 1301328464U;
  c8_info[22].fileTimeHi = 0U;
  c8_info[22].mFileTimeLo = 0U;
  c8_info[22].mFileTimeHi = 0U;
}

static real_T c8_norm(SFc8_ref_genInstanceStruct *chartInstance, real_T c8_x[2])
{
  real_T c8_y;
  real_T c8_scale;
  int32_T c8_k;
  int32_T c8_b_k;
  real_T c8_b_x;
  real_T c8_c_x;
  real_T c8_absxk;
  real_T c8_t;
  c8_y = 0.0;
  c8_scale = 2.2250738585072014E-308;
  for (c8_k = 1; c8_k < 3; c8_k++) {
    c8_b_k = c8_k;
    c8_b_x = c8_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c8_b_k), 1, 2, 1, 0) - 1];
    c8_c_x = c8_b_x;
    c8_absxk = muDoubleScalarAbs(c8_c_x);
    if (c8_absxk > c8_scale) {
      c8_t = c8_scale / c8_absxk;
      c8_y = 1.0 + c8_y * c8_t * c8_t;
      c8_scale = c8_absxk;
    } else {
      c8_t = c8_absxk / c8_scale;
      c8_y += c8_t * c8_t;
    }
  }

  return c8_scale * muDoubleScalarSqrt(c8_y);
}

static real_T c8_mrdivide(SFc8_ref_genInstanceStruct *chartInstance, real_T c8_A,
  real_T c8_B)
{
  real_T c8_x;
  real_T c8_b_y;
  real_T c8_b_x;
  real_T c8_c_y;
  c8_x = c8_A;
  c8_b_y = c8_B;
  c8_b_x = c8_x;
  c8_c_y = c8_b_y;
  return c8_b_x / c8_c_y;
}

static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(int32_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static int32_T c8_d_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  int32_T c8_y;
  int32_T c8_i23;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_i23, 1, 6, 0U, 0, 0U, 0);
  c8_y = c8_i23;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_sfEvent;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  int32_T c8_y;
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)chartInstanceVoid;
  c8_b_sfEvent = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_sfEvent),
    &c8_thisId);
  sf_mex_destroy(&c8_b_sfEvent);
  *(int32_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static uint8_T c8_e_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_b_is_active_c8_ref_gen, const char_T *c8_identifier)
{
  uint8_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c8_b_is_active_c8_ref_gen), &c8_thisId);
  sf_mex_destroy(&c8_b_is_active_c8_ref_gen);
  return c8_y;
}

static uint8_T c8_f_emlrt_marshallIn(SFc8_ref_genInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  uint8_T c8_y;
  uint8_T c8_u0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_u0, 1, 3, 0U, 0, 0U, 0);
  c8_y = c8_u0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void init_dsm_address_info(SFc8_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c8_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(568368733U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3217189752U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(240815520U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(651397808U);
}

mxArray *sf_c8_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("e5zI5n3ogfjngkq4RnQFxF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c8_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[10],T\"my_lat\",},{M[1],M[5],T\"my_long\",},{M[8],M[0],T\"is_active_c8_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c8_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc8_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc8_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          8,
          1,
          1,
          7,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_body");
          _SFD_SET_DATA_PROPS(1,1,1,0,"sigma_long");
          _SFD_SET_DATA_PROPS(2,1,1,0,"sigma_lat");
          _SFD_SET_DATA_PROPS(3,1,1,0,"sigma_res");
          _SFD_SET_DATA_PROPS(4,2,0,1,"my_long");
          _SFD_SET_DATA_PROPS(5,10,0,0,"road_condition");
          _SFD_SET_DATA_PROPS(6,2,0,1,"my_lat");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,8,0,1,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,2575);
        _SFD_CV_INIT_EML_IF(0,1,0,575,598,-1,622);
        _SFD_CV_INIT_EML_IF(0,1,1,623,646,-1,670);
        _SFD_CV_INIT_EML_IF(0,1,2,671,694,-1,718);
        _SFD_CV_INIT_EML_IF(0,1,3,719,742,-1,766);
        _SFD_CV_INIT_EML_IF(0,1,4,767,789,-1,812);
        _SFD_CV_INIT_EML_IF(0,1,5,813,835,-1,858);
        _SFD_CV_INIT_EML_IF(0,1,6,859,881,-1,904);
        _SFD_CV_INIT_EML_IF(0,1,7,905,927,-1,950);

        {
          static int caseStart[] = { 1786, 978, 1091, 1205, 1322, 1443, 1564,
            1673 };

          static int caseExprEnd[] = { 1795, 984, 1097, 1211, 1328, 1449, 1570,
            1679 };

          _SFD_CV_INIT_EML_SWITCH(0,1,0,952,974,1864,8,&(caseStart[0]),
            &(caseExprEnd[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)
            c8_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)c8_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)
            c8_sf_marshallIn);
        }

        {
          real_T (*c8_v_body)[3];
          real_T (*c8_sigma_long)[4];
          real_T (*c8_sigma_lat)[4];
          real_T (*c8_sigma_res)[4];
          real_T (*c8_my_long)[4];
          real_T (*c8_my_lat)[4];
          c8_my_lat = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
          c8_my_long = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
          c8_sigma_res = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
          c8_sigma_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
          c8_sigma_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S,
            1);
          c8_v_body = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c8_v_body);
          _SFD_SET_DATA_VALUE_PTR(1U, *c8_sigma_long);
          _SFD_SET_DATA_VALUE_PTR(2U, *c8_sigma_lat);
          _SFD_SET_DATA_VALUE_PTR(3U, *c8_sigma_res);
          _SFD_SET_DATA_VALUE_PTR(4U, *c8_my_long);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c8_road_condition);
          _SFD_SET_DATA_VALUE_PTR(6U, *c8_my_lat);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c8_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc8_ref_genInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c8_ref_gen(void *chartInstanceVar)
{
  enable_c8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c8_ref_gen(void *chartInstanceVar)
{
  disable_c8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c8_ref_gen(void *chartInstanceVar)
{
  sf_c8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c8_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c8_ref_gen((SFc8_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c8_ref_gen(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c8_ref_gen((SFc8_ref_genInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c8_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c8_ref_gen(S);
}

static void sf_opaque_set_sim_state_c8_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c8_ref_gen(S, st);
}

static void sf_opaque_terminate_c8_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc8_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc8_ref_gen((SFc8_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c8_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c8_ref_gen((SFc8_ref_genInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c8_ref_gen(SimStruct *S)
{
  /* Actual parameters from chart:
     road_condition
   */
  const char_T *rtParamNames[] = { "p1" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for road_condition*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,8);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,8,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,8,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,8,4);
      sf_mark_chart_reusable_outputs(S,infoStruct,8,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,8);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2899445779U));
  ssSetChecksum1(S,(4201717919U));
  ssSetChecksum2(S,(602775221U));
  ssSetChecksum3(S,(3840416749U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c8_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c8_ref_gen(SimStruct *S)
{
  SFc8_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc8_ref_genInstanceStruct *)malloc(sizeof
    (SFc8_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc8_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c8_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c8_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c8_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c8_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c8_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c8_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c8_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c8_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c8_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c8_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c8_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c8_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c8_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c8_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c8_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c8_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
