function Fz_wheel = vertical_wheel_forces(l_front, l_rear, m_car, l_car)

% chassis acceleration
g = -9.81;

% normal force acting on wheels
Fz_fl = -m_car*(l_rear*g/l_car)*(0.5);
Fz_fr = -m_car*(l_rear*g/l_car)*(0.5);
Fz_rl = -m_car*(l_front*g/l_car)*(0.5);
Fz_rr = -m_car*(l_front*g/l_car)*(0.5);

Fz_wheel = [Fz_fl Fz_fr Fz_rl Fz_rr]';