function F_air = aerodynamic_drag(v_body, C_air, rho_air, A_front, A_side)
% finds the aerodynamic drag

u = v_body(1);
v = v_body(2);

% aerodynamic drag
F_air   = [0.5*C_air*A_front*rho_air*u^2*sign(u);
           0.5*C_air*A_side*rho_air*v^2*sign(v);
           0];