%steady_state_values.mat: undesired poles removed
%all_steady_state_values.mat: has all the poles
remove = 0; % keep(0) or remove(1) undesired values
if remove == 1
    load('steady_state_values')
else
    load('all_steady_state_values')
end

n = 30; % number of sideslip angles
m = 10; % number of speeds

% initalisation of variables used for plotting
plotdelta = zeros(n,m);
plotX_Rinput = zeros(n,m);
plotbeta = zeros(n,m);
plotV0 = zeros(n,m);
plotpsidot = zeros(n,m);
plotdeltafail = zeros(n,m);
plotX_Rinputfail = zeros(n,m);
plotbetafail = zeros(n,m);
plotV0fail = zeros(n,m);
plotpsidotfail = zeros(n,m);
u_ainput = zeros(n,m);
u_ainputfail = zeros(n,m);

plotdeltaMatrix = zeros(n,m);
plotX_RinputMatrix = zeros(n,m);
plotbetaMatrix = zeros(n,m);
plotV0Matrix = zeros(n,m);
plotpsidotMatrix = zeros(n,m);
plotdeltafailMatrix = zeros(n,m);
plotX_RinputfailMatrix = zeros(n,m);
plotbetafailMatrix = zeros(n,m);
plotV0failMatrix = zeros(n,m);
plotpsidotfailMatrix = zeros(n,m);
u_ainputMatrix = zeros(n,m);
u_ainputfailMatrix = zeros(n,m);

% counters used for keeping track of the indices of the feasible steady
% state values
p1 = 0;
p2 = 0;
p3 = 0;
p4 = 0;
p5 = 0;
p6 = 0;
p7 = 0;
p8 = 0;
p9 = 0;
p10 = 0;

% counters used for keeping track of the indices of the unreachable steady
% state values
f1 = 0;
f2 = 0;
f3 = 0;
f4 = 0;
f5 = 0;
f6 = 0;
f7 = 0;
f8 = 0;
f9 = 0;
f10 = 0;

% sorts the values needed for plotting
for i = 1:n
    for j = 1:m
        if passedss(i,j) == 1
                if j == 1 && i > 5*remove
                    if p1 == 0
                        p1 = i;
                    else
                        p1 = [p1;i];
                    end
                elseif j == 2 && i > 6*remove
                    if p2 == 0
                        p2 = i;
                    else
                        p2 = [p2;i];
                    end
                elseif j == 3 && i > 3*remove
                    if p3 == 0
                        p3 = i;
                    else
                        p3 = [p3;i];
                    end
                elseif j == 4 && i > 1*remove
                    if p4 == 0
                        p4 = i;
                    else
                        p4 = [p4;i];
                    end
                elseif j == 5
                    if p5 == 0
                        p5 = i;
                    else
                        p5 = [p5;i];
                    end
                elseif j == 6
                    if p6 == 0
                        p6 = i;
                    else
                        p6 = [p6;i];
                    end
                elseif j == 7
                    if p7 == 0
                        p7 = i;
                    else
                        p7 = [p7;i];
                    end
                elseif j == 8
                    if p8 == 0
                        p8 = i;
                    else
                        p8 = [p8;i];
                    end
                elseif j == 9
                    if p9 == 0
                        p9 = i;
                    else
                        p9 = [p9;i];
                    end
                else
                    if p10 == 0
                        p10 = i;
                    else
                        p10 = [p10;i];
                    end
                end
                plotdeltaMatrix(i,j) = deltass(i,j)*180/pi;
                plotX_RinputMatrix(i,j) = X_Rinputss(i,j);
                plotpsidotMatrix(i,j) = psi_dotss(i,j)*180/pi;
                u_ainputMatrix(i,j) = u_a0ss(i,j);
                plotbetaMatrix(i,j) = -i;
                plotV0Matrix(i,j) = j;
            if plotdelta == 0
                plotdelta = deltass(i,j)*180/pi;
                plotX_Rinput = X_Rinputss(i,j);
                plotpsidot = psi_dotss(i,j)*180/pi;
                u_ainput = u_a0ss(i,j);
                plotbeta = -i;
                plotV0 = j;
            else
                plotdelta = [plotdelta;deltass(i,j)*180/pi];
                plotX_Rinput = [plotX_Rinput;X_Rinputss(i,j)];
                plotbeta = [plotbeta;-i];
                plotV0 = [plotV0;j];
                plotpsidot = [plotpsidot;psi_dotss(i,j)*180/pi];
                u_ainput = [u_ainput; u_a0ss(i,j)];
            end
        else
                if j == 1 && i > 5*remove
                    if f1 == 0
                        f1 = i;
                    else
                        f1 = [f1;i];
                    end
                elseif j == 2 && i > 6*remove
                    if f2 == 0
                        f2 = i;
                    else
                        f2 = [f2;i];
                    end
                elseif j == 3 && i > 3*remove
                    if f3 == 0
                        f3 = i;
                    else
                        f3 = [f3;i];
                    end
                elseif j == 4 && i > 1*remove
                    if f4 == 0
                        f4 = i;
                    else
                        f4 = [f4;i];
                    end
                elseif j == 5
                    if f5 == 0
                        f5 = i;
                    else
                        f5 = [f5;i];
                    end
                elseif j == 6
                    if f6 == 0
                        f6 = i;
                    else
                        f6 = [f6;i];
                    end
                elseif j == 7
                    if f7 == 0
                        f7 = i;
                    else
                        f7 = [f7;i];
                    end
                elseif j == 8
                    if f8 == 0
                        f8 = i;
                    else
                        f8 = [f8;i];
                    end
                elseif j == 9
                    if f9 == 0
                        f9 = i;
                    else
                        f9 = [f9;i];
                    end
                else
                    if f10 == 0
                        f10 = i;
                    else
                        f10 = [f10;i];
                    end
                end
                plotdeltafailMatrix(i,j) = deltass(i,j)*180/pi;
                plotX_RinputfailMatrix(i,j) = X_Rinputss(i,j);
                plotpsidotfailMatrix(i,j) = psi_dotss(i,j)*180/pi;
                u_ainputfailMatrix(i,j) =  u_a0ss(i,j);
                plotbetafailMatrix(i,j) = -i;
                plotV0failMatrix(i,j) = j;
             if plotdeltafail(i,1) == 0
                plotdeltafail = deltass(i,j)*180/pi;
                plotX_Rinputfail = X_Rinputss(i,j);
                plotpsidotfail = psi_dotss(i,j)*180/pi;
                u_ainputfail =  u_a0ss(i,j);
                plotbetafail = -i;
                plotV0fail = j;
            else
                plotdeltafail = [plotdeltafail;deltass(i,j)*180/pi];
                plotX_Rinputfail = [plotX_Rinputfail;X_Rinputss(i,j)];
                plotbetafail = [plotbetafail;-i];
                plotV0fail = [plotV0fail;j];
                plotpsidotfail = [plotpsidotfail;psi_dotss(i,j)*180/pi];
                u_ainputfail = [u_ainputfail;u_a0ss(i,j)];
            end
        end
    end
end

%% beta vs steering

colormap('jet(10)')
map = colormap;
map(1,:) = [0 0 0];
map(3,:) = [1 0 1];

figure(3302)
set(gcf,'DefaultAxesColorOrder',map);
if remove == 0
    plot(plotdeltafailMatrix(f1,1),plotbetafailMatrix(f1,1),'-*',...
    plotdeltafailMatrix(f2,2),plotbetafailMatrix(f2,2),'-*',...
    plotdeltafailMatrix(f3,3),plotbetafailMatrix(f3,3),'-*',...
    plotdeltafailMatrix(f4,4),plotbetafailMatrix(f4,4),'-*',...
    plotdeltafailMatrix(f5,5),plotbetafailMatrix(f5,5),'-*',...
    plotdeltafailMatrix(f6,6),plotbetafailMatrix(f6,6),'-*',...
    plotdeltafailMatrix(f7,7),plotbetafailMatrix(f7,7),'-*',...
    plotdeltafailMatrix(f8,8),plotbetafailMatrix(f8,8),'-*',...
    plotdeltafailMatrix(f9,9),plotbetafailMatrix(f9,9),'-*',...
    plotdeltafailMatrix(f10,10),plotbetafailMatrix(f10,10),'-*')
end
hold on
grid on
    plot(plotdeltaMatrix(p1,1),plotbetaMatrix(p1,1),'-o',...
    plotdeltaMatrix(p2,2),plotbetaMatrix(p2,2),'-o',...
    plotdeltaMatrix(p3,3),plotbetaMatrix(p3,3),'-o',...
    plotdeltaMatrix(p4,4),plotbetaMatrix(p4,4),'-o',...
    plotdeltaMatrix(p5,5),plotbetaMatrix(p5,5),'-o',...
    plotdeltaMatrix(p6,6),plotbetaMatrix(p6,6),'-o',...
    plotdeltaMatrix(p7,7),plotbetaMatrix(p7,7),'-o',...
    plotdeltaMatrix(p8,8),plotbetaMatrix(p8,8),'-o',...
    plotdeltaMatrix(p9,9),plotbetaMatrix(p9,9),'-o')
if remove == 0
h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','$V_{T0}$ = 10','location','best');
else
    h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','location','best');
end
set(h,'interpreter','latex')
if remove == 1
    title('Feasible steady state sideslip angle vs steering angle with outliers removed','interpreter','latex')
else
    title('Steady state sideslip angle vs steering angle','interpreter','latex')
end

xlabel('Steering angle [deg]','interpreter','latex')
ylabel('Sideslip angle [deg]','interpreter','latex')

%% beta vs thrust

colormap('jet(10)')
map = colormap;
map(1,:) = [0 0 0];
map(3,:) = [1 0 1];

figure(3303)
set(gcf,'DefaultAxesColorOrder',map);
if remove == 0
    plot(plotX_RinputfailMatrix(f1,1),plotbetafailMatrix(f1,1),'-*',...
    plotX_RinputfailMatrix(f2,2),plotbetafailMatrix(f2,2),'-*',...
    plotX_RinputfailMatrix(f3,3),plotbetafailMatrix(f3,3),'-*',...
    plotX_RinputfailMatrix(f4,4),plotbetafailMatrix(f4,4),'-*',...
    plotX_RinputfailMatrix(f5,5),plotbetafailMatrix(f5,5),'-*',...
    plotX_RinputfailMatrix(f6,6),plotbetafailMatrix(f6,6),'-*',...
    plotX_RinputfailMatrix(f7,7),plotbetafailMatrix(f7,7),'-*',...
    plotX_RinputfailMatrix(f8,8),plotbetafailMatrix(f8,8),'-*',...
    plotX_RinputfailMatrix(f9,9),plotbetafailMatrix(f9,9),'-*',...
    plotX_RinputfailMatrix(f10,10),plotbetafailMatrix(f10,10),'-*')
end
hold on
grid on
    plot(plotX_RinputMatrix(p1,1),plotbetaMatrix(p1,1),'-o',...
    plotX_RinputMatrix(p2,2),plotbetaMatrix(p2,2),'-o',...
    plotX_RinputMatrix(p3,3),plotbetaMatrix(p3,3),'-o',...
    plotX_RinputMatrix(p4,4),plotbetaMatrix(p4,4),'-o',...
    plotX_RinputMatrix(p5,5),plotbetaMatrix(p5,5),'-o',...
    plotX_RinputMatrix(p6,6),plotbetaMatrix(p6,6),'-o',...
    plotX_RinputMatrix(p7,7),plotbetaMatrix(p7,7),'-o',...
    plotX_RinputMatrix(p8,8),plotbetaMatrix(p8,8),'-o',...
    plotX_RinputMatrix(p9,9),plotbetaMatrix(p9,9),'-o')
if remove == 0
h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','$V_{T0}$ = 10','location','best');
else
    h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','location','best');
end
set(h,'interpreter','latex')
if remove == 1
 title('Feasible steady state sideslip angle vs thrust with outliers removed','interpreter','latex') 
else
title('Steady state sideslip angle vs thrust','interpreter','latex')
end
xlabel('Thrust','interpreter','latex')
ylabel('Sideslip angle [deg]','interpreter','latex')

%% yaw rate vs steering

colormap('jet(10)')
map = colormap;
map(1,:) = [0 0 0];
map(3,:) = [1 0 1];

figure(3306)
set(gcf,'DefaultAxesColorOrder',map);
set(gcf,'renderer','painters')
if remove == 0
    plot(plotdeltafailMatrix(f1,1),plotpsidotfailMatrix(f1,1),'-*',...
    plotdeltafailMatrix(f2,2),plotpsidotfailMatrix(f2,2),'-*',...
    plotdeltafailMatrix(f3,3),plotpsidotfailMatrix(f3,3),'-*',...
    plotdeltafailMatrix(f4,4),plotpsidotfailMatrix(f4,4),'-*',...
    plotdeltafailMatrix(f5,5),plotpsidotfailMatrix(f5,5),'-*',...
    plotdeltafailMatrix(f6,6),plotpsidotfailMatrix(f6,6),'-*',...
    plotdeltafailMatrix(f7,7),plotpsidotfailMatrix(f7,7),'-*',...
    plotdeltafailMatrix(f8,8),plotpsidotfailMatrix(f8,8),'-*',...
    plotdeltafailMatrix(f9,9),plotpsidotfailMatrix(f9,9),'-*',...
    plotdeltafailMatrix(f10,10),plotpsidotfailMatrix(f10,10),'-*')
end
hold on
grid on
    plot(plotdeltaMatrix(p1,1),plotpsidotMatrix(p1,1),'-o',...
    plotdeltaMatrix(p2,2),plotpsidotMatrix(p2,2),'-o',...
    plotdeltaMatrix(p3,3),plotpsidotMatrix(p3,3),'-o',...
    plotdeltaMatrix(p4,4),plotpsidotMatrix(p4,4),'-o',...
    plotdeltaMatrix(p5,5),plotpsidotMatrix(p5,5),'-o',...
    plotdeltaMatrix(p6,6),plotpsidotMatrix(p6,6),'-o',...
    plotdeltaMatrix(p7,7),plotpsidotMatrix(p7,7),'-o',...
    plotdeltaMatrix(p8,8),plotpsidotMatrix(p8,8),'-o',...
    plotdeltaMatrix(p9,9),plotpsidotMatrix(p9,9),'-o')
if remove == 0
h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','$V_{T0}$ = 10','location','best');
else
    h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','location','best');
end
set(h,'interpreter','latex')
if remove == 1
 title('Feasible steady state yaw rate vs steering angle with outliers removed','interpreter','latex')
else
title('Steady state yaw rate vs steering angle','interpreter','latex')
end
xlabel('Steering angle [deg]','interpreter','latex')
ylabel('Yaw rate [deg/s]','interpreter','latex')

%% yawrate vs thrust

colormap('jet(10)')
map = colormap;
map(1,:) = [0 0 0];
map(3,:) = [1 0 1];

figure(3305)
set(gcf,'DefaultAxesColorOrder',map);
if remove == 0
    plot(plotX_RinputfailMatrix(f1,1),plotpsidotfailMatrix(f1,1),'-*',...
    plotX_RinputfailMatrix(f2,2),plotpsidotfailMatrix(f2,2),'-*',...
    plotX_RinputfailMatrix(f3,3),plotpsidotfailMatrix(f3,3),'-*',...
    plotX_RinputfailMatrix(f4,4),plotpsidotfailMatrix(f4,4),'-*',...
    plotX_RinputfailMatrix(f5,5),plotpsidotfailMatrix(f5,5),'-*',...
    plotX_RinputfailMatrix(f6,6),plotpsidotfailMatrix(f6,6),'-*',...
    plotX_RinputfailMatrix(f7,7),plotpsidotfailMatrix(f7,7),'-*',...
    plotX_RinputfailMatrix(f8,8),plotpsidotfailMatrix(f8,8),'-*',...
    plotX_RinputfailMatrix(f9,9),plotpsidotfailMatrix(f9,9),'-*',...
    plotX_RinputfailMatrix(f10,10),plotpsidotfailMatrix(f10,10),'-*')
end
hold on
grid on
    plot(plotX_RinputMatrix(p1,1),plotpsidotMatrix(p1,1),'-o',...
    plotX_RinputMatrix(p2,2),plotpsidotMatrix(p2,2),'-o',...
    plotX_RinputMatrix(p3,3),plotpsidotMatrix(p3,3),'-o',...
    plotX_RinputMatrix(p4,4),plotpsidotMatrix(p4,4),'-o',...
    plotX_RinputMatrix(p5,5),plotpsidotMatrix(p5,5),'-o',...
    plotX_RinputMatrix(p6,6),plotpsidotMatrix(p6,6),'-o',...
    plotX_RinputMatrix(p7,7),plotpsidotMatrix(p7,7),'-o',...
    plotX_RinputMatrix(p8,8),plotpsidotMatrix(p8,8),'-o',...
    plotX_RinputMatrix(p9,9),plotpsidotMatrix(p9,9),'-o')
if remove == 0
h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','$V_{T0}$ = 10','location','best');
else
    h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','location','best');
end
set(h,'interpreter','latex')
if remove == 1
title('Feasible steady state yaw rate vs thrust with outliers removed','interpreter','latex')
else
title('Steady state yaw rate vs thrust','interpreter','latex')
end
xlabel('Thrust','interpreter','latex')
ylabel('Yaw rate [deg/s]','interpreter','latex')

%% pole movements
load('steady_state_values')
run_linearisation

% used for storing eigenvalues
eigvect1 = 0;
eigvect2 = 0;
eigvect3 = 0;
eigvect4 = 0;
eigvect5 = 0;
eigvect6 = 0;
eigvect7 = 0;
eigvect8 = 0;
eigvect9 = 0;
eigvect10 = 0;

% extract eigenvalues
for i = 1:30
    for j = 1:10
        if eigMatrix(:,j,i) ~= zeros(3,1)
            if j == 1
               if eigvect1 == 0
                   eigvect1 = eigMatrix(:,j,i);
               else
                   eigvect1 = [eigvect1 eigMatrix(:,j,i)];
               end
            elseif j == 2
               if eigvect2 == 0
                   eigvect2 = eigMatrix(:,j,i);
               else
                   eigvect2 = [eigvect2 eigMatrix(:,j,i)];
               end
            elseif j == 3
               if eigvect3 == 0
                   eigvect3 = eigMatrix(:,j,i);
               else
                   eigvect3 = [eigvect3 eigMatrix(:,j,i)];
               end
            elseif j == 4
               if eigvect4 == 0
                   eigvect4 = eigMatrix(:,j,i);
               else
                   eigvect4 = [eigvect4 eigMatrix(:,j,i)];
               end
            elseif j == 5
               if eigvect5 == 0
                   eigvect5 = eigMatrix(:,j,i);
               else
                   eigvect5 = [eigvect5 eigMatrix(:,j,i)];
               end
            elseif j == 6
               if eigvect6 == 0
                   eigvect6 = eigMatrix(:,j,i);
               else
                   eigvect6 = [eigvect6 eigMatrix(:,j,i)];
               end
            elseif j == 7
               if eigvect7 == 0
                   eigvect7 = eigMatrix(:,j,i);
               else
                   eigvect7 = [eigvect7 eigMatrix(:,j,i)];
               end
            elseif j == 8
               if eigvect8 == 0
                   eigvect8 = eigMatrix(:,j,i);
               else
                   eigvect8 = [eigvect8 eigMatrix(:,j,i)];
               end
            elseif j == 9
               if eigvect9 == 0
                   eigvect9 = eigMatrix(:,j,i);
               else
                   eigvect9 = [eigvect9 eigMatrix(:,j,i)];
               end
            elseif j == 10
               if eigvect10 == 0
                   eigvect10 = eigMatrix(:,j,i);
               else
                   eigvect10 = [eigvect10 eigMatrix(:,j,i)];
               end
            end
        end
    end
end

% find the real and imaginary values for the eigenvalues
Re_eigvect1 = real(eigvect1);
Im_eigvect1 = imag(eigvect1);
Re_eigvect2 = real(eigvect2);
Im_eigvect2 = imag(eigvect2);
Re_eigvect3 = real(eigvect3);
Im_eigvect3 = imag(eigvect3);
Re_eigvect4 = real(eigvect4);
Im_eigvect4 = imag(eigvect4);
Re_eigvect5 = real(eigvect5);
Im_eigvect5 = imag(eigvect5);
Re_eigvect6 = real(eigvect6);
Im_eigvect6 = imag(eigvect6);
Re_eigvect7 = real(eigvect7);
Im_eigvect7 = imag(eigvect7);
Re_eigvect8 = real(eigvect8);
Im_eigvect8 = imag(eigvect8);
Re_eigvect9 = real(eigvect9);
Im_eigvect9 = imag(eigvect9);
Re_eigvect10 = real(eigvect10);
Im_eigvect10 = imag(eigvect10);

%% plot poles
colormap('jet(10)')
map = colormap;
map(1,:) = [0 0 0];
map(3,:) = [1 0 1];
map = map(1:9,:);

figure(1401)
set(gcf,'DefaultAxesColorOrder',map);
plot(Re_eigvect1(1,:),Im_eigvect1(1,:),'-x',Re_eigvect2(1,:),Im_eigvect2(1,:),'-x',...
    Re_eigvect3(1,:),Im_eigvect3(1,:),'-x',Re_eigvect4(1,:),Im_eigvect4(1,:),'-x',...
    Re_eigvect5(1,:),Im_eigvect5(1,:),'-x',Re_eigvect6(1,:),Im_eigvect6(1,:),'-x',...
    Re_eigvect7(1,:),Im_eigvect7(1,:),'-x',Re_eigvect8(1,:),Im_eigvect8(1,:),'-x',...
    Re_eigvect9(1,:),Im_eigvect9(1,:),'-x',...
    Re_eigvect1(2,:),Im_eigvect1(2,:),'-s',Re_eigvect2(2,:),Im_eigvect2(2,:),'-s',...
    Re_eigvect3(2,:),Im_eigvect3(2,:),'-s',Re_eigvect4(2,:),Im_eigvect4(2,:),'-s',...
    Re_eigvect5(2,:),Im_eigvect5(2,:),'-s',Re_eigvect6(2,:),Im_eigvect6(2,:),'-s',...
    Re_eigvect7(2,:),Im_eigvect7(2,:),'-s',Re_eigvect8(2,:),Im_eigvect8(2,:),'-s',...
    Re_eigvect9(2,:),Im_eigvect9(2,:),'-s',...
    Re_eigvect1(3,:),Im_eigvect1(3,:),'-p',Re_eigvect2(3,:),Im_eigvect2(3,:),'-p',...
    Re_eigvect3(3,:),Im_eigvect3(3,:),'-p',Re_eigvect4(3,:),Im_eigvect4(3,:),'-p',...
    Re_eigvect5(3,:),Im_eigvect5(3,:),'-p',Re_eigvect6(3,:),Im_eigvect6(3,:),'-p',...
    Re_eigvect7(3,:),Im_eigvect7(3,:),'-p',Re_eigvect8(3,:),Im_eigvect8(3,:),'-p',...
    Re_eigvect9(3,:),Im_eigvect9(3,:),'-p','linewidth',0.5)
h = legend('$V_{T0}$ = 1','$V_{T0}$ = 2','$V_{T0}$ = 3','$V_{T0}$ = 4','$V_{T0}$ = 5',...
    '$V_{T0}$ = 6','$V_{T0}$ = 7', '$V_{T0}$ = 8','$V_{T0}$ = 9','location','best');
set(h,'interpreter','latex')
hold on
grid on
title('Poles for the linearised systems','interpreter','latex')
xlabel('Real value','interpreter','latex')
ylabel('Imaginary value','interpreter','latex')
