/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c13_carsim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c13_debug_family_names[7] = { "nargin", "nargout", "wp",
  "next", "wpout", "i", "last" };

/* Function Declarations */
static void initialize_c13_carsim(SFc13_carsimInstanceStruct *chartInstance);
static void initialize_params_c13_carsim(SFc13_carsimInstanceStruct
  *chartInstance);
static void enable_c13_carsim(SFc13_carsimInstanceStruct *chartInstance);
static void disable_c13_carsim(SFc13_carsimInstanceStruct *chartInstance);
static void c13_update_debugger_state_c13_carsim(SFc13_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c13_carsim(SFc13_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c13_carsim(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_st);
static void finalize_c13_carsim(SFc13_carsimInstanceStruct *chartInstance);
static void sf_c13_carsim(SFc13_carsimInstanceStruct *chartInstance);
static void initSimStructsc13_carsim(SFc13_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c13_machineNumber, uint32_T
  c13_chartNumber);
static const mxArray *c13_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static real_T c13_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_b_last, const char_T *c13_identifier);
static real_T c13_b_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void c13_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static const mxArray *c13_b_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static real_T c13_c_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_b_i, const char_T *c13_identifier);
static real_T c13_d_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void c13_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static const mxArray *c13_c_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static void c13_e_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_wpout, const char_T *c13_identifier, real_T c13_y[8]);
static void c13_f_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId, real_T c13_y[8]);
static void c13_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static const mxArray *c13_d_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static const mxArray *c13_e_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static real_T c13_g_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void c13_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static const mxArray *c13_f_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static int32_T c13_h_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void c13_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static uint8_T c13_i_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_b_is_active_c13_carsim, const char_T *c13_identifier);
static uint8_T c13_j_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void init_dsm_address_info(SFc13_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c13_carsim(SFc13_carsimInstanceStruct *chartInstance)
{
  chartInstance->c13_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c13_i_not_empty = FALSE;
  chartInstance->c13_last_not_empty = FALSE;
  chartInstance->c13_is_active_c13_carsim = 0U;
}

static void initialize_params_c13_carsim(SFc13_carsimInstanceStruct
  *chartInstance)
{
}

static void enable_c13_carsim(SFc13_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c13_carsim(SFc13_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c13_update_debugger_state_c13_carsim(SFc13_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c13_carsim(SFc13_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c13_st;
  const mxArray *c13_y = NULL;
  int32_T c13_i0;
  real_T c13_u[8];
  const mxArray *c13_b_y = NULL;
  real_T c13_hoistedGlobal;
  real_T c13_b_u;
  const mxArray *c13_c_y = NULL;
  real_T c13_b_hoistedGlobal;
  real_T c13_c_u;
  const mxArray *c13_d_y = NULL;
  uint8_T c13_c_hoistedGlobal;
  uint8_T c13_d_u;
  const mxArray *c13_e_y = NULL;
  real_T (*c13_wpout)[8];
  c13_wpout = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 1);
  c13_st = NULL;
  c13_st = NULL;
  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_createcellarray(4), FALSE);
  for (c13_i0 = 0; c13_i0 < 8; c13_i0++) {
    c13_u[c13_i0] = (*c13_wpout)[c13_i0];
  }

  c13_b_y = NULL;
  sf_mex_assign(&c13_b_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 2, 1, 8),
                FALSE);
  sf_mex_setcell(c13_y, 0, c13_b_y);
  c13_hoistedGlobal = chartInstance->c13_i;
  c13_b_u = c13_hoistedGlobal;
  c13_c_y = NULL;
  if (!chartInstance->c13_i_not_empty) {
    sf_mex_assign(&c13_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c13_c_y, sf_mex_create("y", &c13_b_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c13_y, 1, c13_c_y);
  c13_b_hoistedGlobal = chartInstance->c13_last;
  c13_c_u = c13_b_hoistedGlobal;
  c13_d_y = NULL;
  if (!chartInstance->c13_last_not_empty) {
    sf_mex_assign(&c13_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c13_d_y, sf_mex_create("y", &c13_c_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c13_y, 2, c13_d_y);
  c13_c_hoistedGlobal = chartInstance->c13_is_active_c13_carsim;
  c13_d_u = c13_c_hoistedGlobal;
  c13_e_y = NULL;
  sf_mex_assign(&c13_e_y, sf_mex_create("y", &c13_d_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c13_y, 3, c13_e_y);
  sf_mex_assign(&c13_st, c13_y, FALSE);
  return c13_st;
}

static void set_sim_state_c13_carsim(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_st)
{
  const mxArray *c13_u;
  real_T c13_dv0[8];
  int32_T c13_i1;
  real_T (*c13_wpout)[8];
  c13_wpout = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c13_doneDoubleBufferReInit = TRUE;
  c13_u = sf_mex_dup(c13_st);
  c13_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c13_u, 0)),
    "wpout", c13_dv0);
  for (c13_i1 = 0; c13_i1 < 8; c13_i1++) {
    (*c13_wpout)[c13_i1] = c13_dv0[c13_i1];
  }

  chartInstance->c13_i = c13_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c13_u, 1)), "i");
  chartInstance->c13_last = c13_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c13_u, 2)), "last");
  chartInstance->c13_is_active_c13_carsim = c13_i_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c13_u, 3)), "is_active_c13_carsim");
  sf_mex_destroy(&c13_u);
  c13_update_debugger_state_c13_carsim(chartInstance);
  sf_mex_destroy(&c13_st);
}

static void finalize_c13_carsim(SFc13_carsimInstanceStruct *chartInstance)
{
}

static void sf_c13_carsim(SFc13_carsimInstanceStruct *chartInstance)
{
  int32_T c13_i2;
  int32_T c13_i3;
  real_T c13_hoistedGlobal;
  int32_T c13_i4;
  real_T c13_wp[20];
  real_T c13_next;
  uint32_T c13_debug_family_var_map[7];
  real_T c13_nargin = 2.0;
  real_T c13_nargout = 1.0;
  real_T c13_wpout[8];
  int32_T c13_i5;
  real_T *c13_b_next;
  real_T (*c13_b_wpout)[8];
  real_T (*c13_b_wp)[20];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  c13_b_next = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c13_b_wpout = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 1);
  c13_b_wp = (real_T (*)[20])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 7U, chartInstance->c13_sfEvent);
  for (c13_i2 = 0; c13_i2 < 20; c13_i2++) {
    _SFD_DATA_RANGE_CHECK((*c13_b_wp)[c13_i2], 0U);
  }

  for (c13_i3 = 0; c13_i3 < 8; c13_i3++) {
    _SFD_DATA_RANGE_CHECK((*c13_b_wpout)[c13_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c13_b_next, 2U);
  chartInstance->c13_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 7U, chartInstance->c13_sfEvent);
  c13_hoistedGlobal = *c13_b_next;
  for (c13_i4 = 0; c13_i4 < 20; c13_i4++) {
    c13_wp[c13_i4] = (*c13_b_wp)[c13_i4];
  }

  c13_next = c13_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 7U, 7U, c13_debug_family_names,
    c13_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c13_nargin, 0U, c13_d_sf_marshallOut,
    c13_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c13_nargout, 1U,
    c13_d_sf_marshallOut, c13_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c13_wp, 2U, c13_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c13_next, 3U, c13_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c13_wpout, 4U, c13_c_sf_marshallOut,
    c13_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c13_i, 5U,
    c13_b_sf_marshallOut, c13_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c13_last, 6U,
    c13_sf_marshallOut, c13_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 4);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c13_i_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 5);
    chartInstance->c13_i = 1.0;
    chartInstance->c13_i_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 6);
    chartInstance->c13_last = 0.0;
    chartInstance->c13_last_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 9);
  guard3 = FALSE;
  guard4 = FALSE;
  if (CV_EML_COND(0, 1, 0, c13_next == 1.0)) {
    if (CV_EML_COND(0, 1, 1, chartInstance->c13_i < 12.0)) {
      if (CV_EML_COND(0, 1, 2, chartInstance->c13_last == 0.0)) {
        CV_EML_MCDC(0, 1, 0, TRUE);
        CV_EML_IF(0, 1, 1, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 10);
        chartInstance->c13_i += 4.0;
        _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 11);
        chartInstance->c13_last = 1.0;
      } else {
        guard3 = TRUE;
      }
    } else {
      guard4 = TRUE;
    }
  } else {
    guard4 = TRUE;
  }

  if (guard4 == TRUE) {
    guard3 = TRUE;
  }

  if (guard3 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 15);
  if (CV_EML_IF(0, 1, 2, c13_next == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 16);
    chartInstance->c13_last = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 19);
  c13_wpout[0] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+4", chartInstance->c13_i + 4.0), 1, 20, 1, 0) - 1];
  c13_wpout[1] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+5", chartInstance->c13_i + 5.0), 1, 20, 1, 0) - 1];
  c13_wpout[2] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+6", chartInstance->c13_i + 6.0), 1, 20, 1, 0) - 1];
  c13_wpout[3] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+7", chartInstance->c13_i + 7.0), 1, 20, 1, 0) - 1];
  c13_wpout[4] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i", chartInstance->c13_i), 1, 20, 1, 0) - 1];
  c13_wpout[5] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+1", chartInstance->c13_i + 1.0), 1, 20, 1, 0) - 1];
  c13_wpout[6] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+2", chartInstance->c13_i + 2.0), 1, 20, 1, 0) - 1];
  c13_wpout[7] = c13_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+3", chartInstance->c13_i + 3.0), 1, 20, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 21);
  guard1 = FALSE;
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 3, c13_next == 1.0)) {
    if (CV_EML_COND(0, 1, 4, chartInstance->c13_i > 12.0)) {
      if (CV_EML_COND(0, 1, 5, chartInstance->c13_last == 0.0)) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 3, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 22);
        chartInstance->c13_i = 1.0;
        _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 23);
        chartInstance->c13_last = 1.0;
      } else {
        guard1 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 1, FALSE);
    CV_EML_IF(0, 1, 3, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, -23);
  sf_debug_symbol_scope_pop();
  for (c13_i5 = 0; c13_i5 < 8; c13_i5++) {
    (*c13_b_wpout)[c13_i5] = c13_wpout[c13_i5];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 7U, chartInstance->c13_sfEvent);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc13_carsim(SFc13_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c13_machineNumber, uint32_T
  c13_chartNumber)
{
}

static const mxArray *c13_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  real_T c13_u;
  const mxArray *c13_y = NULL;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_u = *(real_T *)c13_inData;
  c13_y = NULL;
  if (!chartInstance->c13_last_not_empty) {
    sf_mex_assign(&c13_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c13_y, sf_mex_create("y", &c13_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static real_T c13_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_b_last, const char_T *c13_identifier)
{
  real_T c13_y;
  emlrtMsgIdentifier c13_thisId;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_b_last),
    &c13_thisId);
  sf_mex_destroy(&c13_b_last);
  return c13_y;
}

static real_T c13_b_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  real_T c13_y;
  real_T c13_d0;
  if (mxIsEmpty(c13_u)) {
    chartInstance->c13_last_not_empty = FALSE;
  } else {
    chartInstance->c13_last_not_empty = TRUE;
    sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_d0, 1, 0, 0U, 0, 0U, 0);
    c13_y = c13_d0;
  }

  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void c13_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_b_last;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_b_last = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_b_last),
    &c13_thisId);
  sf_mex_destroy(&c13_b_last);
  *(real_T *)c13_outData = c13_y;
  sf_mex_destroy(&c13_mxArrayInData);
}

static const mxArray *c13_b_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  real_T c13_u;
  const mxArray *c13_y = NULL;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_u = *(real_T *)c13_inData;
  c13_y = NULL;
  if (!chartInstance->c13_i_not_empty) {
    sf_mex_assign(&c13_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c13_y, sf_mex_create("y", &c13_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static real_T c13_c_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_b_i, const char_T *c13_identifier)
{
  real_T c13_y;
  emlrtMsgIdentifier c13_thisId;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_b_i), &c13_thisId);
  sf_mex_destroy(&c13_b_i);
  return c13_y;
}

static real_T c13_d_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  real_T c13_y;
  real_T c13_d1;
  if (mxIsEmpty(c13_u)) {
    chartInstance->c13_i_not_empty = FALSE;
  } else {
    chartInstance->c13_i_not_empty = TRUE;
    sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_d1, 1, 0, 0U, 0, 0U, 0);
    c13_y = c13_d1;
  }

  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void c13_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_b_i;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_b_i = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_b_i), &c13_thisId);
  sf_mex_destroy(&c13_b_i);
  *(real_T *)c13_outData = c13_y;
  sf_mex_destroy(&c13_mxArrayInData);
}

static const mxArray *c13_c_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_i6;
  real_T c13_b_inData[8];
  int32_T c13_i7;
  real_T c13_u[8];
  const mxArray *c13_y = NULL;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  for (c13_i6 = 0; c13_i6 < 8; c13_i6++) {
    c13_b_inData[c13_i6] = (*(real_T (*)[8])c13_inData)[c13_i6];
  }

  for (c13_i7 = 0; c13_i7 < 8; c13_i7++) {
    c13_u[c13_i7] = c13_b_inData[c13_i7];
  }

  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 2, 1, 8), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static void c13_e_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_wpout, const char_T *c13_identifier, real_T c13_y[8])
{
  emlrtMsgIdentifier c13_thisId;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_wpout), &c13_thisId,
    c13_y);
  sf_mex_destroy(&c13_wpout);
}

static void c13_f_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId, real_T c13_y[8])
{
  real_T c13_dv1[8];
  int32_T c13_i8;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), c13_dv1, 1, 0, 0U, 1, 0U, 2, 1,
                8);
  for (c13_i8 = 0; c13_i8 < 8; c13_i8++) {
    c13_y[c13_i8] = c13_dv1[c13_i8];
  }

  sf_mex_destroy(&c13_u);
}

static void c13_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_wpout;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y[8];
  int32_T c13_i9;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_wpout = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_wpout), &c13_thisId,
    c13_y);
  sf_mex_destroy(&c13_wpout);
  for (c13_i9 = 0; c13_i9 < 8; c13_i9++) {
    (*(real_T (*)[8])c13_outData)[c13_i9] = c13_y[c13_i9];
  }

  sf_mex_destroy(&c13_mxArrayInData);
}

static const mxArray *c13_d_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  real_T c13_u;
  const mxArray *c13_y = NULL;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_u = *(real_T *)c13_inData;
  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", &c13_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static const mxArray *c13_e_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_i10;
  real_T c13_b_inData[20];
  int32_T c13_i11;
  real_T c13_u[20];
  const mxArray *c13_y = NULL;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  for (c13_i10 = 0; c13_i10 < 20; c13_i10++) {
    c13_b_inData[c13_i10] = (*(real_T (*)[20])c13_inData)[c13_i10];
  }

  for (c13_i11 = 0; c13_i11 < 20; c13_i11++) {
    c13_u[c13_i11] = c13_b_inData[c13_i11];
  }

  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 1, 20), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static real_T c13_g_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  real_T c13_y;
  real_T c13_d2;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_d2, 1, 0, 0U, 0, 0U, 0);
  c13_y = c13_d2;
  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void c13_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_nargout;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_nargout = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_nargout),
    &c13_thisId);
  sf_mex_destroy(&c13_nargout);
  *(real_T *)c13_outData = c13_y;
  sf_mex_destroy(&c13_mxArrayInData);
}

const mxArray *sf_c13_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c13_nameCaptureInfo;
  c13_ResolvedFunctionInfo c13_info[1];
  c13_ResolvedFunctionInfo (*c13_b_info)[1];
  const mxArray *c13_m0 = NULL;
  int32_T c13_i12;
  c13_ResolvedFunctionInfo *c13_r0;
  c13_nameCaptureInfo = NULL;
  c13_nameCaptureInfo = NULL;
  c13_b_info = (c13_ResolvedFunctionInfo (*)[1])c13_info;
  (*c13_b_info)[0].context = "";
  (*c13_b_info)[0].name = "length";
  (*c13_b_info)[0].dominantType = "double";
  (*c13_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  (*c13_b_info)[0].fileTimeLo = 1303146206U;
  (*c13_b_info)[0].fileTimeHi = 0U;
  (*c13_b_info)[0].mFileTimeLo = 0U;
  (*c13_b_info)[0].mFileTimeHi = 0U;
  sf_mex_assign(&c13_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1), FALSE);
  for (c13_i12 = 0; c13_i12 < 1; c13_i12++) {
    c13_r0 = &c13_info[c13_i12];
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", c13_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c13_r0->context)), "context", "nameCaptureInfo",
                    c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", c13_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c13_r0->name)), "name", "nameCaptureInfo",
                    c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo",
      c13_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c13_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", c13_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c13_r0->resolved)), "resolved",
                    "nameCaptureInfo", c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", &c13_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", &c13_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo",
      &c13_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c13_i12);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo",
      &c13_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c13_i12);
  }

  sf_mex_assign(&c13_nameCaptureInfo, c13_m0, FALSE);
  return c13_nameCaptureInfo;
}

static const mxArray *c13_f_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_u;
  const mxArray *c13_y = NULL;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_u = *(int32_T *)c13_inData;
  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", &c13_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static int32_T c13_h_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  int32_T c13_y;
  int32_T c13_i13;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_i13, 1, 6, 0U, 0, 0U, 0);
  c13_y = c13_i13;
  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void c13_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_b_sfEvent;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  int32_T c13_y;
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)chartInstanceVoid;
  c13_b_sfEvent = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_b_sfEvent),
    &c13_thisId);
  sf_mex_destroy(&c13_b_sfEvent);
  *(int32_T *)c13_outData = c13_y;
  sf_mex_destroy(&c13_mxArrayInData);
}

static uint8_T c13_i_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_b_is_active_c13_carsim, const char_T *c13_identifier)
{
  uint8_T c13_y;
  emlrtMsgIdentifier c13_thisId;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c13_b_is_active_c13_carsim), &c13_thisId);
  sf_mex_destroy(&c13_b_is_active_c13_carsim);
  return c13_y;
}

static uint8_T c13_j_emlrt_marshallIn(SFc13_carsimInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  uint8_T c13_y;
  uint8_T c13_u0;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_u0, 1, 3, 0U, 0, 0U, 0);
  c13_y = c13_u0;
  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void init_dsm_address_info(SFc13_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c13_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1001299054U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(43351367U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1416413094U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3126460561U);
}

mxArray *sf_c13_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("y4pNxur08FeOXyROSzw8eD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(20);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(8);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c13_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[5],T\"wpout\",},{M[4],M[0],T\"i\",S'l','i','p'{{M1x2[45 46],M[0],}}},{M[4],M[0],T\"last\",S'l','i','p'{{M1x2[63 67],M[0],}}},{M[8],M[0],T\"is_active_c13_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c13_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc13_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc13_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          13,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"wp");
          _SFD_SET_DATA_PROPS(1,2,0,1,"wpout");
          _SFD_SET_DATA_PROPS(2,1,1,0,"next");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,6,2);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,453);
        _SFD_CV_INIT_EML_IF(0,1,0,73,86,-1,127);
        _SFD_CV_INIT_EML_IF(0,1,1,140,179,-1,225);
        _SFD_CV_INIT_EML_IF(0,1,2,239,251,-1,277);
        _SFD_CV_INIT_EML_IF(0,1,3,365,404,-1,453);

        {
          static int condStart[] = { 143, 154, 172 };

          static int condEnd[] = { 150, 168, 179 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,143,179,3,0,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 368, 379, 397 };

          static int condEnd[] = { 375, 393, 404 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,368,404,3,3,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 20;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c13_e_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 8;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c13_c_sf_marshallOut,(MexInFcnForType)
            c13_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c13_d_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c13_next;
          real_T (*c13_wp)[20];
          real_T (*c13_wpout)[8];
          c13_next = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c13_wpout = (real_T (*)[8])ssGetOutputPortSignal(chartInstance->S, 1);
          c13_wp = (real_T (*)[20])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c13_wp);
          _SFD_SET_DATA_VALUE_PTR(1U, *c13_wpout);
          _SFD_SET_DATA_VALUE_PTR(2U, c13_next);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c13_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc13_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
  initialize_c13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c13_carsim(void *chartInstanceVar)
{
  enable_c13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c13_carsim(void *chartInstanceVar)
{
  disable_c13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c13_carsim(void *chartInstanceVar)
{
  sf_c13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c13_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c13_carsim((SFc13_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c13_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c13_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c13_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c13_carsim((SFc13_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c13_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c13_carsim(S);
}

static void sf_opaque_set_sim_state_c13_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c13_carsim(S, st);
}

static void sf_opaque_terminate_c13_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc13_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc13_carsim((SFc13_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c13_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c13_carsim((SFc13_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c13_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,13);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,13,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,13,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,13,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,13,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,13);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1482078425U));
  ssSetChecksum1(S,(3176425076U));
  ssSetChecksum2(S,(2549443173U));
  ssSetChecksum3(S,(1534574352U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c13_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c13_carsim(SimStruct *S)
{
  SFc13_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc13_carsimInstanceStruct *)malloc(sizeof
    (SFc13_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc13_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c13_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c13_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c13_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c13_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c13_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c13_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c13_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c13_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c13_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c13_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c13_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c13_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c13_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c13_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c13_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c13_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
