/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c21_carsim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c21_debug_family_names[15] = { "v_body", "omega_body", "I_g",
  "M_RB", "C_RB", "D_RB", "g", "nargin", "nargout", "nu_body", "tau", "m_car",
  "I_car", "nu_body_dot", "a_body" };

static const char * c21_b_debug_family_names[4] = { "nargin", "nargout", "r",
  "S" };

/* Function Declarations */
static void initialize_c21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void initialize_params_c21_carsim(SFc21_carsimInstanceStruct
  *chartInstance);
static void enable_c21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void disable_c21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void c21_update_debugger_state_c21_carsim(SFc21_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c21_carsim(SFc21_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c21_carsim(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_st);
static void finalize_c21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void sf_c21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void c21_chartstep_c21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void initSimStructsc21_carsim(SFc21_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c21_machineNumber, uint32_T
  c21_chartNumber);
static const mxArray *c21_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_a_body, const char_T *c21_identifier, real_T c21_y[6]);
static void c21_b_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[6]);
static void c21_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_b_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_c_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[3]);
static void c21_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_c_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static real_T c21_d_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId);
static void c21_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_d_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_e_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[36]);
static void c21_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_e_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_f_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[9]);
static void c21_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_f_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_g_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[3]);
static void c21_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static void c21_info_helper(c21_ResolvedFunctionInfo c21_info[50]);
static void c21_diag(SFc21_carsimInstanceStruct *chartInstance, real_T c21_v[3],
                     real_T c21_d[9]);
static void c21_Smtrx(SFc21_carsimInstanceStruct *chartInstance, real_T c21_r[3],
                      real_T c21_S[9]);
static void c21_eml_scalar_eg(SFc21_carsimInstanceStruct *chartInstance);
static void c21_b_eml_scalar_eg(SFc21_carsimInstanceStruct *chartInstance);
static void c21_mldivide(SFc21_carsimInstanceStruct *chartInstance, real_T
  c21_A[36], real_T c21_B[6], real_T c21_Y[6]);
static void c21_eps(SFc21_carsimInstanceStruct *chartInstance);
static void c21_eml_matlab_zgetrf(SFc21_carsimInstanceStruct *chartInstance,
  real_T c21_A[36], real_T c21_b_A[36], int32_T c21_ipiv[6], int32_T *c21_info);
static int32_T c21_eml_ixamax(SFc21_carsimInstanceStruct *chartInstance, int32_T
  c21_n, real_T c21_x[36], int32_T c21_ix0);
static void c21_eml_warning(SFc21_carsimInstanceStruct *chartInstance);
static void c21_below_threshold(SFc21_carsimInstanceStruct *chartInstance);
static void c21_c_eml_scalar_eg(SFc21_carsimInstanceStruct *chartInstance);
static const mxArray *c21_g_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static int32_T c21_h_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId);
static void c21_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static uint8_T c21_i_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_b_is_active_c21_carsim, const char_T *c21_identifier);
static uint8_T c21_j_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId);
static void c21_b_eml_matlab_zgetrf(SFc21_carsimInstanceStruct *chartInstance,
  real_T c21_A[36], int32_T c21_ipiv[6], int32_T *c21_info);
static void init_dsm_address_info(SFc21_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
  chartInstance->c21_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c21_is_active_c21_carsim = 0U;
}

static void initialize_params_c21_carsim(SFc21_carsimInstanceStruct
  *chartInstance)
{
  real_T c21_d0;
  real_T c21_dv0[3];
  int32_T c21_i0;
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c21_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c21_m_car = c21_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_car' in the parent workspace.\n");
  sf_mex_import_named("I_car", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c21_dv0, 0, 0, 0U, 1, 0U, 2, 1, 3);
  for (c21_i0 = 0; c21_i0 < 3; c21_i0++) {
    chartInstance->c21_I_car[c21_i0] = c21_dv0[c21_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c21_update_debugger_state_c21_carsim(SFc21_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c21_carsim(SFc21_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c21_st;
  const mxArray *c21_y = NULL;
  int32_T c21_i1;
  real_T c21_u[6];
  const mxArray *c21_b_y = NULL;
  int32_T c21_i2;
  real_T c21_b_u[6];
  const mxArray *c21_c_y = NULL;
  uint8_T c21_hoistedGlobal;
  uint8_T c21_c_u;
  const mxArray *c21_d_y = NULL;
  real_T (*c21_nu_body_dot)[6];
  real_T (*c21_a_body)[6];
  c21_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c21_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c21_st = NULL;
  c21_st = NULL;
  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_createcellarray(3), FALSE);
  for (c21_i1 = 0; c21_i1 < 6; c21_i1++) {
    c21_u[c21_i1] = (*c21_a_body)[c21_i1];
  }

  c21_b_y = NULL;
  sf_mex_assign(&c21_b_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c21_y, 0, c21_b_y);
  for (c21_i2 = 0; c21_i2 < 6; c21_i2++) {
    c21_b_u[c21_i2] = (*c21_nu_body_dot)[c21_i2];
  }

  c21_c_y = NULL;
  sf_mex_assign(&c21_c_y, sf_mex_create("y", c21_b_u, 0, 0U, 1U, 0U, 1, 6),
                FALSE);
  sf_mex_setcell(c21_y, 1, c21_c_y);
  c21_hoistedGlobal = chartInstance->c21_is_active_c21_carsim;
  c21_c_u = c21_hoistedGlobal;
  c21_d_y = NULL;
  sf_mex_assign(&c21_d_y, sf_mex_create("y", &c21_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c21_y, 2, c21_d_y);
  sf_mex_assign(&c21_st, c21_y, FALSE);
  return c21_st;
}

static void set_sim_state_c21_carsim(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_st)
{
  const mxArray *c21_u;
  real_T c21_dv1[6];
  int32_T c21_i3;
  real_T c21_dv2[6];
  int32_T c21_i4;
  real_T (*c21_a_body)[6];
  real_T (*c21_nu_body_dot)[6];
  c21_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c21_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c21_doneDoubleBufferReInit = TRUE;
  c21_u = sf_mex_dup(c21_st);
  c21_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c21_u, 0)),
                       "a_body", c21_dv1);
  for (c21_i3 = 0; c21_i3 < 6; c21_i3++) {
    (*c21_a_body)[c21_i3] = c21_dv1[c21_i3];
  }

  c21_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c21_u, 1)),
                       "nu_body_dot", c21_dv2);
  for (c21_i4 = 0; c21_i4 < 6; c21_i4++) {
    (*c21_nu_body_dot)[c21_i4] = c21_dv2[c21_i4];
  }

  chartInstance->c21_is_active_c21_carsim = c21_i_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c21_u, 2)), "is_active_c21_carsim");
  sf_mex_destroy(&c21_u);
  c21_update_debugger_state_c21_carsim(chartInstance);
  sf_mex_destroy(&c21_st);
}

static void finalize_c21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
}

static void sf_c21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
  int32_T c21_i5;
  int32_T c21_i6;
  int32_T c21_i7;
  int32_T c21_i8;
  int32_T c21_i9;
  real_T (*c21_a_body)[6];
  real_T (*c21_nu_body_dot)[6];
  real_T (*c21_tau)[6];
  real_T (*c21_nu_body)[6];
  c21_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c21_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c21_tau = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c21_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 9U, chartInstance->c21_sfEvent);
  for (c21_i5 = 0; c21_i5 < 6; c21_i5++) {
    _SFD_DATA_RANGE_CHECK((*c21_nu_body)[c21_i5], 0U);
  }

  for (c21_i6 = 0; c21_i6 < 6; c21_i6++) {
    _SFD_DATA_RANGE_CHECK((*c21_tau)[c21_i6], 1U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c21_m_car, 2U);
  for (c21_i7 = 0; c21_i7 < 3; c21_i7++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c21_I_car[c21_i7], 3U);
  }

  for (c21_i8 = 0; c21_i8 < 6; c21_i8++) {
    _SFD_DATA_RANGE_CHECK((*c21_nu_body_dot)[c21_i8], 4U);
  }

  for (c21_i9 = 0; c21_i9 < 6; c21_i9++) {
    _SFD_DATA_RANGE_CHECK((*c21_a_body)[c21_i9], 5U);
  }

  chartInstance->c21_sfEvent = CALL_EVENT;
  c21_chartstep_c21_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c21_chartstep_c21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
  real_T c21_hoistedGlobal;
  int32_T c21_i10;
  real_T c21_nu_body[6];
  int32_T c21_i11;
  real_T c21_tau[6];
  real_T c21_b_m_car;
  int32_T c21_i12;
  real_T c21_b_I_car[3];
  uint32_T c21_debug_family_var_map[15];
  real_T c21_v_body[3];
  real_T c21_omega_body[3];
  real_T c21_I_g[9];
  real_T c21_M_RB[36];
  real_T c21_C_RB[36];
  real_T c21_D_RB[36];
  real_T c21_g[6];
  real_T c21_nargin = 4.0;
  real_T c21_nargout = 2.0;
  real_T c21_nu_body_dot[6];
  real_T c21_a_body[6];
  int32_T c21_i13;
  int32_T c21_i14;
  int32_T c21_i15;
  real_T c21_c_I_car[3];
  real_T c21_dv3[9];
  int32_T c21_i16;
  real_T c21_a;
  int32_T c21_i17;
  static real_T c21_b[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0 };

  real_T c21_y[9];
  int32_T c21_i18;
  int32_T c21_i19;
  int32_T c21_i20;
  int32_T c21_i21;
  int32_T c21_i22;
  int32_T c21_i23;
  int32_T c21_i24;
  int32_T c21_i25;
  int32_T c21_i26;
  int32_T c21_i27;
  int32_T c21_i28;
  int32_T c21_i29;
  int32_T c21_i30;
  int32_T c21_i31;
  real_T c21_b_a;
  int32_T c21_i32;
  real_T c21_b_omega_body[3];
  real_T c21_b_b[9];
  int32_T c21_i33;
  int32_T c21_i34;
  int32_T c21_i35;
  real_T c21_c_b[3];
  int32_T c21_i36;
  real_T c21_b_y[3];
  int32_T c21_i37;
  int32_T c21_i38;
  int32_T c21_i39;
  real_T c21_c_y[3];
  int32_T c21_i40;
  int32_T c21_i41;
  int32_T c21_i42;
  int32_T c21_i43;
  int32_T c21_i44;
  int32_T c21_i45;
  int32_T c21_i46;
  int32_T c21_i47;
  int32_T c21_i48;
  int32_T c21_i49;
  int32_T c21_i50;
  int32_T c21_i51;
  int32_T c21_i52;
  int32_T c21_i53;
  int32_T c21_i54;
  real_T c21_c_a;
  real_T c21_d_y;
  real_T c21_dv4[6];
  int32_T c21_i55;
  int32_T c21_i56;
  real_T c21_d_a[36];
  int32_T c21_i57;
  real_T c21_d_b[6];
  int32_T c21_i58;
  real_T c21_e_y[6];
  int32_T c21_i59;
  int32_T c21_i60;
  int32_T c21_i61;
  int32_T c21_i62;
  real_T c21_f_y[6];
  int32_T c21_i63;
  int32_T c21_i64;
  real_T c21_b_M_RB[36];
  int32_T c21_i65;
  real_T c21_b_tau[6];
  real_T c21_dv5[6];
  int32_T c21_i66;
  int32_T c21_i67;
  real_T c21_c_omega_body[3];
  int32_T c21_i68;
  int32_T c21_i69;
  int32_T c21_i70;
  int32_T c21_i71;
  int32_T c21_i72;
  real_T c21_r[3];
  uint32_T c21_b_debug_family_var_map[4];
  real_T c21_b_nargin = 1.0;
  real_T c21_b_nargout = 1.0;
  real_T c21_S[9];
  int32_T c21_i73;
  int32_T c21_i74;
  int32_T c21_i75;
  real_T c21_g_y[3];
  int32_T c21_i76;
  int32_T c21_i77;
  int32_T c21_i78;
  real_T c21_h_y[6];
  int32_T c21_i79;
  int32_T c21_i80;
  int32_T c21_i81;
  int32_T c21_i82;
  int32_T c21_i83;
  real_T (*c21_b_nu_body_dot)[6];
  real_T (*c21_b_a_body)[6];
  real_T (*c21_c_tau)[6];
  real_T (*c21_b_nu_body)[6];
  c21_b_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c21_b_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c21_c_tau = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c21_b_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 9U, chartInstance->c21_sfEvent);
  c21_hoistedGlobal = chartInstance->c21_m_car;
  for (c21_i10 = 0; c21_i10 < 6; c21_i10++) {
    c21_nu_body[c21_i10] = (*c21_b_nu_body)[c21_i10];
  }

  for (c21_i11 = 0; c21_i11 < 6; c21_i11++) {
    c21_tau[c21_i11] = (*c21_c_tau)[c21_i11];
  }

  c21_b_m_car = c21_hoistedGlobal;
  for (c21_i12 = 0; c21_i12 < 3; c21_i12++) {
    c21_b_I_car[c21_i12] = chartInstance->c21_I_car[c21_i12];
  }

  sf_debug_symbol_scope_push_eml(0U, 15U, 15U, c21_debug_family_names,
    c21_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c21_v_body, 0U, c21_f_sf_marshallOut,
    c21_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_omega_body, 1U,
    c21_f_sf_marshallOut, c21_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_I_g, 2U, c21_e_sf_marshallOut,
    c21_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_M_RB, 3U, c21_d_sf_marshallOut,
    c21_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_C_RB, 4U, c21_d_sf_marshallOut,
    c21_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c21_D_RB, 5U, c21_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c21_g, 6U, c21_sf_marshallOut,
    c21_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_nargin, 7U, c21_c_sf_marshallOut,
    c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_nargout, 8U,
    c21_c_sf_marshallOut, c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c21_nu_body, 9U, c21_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c21_tau, 10U, c21_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c21_b_m_car, 11U,
    c21_c_sf_marshallOut, c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_b_I_car, 12U,
    c21_b_sf_marshallOut, c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_nu_body_dot, 13U,
    c21_sf_marshallOut, c21_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_a_body, 14U, c21_sf_marshallOut,
    c21_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 3);
  for (c21_i13 = 0; c21_i13 < 3; c21_i13++) {
    c21_v_body[c21_i13] = c21_nu_body[c21_i13];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 4);
  for (c21_i14 = 0; c21_i14 < 3; c21_i14++) {
    c21_omega_body[c21_i14] = c21_nu_body[c21_i14 + 3];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 7);
  for (c21_i15 = 0; c21_i15 < 3; c21_i15++) {
    c21_c_I_car[c21_i15] = c21_b_I_car[c21_i15];
  }

  c21_diag(chartInstance, c21_c_I_car, c21_dv3);
  for (c21_i16 = 0; c21_i16 < 9; c21_i16++) {
    c21_I_g[c21_i16] = c21_dv3[c21_i16];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 10);
  c21_a = c21_b_m_car;
  for (c21_i17 = 0; c21_i17 < 9; c21_i17++) {
    c21_y[c21_i17] = c21_a * c21_b[c21_i17];
  }

  c21_i18 = 0;
  c21_i19 = 0;
  for (c21_i20 = 0; c21_i20 < 3; c21_i20++) {
    for (c21_i21 = 0; c21_i21 < 3; c21_i21++) {
      c21_M_RB[c21_i21 + c21_i18] = c21_y[c21_i21 + c21_i19];
    }

    c21_i18 += 6;
    c21_i19 += 3;
  }

  c21_i22 = 0;
  for (c21_i23 = 0; c21_i23 < 3; c21_i23++) {
    for (c21_i24 = 0; c21_i24 < 3; c21_i24++) {
      c21_M_RB[(c21_i24 + c21_i22) + 18] = 0.0;
    }

    c21_i22 += 6;
  }

  c21_i25 = 0;
  for (c21_i26 = 0; c21_i26 < 3; c21_i26++) {
    for (c21_i27 = 0; c21_i27 < 3; c21_i27++) {
      c21_M_RB[(c21_i27 + c21_i25) + 3] = 0.0;
    }

    c21_i25 += 6;
  }

  c21_i28 = 0;
  c21_i29 = 0;
  for (c21_i30 = 0; c21_i30 < 3; c21_i30++) {
    for (c21_i31 = 0; c21_i31 < 3; c21_i31++) {
      c21_M_RB[(c21_i31 + c21_i28) + 21] = c21_I_g[c21_i31 + c21_i29];
    }

    c21_i28 += 6;
    c21_i29 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 14);
  c21_b_a = c21_b_m_car;
  for (c21_i32 = 0; c21_i32 < 3; c21_i32++) {
    c21_b_omega_body[c21_i32] = c21_omega_body[c21_i32];
  }

  c21_Smtrx(chartInstance, c21_b_omega_body, c21_b_b);
  for (c21_i33 = 0; c21_i33 < 9; c21_i33++) {
    c21_b_b[c21_i33] *= c21_b_a;
  }

  for (c21_i34 = 0; c21_i34 < 9; c21_i34++) {
    c21_y[c21_i34] = c21_I_g[c21_i34];
  }

  for (c21_i35 = 0; c21_i35 < 3; c21_i35++) {
    c21_c_b[c21_i35] = c21_omega_body[c21_i35];
  }

  c21_eml_scalar_eg(chartInstance);
  c21_eml_scalar_eg(chartInstance);
  for (c21_i36 = 0; c21_i36 < 3; c21_i36++) {
    c21_b_y[c21_i36] = 0.0;
    c21_i37 = 0;
    for (c21_i38 = 0; c21_i38 < 3; c21_i38++) {
      c21_b_y[c21_i36] += c21_y[c21_i37 + c21_i36] * c21_c_b[c21_i38];
      c21_i37 += 3;
    }
  }

  for (c21_i39 = 0; c21_i39 < 3; c21_i39++) {
    c21_c_y[c21_i39] = c21_b_y[c21_i39];
  }

  c21_Smtrx(chartInstance, c21_c_y, c21_y);
  c21_i40 = 0;
  c21_i41 = 0;
  for (c21_i42 = 0; c21_i42 < 3; c21_i42++) {
    for (c21_i43 = 0; c21_i43 < 3; c21_i43++) {
      c21_C_RB[c21_i43 + c21_i40] = c21_b_b[c21_i43 + c21_i41];
    }

    c21_i40 += 6;
    c21_i41 += 3;
  }

  c21_i44 = 0;
  for (c21_i45 = 0; c21_i45 < 3; c21_i45++) {
    for (c21_i46 = 0; c21_i46 < 3; c21_i46++) {
      c21_C_RB[(c21_i46 + c21_i44) + 18] = 0.0;
    }

    c21_i44 += 6;
  }

  c21_i47 = 0;
  for (c21_i48 = 0; c21_i48 < 3; c21_i48++) {
    for (c21_i49 = 0; c21_i49 < 3; c21_i49++) {
      c21_C_RB[(c21_i49 + c21_i47) + 3] = 0.0;
    }

    c21_i47 += 6;
  }

  c21_i50 = 0;
  c21_i51 = 0;
  for (c21_i52 = 0; c21_i52 < 3; c21_i52++) {
    for (c21_i53 = 0; c21_i53 < 3; c21_i53++) {
      c21_C_RB[(c21_i53 + c21_i50) + 21] = -c21_y[c21_i53 + c21_i51];
    }

    c21_i50 += 6;
    c21_i51 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 18);
  for (c21_i54 = 0; c21_i54 < 36; c21_i54++) {
    c21_D_RB[c21_i54] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 21);
  c21_c_a = -c21_b_m_car;
  c21_d_y = c21_c_a * 9.81;
  c21_dv4[0] = 0.0;
  c21_dv4[1] = 0.0;
  c21_dv4[2] = c21_d_y;
  c21_dv4[3] = 0.0;
  c21_dv4[4] = 0.0;
  c21_dv4[5] = 0.0;
  for (c21_i55 = 0; c21_i55 < 6; c21_i55++) {
    c21_g[c21_i55] = c21_dv4[c21_i55];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 24);
  for (c21_i56 = 0; c21_i56 < 36; c21_i56++) {
    c21_d_a[c21_i56] = c21_C_RB[c21_i56];
  }

  for (c21_i57 = 0; c21_i57 < 6; c21_i57++) {
    c21_d_b[c21_i57] = c21_nu_body[c21_i57];
  }

  c21_b_eml_scalar_eg(chartInstance);
  c21_b_eml_scalar_eg(chartInstance);
  for (c21_i58 = 0; c21_i58 < 6; c21_i58++) {
    c21_e_y[c21_i58] = 0.0;
    c21_i59 = 0;
    for (c21_i60 = 0; c21_i60 < 6; c21_i60++) {
      c21_e_y[c21_i58] += c21_d_a[c21_i59 + c21_i58] * c21_d_b[c21_i60];
      c21_i59 += 6;
    }
  }

  for (c21_i61 = 0; c21_i61 < 6; c21_i61++) {
    c21_d_b[c21_i61] = c21_nu_body[c21_i61];
  }

  c21_b_eml_scalar_eg(chartInstance);
  c21_b_eml_scalar_eg(chartInstance);
  for (c21_i62 = 0; c21_i62 < 6; c21_i62++) {
    c21_f_y[c21_i62] = 0.0;
    for (c21_i63 = 0; c21_i63 < 6; c21_i63++) {
      c21_f_y[c21_i62] += 0.0 * c21_d_b[c21_i63];
    }
  }

  for (c21_i64 = 0; c21_i64 < 36; c21_i64++) {
    c21_b_M_RB[c21_i64] = c21_M_RB[c21_i64];
  }

  for (c21_i65 = 0; c21_i65 < 6; c21_i65++) {
    c21_b_tau[c21_i65] = ((c21_tau[c21_i65] - c21_e_y[c21_i65]) -
                          c21_f_y[c21_i65]) - c21_g[c21_i65];
  }

  c21_mldivide(chartInstance, c21_b_M_RB, c21_b_tau, c21_dv5);
  for (c21_i66 = 0; c21_i66 < 6; c21_i66++) {
    c21_nu_body_dot[c21_i66] = c21_dv5[c21_i66];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 27);
  for (c21_i67 = 0; c21_i67 < 3; c21_i67++) {
    c21_c_omega_body[c21_i67] = c21_omega_body[c21_i67];
  }

  c21_Smtrx(chartInstance, c21_c_omega_body, c21_y);
  for (c21_i68 = 0; c21_i68 < 3; c21_i68++) {
    c21_c_b[c21_i68] = c21_v_body[c21_i68];
  }

  c21_eml_scalar_eg(chartInstance);
  c21_eml_scalar_eg(chartInstance);
  for (c21_i69 = 0; c21_i69 < 3; c21_i69++) {
    c21_b_y[c21_i69] = 0.0;
    c21_i70 = 0;
    for (c21_i71 = 0; c21_i71 < 3; c21_i71++) {
      c21_b_y[c21_i69] += c21_y[c21_i70 + c21_i69] * c21_c_b[c21_i71];
      c21_i70 += 3;
    }
  }

  for (c21_i72 = 0; c21_i72 < 3; c21_i72++) {
    c21_r[c21_i72] = c21_omega_body[c21_i72];
  }

  sf_debug_symbol_scope_push_eml(0U, 4U, 4U, c21_b_debug_family_names,
    c21_b_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c21_b_nargin, 0U,
    c21_c_sf_marshallOut, c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_b_nargout, 1U,
    c21_c_sf_marshallOut, c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_r, 2U, c21_f_sf_marshallOut,
    c21_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_S, 3U, c21_e_sf_marshallOut,
    c21_e_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c21_sfEvent, 32);
  c21_S[0] = 0.0;
  c21_S[3] = -c21_r[2];
  c21_S[6] = c21_r[1];
  c21_S[1] = c21_r[2];
  c21_S[4] = 0.0;
  c21_S[7] = -c21_r[0];
  c21_S[2] = -c21_r[1];
  c21_S[5] = c21_r[0];
  c21_S[8] = 0.0;
  _SFD_SCRIPT_CALL(0U, chartInstance->c21_sfEvent, -32);
  sf_debug_symbol_scope_pop();
  for (c21_i73 = 0; c21_i73 < 9; c21_i73++) {
    c21_y[c21_i73] = -c21_S[c21_i73];
  }

  for (c21_i74 = 0; c21_i74 < 3; c21_i74++) {
    c21_c_b[c21_i74] = c21_omega_body[c21_i74];
  }

  c21_eml_scalar_eg(chartInstance);
  c21_eml_scalar_eg(chartInstance);
  for (c21_i75 = 0; c21_i75 < 3; c21_i75++) {
    c21_g_y[c21_i75] = 0.0;
    c21_i76 = 0;
    for (c21_i77 = 0; c21_i77 < 3; c21_i77++) {
      c21_g_y[c21_i75] += c21_y[c21_i76 + c21_i75] * c21_c_b[c21_i77];
      c21_i76 += 3;
    }
  }

  for (c21_i78 = 0; c21_i78 < 3; c21_i78++) {
    c21_h_y[c21_i78] = c21_b_y[c21_i78];
  }

  for (c21_i79 = 0; c21_i79 < 3; c21_i79++) {
    c21_h_y[c21_i79 + 3] = c21_g_y[c21_i79];
  }

  for (c21_i80 = 0; c21_i80 < 6; c21_i80++) {
    c21_a_body[c21_i80] = c21_nu_body_dot[c21_i80] + c21_h_y[c21_i80];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 31);
  for (c21_i81 = 0; c21_i81 < 3; c21_i81++) {
    c21_nu_body_dot[c21_i81 + 2] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, -31);
  sf_debug_symbol_scope_pop();
  for (c21_i82 = 0; c21_i82 < 6; c21_i82++) {
    (*c21_b_nu_body_dot)[c21_i82] = c21_nu_body_dot[c21_i82];
  }

  for (c21_i83 = 0; c21_i83 < 6; c21_i83++) {
    (*c21_b_a_body)[c21_i83] = c21_a_body[c21_i83];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 9U, chartInstance->c21_sfEvent);
}

static void initSimStructsc21_carsim(SFc21_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c21_machineNumber, uint32_T
  c21_chartNumber)
{
  _SFD_SCRIPT_TRANSLATION(c21_chartNumber, 0U, sf_debug_get_script_id(
    "C:/Users/stianell/Desktop/Oppgave/Backstepping controller og guidance til levering/Smtrx.m"));
}

static const mxArray *c21_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i84;
  real_T c21_b_inData[6];
  int32_T c21_i85;
  real_T c21_u[6];
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  for (c21_i84 = 0; c21_i84 < 6; c21_i84++) {
    c21_b_inData[c21_i84] = (*(real_T (*)[6])c21_inData)[c21_i84];
  }

  for (c21_i85 = 0; c21_i85 < 6; c21_i85++) {
    c21_u[c21_i85] = c21_b_inData[c21_i85];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_a_body, const char_T *c21_identifier, real_T c21_y[6])
{
  emlrtMsgIdentifier c21_thisId;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_a_body), &c21_thisId,
    c21_y);
  sf_mex_destroy(&c21_a_body);
}

static void c21_b_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[6])
{
  real_T c21_dv6[6];
  int32_T c21_i86;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv6, 1, 0, 0U, 1, 0U, 1, 6);
  for (c21_i86 = 0; c21_i86 < 6; c21_i86++) {
    c21_y[c21_i86] = c21_dv6[c21_i86];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_a_body;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[6];
  int32_T c21_i87;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_a_body = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_a_body), &c21_thisId,
    c21_y);
  sf_mex_destroy(&c21_a_body);
  for (c21_i87 = 0; c21_i87 < 6; c21_i87++) {
    (*(real_T (*)[6])c21_outData)[c21_i87] = c21_y[c21_i87];
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_b_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i88;
  real_T c21_b_inData[3];
  int32_T c21_i89;
  real_T c21_u[3];
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  for (c21_i88 = 0; c21_i88 < 3; c21_i88++) {
    c21_b_inData[c21_i88] = (*(real_T (*)[3])c21_inData)[c21_i88];
  }

  for (c21_i89 = 0; c21_i89 < 3; c21_i89++) {
    c21_u[c21_i89] = c21_b_inData[c21_i89];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_c_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[3])
{
  real_T c21_dv7[3];
  int32_T c21_i90;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv7, 1, 0, 0U, 1, 0U, 2, 1,
                3);
  for (c21_i90 = 0; c21_i90 < 3; c21_i90++) {
    c21_y[c21_i90] = c21_dv7[c21_i90];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_b_I_car;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[3];
  int32_T c21_i91;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_b_I_car = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_b_I_car), &c21_thisId,
    c21_y);
  sf_mex_destroy(&c21_b_I_car);
  for (c21_i91 = 0; c21_i91 < 3; c21_i91++) {
    (*(real_T (*)[3])c21_outData)[c21_i91] = c21_y[c21_i91];
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_c_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  real_T c21_u;
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_u = *(real_T *)c21_inData;
  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", &c21_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static real_T c21_d_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId)
{
  real_T c21_y;
  real_T c21_d1;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), &c21_d1, 1, 0, 0U, 0, 0U, 0);
  c21_y = c21_d1;
  sf_mex_destroy(&c21_u);
  return c21_y;
}

static void c21_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_b_m_car;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_b_m_car = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_y = c21_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_b_m_car),
    &c21_thisId);
  sf_mex_destroy(&c21_b_m_car);
  *(real_T *)c21_outData = c21_y;
  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_d_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i92;
  int32_T c21_i93;
  int32_T c21_i94;
  real_T c21_b_inData[36];
  int32_T c21_i95;
  int32_T c21_i96;
  int32_T c21_i97;
  real_T c21_u[36];
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_i92 = 0;
  for (c21_i93 = 0; c21_i93 < 6; c21_i93++) {
    for (c21_i94 = 0; c21_i94 < 6; c21_i94++) {
      c21_b_inData[c21_i94 + c21_i92] = (*(real_T (*)[36])c21_inData)[c21_i94 +
        c21_i92];
    }

    c21_i92 += 6;
  }

  c21_i95 = 0;
  for (c21_i96 = 0; c21_i96 < 6; c21_i96++) {
    for (c21_i97 = 0; c21_i97 < 6; c21_i97++) {
      c21_u[c21_i97 + c21_i95] = c21_b_inData[c21_i97 + c21_i95];
    }

    c21_i95 += 6;
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_e_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[36])
{
  real_T c21_dv8[36];
  int32_T c21_i98;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv8, 1, 0, 0U, 1, 0U, 2, 6,
                6);
  for (c21_i98 = 0; c21_i98 < 36; c21_i98++) {
    c21_y[c21_i98] = c21_dv8[c21_i98];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_C_RB;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[36];
  int32_T c21_i99;
  int32_T c21_i100;
  int32_T c21_i101;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_C_RB = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_C_RB), &c21_thisId, c21_y);
  sf_mex_destroy(&c21_C_RB);
  c21_i99 = 0;
  for (c21_i100 = 0; c21_i100 < 6; c21_i100++) {
    for (c21_i101 = 0; c21_i101 < 6; c21_i101++) {
      (*(real_T (*)[36])c21_outData)[c21_i101 + c21_i99] = c21_y[c21_i101 +
        c21_i99];
    }

    c21_i99 += 6;
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_e_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i102;
  int32_T c21_i103;
  int32_T c21_i104;
  real_T c21_b_inData[9];
  int32_T c21_i105;
  int32_T c21_i106;
  int32_T c21_i107;
  real_T c21_u[9];
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_i102 = 0;
  for (c21_i103 = 0; c21_i103 < 3; c21_i103++) {
    for (c21_i104 = 0; c21_i104 < 3; c21_i104++) {
      c21_b_inData[c21_i104 + c21_i102] = (*(real_T (*)[9])c21_inData)[c21_i104
        + c21_i102];
    }

    c21_i102 += 3;
  }

  c21_i105 = 0;
  for (c21_i106 = 0; c21_i106 < 3; c21_i106++) {
    for (c21_i107 = 0; c21_i107 < 3; c21_i107++) {
      c21_u[c21_i107 + c21_i105] = c21_b_inData[c21_i107 + c21_i105];
    }

    c21_i105 += 3;
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_f_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[9])
{
  real_T c21_dv9[9];
  int32_T c21_i108;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv9, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c21_i108 = 0; c21_i108 < 9; c21_i108++) {
    c21_y[c21_i108] = c21_dv9[c21_i108];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_I_g;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[9];
  int32_T c21_i109;
  int32_T c21_i110;
  int32_T c21_i111;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_I_g = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_I_g), &c21_thisId, c21_y);
  sf_mex_destroy(&c21_I_g);
  c21_i109 = 0;
  for (c21_i110 = 0; c21_i110 < 3; c21_i110++) {
    for (c21_i111 = 0; c21_i111 < 3; c21_i111++) {
      (*(real_T (*)[9])c21_outData)[c21_i111 + c21_i109] = c21_y[c21_i111 +
        c21_i109];
    }

    c21_i109 += 3;
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_f_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i112;
  real_T c21_b_inData[3];
  int32_T c21_i113;
  real_T c21_u[3];
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  for (c21_i112 = 0; c21_i112 < 3; c21_i112++) {
    c21_b_inData[c21_i112] = (*(real_T (*)[3])c21_inData)[c21_i112];
  }

  for (c21_i113 = 0; c21_i113 < 3; c21_i113++) {
    c21_u[c21_i113] = c21_b_inData[c21_i113];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_g_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[3])
{
  real_T c21_dv10[3];
  int32_T c21_i114;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv10, 1, 0, 0U, 1, 0U, 1, 3);
  for (c21_i114 = 0; c21_i114 < 3; c21_i114++) {
    c21_y[c21_i114] = c21_dv10[c21_i114];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_omega_body;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[3];
  int32_T c21_i115;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_omega_body = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_omega_body), &c21_thisId,
    c21_y);
  sf_mex_destroy(&c21_omega_body);
  for (c21_i115 = 0; c21_i115 < 3; c21_i115++) {
    (*(real_T (*)[3])c21_outData)[c21_i115] = c21_y[c21_i115];
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

const mxArray *sf_c21_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c21_nameCaptureInfo;
  c21_ResolvedFunctionInfo c21_info[50];
  const mxArray *c21_m0 = NULL;
  int32_T c21_i116;
  c21_ResolvedFunctionInfo *c21_r0;
  c21_nameCaptureInfo = NULL;
  c21_nameCaptureInfo = NULL;
  c21_info_helper(c21_info);
  sf_mex_assign(&c21_m0, sf_mex_createstruct("nameCaptureInfo", 1, 50), FALSE);
  for (c21_i116 = 0; c21_i116 < 50; c21_i116++) {
    c21_r0 = &c21_info[c21_i116];
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", c21_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c21_r0->context)), "context", "nameCaptureInfo",
                    c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", c21_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c21_r0->name)), "name", "nameCaptureInfo",
                    c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo",
      c21_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c21_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", c21_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c21_r0->resolved)), "resolved",
                    "nameCaptureInfo", c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", &c21_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", &c21_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo",
      &c21_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c21_i116);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo",
      &c21_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c21_i116);
  }

  sf_mex_assign(&c21_nameCaptureInfo, c21_m0, FALSE);
  return c21_nameCaptureInfo;
}

static void c21_info_helper(c21_ResolvedFunctionInfo c21_info[50])
{
  c21_info[0].context = "";
  c21_info[0].name = "diag";
  c21_info[0].dominantType = "double";
  c21_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c21_info[0].fileTimeLo = 1286818686U;
  c21_info[0].fileTimeHi = 0U;
  c21_info[0].mFileTimeLo = 0U;
  c21_info[0].mFileTimeHi = 0U;
  c21_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c21_info[1].name = "eml_index_class";
  c21_info[1].dominantType = "";
  c21_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c21_info[1].fileTimeLo = 1286818778U;
  c21_info[1].fileTimeHi = 0U;
  c21_info[1].mFileTimeLo = 0U;
  c21_info[1].mFileTimeHi = 0U;
  c21_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c21_info[2].name = "eml_index_plus";
  c21_info[2].dominantType = "int32";
  c21_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c21_info[2].fileTimeLo = 1286818778U;
  c21_info[2].fileTimeHi = 0U;
  c21_info[2].mFileTimeLo = 0U;
  c21_info[2].mFileTimeHi = 0U;
  c21_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c21_info[3].name = "eml_scalar_eg";
  c21_info[3].dominantType = "double";
  c21_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c21_info[3].fileTimeLo = 1286818796U;
  c21_info[3].fileTimeHi = 0U;
  c21_info[3].mFileTimeLo = 0U;
  c21_info[3].mFileTimeHi = 0U;
  c21_info[4].context = "";
  c21_info[4].name = "eye";
  c21_info[4].dominantType = "double";
  c21_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c21_info[4].fileTimeLo = 1286818688U;
  c21_info[4].fileTimeHi = 0U;
  c21_info[4].mFileTimeLo = 0U;
  c21_info[4].mFileTimeHi = 0U;
  c21_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c21_info[5].name = "eml_assert_valid_size_arg";
  c21_info[5].dominantType = "double";
  c21_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c21_info[5].fileTimeLo = 1286818694U;
  c21_info[5].fileTimeHi = 0U;
  c21_info[5].mFileTimeLo = 0U;
  c21_info[5].mFileTimeHi = 0U;
  c21_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!isintegral";
  c21_info[6].name = "isinf";
  c21_info[6].dominantType = "double";
  c21_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c21_info[6].fileTimeLo = 1286818760U;
  c21_info[6].fileTimeHi = 0U;
  c21_info[6].mFileTimeLo = 0U;
  c21_info[6].mFileTimeHi = 0U;
  c21_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!numel_for_size";
  c21_info[7].name = "mtimes";
  c21_info[7].dominantType = "double";
  c21_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c21_info[7].fileTimeLo = 1289519692U;
  c21_info[7].fileTimeHi = 0U;
  c21_info[7].mFileTimeLo = 0U;
  c21_info[7].mFileTimeHi = 0U;
  c21_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c21_info[8].name = "intmax";
  c21_info[8].dominantType = "char";
  c21_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c21_info[8].fileTimeLo = 1286818756U;
  c21_info[8].fileTimeHi = 0U;
  c21_info[8].mFileTimeLo = 0U;
  c21_info[8].mFileTimeHi = 0U;
  c21_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c21_info[9].name = "eml_is_float_class";
  c21_info[9].dominantType = "char";
  c21_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c21_info[9].fileTimeLo = 1286818782U;
  c21_info[9].fileTimeHi = 0U;
  c21_info[9].mFileTimeLo = 0U;
  c21_info[9].mFileTimeHi = 0U;
  c21_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c21_info[10].name = "min";
  c21_info[10].dominantType = "double";
  c21_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c21_info[10].fileTimeLo = 1308747330U;
  c21_info[10].fileTimeHi = 0U;
  c21_info[10].mFileTimeLo = 0U;
  c21_info[10].mFileTimeHi = 0U;
  c21_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c21_info[11].name = "eml_min_or_max";
  c21_info[11].dominantType = "char";
  c21_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c21_info[11].fileTimeLo = 1303146212U;
  c21_info[11].fileTimeHi = 0U;
  c21_info[11].mFileTimeLo = 0U;
  c21_info[11].mFileTimeHi = 0U;
  c21_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c21_info[12].name = "eml_scalexp_alloc";
  c21_info[12].dominantType = "double";
  c21_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c21_info[12].fileTimeLo = 1286818796U;
  c21_info[12].fileTimeHi = 0U;
  c21_info[12].mFileTimeLo = 0U;
  c21_info[12].mFileTimeHi = 0U;
  c21_info[13].context = "";
  c21_info[13].name = "Smtrx";
  c21_info[13].dominantType = "double";
  c21_info[13].resolved =
    "[E]C:/Users/stianell/Desktop/Oppgave/Backstepping controller og guidance til levering/Smtrx.m";
  c21_info[13].fileTimeLo = 1326438620U;
  c21_info[13].fileTimeHi = 0U;
  c21_info[13].mFileTimeLo = 0U;
  c21_info[13].mFileTimeHi = 0U;
  c21_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c21_info[14].name = "eml_xgemm";
  c21_info[14].dominantType = "int32";
  c21_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c21_info[14].fileTimeLo = 1299076772U;
  c21_info[14].fileTimeHi = 0U;
  c21_info[14].mFileTimeLo = 0U;
  c21_info[14].mFileTimeHi = 0U;
  c21_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c21_info[15].name = "eml_blas_inline";
  c21_info[15].dominantType = "";
  c21_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c21_info[15].fileTimeLo = 1299076768U;
  c21_info[15].fileTimeHi = 0U;
  c21_info[15].mFileTimeLo = 0U;
  c21_info[15].mFileTimeHi = 0U;
  c21_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c21_info[16].name = "eml_refblas_xgemm";
  c21_info[16].dominantType = "int32";
  c21_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c21_info[16].fileTimeLo = 1299076774U;
  c21_info[16].fileTimeHi = 0U;
  c21_info[16].mFileTimeLo = 0U;
  c21_info[16].mFileTimeHi = 0U;
  c21_info[17].context = "";
  c21_info[17].name = "mldivide";
  c21_info[17].dominantType = "double";
  c21_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c21_info[17].fileTimeLo = 1310137456U;
  c21_info[17].fileTimeHi = 0U;
  c21_info[17].mFileTimeLo = 1289519690U;
  c21_info[17].mFileTimeHi = 0U;
  c21_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c21_info[18].name = "eml_lusolve";
  c21_info[18].dominantType = "double";
  c21_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c21_info[18].fileTimeLo = 1305318000U;
  c21_info[18].fileTimeHi = 0U;
  c21_info[18].mFileTimeLo = 0U;
  c21_info[18].mFileTimeHi = 0U;
  c21_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolveNxN";
  c21_info[19].name = "eml_xgetrf";
  c21_info[19].dominantType = "int32";
  c21_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/eml_xgetrf.m";
  c21_info[19].fileTimeLo = 1286818806U;
  c21_info[19].fileTimeHi = 0U;
  c21_info[19].mFileTimeLo = 0U;
  c21_info[19].mFileTimeHi = 0U;
  c21_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/eml_xgetrf.m";
  c21_info[20].name = "eml_lapack_xgetrf";
  c21_info[20].dominantType = "int32";
  c21_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/internal/eml_lapack_xgetrf.m";
  c21_info[20].fileTimeLo = 1286818810U;
  c21_info[20].fileTimeHi = 0U;
  c21_info[20].mFileTimeLo = 0U;
  c21_info[20].mFileTimeHi = 0U;
  c21_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/internal/eml_lapack_xgetrf.m";
  c21_info[21].name = "eml_matlab_zgetrf";
  c21_info[21].dominantType = "int32";
  c21_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[21].fileTimeLo = 1302688994U;
  c21_info[21].fileTimeHi = 0U;
  c21_info[21].mFileTimeLo = 0U;
  c21_info[21].mFileTimeHi = 0U;
  c21_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[22].name = "realmin";
  c21_info[22].dominantType = "char";
  c21_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c21_info[22].fileTimeLo = 1286818768U;
  c21_info[22].fileTimeHi = 0U;
  c21_info[22].mFileTimeLo = 0U;
  c21_info[22].mFileTimeHi = 0U;
  c21_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c21_info[23].name = "mpower";
  c21_info[23].dominantType = "double";
  c21_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c21_info[23].fileTimeLo = 1286818842U;
  c21_info[23].fileTimeHi = 0U;
  c21_info[23].mFileTimeLo = 0U;
  c21_info[23].mFileTimeHi = 0U;
  c21_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c21_info[24].name = "power";
  c21_info[24].dominantType = "double";
  c21_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c21_info[24].fileTimeLo = 1294067944U;
  c21_info[24].fileTimeHi = 0U;
  c21_info[24].mFileTimeLo = 0U;
  c21_info[24].mFileTimeHi = 0U;
  c21_info[25].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c21_info[25].name = "eml_scalar_floor";
  c21_info[25].dominantType = "double";
  c21_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c21_info[25].fileTimeLo = 1286818726U;
  c21_info[25].fileTimeHi = 0U;
  c21_info[25].mFileTimeLo = 0U;
  c21_info[25].mFileTimeHi = 0U;
  c21_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[26].name = "eps";
  c21_info[26].dominantType = "char";
  c21_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c21_info[26].fileTimeLo = 1286818686U;
  c21_info[26].fileTimeHi = 0U;
  c21_info[26].mFileTimeLo = 0U;
  c21_info[26].mFileTimeHi = 0U;
  c21_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[27].name = "colon";
  c21_info[27].dominantType = "int32";
  c21_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m";
  c21_info[27].fileTimeLo = 1286818838U;
  c21_info[27].fileTimeHi = 0U;
  c21_info[27].mFileTimeLo = 0U;
  c21_info[27].mFileTimeHi = 0U;
  c21_info[28].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m";
  c21_info[28].name = "floor";
  c21_info[28].dominantType = "double";
  c21_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c21_info[28].fileTimeLo = 1286818742U;
  c21_info[28].fileTimeHi = 0U;
  c21_info[28].mFileTimeLo = 0U;
  c21_info[28].mFileTimeHi = 0U;
  c21_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!checkrange";
  c21_info[29].name = "intmin";
  c21_info[29].dominantType = "char";
  c21_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmin.m";
  c21_info[29].fileTimeLo = 1286818756U;
  c21_info[29].fileTimeHi = 0U;
  c21_info[29].mFileTimeLo = 0U;
  c21_info[29].mFileTimeHi = 0U;
  c21_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!eml_integer_colon";
  c21_info[30].name = "mrdivide";
  c21_info[30].dominantType = "double";
  c21_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c21_info[30].fileTimeLo = 1310137456U;
  c21_info[30].fileTimeHi = 0U;
  c21_info[30].mFileTimeLo = 1289519692U;
  c21_info[30].mFileTimeHi = 0U;
  c21_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c21_info[31].name = "rdivide";
  c21_info[31].dominantType = "double";
  c21_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c21_info[31].fileTimeLo = 1286818844U;
  c21_info[31].fileTimeHi = 0U;
  c21_info[31].mFileTimeLo = 0U;
  c21_info[31].mFileTimeHi = 0U;
  c21_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c21_info[32].name = "eml_div";
  c21_info[32].dominantType = "double";
  c21_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c21_info[32].fileTimeLo = 1305318000U;
  c21_info[32].fileTimeHi = 0U;
  c21_info[32].mFileTimeLo = 0U;
  c21_info[32].mFileTimeHi = 0U;
  c21_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[33].name = "eml_index_minus";
  c21_info[33].dominantType = "int32";
  c21_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c21_info[33].fileTimeLo = 1286818778U;
  c21_info[33].fileTimeHi = 0U;
  c21_info[33].mFileTimeLo = 0U;
  c21_info[33].mFileTimeHi = 0U;
  c21_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[34].name = "eml_index_times";
  c21_info[34].dominantType = "int32";
  c21_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c21_info[34].fileTimeLo = 1286818780U;
  c21_info[34].fileTimeHi = 0U;
  c21_info[34].mFileTimeLo = 0U;
  c21_info[34].mFileTimeHi = 0U;
  c21_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[35].name = "eml_ixamax";
  c21_info[35].dominantType = "int32";
  c21_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_ixamax.m";
  c21_info[35].fileTimeLo = 1299076770U;
  c21_info[35].fileTimeHi = 0U;
  c21_info[35].mFileTimeLo = 0U;
  c21_info[35].mFileTimeHi = 0U;
  c21_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_ixamax.m!below_threshold";
  c21_info[36].name = "length";
  c21_info[36].dominantType = "double";
  c21_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c21_info[36].fileTimeLo = 1303146206U;
  c21_info[36].fileTimeHi = 0U;
  c21_info[36].mFileTimeLo = 0U;
  c21_info[36].mFileTimeHi = 0U;
  c21_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_ixamax.m";
  c21_info[37].name = "eml_refblas_ixamax";
  c21_info[37].dominantType = "int32";
  c21_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_ixamax.m";
  c21_info[37].fileTimeLo = 1299076770U;
  c21_info[37].fileTimeHi = 0U;
  c21_info[37].mFileTimeLo = 0U;
  c21_info[37].mFileTimeHi = 0U;
  c21_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_ixamax.m";
  c21_info[38].name = "eml_xcabs1";
  c21_info[38].dominantType = "double";
  c21_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c21_info[38].fileTimeLo = 1286818706U;
  c21_info[38].fileTimeHi = 0U;
  c21_info[38].mFileTimeLo = 0U;
  c21_info[38].mFileTimeHi = 0U;
  c21_info[39].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c21_info[39].name = "abs";
  c21_info[39].dominantType = "double";
  c21_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c21_info[39].fileTimeLo = 1286818694U;
  c21_info[39].fileTimeHi = 0U;
  c21_info[39].mFileTimeLo = 0U;
  c21_info[39].mFileTimeHi = 0U;
  c21_info[40].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c21_info[40].name = "eml_scalar_abs";
  c21_info[40].dominantType = "double";
  c21_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c21_info[40].fileTimeLo = 1286818712U;
  c21_info[40].fileTimeHi = 0U;
  c21_info[40].mFileTimeLo = 0U;
  c21_info[40].mFileTimeHi = 0U;
  c21_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[41].name = "eml_xswap";
  c21_info[41].dominantType = "int32";
  c21_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xswap.m";
  c21_info[41].fileTimeLo = 1299076778U;
  c21_info[41].fileTimeHi = 0U;
  c21_info[41].mFileTimeLo = 0U;
  c21_info[41].mFileTimeHi = 0U;
  c21_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xswap.m";
  c21_info[42].name = "eml_refblas_xswap";
  c21_info[42].dominantType = "int32";
  c21_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xswap.m";
  c21_info[42].fileTimeLo = 1299076786U;
  c21_info[42].fileTimeHi = 0U;
  c21_info[42].mFileTimeLo = 0U;
  c21_info[42].mFileTimeHi = 0U;
  c21_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c21_info[43].name = "eml_xgeru";
  c21_info[43].dominantType = "int32";
  c21_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgeru.m";
  c21_info[43].fileTimeLo = 1299076774U;
  c21_info[43].fileTimeHi = 0U;
  c21_info[43].mFileTimeLo = 0U;
  c21_info[43].mFileTimeHi = 0U;
  c21_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgeru.m";
  c21_info[44].name = "eml_xger";
  c21_info[44].dominantType = "int32";
  c21_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xger.m";
  c21_info[44].fileTimeLo = 1299076774U;
  c21_info[44].fileTimeHi = 0U;
  c21_info[44].mFileTimeLo = 0U;
  c21_info[44].mFileTimeHi = 0U;
  c21_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xger.m";
  c21_info[45].name = "eml_refblas_xger";
  c21_info[45].dominantType = "int32";
  c21_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xger.m";
  c21_info[45].fileTimeLo = 1299076776U;
  c21_info[45].fileTimeHi = 0U;
  c21_info[45].mFileTimeLo = 0U;
  c21_info[45].mFileTimeHi = 0U;
  c21_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xger.m";
  c21_info[46].name = "eml_refblas_xgerx";
  c21_info[46].dominantType = "int32";
  c21_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgerx.m";
  c21_info[46].fileTimeLo = 1299076778U;
  c21_info[46].fileTimeHi = 0U;
  c21_info[46].mFileTimeLo = 0U;
  c21_info[46].mFileTimeHi = 0U;
  c21_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!warn_singular";
  c21_info[47].name = "eml_warning";
  c21_info[47].dominantType = "char";
  c21_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c21_info[47].fileTimeLo = 1286818802U;
  c21_info[47].fileTimeHi = 0U;
  c21_info[47].mFileTimeLo = 0U;
  c21_info[47].mFileTimeHi = 0U;
  c21_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolveNxN";
  c21_info[48].name = "eml_xtrsm";
  c21_info[48].dominantType = "int32";
  c21_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xtrsm.m";
  c21_info[48].fileTimeLo = 1299076778U;
  c21_info[48].fileTimeHi = 0U;
  c21_info[48].mFileTimeLo = 0U;
  c21_info[48].mFileTimeHi = 0U;
  c21_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xtrsm.m";
  c21_info[49].name = "eml_refblas_xtrsm";
  c21_info[49].dominantType = "int32";
  c21_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xtrsm.m";
  c21_info[49].fileTimeLo = 1299076786U;
  c21_info[49].fileTimeHi = 0U;
  c21_info[49].mFileTimeLo = 0U;
  c21_info[49].mFileTimeHi = 0U;
}

static void c21_diag(SFc21_carsimInstanceStruct *chartInstance, real_T c21_v[3],
                     real_T c21_d[9])
{
  int32_T c21_i117;
  int32_T c21_j;
  int32_T c21_b_j;
  int32_T c21_a;
  int32_T c21_c;
  for (c21_i117 = 0; c21_i117 < 9; c21_i117++) {
    c21_d[c21_i117] = 0.0;
  }

  for (c21_j = 1; c21_j < 4; c21_j++) {
    c21_b_j = c21_j;
    c21_a = c21_b_j;
    c21_c = c21_a;
    c21_d[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
             (real_T)c21_b_j), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("",
             (int32_T)_SFD_INTEGER_CHECK("", (real_T)c21_c), 1, 3, 2, 0) - 1)) -
      1] = c21_v[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c21_b_j), 1, 3, 1, 0) - 1];
  }
}

static void c21_Smtrx(SFc21_carsimInstanceStruct *chartInstance, real_T c21_r[3],
                      real_T c21_S[9])
{
  uint32_T c21_debug_family_var_map[4];
  real_T c21_nargin = 1.0;
  real_T c21_nargout = 1.0;
  sf_debug_symbol_scope_push_eml(0U, 4U, 4U, c21_b_debug_family_names,
    c21_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c21_nargin, 0U, c21_c_sf_marshallOut,
    c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_nargout, 1U,
    c21_c_sf_marshallOut, c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_r, 2U, c21_f_sf_marshallOut,
    c21_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_S, 3U, c21_e_sf_marshallOut,
    c21_e_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c21_sfEvent, 32);
  c21_S[0] = 0.0;
  c21_S[3] = -c21_r[2];
  c21_S[6] = c21_r[1];
  c21_S[1] = c21_r[2];
  c21_S[4] = 0.0;
  c21_S[7] = -c21_r[0];
  c21_S[2] = -c21_r[1];
  c21_S[5] = c21_r[0];
  c21_S[8] = 0.0;
  _SFD_SCRIPT_CALL(0U, chartInstance->c21_sfEvent, -32);
  sf_debug_symbol_scope_pop();
}

static void c21_eml_scalar_eg(SFc21_carsimInstanceStruct *chartInstance)
{
}

static void c21_b_eml_scalar_eg(SFc21_carsimInstanceStruct *chartInstance)
{
}

static void c21_mldivide(SFc21_carsimInstanceStruct *chartInstance, real_T
  c21_A[36], real_T c21_B[6], real_T c21_Y[6])
{
  int32_T c21_i118;
  real_T c21_b_A[36];
  int32_T c21_info;
  int32_T c21_ipiv[6];
  int32_T c21_b_info;
  int32_T c21_c_info;
  int32_T c21_d_info;
  int32_T c21_i119;
  int32_T c21_i;
  int32_T c21_b_i;
  int32_T c21_ip;
  real_T c21_temp;
  int32_T c21_k;
  int32_T c21_b_k;
  int32_T c21_a;
  int32_T c21_c;
  int32_T c21_b;
  int32_T c21_b_c;
  int32_T c21_b_b;
  int32_T c21_kAcol;
  int32_T c21_b_a;
  int32_T c21_c_c;
  int32_T c21_c_a;
  int32_T c21_i120;
  int32_T c21_c_i;
  int32_T c21_d_i;
  int32_T c21_d_a;
  int32_T c21_d_c;
  int32_T c21_e_a;
  int32_T c21_e_c;
  int32_T c21_f_a;
  int32_T c21_f_c;
  int32_T c21_g_a;
  int32_T c21_c_b;
  int32_T c21_g_c;
  int32_T c21_c_k;
  int32_T c21_d_k;
  int32_T c21_h_a;
  int32_T c21_h_c;
  int32_T c21_d_b;
  int32_T c21_i_c;
  int32_T c21_e_b;
  int32_T c21_b_kAcol;
  int32_T c21_i_a;
  int32_T c21_j_c;
  int32_T c21_j_a;
  int32_T c21_k_c;
  int32_T c21_k_a;
  int32_T c21_l_c;
  int32_T c21_l_a;
  int32_T c21_f_b;
  int32_T c21_m_c;
  real_T c21_x;
  real_T c21_y;
  real_T c21_z;
  int32_T c21_m_a;
  int32_T c21_i121;
  int32_T c21_e_i;
  int32_T c21_f_i;
  int32_T c21_n_a;
  int32_T c21_n_c;
  int32_T c21_o_a;
  int32_T c21_o_c;
  int32_T c21_p_a;
  int32_T c21_p_c;
  int32_T c21_q_a;
  int32_T c21_g_b;
  int32_T c21_q_c;
  for (c21_i118 = 0; c21_i118 < 36; c21_i118++) {
    c21_b_A[c21_i118] = c21_A[c21_i118];
  }

  c21_b_eml_matlab_zgetrf(chartInstance, c21_b_A, c21_ipiv, &c21_info);
  c21_b_info = c21_info;
  c21_c_info = c21_b_info;
  c21_d_info = c21_c_info;
  if ((real_T)c21_d_info > 0.0) {
    c21_eml_warning(chartInstance);
  }

  c21_b_eml_scalar_eg(chartInstance);
  for (c21_i119 = 0; c21_i119 < 6; c21_i119++) {
    c21_Y[c21_i119] = c21_B[c21_i119];
  }

  for (c21_i = 1; c21_i < 7; c21_i++) {
    c21_b_i = c21_i;
    if (c21_ipiv[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_b_i), 1, 6, 1, 0) - 1] != c21_b_i) {
      c21_ip = c21_ipiv[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c21_b_i), 1, 6, 1, 0) - 1];
      c21_temp = c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c21_b_i), 1, 6, 1, 0) - 1];
      c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c21_b_i), 1, 6, 1, 0) - 1] = c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK(
        "", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c21_ip), 1, 6, 1, 0) - 1];
      c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c21_ip), 1, 6, 1, 0) - 1] = c21_temp;
    }
  }

  c21_below_threshold(chartInstance);
  c21_c_eml_scalar_eg(chartInstance);
  for (c21_k = 1; c21_k < 7; c21_k++) {
    c21_b_k = c21_k;
    c21_a = c21_b_k;
    c21_c = c21_a;
    c21_b = c21_c - 1;
    c21_b_c = 6 * c21_b;
    c21_b_b = c21_b_c;
    c21_kAcol = c21_b_b;
    c21_b_a = c21_b_k;
    c21_c_c = c21_b_a;
    if (c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_c_c), 1, 6, 1, 0) - 1] != 0.0) {
      c21_c_a = c21_b_k;
      c21_i120 = c21_c_a;
      for (c21_c_i = c21_i120 + 1; c21_c_i < 7; c21_c_i++) {
        c21_d_i = c21_c_i;
        c21_d_a = c21_d_i;
        c21_d_c = c21_d_a;
        c21_e_a = c21_d_i;
        c21_e_c = c21_e_a;
        c21_f_a = c21_b_k;
        c21_f_c = c21_f_a;
        c21_g_a = c21_d_i;
        c21_c_b = c21_kAcol;
        c21_g_c = c21_g_a + c21_c_b;
        c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_d_c), 1, 6, 1, 0) - 1] = c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK
          ("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c21_e_c), 1, 6, 1, 0) - 1]
          - c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_f_c), 1, 6, 1, 0) - 1] *
          c21_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_g_c), 1, 36, 1, 0) - 1];
      }
    }
  }

  c21_below_threshold(chartInstance);
  c21_c_eml_scalar_eg(chartInstance);
  for (c21_c_k = 6; c21_c_k > 0; c21_c_k--) {
    c21_d_k = c21_c_k;
    c21_h_a = c21_d_k;
    c21_h_c = c21_h_a;
    c21_d_b = c21_h_c - 1;
    c21_i_c = 6 * c21_d_b;
    c21_e_b = c21_i_c;
    c21_b_kAcol = c21_e_b;
    c21_i_a = c21_d_k;
    c21_j_c = c21_i_a;
    if (c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_j_c), 1, 6, 1, 0) - 1] != 0.0) {
      c21_j_a = c21_d_k;
      c21_k_c = c21_j_a;
      c21_k_a = c21_d_k;
      c21_l_c = c21_k_a;
      c21_l_a = c21_d_k;
      c21_f_b = c21_b_kAcol;
      c21_m_c = c21_l_a + c21_f_b;
      c21_x = c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c21_l_c), 1, 6, 1, 0) - 1];
      c21_y = c21_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c21_m_c), 1, 36, 1, 0) - 1];
      c21_z = c21_x / c21_y;
      c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c21_k_c), 1, 6, 1, 0) - 1] = c21_z;
      c21_m_a = c21_d_k;
      c21_i121 = c21_m_a;
      for (c21_e_i = 1; c21_e_i <= c21_i121 - 1; c21_e_i++) {
        c21_f_i = c21_e_i;
        c21_n_a = c21_f_i;
        c21_n_c = c21_n_a;
        c21_o_a = c21_f_i;
        c21_o_c = c21_o_a;
        c21_p_a = c21_d_k;
        c21_p_c = c21_p_a;
        c21_q_a = c21_f_i;
        c21_g_b = c21_b_kAcol;
        c21_q_c = c21_q_a + c21_g_b;
        c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_n_c), 1, 6, 1, 0) - 1] = c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK
          ("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c21_o_c), 1, 6, 1, 0) - 1]
          - c21_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_p_c), 1, 6, 1, 0) - 1] *
          c21_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_q_c), 1, 36, 1, 0) - 1];
      }
    }
  }
}

static void c21_eps(SFc21_carsimInstanceStruct *chartInstance)
{
}

static void c21_eml_matlab_zgetrf(SFc21_carsimInstanceStruct *chartInstance,
  real_T c21_A[36], real_T c21_b_A[36], int32_T c21_ipiv[6], int32_T *c21_info)
{
  int32_T c21_i122;
  for (c21_i122 = 0; c21_i122 < 36; c21_i122++) {
    c21_b_A[c21_i122] = c21_A[c21_i122];
  }

  c21_b_eml_matlab_zgetrf(chartInstance, c21_b_A, c21_ipiv, c21_info);
}

static int32_T c21_eml_ixamax(SFc21_carsimInstanceStruct *chartInstance, int32_T
  c21_n, real_T c21_x[36], int32_T c21_ix0)
{
  int32_T c21_idxmax;
  int32_T c21_b_n;
  int32_T c21_b_ix0;
  int32_T c21_c_n;
  int32_T c21_c_ix0;
  int32_T c21_ix;
  real_T c21_b_x;
  real_T c21_c_x;
  real_T c21_d_x;
  real_T c21_y;
  real_T c21_e_x;
  real_T c21_f_x;
  real_T c21_b_y;
  real_T c21_smax;
  int32_T c21_loop_ub;
  int32_T c21_k;
  int32_T c21_b_k;
  int32_T c21_a;
  real_T c21_g_x;
  real_T c21_h_x;
  real_T c21_i_x;
  real_T c21_c_y;
  real_T c21_j_x;
  real_T c21_k_x;
  real_T c21_d_y;
  real_T c21_s;
  c21_b_n = c21_n;
  c21_b_ix0 = c21_ix0;
  c21_c_n = c21_b_n;
  c21_c_ix0 = c21_b_ix0;
  if ((real_T)c21_c_n < 1.0) {
    c21_idxmax = 0;
  } else {
    c21_idxmax = 1;
    if ((real_T)c21_c_n > 1.0) {
      c21_ix = c21_c_ix0;
      c21_b_x = c21_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c21_ix), 1, 36, 1, 0) - 1];
      c21_c_x = c21_b_x;
      c21_d_x = c21_c_x;
      c21_y = muDoubleScalarAbs(c21_d_x);
      c21_e_x = 0.0;
      c21_f_x = c21_e_x;
      c21_b_y = muDoubleScalarAbs(c21_f_x);
      c21_smax = c21_y + c21_b_y;
      c21_loop_ub = c21_c_n;
      for (c21_k = 2; c21_k <= c21_loop_ub; c21_k++) {
        c21_b_k = c21_k;
        c21_a = c21_ix + 1;
        c21_ix = c21_a;
        c21_g_x = c21_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c21_ix), 1, 36, 1, 0) - 1];
        c21_h_x = c21_g_x;
        c21_i_x = c21_h_x;
        c21_c_y = muDoubleScalarAbs(c21_i_x);
        c21_j_x = 0.0;
        c21_k_x = c21_j_x;
        c21_d_y = muDoubleScalarAbs(c21_k_x);
        c21_s = c21_c_y + c21_d_y;
        if (c21_s > c21_smax) {
          c21_idxmax = c21_b_k;
          c21_smax = c21_s;
        }
      }
    }
  }

  return c21_idxmax;
}

static void c21_eml_warning(SFc21_carsimInstanceStruct *chartInstance)
{
  int32_T c21_i123;
  static char_T c21_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c21_u[27];
  const mxArray *c21_y = NULL;
  for (c21_i123 = 0; c21_i123 < 27; c21_i123++) {
    c21_u[c21_i123] = c21_varargin_1[c21_i123];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 10, 0U, 1U, 0U, 2, 1, 27),
                FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c21_y));
}

static void c21_below_threshold(SFc21_carsimInstanceStruct *chartInstance)
{
}

static void c21_c_eml_scalar_eg(SFc21_carsimInstanceStruct *chartInstance)
{
}

static const mxArray *c21_g_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_u;
  const mxArray *c21_y = NULL;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_u = *(int32_T *)c21_inData;
  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", &c21_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static int32_T c21_h_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId)
{
  int32_T c21_y;
  int32_T c21_i124;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), &c21_i124, 1, 6, 0U, 0, 0U, 0);
  c21_y = c21_i124;
  sf_mex_destroy(&c21_u);
  return c21_y;
}

static void c21_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_b_sfEvent;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  int32_T c21_y;
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)chartInstanceVoid;
  c21_b_sfEvent = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_y = c21_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_b_sfEvent),
    &c21_thisId);
  sf_mex_destroy(&c21_b_sfEvent);
  *(int32_T *)c21_outData = c21_y;
  sf_mex_destroy(&c21_mxArrayInData);
}

static uint8_T c21_i_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_b_is_active_c21_carsim, const char_T *c21_identifier)
{
  uint8_T c21_y;
  emlrtMsgIdentifier c21_thisId;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_y = c21_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c21_b_is_active_c21_carsim), &c21_thisId);
  sf_mex_destroy(&c21_b_is_active_c21_carsim);
  return c21_y;
}

static uint8_T c21_j_emlrt_marshallIn(SFc21_carsimInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId)
{
  uint8_T c21_y;
  uint8_T c21_u0;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), &c21_u0, 1, 3, 0U, 0, 0U, 0);
  c21_y = c21_u0;
  sf_mex_destroy(&c21_u);
  return c21_y;
}

static void c21_b_eml_matlab_zgetrf(SFc21_carsimInstanceStruct *chartInstance,
  real_T c21_A[36], int32_T c21_ipiv[6], int32_T *c21_info)
{
  int32_T c21_i125;
  int32_T c21_j;
  int32_T c21_b_j;
  int32_T c21_a;
  int32_T c21_jm1;
  int32_T c21_b;
  int32_T c21_mmj;
  int32_T c21_b_a;
  int32_T c21_c;
  int32_T c21_b_b;
  int32_T c21_jj;
  int32_T c21_c_a;
  int32_T c21_jp1j;
  int32_T c21_d_a;
  int32_T c21_b_c;
  int32_T c21_i126;
  int32_T c21_i127;
  int32_T c21_i128;
  real_T c21_b_A[36];
  int32_T c21_e_a;
  int32_T c21_jpiv_offset;
  int32_T c21_f_a;
  int32_T c21_c_b;
  int32_T c21_jpiv;
  int32_T c21_g_a;
  int32_T c21_d_b;
  int32_T c21_c_c;
  int32_T c21_e_b;
  int32_T c21_jrow;
  int32_T c21_h_a;
  int32_T c21_f_b;
  int32_T c21_jprow;
  int32_T c21_ix0;
  int32_T c21_iy0;
  int32_T c21_b_ix0;
  int32_T c21_b_iy0;
  int32_T c21_c_ix0;
  int32_T c21_c_iy0;
  int32_T c21_ix;
  int32_T c21_iy;
  int32_T c21_k;
  real_T c21_temp;
  int32_T c21_i_a;
  int32_T c21_j_a;
  int32_T c21_b_jp1j;
  int32_T c21_k_a;
  int32_T c21_d_c;
  int32_T c21_l_a;
  int32_T c21_g_b;
  int32_T c21_i129;
  int32_T c21_i;
  int32_T c21_b_i;
  real_T c21_x;
  real_T c21_y;
  real_T c21_z;
  int32_T c21_h_b;
  int32_T c21_e_c;
  int32_T c21_m_a;
  int32_T c21_f_c;
  int32_T c21_n_a;
  int32_T c21_g_c;
  int32_T c21_m;
  int32_T c21_n;
  int32_T c21_d_ix0;
  int32_T c21_d_iy0;
  int32_T c21_ia0;
  int32_T c21_b_m;
  int32_T c21_b_n;
  int32_T c21_e_ix0;
  int32_T c21_e_iy0;
  int32_T c21_b_ia0;
  int32_T c21_c_m;
  int32_T c21_c_n;
  int32_T c21_f_ix0;
  int32_T c21_f_iy0;
  int32_T c21_c_ia0;
  int32_T c21_d_m;
  int32_T c21_d_n;
  int32_T c21_g_ix0;
  int32_T c21_g_iy0;
  int32_T c21_d_ia0;
  int32_T c21_e_m;
  int32_T c21_e_n;
  int32_T c21_h_ix0;
  int32_T c21_h_iy0;
  int32_T c21_e_ia0;
  int32_T c21_ixstart;
  int32_T c21_o_a;
  int32_T c21_jA;
  int32_T c21_jy;
  int32_T c21_loop_ub;
  int32_T c21_c_j;
  real_T c21_yjy;
  real_T c21_b_temp;
  int32_T c21_b_ix;
  int32_T c21_i_b;
  int32_T c21_i130;
  int32_T c21_p_a;
  int32_T c21_j_b;
  int32_T c21_i131;
  int32_T c21_ijA;
  int32_T c21_b_ijA;
  int32_T c21_q_a;
  int32_T c21_r_a;
  int32_T c21_s_a;
  c21_eps(chartInstance);
  for (c21_i125 = 0; c21_i125 < 6; c21_i125++) {
    c21_ipiv[c21_i125] = 1 + c21_i125;
  }

  *c21_info = 0;
  for (c21_j = 1; c21_j < 6; c21_j++) {
    c21_b_j = c21_j;
    c21_a = c21_b_j - 1;
    c21_jm1 = c21_a;
    c21_b = c21_b_j;
    c21_mmj = 6 - c21_b;
    c21_b_a = c21_jm1;
    c21_c = c21_b_a * 7;
    c21_b_b = c21_c + 1;
    c21_jj = c21_b_b;
    c21_c_a = c21_jj + 1;
    c21_jp1j = c21_c_a;
    c21_d_a = c21_mmj;
    c21_b_c = c21_d_a;
    c21_i126 = 0;
    for (c21_i127 = 0; c21_i127 < 6; c21_i127++) {
      for (c21_i128 = 0; c21_i128 < 6; c21_i128++) {
        c21_b_A[c21_i128 + c21_i126] = c21_A[c21_i128 + c21_i126];
      }

      c21_i126 += 6;
    }

    c21_e_a = c21_eml_ixamax(chartInstance, c21_b_c + 1, c21_b_A, c21_jj) - 1;
    c21_jpiv_offset = c21_e_a;
    c21_f_a = c21_jj;
    c21_c_b = c21_jpiv_offset;
    c21_jpiv = c21_f_a + c21_c_b;
    if (c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_jpiv), 1, 36, 1, 0) - 1] != 0.0) {
      if ((real_T)c21_jpiv_offset != 0.0) {
        c21_g_a = c21_b_j;
        c21_d_b = c21_jpiv_offset;
        c21_c_c = c21_g_a + c21_d_b;
        c21_ipiv[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_b_j), 1, 6, 1, 0) - 1] = c21_c_c;
        c21_e_b = c21_jm1 + 1;
        c21_jrow = c21_e_b;
        c21_h_a = c21_jrow;
        c21_f_b = c21_jpiv_offset;
        c21_jprow = c21_h_a + c21_f_b;
        c21_ix0 = c21_jrow;
        c21_iy0 = c21_jprow;
        c21_b_ix0 = c21_ix0;
        c21_b_iy0 = c21_iy0;
        c21_c_ix0 = c21_b_ix0;
        c21_c_iy0 = c21_b_iy0;
        c21_ix = c21_c_ix0;
        c21_iy = c21_c_iy0;
        for (c21_k = 1; c21_k < 7; c21_k++) {
          c21_temp = c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c21_ix), 1, 36, 1, 0) - 1];
          c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c21_ix), 1, 36, 1, 0) - 1] =
            c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c21_iy), 1, 36, 1, 0) - 1];
          c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c21_iy), 1, 36, 1, 0) - 1] = c21_temp;
          c21_i_a = c21_ix + 6;
          c21_ix = c21_i_a;
          c21_j_a = c21_iy + 6;
          c21_iy = c21_j_a;
        }
      }

      c21_b_jp1j = c21_jp1j;
      c21_k_a = c21_mmj;
      c21_d_c = c21_k_a;
      c21_l_a = c21_jp1j;
      c21_g_b = c21_d_c - 1;
      c21_i129 = c21_l_a + c21_g_b;
      for (c21_i = c21_b_jp1j; c21_i <= c21_i129; c21_i++) {
        c21_b_i = c21_i;
        c21_x = c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c21_b_i), 1, 36, 1, 0) - 1];
        c21_y = c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c21_jj), 1, 36, 1, 0) - 1];
        c21_z = c21_x / c21_y;
        c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c21_b_i), 1, 36, 1, 0) - 1] = c21_z;
      }
    } else {
      *c21_info = c21_b_j;
    }

    c21_h_b = c21_b_j;
    c21_e_c = 6 - c21_h_b;
    c21_m_a = c21_jj;
    c21_f_c = c21_m_a;
    c21_n_a = c21_jj;
    c21_g_c = c21_n_a;
    c21_m = c21_mmj;
    c21_n = c21_e_c;
    c21_d_ix0 = c21_jp1j;
    c21_d_iy0 = c21_f_c + 6;
    c21_ia0 = c21_g_c + 7;
    c21_b_m = c21_m;
    c21_b_n = c21_n;
    c21_e_ix0 = c21_d_ix0;
    c21_e_iy0 = c21_d_iy0;
    c21_b_ia0 = c21_ia0;
    c21_c_m = c21_b_m;
    c21_c_n = c21_b_n;
    c21_f_ix0 = c21_e_ix0;
    c21_f_iy0 = c21_e_iy0;
    c21_c_ia0 = c21_b_ia0;
    c21_d_m = c21_c_m;
    c21_d_n = c21_c_n;
    c21_g_ix0 = c21_f_ix0;
    c21_g_iy0 = c21_f_iy0;
    c21_d_ia0 = c21_c_ia0;
    c21_e_m = c21_d_m;
    c21_e_n = c21_d_n;
    c21_h_ix0 = c21_g_ix0;
    c21_h_iy0 = c21_g_iy0;
    c21_e_ia0 = c21_d_ia0;
    c21_ixstart = c21_h_ix0;
    c21_o_a = c21_e_ia0 - 1;
    c21_jA = c21_o_a;
    c21_jy = c21_h_iy0;
    c21_loop_ub = c21_e_n;
    for (c21_c_j = 1; c21_c_j <= c21_loop_ub; c21_c_j++) {
      c21_yjy = c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c21_jy), 1, 36, 1, 0) - 1];
      if (c21_yjy != 0.0) {
        c21_b_temp = -c21_yjy;
        c21_b_ix = c21_ixstart;
        c21_i_b = c21_jA;
        c21_i130 = c21_i_b;
        c21_p_a = c21_e_m;
        c21_j_b = c21_jA;
        c21_i131 = c21_p_a + c21_j_b;
        for (c21_ijA = c21_i130 + 1; c21_ijA <= c21_i131; c21_ijA++) {
          c21_b_ijA = c21_ijA;
          c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c21_b_ijA), 1, 36, 1, 0) - 1] =
            c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c21_b_ijA), 1, 36, 1, 0) - 1] +
            c21_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c21_b_ix), 1, 36, 1, 0) - 1] * c21_b_temp;
          c21_q_a = c21_b_ix + 1;
          c21_b_ix = c21_q_a;
        }
      }

      c21_r_a = c21_jy + 6;
      c21_jy = c21_r_a;
      c21_s_a = c21_jA + 6;
      c21_jA = c21_s_a;
    }
  }

  if ((real_T)*c21_info == 0.0) {
    if (!(c21_A[35] != 0.0)) {
      *c21_info = 6;
    }
  }
}

static void init_dsm_address_info(SFc21_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c21_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(4116203951U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3904495814U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1895986515U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1584659544U);
}

mxArray *sf_c21_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("U8HKESQbX1lTCqOb6U8FFF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c21_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[16],T\"a_body\",},{M[1],M[15],T\"nu_body_dot\",},{M[8],M[0],T\"is_active_c21_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c21_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc21_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc21_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          21,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          1,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"nu_body");
          _SFD_SET_DATA_PROPS(1,1,1,0,"tau");
          _SFD_SET_DATA_PROPS(2,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(3,10,0,0,"I_car");
          _SFD_SET_DATA_PROPS(4,2,0,1,"nu_body_dot");
          _SFD_SET_DATA_PROPS(5,2,0,1,"a_body");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,730);
        _SFD_CV_INIT_SCRIPT(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_SCRIPT_FCN(0,0,"Smtrx",0,-1,1277);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c21_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c21_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_c_sf_marshallOut,(MexInFcnForType)
          c21_c_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)
            c21_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c21_sf_marshallOut,(MexInFcnForType)
            c21_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c21_sf_marshallOut,(MexInFcnForType)
            c21_sf_marshallIn);
        }

        {
          real_T (*c21_nu_body)[6];
          real_T (*c21_tau)[6];
          real_T (*c21_nu_body_dot)[6];
          real_T (*c21_a_body)[6];
          c21_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
          c21_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c21_tau = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
          c21_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c21_nu_body);
          _SFD_SET_DATA_VALUE_PTR(1U, *c21_tau);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c21_m_car);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c21_I_car);
          _SFD_SET_DATA_VALUE_PTR(4U, *c21_nu_body_dot);
          _SFD_SET_DATA_VALUE_PTR(5U, *c21_a_body);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c21_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc21_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
  initialize_c21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c21_carsim(void *chartInstanceVar)
{
  enable_c21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c21_carsim(void *chartInstanceVar)
{
  disable_c21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c21_carsim(void *chartInstanceVar)
{
  sf_c21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c21_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c21_carsim((SFc21_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c21_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c21_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c21_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c21_carsim((SFc21_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c21_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c21_carsim(S);
}

static void sf_opaque_set_sim_state_c21_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c21_carsim(S, st);
}

static void sf_opaque_terminate_c21_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc21_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc21_carsim((SFc21_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c21_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c21_carsim((SFc21_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c21_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     I_car m_car
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for I_car*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,21);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,21,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,21,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,21,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,21,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,21);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1525434927U));
  ssSetChecksum1(S,(1502693245U));
  ssSetChecksum2(S,(517385049U));
  ssSetChecksum3(S,(1803811734U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c21_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c21_carsim(SimStruct *S)
{
  SFc21_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc21_carsimInstanceStruct *)malloc(sizeof
    (SFc21_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc21_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c21_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c21_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c21_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c21_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c21_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c21_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c21_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c21_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c21_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c21_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c21_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c21_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c21_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c21_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c21_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c21_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
