/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c23_carsim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c23_debug_family_names[13] = { "phi", "theta", "psi", "R_x",
  "R_y", "R_z", "T", "rot", "nargin", "nargout", "nu_body", "eta", "eta_dot" };

/* Function Declarations */
static void initialize_c23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void initialize_params_c23_carsim(SFc23_carsimInstanceStruct
  *chartInstance);
static void enable_c23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void disable_c23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void c23_update_debugger_state_c23_carsim(SFc23_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c23_carsim(SFc23_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c23_carsim(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_st);
static void finalize_c23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void sf_c23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void c23_chartstep_c23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void initSimStructsc23_carsim(SFc23_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c23_machineNumber, uint32_T
  c23_chartNumber);
static const mxArray *c23_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData);
static void c23_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_eta_dot, const char_T *c23_identifier, real_T c23_y[6]);
static void c23_b_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId, real_T c23_y[6]);
static void c23_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData);
static const mxArray *c23_b_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData);
static real_T c23_c_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId);
static void c23_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData);
static const mxArray *c23_c_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData);
static void c23_d_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId, real_T c23_y[36]);
static void c23_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData);
static const mxArray *c23_d_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData);
static void c23_e_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId, real_T c23_y[9]);
static void c23_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData);
static void c23_info_helper(c23_ResolvedFunctionInfo c23_info[15]);
static void c23_eml_scalar_eg(SFc23_carsimInstanceStruct *chartInstance);
static void c23_eml_xgemm(SFc23_carsimInstanceStruct *chartInstance, real_T
  c23_A[9], real_T c23_B[9], real_T c23_C[9], real_T c23_b_C[9]);
static void c23_b_eml_scalar_eg(SFc23_carsimInstanceStruct *chartInstance);
static const mxArray *c23_e_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData);
static int32_T c23_f_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId);
static void c23_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData);
static uint8_T c23_g_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_b_is_active_c23_carsim, const char_T *c23_identifier);
static uint8_T c23_h_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId);
static void c23_b_eml_xgemm(SFc23_carsimInstanceStruct *chartInstance, real_T
  c23_A[9], real_T c23_B[9], real_T c23_C[9]);
static void init_dsm_address_info(SFc23_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
  chartInstance->c23_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c23_is_active_c23_carsim = 0U;
}

static void initialize_params_c23_carsim(SFc23_carsimInstanceStruct
  *chartInstance)
{
}

static void enable_c23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c23_update_debugger_state_c23_carsim(SFc23_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c23_carsim(SFc23_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c23_st;
  const mxArray *c23_y = NULL;
  int32_T c23_i0;
  real_T c23_u[6];
  const mxArray *c23_b_y = NULL;
  uint8_T c23_hoistedGlobal;
  uint8_T c23_b_u;
  const mxArray *c23_c_y = NULL;
  real_T (*c23_eta_dot)[6];
  c23_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c23_st = NULL;
  c23_st = NULL;
  c23_y = NULL;
  sf_mex_assign(&c23_y, sf_mex_createcellarray(2), FALSE);
  for (c23_i0 = 0; c23_i0 < 6; c23_i0++) {
    c23_u[c23_i0] = (*c23_eta_dot)[c23_i0];
  }

  c23_b_y = NULL;
  sf_mex_assign(&c23_b_y, sf_mex_create("y", c23_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c23_y, 0, c23_b_y);
  c23_hoistedGlobal = chartInstance->c23_is_active_c23_carsim;
  c23_b_u = c23_hoistedGlobal;
  c23_c_y = NULL;
  sf_mex_assign(&c23_c_y, sf_mex_create("y", &c23_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c23_y, 1, c23_c_y);
  sf_mex_assign(&c23_st, c23_y, FALSE);
  return c23_st;
}

static void set_sim_state_c23_carsim(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_st)
{
  const mxArray *c23_u;
  real_T c23_dv0[6];
  int32_T c23_i1;
  real_T (*c23_eta_dot)[6];
  c23_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c23_doneDoubleBufferReInit = TRUE;
  c23_u = sf_mex_dup(c23_st);
  c23_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c23_u, 0)),
                       "eta_dot", c23_dv0);
  for (c23_i1 = 0; c23_i1 < 6; c23_i1++) {
    (*c23_eta_dot)[c23_i1] = c23_dv0[c23_i1];
  }

  chartInstance->c23_is_active_c23_carsim = c23_g_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c23_u, 1)), "is_active_c23_carsim");
  sf_mex_destroy(&c23_u);
  c23_update_debugger_state_c23_carsim(chartInstance);
  sf_mex_destroy(&c23_st);
}

static void finalize_c23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
}

static void sf_c23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
  int32_T c23_i2;
  int32_T c23_i3;
  int32_T c23_i4;
  real_T (*c23_eta)[6];
  real_T (*c23_eta_dot)[6];
  real_T (*c23_nu_body)[6];
  c23_eta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c23_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c23_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 11U, chartInstance->c23_sfEvent);
  for (c23_i2 = 0; c23_i2 < 6; c23_i2++) {
    _SFD_DATA_RANGE_CHECK((*c23_nu_body)[c23_i2], 0U);
  }

  for (c23_i3 = 0; c23_i3 < 6; c23_i3++) {
    _SFD_DATA_RANGE_CHECK((*c23_eta_dot)[c23_i3], 1U);
  }

  for (c23_i4 = 0; c23_i4 < 6; c23_i4++) {
    _SFD_DATA_RANGE_CHECK((*c23_eta)[c23_i4], 2U);
  }

  chartInstance->c23_sfEvent = CALL_EVENT;
  c23_chartstep_c23_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c23_chartstep_c23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
  int32_T c23_i5;
  real_T c23_nu_body[6];
  int32_T c23_i6;
  real_T c23_eta[6];
  uint32_T c23_debug_family_var_map[13];
  real_T c23_phi;
  real_T c23_theta;
  real_T c23_psi;
  real_T c23_R_x[9];
  real_T c23_R_y[9];
  real_T c23_R_z[9];
  real_T c23_T[9];
  real_T c23_rot[36];
  real_T c23_nargin = 2.0;
  real_T c23_nargout = 1.0;
  real_T c23_eta_dot[6];
  int32_T c23_i7;
  static real_T c23_b[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, -0.0, 1.0 };

  int32_T c23_i8;
  static real_T c23_b_b[9] = { 1.0, 0.0, -0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0 };

  real_T c23_x;
  real_T c23_b_x;
  real_T c23_c_x;
  real_T c23_d_x;
  real_T c23_e_x;
  real_T c23_f_x;
  real_T c23_g_x;
  real_T c23_h_x;
  int32_T c23_i9;
  int32_T c23_i10;
  static real_T c23_dv1[3] = { 0.0, 0.0, 1.0 };

  int32_T c23_i11;
  static real_T c23_dv2[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, -0.0, 1.0 };

  int32_T c23_i12;
  real_T c23_a[9];
  int32_T c23_i13;
  real_T c23_y[9];
  int32_T c23_i14;
  real_T c23_b_a[9];
  int32_T c23_i15;
  real_T c23_c_b[9];
  int32_T c23_i16;
  int32_T c23_i17;
  real_T c23_b_y[9];
  int32_T c23_i18;
  real_T c23_d_b[9];
  int32_T c23_i19;
  int32_T c23_i20;
  int32_T c23_i21;
  int32_T c23_i22;
  int32_T c23_i23;
  int32_T c23_i24;
  int32_T c23_i25;
  int32_T c23_i26;
  int32_T c23_i27;
  int32_T c23_i28;
  int32_T c23_i29;
  int32_T c23_i30;
  int32_T c23_i31;
  int32_T c23_i32;
  int32_T c23_i33;
  real_T c23_c_a[36];
  int32_T c23_i34;
  real_T c23_e_b[6];
  int32_T c23_i35;
  int32_T c23_i36;
  int32_T c23_i37;
  real_T c23_C[6];
  int32_T c23_i38;
  int32_T c23_i39;
  int32_T c23_i40;
  int32_T c23_i41;
  int32_T c23_i42;
  int32_T c23_i43;
  int32_T c23_i44;
  real_T (*c23_b_eta_dot)[6];
  real_T (*c23_b_eta)[6];
  real_T (*c23_b_nu_body)[6];
  c23_b_eta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c23_b_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c23_b_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 11U, chartInstance->c23_sfEvent);
  for (c23_i5 = 0; c23_i5 < 6; c23_i5++) {
    c23_nu_body[c23_i5] = (*c23_b_nu_body)[c23_i5];
  }

  for (c23_i6 = 0; c23_i6 < 6; c23_i6++) {
    c23_eta[c23_i6] = (*c23_b_eta)[c23_i6];
  }

  sf_debug_symbol_scope_push_eml(0U, 13U, 13U, c23_debug_family_names,
    c23_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c23_phi, 0U, c23_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c23_theta, 1U, c23_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c23_psi, 2U, c23_b_sf_marshallOut,
    c23_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c23_R_x, 3U, c23_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c23_R_y, 4U, c23_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c23_R_z, 5U, c23_d_sf_marshallOut,
    c23_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c23_T, 6U, c23_d_sf_marshallOut,
    c23_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c23_rot, 7U, c23_c_sf_marshallOut,
    c23_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c23_nargin, 8U, c23_b_sf_marshallOut,
    c23_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c23_nargout, 9U,
    c23_b_sf_marshallOut, c23_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c23_nu_body, 10U, c23_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c23_eta, 11U, c23_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c23_eta_dot, 12U, c23_sf_marshallOut,
    c23_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 3);
  c23_phi = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 4);
  c23_theta = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 5);
  c23_psi = c23_eta[5];
  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 8);
  for (c23_i7 = 0; c23_i7 < 9; c23_i7++) {
    c23_R_x[c23_i7] = c23_b[c23_i7];
  }

  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 12);
  for (c23_i8 = 0; c23_i8 < 9; c23_i8++) {
    c23_R_y[c23_i8] = c23_b_b[c23_i8];
  }

  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 16);
  c23_x = c23_psi;
  c23_b_x = c23_x;
  c23_b_x = muDoubleScalarCos(c23_b_x);
  c23_c_x = c23_psi;
  c23_d_x = c23_c_x;
  c23_d_x = muDoubleScalarSin(c23_d_x);
  c23_e_x = c23_psi;
  c23_f_x = c23_e_x;
  c23_f_x = muDoubleScalarSin(c23_f_x);
  c23_g_x = c23_psi;
  c23_h_x = c23_g_x;
  c23_h_x = muDoubleScalarCos(c23_h_x);
  c23_R_z[0] = c23_b_x;
  c23_R_z[3] = -c23_d_x;
  c23_R_z[6] = 0.0;
  c23_R_z[1] = c23_f_x;
  c23_R_z[4] = c23_h_x;
  c23_R_z[7] = 0.0;
  c23_i9 = 0;
  for (c23_i10 = 0; c23_i10 < 3; c23_i10++) {
    c23_R_z[c23_i9 + 2] = c23_dv1[c23_i10];
    c23_i9 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 21);
  for (c23_i11 = 0; c23_i11 < 9; c23_i11++) {
    c23_T[c23_i11] = c23_dv2[c23_i11];
  }

  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 26);
  for (c23_i12 = 0; c23_i12 < 9; c23_i12++) {
    c23_a[c23_i12] = c23_R_z[c23_i12];
  }

  c23_eml_scalar_eg(chartInstance);
  c23_eml_scalar_eg(chartInstance);
  for (c23_i13 = 0; c23_i13 < 9; c23_i13++) {
    c23_y[c23_i13] = 0.0;
  }

  for (c23_i14 = 0; c23_i14 < 9; c23_i14++) {
    c23_b_a[c23_i14] = c23_a[c23_i14];
  }

  for (c23_i15 = 0; c23_i15 < 9; c23_i15++) {
    c23_c_b[c23_i15] = c23_b_b[c23_i15];
  }

  c23_b_eml_xgemm(chartInstance, c23_b_a, c23_c_b, c23_y);
  c23_eml_scalar_eg(chartInstance);
  c23_eml_scalar_eg(chartInstance);
  for (c23_i16 = 0; c23_i16 < 9; c23_i16++) {
    c23_a[c23_i16] = 0.0;
  }

  for (c23_i17 = 0; c23_i17 < 9; c23_i17++) {
    c23_b_y[c23_i17] = c23_y[c23_i17];
  }

  for (c23_i18 = 0; c23_i18 < 9; c23_i18++) {
    c23_d_b[c23_i18] = c23_b[c23_i18];
  }

  c23_b_eml_xgemm(chartInstance, c23_b_y, c23_d_b, c23_a);
  c23_i19 = 0;
  c23_i20 = 0;
  for (c23_i21 = 0; c23_i21 < 3; c23_i21++) {
    for (c23_i22 = 0; c23_i22 < 3; c23_i22++) {
      c23_rot[c23_i22 + c23_i19] = c23_a[c23_i22 + c23_i20];
    }

    c23_i19 += 6;
    c23_i20 += 3;
  }

  c23_i23 = 0;
  for (c23_i24 = 0; c23_i24 < 3; c23_i24++) {
    for (c23_i25 = 0; c23_i25 < 3; c23_i25++) {
      c23_rot[(c23_i25 + c23_i23) + 18] = 0.0;
    }

    c23_i23 += 6;
  }

  c23_i26 = 0;
  for (c23_i27 = 0; c23_i27 < 3; c23_i27++) {
    for (c23_i28 = 0; c23_i28 < 3; c23_i28++) {
      c23_rot[(c23_i28 + c23_i26) + 3] = 0.0;
    }

    c23_i26 += 6;
  }

  c23_i29 = 0;
  c23_i30 = 0;
  for (c23_i31 = 0; c23_i31 < 3; c23_i31++) {
    for (c23_i32 = 0; c23_i32 < 3; c23_i32++) {
      c23_rot[(c23_i32 + c23_i29) + 21] = c23_T[c23_i32 + c23_i30];
    }

    c23_i29 += 6;
    c23_i30 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, 29);
  for (c23_i33 = 0; c23_i33 < 36; c23_i33++) {
    c23_c_a[c23_i33] = c23_rot[c23_i33];
  }

  for (c23_i34 = 0; c23_i34 < 6; c23_i34++) {
    c23_e_b[c23_i34] = c23_nu_body[c23_i34];
  }

  c23_b_eml_scalar_eg(chartInstance);
  c23_b_eml_scalar_eg(chartInstance);
  for (c23_i35 = 0; c23_i35 < 6; c23_i35++) {
    c23_eta_dot[c23_i35] = 0.0;
  }

  for (c23_i36 = 0; c23_i36 < 6; c23_i36++) {
    c23_eta_dot[c23_i36] = 0.0;
  }

  for (c23_i37 = 0; c23_i37 < 6; c23_i37++) {
    c23_C[c23_i37] = c23_eta_dot[c23_i37];
  }

  for (c23_i38 = 0; c23_i38 < 6; c23_i38++) {
    c23_eta_dot[c23_i38] = c23_C[c23_i38];
  }

  for (c23_i39 = 0; c23_i39 < 6; c23_i39++) {
    c23_C[c23_i39] = c23_eta_dot[c23_i39];
  }

  for (c23_i40 = 0; c23_i40 < 6; c23_i40++) {
    c23_eta_dot[c23_i40] = c23_C[c23_i40];
  }

  for (c23_i41 = 0; c23_i41 < 6; c23_i41++) {
    c23_eta_dot[c23_i41] = 0.0;
    c23_i42 = 0;
    for (c23_i43 = 0; c23_i43 < 6; c23_i43++) {
      c23_eta_dot[c23_i41] += c23_c_a[c23_i42 + c23_i41] * c23_e_b[c23_i43];
      c23_i42 += 6;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c23_sfEvent, -29);
  sf_debug_symbol_scope_pop();
  for (c23_i44 = 0; c23_i44 < 6; c23_i44++) {
    (*c23_b_eta_dot)[c23_i44] = c23_eta_dot[c23_i44];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 11U, chartInstance->c23_sfEvent);
}

static void initSimStructsc23_carsim(SFc23_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c23_machineNumber, uint32_T
  c23_chartNumber)
{
}

static const mxArray *c23_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData)
{
  const mxArray *c23_mxArrayOutData = NULL;
  int32_T c23_i45;
  real_T c23_b_inData[6];
  int32_T c23_i46;
  real_T c23_u[6];
  const mxArray *c23_y = NULL;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_mxArrayOutData = NULL;
  for (c23_i45 = 0; c23_i45 < 6; c23_i45++) {
    c23_b_inData[c23_i45] = (*(real_T (*)[6])c23_inData)[c23_i45];
  }

  for (c23_i46 = 0; c23_i46 < 6; c23_i46++) {
    c23_u[c23_i46] = c23_b_inData[c23_i46];
  }

  c23_y = NULL;
  sf_mex_assign(&c23_y, sf_mex_create("y", c23_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c23_mxArrayOutData, c23_y, FALSE);
  return c23_mxArrayOutData;
}

static void c23_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_eta_dot, const char_T *c23_identifier, real_T c23_y[6])
{
  emlrtMsgIdentifier c23_thisId;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c23_eta_dot), &c23_thisId,
    c23_y);
  sf_mex_destroy(&c23_eta_dot);
}

static void c23_b_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId, real_T c23_y[6])
{
  real_T c23_dv3[6];
  int32_T c23_i47;
  sf_mex_import(c23_parentId, sf_mex_dup(c23_u), c23_dv3, 1, 0, 0U, 1, 0U, 1, 6);
  for (c23_i47 = 0; c23_i47 < 6; c23_i47++) {
    c23_y[c23_i47] = c23_dv3[c23_i47];
  }

  sf_mex_destroy(&c23_u);
}

static void c23_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData)
{
  const mxArray *c23_eta_dot;
  const char_T *c23_identifier;
  emlrtMsgIdentifier c23_thisId;
  real_T c23_y[6];
  int32_T c23_i48;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_eta_dot = sf_mex_dup(c23_mxArrayInData);
  c23_identifier = c23_varName;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c23_eta_dot), &c23_thisId,
    c23_y);
  sf_mex_destroy(&c23_eta_dot);
  for (c23_i48 = 0; c23_i48 < 6; c23_i48++) {
    (*(real_T (*)[6])c23_outData)[c23_i48] = c23_y[c23_i48];
  }

  sf_mex_destroy(&c23_mxArrayInData);
}

static const mxArray *c23_b_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData)
{
  const mxArray *c23_mxArrayOutData = NULL;
  real_T c23_u;
  const mxArray *c23_y = NULL;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_mxArrayOutData = NULL;
  c23_u = *(real_T *)c23_inData;
  c23_y = NULL;
  sf_mex_assign(&c23_y, sf_mex_create("y", &c23_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c23_mxArrayOutData, c23_y, FALSE);
  return c23_mxArrayOutData;
}

static real_T c23_c_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId)
{
  real_T c23_y;
  real_T c23_d0;
  sf_mex_import(c23_parentId, sf_mex_dup(c23_u), &c23_d0, 1, 0, 0U, 0, 0U, 0);
  c23_y = c23_d0;
  sf_mex_destroy(&c23_u);
  return c23_y;
}

static void c23_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData)
{
  const mxArray *c23_nargout;
  const char_T *c23_identifier;
  emlrtMsgIdentifier c23_thisId;
  real_T c23_y;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_nargout = sf_mex_dup(c23_mxArrayInData);
  c23_identifier = c23_varName;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_y = c23_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c23_nargout),
    &c23_thisId);
  sf_mex_destroy(&c23_nargout);
  *(real_T *)c23_outData = c23_y;
  sf_mex_destroy(&c23_mxArrayInData);
}

static const mxArray *c23_c_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData)
{
  const mxArray *c23_mxArrayOutData = NULL;
  int32_T c23_i49;
  int32_T c23_i50;
  int32_T c23_i51;
  real_T c23_b_inData[36];
  int32_T c23_i52;
  int32_T c23_i53;
  int32_T c23_i54;
  real_T c23_u[36];
  const mxArray *c23_y = NULL;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_mxArrayOutData = NULL;
  c23_i49 = 0;
  for (c23_i50 = 0; c23_i50 < 6; c23_i50++) {
    for (c23_i51 = 0; c23_i51 < 6; c23_i51++) {
      c23_b_inData[c23_i51 + c23_i49] = (*(real_T (*)[36])c23_inData)[c23_i51 +
        c23_i49];
    }

    c23_i49 += 6;
  }

  c23_i52 = 0;
  for (c23_i53 = 0; c23_i53 < 6; c23_i53++) {
    for (c23_i54 = 0; c23_i54 < 6; c23_i54++) {
      c23_u[c23_i54 + c23_i52] = c23_b_inData[c23_i54 + c23_i52];
    }

    c23_i52 += 6;
  }

  c23_y = NULL;
  sf_mex_assign(&c23_y, sf_mex_create("y", c23_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  sf_mex_assign(&c23_mxArrayOutData, c23_y, FALSE);
  return c23_mxArrayOutData;
}

static void c23_d_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId, real_T c23_y[36])
{
  real_T c23_dv4[36];
  int32_T c23_i55;
  sf_mex_import(c23_parentId, sf_mex_dup(c23_u), c23_dv4, 1, 0, 0U, 1, 0U, 2, 6,
                6);
  for (c23_i55 = 0; c23_i55 < 36; c23_i55++) {
    c23_y[c23_i55] = c23_dv4[c23_i55];
  }

  sf_mex_destroy(&c23_u);
}

static void c23_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData)
{
  const mxArray *c23_rot;
  const char_T *c23_identifier;
  emlrtMsgIdentifier c23_thisId;
  real_T c23_y[36];
  int32_T c23_i56;
  int32_T c23_i57;
  int32_T c23_i58;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_rot = sf_mex_dup(c23_mxArrayInData);
  c23_identifier = c23_varName;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c23_rot), &c23_thisId, c23_y);
  sf_mex_destroy(&c23_rot);
  c23_i56 = 0;
  for (c23_i57 = 0; c23_i57 < 6; c23_i57++) {
    for (c23_i58 = 0; c23_i58 < 6; c23_i58++) {
      (*(real_T (*)[36])c23_outData)[c23_i58 + c23_i56] = c23_y[c23_i58 +
        c23_i56];
    }

    c23_i56 += 6;
  }

  sf_mex_destroy(&c23_mxArrayInData);
}

static const mxArray *c23_d_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData)
{
  const mxArray *c23_mxArrayOutData = NULL;
  int32_T c23_i59;
  int32_T c23_i60;
  int32_T c23_i61;
  real_T c23_b_inData[9];
  int32_T c23_i62;
  int32_T c23_i63;
  int32_T c23_i64;
  real_T c23_u[9];
  const mxArray *c23_y = NULL;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_mxArrayOutData = NULL;
  c23_i59 = 0;
  for (c23_i60 = 0; c23_i60 < 3; c23_i60++) {
    for (c23_i61 = 0; c23_i61 < 3; c23_i61++) {
      c23_b_inData[c23_i61 + c23_i59] = (*(real_T (*)[9])c23_inData)[c23_i61 +
        c23_i59];
    }

    c23_i59 += 3;
  }

  c23_i62 = 0;
  for (c23_i63 = 0; c23_i63 < 3; c23_i63++) {
    for (c23_i64 = 0; c23_i64 < 3; c23_i64++) {
      c23_u[c23_i64 + c23_i62] = c23_b_inData[c23_i64 + c23_i62];
    }

    c23_i62 += 3;
  }

  c23_y = NULL;
  sf_mex_assign(&c23_y, sf_mex_create("y", c23_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c23_mxArrayOutData, c23_y, FALSE);
  return c23_mxArrayOutData;
}

static void c23_e_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId, real_T c23_y[9])
{
  real_T c23_dv5[9];
  int32_T c23_i65;
  sf_mex_import(c23_parentId, sf_mex_dup(c23_u), c23_dv5, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c23_i65 = 0; c23_i65 < 9; c23_i65++) {
    c23_y[c23_i65] = c23_dv5[c23_i65];
  }

  sf_mex_destroy(&c23_u);
}

static void c23_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData)
{
  const mxArray *c23_T;
  const char_T *c23_identifier;
  emlrtMsgIdentifier c23_thisId;
  real_T c23_y[9];
  int32_T c23_i66;
  int32_T c23_i67;
  int32_T c23_i68;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_T = sf_mex_dup(c23_mxArrayInData);
  c23_identifier = c23_varName;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c23_T), &c23_thisId, c23_y);
  sf_mex_destroy(&c23_T);
  c23_i66 = 0;
  for (c23_i67 = 0; c23_i67 < 3; c23_i67++) {
    for (c23_i68 = 0; c23_i68 < 3; c23_i68++) {
      (*(real_T (*)[9])c23_outData)[c23_i68 + c23_i66] = c23_y[c23_i68 + c23_i66];
    }

    c23_i66 += 3;
  }

  sf_mex_destroy(&c23_mxArrayInData);
}

const mxArray *sf_c23_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c23_nameCaptureInfo;
  c23_ResolvedFunctionInfo c23_info[15];
  const mxArray *c23_m0 = NULL;
  int32_T c23_i69;
  c23_ResolvedFunctionInfo *c23_r0;
  c23_nameCaptureInfo = NULL;
  c23_nameCaptureInfo = NULL;
  c23_info_helper(c23_info);
  sf_mex_assign(&c23_m0, sf_mex_createstruct("nameCaptureInfo", 1, 15), FALSE);
  for (c23_i69 = 0; c23_i69 < 15; c23_i69++) {
    c23_r0 = &c23_info[c23_i69];
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo", c23_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c23_r0->context)), "context", "nameCaptureInfo",
                    c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo", c23_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c23_r0->name)), "name", "nameCaptureInfo",
                    c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo",
      c23_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c23_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo", c23_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c23_r0->resolved)), "resolved",
                    "nameCaptureInfo", c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo", &c23_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo", &c23_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo",
      &c23_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c23_i69);
    sf_mex_addfield(c23_m0, sf_mex_create("nameCaptureInfo",
      &c23_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c23_i69);
  }

  sf_mex_assign(&c23_nameCaptureInfo, c23_m0, FALSE);
  return c23_nameCaptureInfo;
}

static void c23_info_helper(c23_ResolvedFunctionInfo c23_info[15])
{
  c23_info[0].context = "";
  c23_info[0].name = "cos";
  c23_info[0].dominantType = "double";
  c23_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c23_info[0].fileTimeLo = 1286818706U;
  c23_info[0].fileTimeHi = 0U;
  c23_info[0].mFileTimeLo = 0U;
  c23_info[0].mFileTimeHi = 0U;
  c23_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c23_info[1].name = "eml_scalar_cos";
  c23_info[1].dominantType = "double";
  c23_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c23_info[1].fileTimeLo = 1286818722U;
  c23_info[1].fileTimeHi = 0U;
  c23_info[1].mFileTimeLo = 0U;
  c23_info[1].mFileTimeHi = 0U;
  c23_info[2].context = "";
  c23_info[2].name = "sin";
  c23_info[2].dominantType = "double";
  c23_info[2].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c23_info[2].fileTimeLo = 1286818750U;
  c23_info[2].fileTimeHi = 0U;
  c23_info[2].mFileTimeLo = 0U;
  c23_info[2].mFileTimeHi = 0U;
  c23_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c23_info[3].name = "eml_scalar_sin";
  c23_info[3].dominantType = "double";
  c23_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c23_info[3].fileTimeLo = 1286818736U;
  c23_info[3].fileTimeHi = 0U;
  c23_info[3].mFileTimeLo = 0U;
  c23_info[3].mFileTimeHi = 0U;
  c23_info[4].context = "";
  c23_info[4].name = "tan";
  c23_info[4].dominantType = "double";
  c23_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/tan.m";
  c23_info[4].fileTimeLo = 1286818752U;
  c23_info[4].fileTimeHi = 0U;
  c23_info[4].mFileTimeLo = 0U;
  c23_info[4].mFileTimeHi = 0U;
  c23_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/tan.m";
  c23_info[5].name = "eml_scalar_tan";
  c23_info[5].dominantType = "double";
  c23_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_tan.m";
  c23_info[5].fileTimeLo = 1286818738U;
  c23_info[5].fileTimeHi = 0U;
  c23_info[5].mFileTimeLo = 0U;
  c23_info[5].mFileTimeHi = 0U;
  c23_info[6].context = "";
  c23_info[6].name = "mtimes";
  c23_info[6].dominantType = "double";
  c23_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c23_info[6].fileTimeLo = 1289519692U;
  c23_info[6].fileTimeHi = 0U;
  c23_info[6].mFileTimeLo = 0U;
  c23_info[6].mFileTimeHi = 0U;
  c23_info[7].context = "";
  c23_info[7].name = "mrdivide";
  c23_info[7].dominantType = "double";
  c23_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c23_info[7].fileTimeLo = 1310137456U;
  c23_info[7].fileTimeHi = 0U;
  c23_info[7].mFileTimeLo = 1289519692U;
  c23_info[7].mFileTimeHi = 0U;
  c23_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c23_info[8].name = "rdivide";
  c23_info[8].dominantType = "double";
  c23_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c23_info[8].fileTimeLo = 1286818844U;
  c23_info[8].fileTimeHi = 0U;
  c23_info[8].mFileTimeLo = 0U;
  c23_info[8].mFileTimeHi = 0U;
  c23_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c23_info[9].name = "eml_div";
  c23_info[9].dominantType = "double";
  c23_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c23_info[9].fileTimeLo = 1305318000U;
  c23_info[9].fileTimeHi = 0U;
  c23_info[9].mFileTimeLo = 0U;
  c23_info[9].mFileTimeHi = 0U;
  c23_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c23_info[10].name = "eml_index_class";
  c23_info[10].dominantType = "";
  c23_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c23_info[10].fileTimeLo = 1286818778U;
  c23_info[10].fileTimeHi = 0U;
  c23_info[10].mFileTimeLo = 0U;
  c23_info[10].mFileTimeHi = 0U;
  c23_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c23_info[11].name = "eml_scalar_eg";
  c23_info[11].dominantType = "double";
  c23_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c23_info[11].fileTimeLo = 1286818796U;
  c23_info[11].fileTimeHi = 0U;
  c23_info[11].mFileTimeLo = 0U;
  c23_info[11].mFileTimeHi = 0U;
  c23_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c23_info[12].name = "eml_xgemm";
  c23_info[12].dominantType = "int32";
  c23_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c23_info[12].fileTimeLo = 1299076772U;
  c23_info[12].fileTimeHi = 0U;
  c23_info[12].mFileTimeLo = 0U;
  c23_info[12].mFileTimeHi = 0U;
  c23_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c23_info[13].name = "eml_blas_inline";
  c23_info[13].dominantType = "";
  c23_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c23_info[13].fileTimeLo = 1299076768U;
  c23_info[13].fileTimeHi = 0U;
  c23_info[13].mFileTimeLo = 0U;
  c23_info[13].mFileTimeHi = 0U;
  c23_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c23_info[14].name = "eml_refblas_xgemm";
  c23_info[14].dominantType = "int32";
  c23_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c23_info[14].fileTimeLo = 1299076774U;
  c23_info[14].fileTimeHi = 0U;
  c23_info[14].mFileTimeLo = 0U;
  c23_info[14].mFileTimeHi = 0U;
}

static void c23_eml_scalar_eg(SFc23_carsimInstanceStruct *chartInstance)
{
}

static void c23_eml_xgemm(SFc23_carsimInstanceStruct *chartInstance, real_T
  c23_A[9], real_T c23_B[9], real_T c23_C[9], real_T c23_b_C[9])
{
  int32_T c23_i70;
  int32_T c23_i71;
  real_T c23_b_A[9];
  int32_T c23_i72;
  real_T c23_b_B[9];
  for (c23_i70 = 0; c23_i70 < 9; c23_i70++) {
    c23_b_C[c23_i70] = c23_C[c23_i70];
  }

  for (c23_i71 = 0; c23_i71 < 9; c23_i71++) {
    c23_b_A[c23_i71] = c23_A[c23_i71];
  }

  for (c23_i72 = 0; c23_i72 < 9; c23_i72++) {
    c23_b_B[c23_i72] = c23_B[c23_i72];
  }

  c23_b_eml_xgemm(chartInstance, c23_b_A, c23_b_B, c23_b_C);
}

static void c23_b_eml_scalar_eg(SFc23_carsimInstanceStruct *chartInstance)
{
}

static const mxArray *c23_e_sf_marshallOut(void *chartInstanceVoid, void
  *c23_inData)
{
  const mxArray *c23_mxArrayOutData = NULL;
  int32_T c23_u;
  const mxArray *c23_y = NULL;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_mxArrayOutData = NULL;
  c23_u = *(int32_T *)c23_inData;
  c23_y = NULL;
  sf_mex_assign(&c23_y, sf_mex_create("y", &c23_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c23_mxArrayOutData, c23_y, FALSE);
  return c23_mxArrayOutData;
}

static int32_T c23_f_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId)
{
  int32_T c23_y;
  int32_T c23_i73;
  sf_mex_import(c23_parentId, sf_mex_dup(c23_u), &c23_i73, 1, 6, 0U, 0, 0U, 0);
  c23_y = c23_i73;
  sf_mex_destroy(&c23_u);
  return c23_y;
}

static void c23_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c23_mxArrayInData, const char_T *c23_varName, void *c23_outData)
{
  const mxArray *c23_b_sfEvent;
  const char_T *c23_identifier;
  emlrtMsgIdentifier c23_thisId;
  int32_T c23_y;
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)chartInstanceVoid;
  c23_b_sfEvent = sf_mex_dup(c23_mxArrayInData);
  c23_identifier = c23_varName;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_y = c23_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c23_b_sfEvent),
    &c23_thisId);
  sf_mex_destroy(&c23_b_sfEvent);
  *(int32_T *)c23_outData = c23_y;
  sf_mex_destroy(&c23_mxArrayInData);
}

static uint8_T c23_g_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_b_is_active_c23_carsim, const char_T *c23_identifier)
{
  uint8_T c23_y;
  emlrtMsgIdentifier c23_thisId;
  c23_thisId.fIdentifier = c23_identifier;
  c23_thisId.fParent = NULL;
  c23_y = c23_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c23_b_is_active_c23_carsim), &c23_thisId);
  sf_mex_destroy(&c23_b_is_active_c23_carsim);
  return c23_y;
}

static uint8_T c23_h_emlrt_marshallIn(SFc23_carsimInstanceStruct *chartInstance,
  const mxArray *c23_u, const emlrtMsgIdentifier *c23_parentId)
{
  uint8_T c23_y;
  uint8_T c23_u0;
  sf_mex_import(c23_parentId, sf_mex_dup(c23_u), &c23_u0, 1, 3, 0U, 0, 0U, 0);
  c23_y = c23_u0;
  sf_mex_destroy(&c23_u);
  return c23_y;
}

static void c23_b_eml_xgemm(SFc23_carsimInstanceStruct *chartInstance, real_T
  c23_A[9], real_T c23_B[9], real_T c23_C[9])
{
  int32_T c23_i74;
  int32_T c23_i75;
  int32_T c23_i76;
  int32_T c23_i77;
  int32_T c23_i78;
  for (c23_i74 = 0; c23_i74 < 3; c23_i74++) {
    c23_i75 = 0;
    for (c23_i76 = 0; c23_i76 < 3; c23_i76++) {
      c23_C[c23_i75 + c23_i74] = 0.0;
      c23_i77 = 0;
      for (c23_i78 = 0; c23_i78 < 3; c23_i78++) {
        c23_C[c23_i75 + c23_i74] += c23_A[c23_i77 + c23_i74] * c23_B[c23_i78 +
          c23_i75];
        c23_i77 += 3;
      }

      c23_i75 += 3;
    }
  }
}

static void init_dsm_address_info(SFc23_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c23_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1231324432U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1655134602U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3881213252U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2809551279U);
}

mxArray *sf_c23_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("JyLy41slfgfsXBI8jFct5");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c23_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[10],T\"eta_dot\",},{M[8],M[0],T\"is_active_c23_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c23_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc23_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc23_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          23,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"nu_body");
          _SFD_SET_DATA_PROPS(1,2,0,1,"eta_dot");
          _SFD_SET_DATA_PROPS(2,1,1,0,"eta");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,690);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c23_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c23_sf_marshallOut,(MexInFcnForType)
            c23_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c23_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c23_nu_body)[6];
          real_T (*c23_eta_dot)[6];
          real_T (*c23_eta)[6];
          c23_eta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
          c23_eta_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          c23_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c23_nu_body);
          _SFD_SET_DATA_VALUE_PTR(1U, *c23_eta_dot);
          _SFD_SET_DATA_VALUE_PTR(2U, *c23_eta);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c23_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc23_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
  initialize_c23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c23_carsim(void *chartInstanceVar)
{
  enable_c23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c23_carsim(void *chartInstanceVar)
{
  disable_c23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c23_carsim(void *chartInstanceVar)
{
  sf_c23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c23_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c23_carsim((SFc23_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c23_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c23_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c23_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c23_carsim((SFc23_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c23_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c23_carsim(S);
}

static void sf_opaque_set_sim_state_c23_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c23_carsim(S, st);
}

static void sf_opaque_terminate_c23_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc23_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc23_carsim((SFc23_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c23_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c23_carsim((SFc23_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c23_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,23);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,23,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,23,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,23,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,23,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,23);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1894179882U));
  ssSetChecksum1(S,(3397239648U));
  ssSetChecksum2(S,(920743664U));
  ssSetChecksum3(S,(2649933951U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c23_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c23_carsim(SimStruct *S)
{
  SFc23_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc23_carsimInstanceStruct *)malloc(sizeof
    (SFc23_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc23_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c23_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c23_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c23_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c23_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c23_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c23_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c23_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c23_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c23_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c23_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c23_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c23_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c23_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c23_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c23_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c23_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
