/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c26_carsim.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c26_debug_family_names[17] = { "a_x", "a_y", "g", "Fz_fl",
  "Fz_fr", "Fz_rl", "Fz_rr", "nargin", "nargout", "a_xyz", "l_front", "l_rear",
  "l_tread", "m_car", "h_cg", "l_car", "Fz_wheel" };

/* Function Declarations */
static void initialize_c26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void initialize_params_c26_carsim(SFc26_carsimInstanceStruct
  *chartInstance);
static void enable_c26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void disable_c26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void c26_update_debugger_state_c26_carsim(SFc26_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c26_carsim(SFc26_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c26_carsim(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_st);
static void finalize_c26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void sf_c26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void c26_chartstep_c26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void initSimStructsc26_carsim(SFc26_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c26_machineNumber, uint32_T
  c26_chartNumber);
static const mxArray *c26_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData);
static void c26_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_Fz_wheel, const char_T *c26_identifier, real_T c26_y[4]);
static void c26_b_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId, real_T c26_y[4]);
static void c26_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c26_mxArrayInData, const char_T *c26_varName, void *c26_outData);
static const mxArray *c26_b_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData);
static real_T c26_c_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId);
static void c26_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c26_mxArrayInData, const char_T *c26_varName, void *c26_outData);
static const mxArray *c26_c_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData);
static const mxArray *c26_d_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData);
static int32_T c26_d_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId);
static void c26_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c26_mxArrayInData, const char_T *c26_varName, void *c26_outData);
static uint8_T c26_e_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_b_is_active_c26_carsim, const char_T *c26_identifier);
static uint8_T c26_f_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId);
static void init_dsm_address_info(SFc26_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
  chartInstance->c26_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c26_is_active_c26_carsim = 0U;
}

static void initialize_params_c26_carsim(SFc26_carsimInstanceStruct
  *chartInstance)
{
  real_T c26_d0;
  real_T c26_d1;
  real_T c26_d2;
  real_T c26_d3;
  real_T c26_d4;
  real_T c26_d5;
  sf_set_error_prefix_string(
    "Error evaluating data 'l_front' in the parent workspace.\n");
  sf_mex_import_named("l_front", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c26_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c26_l_front = c26_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_rear' in the parent workspace.\n");
  sf_mex_import_named("l_rear", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c26_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c26_l_rear = c26_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_tread' in the parent workspace.\n");
  sf_mex_import_named("l_tread", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      &c26_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c26_l_tread = c26_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 5, 0),
                      &c26_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c26_m_car = c26_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'h_cg' in the parent workspace.\n");
  sf_mex_import_named("h_cg", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c26_d4, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c26_h_cg = c26_d4;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'l_car' in the parent workspace.\n");
  sf_mex_import_named("l_car", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c26_d5, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c26_l_car = c26_d5;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c26_update_debugger_state_c26_carsim(SFc26_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c26_carsim(SFc26_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c26_st;
  const mxArray *c26_y = NULL;
  int32_T c26_i0;
  real_T c26_u[4];
  const mxArray *c26_b_y = NULL;
  uint8_T c26_hoistedGlobal;
  uint8_T c26_b_u;
  const mxArray *c26_c_y = NULL;
  real_T (*c26_Fz_wheel)[4];
  c26_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c26_st = NULL;
  c26_st = NULL;
  c26_y = NULL;
  sf_mex_assign(&c26_y, sf_mex_createcellarray(2), FALSE);
  for (c26_i0 = 0; c26_i0 < 4; c26_i0++) {
    c26_u[c26_i0] = (*c26_Fz_wheel)[c26_i0];
  }

  c26_b_y = NULL;
  sf_mex_assign(&c26_b_y, sf_mex_create("y", c26_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c26_y, 0, c26_b_y);
  c26_hoistedGlobal = chartInstance->c26_is_active_c26_carsim;
  c26_b_u = c26_hoistedGlobal;
  c26_c_y = NULL;
  sf_mex_assign(&c26_c_y, sf_mex_create("y", &c26_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c26_y, 1, c26_c_y);
  sf_mex_assign(&c26_st, c26_y, FALSE);
  return c26_st;
}

static void set_sim_state_c26_carsim(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_st)
{
  const mxArray *c26_u;
  real_T c26_dv0[4];
  int32_T c26_i1;
  real_T (*c26_Fz_wheel)[4];
  c26_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c26_doneDoubleBufferReInit = TRUE;
  c26_u = sf_mex_dup(c26_st);
  c26_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c26_u, 0)),
                       "Fz_wheel", c26_dv0);
  for (c26_i1 = 0; c26_i1 < 4; c26_i1++) {
    (*c26_Fz_wheel)[c26_i1] = c26_dv0[c26_i1];
  }

  chartInstance->c26_is_active_c26_carsim = c26_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c26_u, 1)), "is_active_c26_carsim");
  sf_mex_destroy(&c26_u);
  c26_update_debugger_state_c26_carsim(chartInstance);
  sf_mex_destroy(&c26_st);
}

static void finalize_c26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
}

static void sf_c26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
  int32_T c26_i2;
  int32_T c26_i3;
  real_T (*c26_Fz_wheel)[4];
  real_T (*c26_a_xyz)[3];
  c26_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c26_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 14U, chartInstance->c26_sfEvent);
  for (c26_i2 = 0; c26_i2 < 3; c26_i2++) {
    _SFD_DATA_RANGE_CHECK((*c26_a_xyz)[c26_i2], 0U);
  }

  for (c26_i3 = 0; c26_i3 < 4; c26_i3++) {
    _SFD_DATA_RANGE_CHECK((*c26_Fz_wheel)[c26_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c26_l_front, 2U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c26_l_rear, 3U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c26_l_tread, 4U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c26_m_car, 5U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c26_h_cg, 6U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c26_l_car, 7U);
  chartInstance->c26_sfEvent = CALL_EVENT;
  c26_chartstep_c26_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c26_chartstep_c26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
  real_T c26_hoistedGlobal;
  real_T c26_b_hoistedGlobal;
  real_T c26_c_hoistedGlobal;
  real_T c26_d_hoistedGlobal;
  real_T c26_e_hoistedGlobal;
  real_T c26_f_hoistedGlobal;
  int32_T c26_i4;
  real_T c26_a_xyz[3];
  real_T c26_b_l_front;
  real_T c26_b_l_rear;
  real_T c26_b_l_tread;
  real_T c26_b_m_car;
  real_T c26_b_h_cg;
  real_T c26_b_l_car;
  uint32_T c26_debug_family_var_map[17];
  real_T c26_a_x;
  real_T c26_a_y;
  real_T c26_g;
  real_T c26_Fz_fl;
  real_T c26_Fz_fr;
  real_T c26_Fz_rl;
  real_T c26_Fz_rr;
  real_T c26_nargin = 7.0;
  real_T c26_nargout = 1.0;
  real_T c26_Fz_wheel[4];
  real_T c26_a;
  real_T c26_y;
  real_T c26_A;
  real_T c26_B;
  real_T c26_x;
  real_T c26_b_y;
  real_T c26_b_x;
  real_T c26_c_y;
  real_T c26_d_y;
  real_T c26_b_a;
  real_T c26_b;
  real_T c26_e_y;
  real_T c26_b_A;
  real_T c26_b_B;
  real_T c26_c_x;
  real_T c26_f_y;
  real_T c26_d_x;
  real_T c26_g_y;
  real_T c26_h_y;
  real_T c26_c_a;
  real_T c26_b_b;
  real_T c26_i_y;
  real_T c26_d_a;
  real_T c26_c_b;
  real_T c26_j_y;
  real_T c26_e_a;
  real_T c26_k_y;
  real_T c26_c_A;
  real_T c26_c_B;
  real_T c26_e_x;
  real_T c26_l_y;
  real_T c26_f_x;
  real_T c26_m_y;
  real_T c26_n_y;
  real_T c26_f_a;
  real_T c26_d_b;
  real_T c26_g_a;
  real_T c26_o_y;
  real_T c26_d_A;
  real_T c26_d_B;
  real_T c26_g_x;
  real_T c26_p_y;
  real_T c26_h_x;
  real_T c26_q_y;
  real_T c26_r_y;
  real_T c26_h_a;
  real_T c26_e_b;
  real_T c26_s_y;
  real_T c26_e_A;
  real_T c26_e_B;
  real_T c26_i_x;
  real_T c26_t_y;
  real_T c26_j_x;
  real_T c26_u_y;
  real_T c26_v_y;
  real_T c26_i_a;
  real_T c26_f_b;
  real_T c26_w_y;
  real_T c26_j_a;
  real_T c26_g_b;
  real_T c26_x_y;
  real_T c26_k_a;
  real_T c26_y_y;
  real_T c26_f_A;
  real_T c26_f_B;
  real_T c26_k_x;
  real_T c26_ab_y;
  real_T c26_l_x;
  real_T c26_bb_y;
  real_T c26_cb_y;
  real_T c26_l_a;
  real_T c26_h_b;
  real_T c26_m_a;
  real_T c26_db_y;
  real_T c26_g_A;
  real_T c26_g_B;
  real_T c26_m_x;
  real_T c26_eb_y;
  real_T c26_n_x;
  real_T c26_fb_y;
  real_T c26_gb_y;
  real_T c26_n_a;
  real_T c26_i_b;
  real_T c26_hb_y;
  real_T c26_h_A;
  real_T c26_h_B;
  real_T c26_o_x;
  real_T c26_ib_y;
  real_T c26_p_x;
  real_T c26_jb_y;
  real_T c26_kb_y;
  real_T c26_o_a;
  real_T c26_j_b;
  real_T c26_lb_y;
  real_T c26_p_a;
  real_T c26_k_b;
  real_T c26_mb_y;
  real_T c26_q_a;
  real_T c26_nb_y;
  real_T c26_i_A;
  real_T c26_i_B;
  real_T c26_q_x;
  real_T c26_ob_y;
  real_T c26_r_x;
  real_T c26_pb_y;
  real_T c26_qb_y;
  real_T c26_r_a;
  real_T c26_l_b;
  real_T c26_s_a;
  real_T c26_rb_y;
  real_T c26_j_A;
  real_T c26_j_B;
  real_T c26_s_x;
  real_T c26_sb_y;
  real_T c26_t_x;
  real_T c26_tb_y;
  real_T c26_ub_y;
  real_T c26_t_a;
  real_T c26_m_b;
  real_T c26_vb_y;
  real_T c26_k_A;
  real_T c26_k_B;
  real_T c26_u_x;
  real_T c26_wb_y;
  real_T c26_v_x;
  real_T c26_xb_y;
  real_T c26_yb_y;
  real_T c26_u_a;
  real_T c26_n_b;
  real_T c26_ac_y;
  real_T c26_v_a;
  real_T c26_o_b;
  real_T c26_bc_y;
  real_T c26_w_a;
  real_T c26_cc_y;
  real_T c26_l_A;
  real_T c26_l_B;
  real_T c26_w_x;
  real_T c26_dc_y;
  real_T c26_x_x;
  real_T c26_ec_y;
  real_T c26_fc_y;
  real_T c26_x_a;
  real_T c26_p_b;
  real_T c26_b_Fz_fl[4];
  int32_T c26_i5;
  int32_T c26_i6;
  real_T (*c26_b_Fz_wheel)[4];
  real_T (*c26_b_a_xyz)[3];
  c26_b_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c26_b_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 14U, chartInstance->c26_sfEvent);
  c26_hoistedGlobal = chartInstance->c26_l_front;
  c26_b_hoistedGlobal = chartInstance->c26_l_rear;
  c26_c_hoistedGlobal = chartInstance->c26_l_tread;
  c26_d_hoistedGlobal = chartInstance->c26_m_car;
  c26_e_hoistedGlobal = chartInstance->c26_h_cg;
  c26_f_hoistedGlobal = chartInstance->c26_l_car;
  for (c26_i4 = 0; c26_i4 < 3; c26_i4++) {
    c26_a_xyz[c26_i4] = (*c26_b_a_xyz)[c26_i4];
  }

  c26_b_l_front = c26_hoistedGlobal;
  c26_b_l_rear = c26_b_hoistedGlobal;
  c26_b_l_tread = c26_c_hoistedGlobal;
  c26_b_m_car = c26_d_hoistedGlobal;
  c26_b_h_cg = c26_e_hoistedGlobal;
  c26_b_l_car = c26_f_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 17U, 17U, c26_debug_family_names,
    c26_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c26_a_x, 0U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_a_y, 1U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c26_g, 2U, c26_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c26_Fz_fl, 3U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_Fz_fr, 4U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_Fz_rl, 5U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_Fz_rr, 6U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_nargin, 7U, c26_b_sf_marshallOut,
    c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_nargout, 8U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c26_a_xyz, 9U, c26_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c26_b_l_front, 10U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_b_l_rear, 11U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_b_l_tread, 12U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_b_m_car, 13U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_b_h_cg, 14U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c26_b_l_car, 15U,
    c26_b_sf_marshallOut, c26_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c26_Fz_wheel, 16U, c26_sf_marshallOut,
    c26_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 4);
  c26_a_x = -c26_a_xyz[0];
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 5);
  c26_a_y = -c26_a_xyz[1];
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 6);
  c26_g = -9.81;
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 9);
  c26_a = c26_b_l_rear;
  c26_y = c26_a * -9.81;
  c26_A = c26_y;
  c26_B = c26_b_l_car;
  c26_x = c26_A;
  c26_b_y = c26_B;
  c26_b_x = c26_x;
  c26_c_y = c26_b_y;
  c26_d_y = c26_b_x / c26_c_y;
  c26_b_a = c26_b_h_cg;
  c26_b = c26_a_x;
  c26_e_y = c26_b_a * c26_b;
  c26_b_A = c26_e_y;
  c26_b_B = c26_b_l_car;
  c26_c_x = c26_b_A;
  c26_f_y = c26_b_B;
  c26_d_x = c26_c_x;
  c26_g_y = c26_f_y;
  c26_h_y = c26_d_x / c26_g_y;
  c26_c_a = -c26_b_m_car;
  c26_b_b = c26_d_y - c26_h_y;
  c26_i_y = c26_c_a * c26_b_b;
  c26_d_a = c26_b_h_cg;
  c26_c_b = c26_a_y;
  c26_j_y = c26_d_a * c26_c_b;
  c26_e_a = c26_b_l_tread;
  c26_k_y = c26_e_a * -9.81;
  c26_c_A = c26_j_y;
  c26_c_B = c26_k_y;
  c26_e_x = c26_c_A;
  c26_l_y = c26_c_B;
  c26_f_x = c26_e_x;
  c26_m_y = c26_l_y;
  c26_n_y = c26_f_x / c26_m_y;
  c26_f_a = c26_i_y;
  c26_d_b = 0.5 - c26_n_y;
  c26_Fz_fl = c26_f_a * c26_d_b;
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 10);
  c26_g_a = c26_b_l_rear;
  c26_o_y = c26_g_a * -9.81;
  c26_d_A = c26_o_y;
  c26_d_B = c26_b_l_car;
  c26_g_x = c26_d_A;
  c26_p_y = c26_d_B;
  c26_h_x = c26_g_x;
  c26_q_y = c26_p_y;
  c26_r_y = c26_h_x / c26_q_y;
  c26_h_a = c26_b_h_cg;
  c26_e_b = c26_a_x;
  c26_s_y = c26_h_a * c26_e_b;
  c26_e_A = c26_s_y;
  c26_e_B = c26_b_l_car;
  c26_i_x = c26_e_A;
  c26_t_y = c26_e_B;
  c26_j_x = c26_i_x;
  c26_u_y = c26_t_y;
  c26_v_y = c26_j_x / c26_u_y;
  c26_i_a = -c26_b_m_car;
  c26_f_b = c26_r_y - c26_v_y;
  c26_w_y = c26_i_a * c26_f_b;
  c26_j_a = c26_b_h_cg;
  c26_g_b = c26_a_y;
  c26_x_y = c26_j_a * c26_g_b;
  c26_k_a = c26_b_l_tread;
  c26_y_y = c26_k_a * -9.81;
  c26_f_A = c26_x_y;
  c26_f_B = c26_y_y;
  c26_k_x = c26_f_A;
  c26_ab_y = c26_f_B;
  c26_l_x = c26_k_x;
  c26_bb_y = c26_ab_y;
  c26_cb_y = c26_l_x / c26_bb_y;
  c26_l_a = c26_w_y;
  c26_h_b = 0.5 + c26_cb_y;
  c26_Fz_fr = c26_l_a * c26_h_b;
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 11);
  c26_m_a = c26_b_l_front;
  c26_db_y = c26_m_a * -9.81;
  c26_g_A = c26_db_y;
  c26_g_B = c26_b_l_car;
  c26_m_x = c26_g_A;
  c26_eb_y = c26_g_B;
  c26_n_x = c26_m_x;
  c26_fb_y = c26_eb_y;
  c26_gb_y = c26_n_x / c26_fb_y;
  c26_n_a = c26_b_h_cg;
  c26_i_b = c26_a_x;
  c26_hb_y = c26_n_a * c26_i_b;
  c26_h_A = c26_hb_y;
  c26_h_B = c26_b_l_car;
  c26_o_x = c26_h_A;
  c26_ib_y = c26_h_B;
  c26_p_x = c26_o_x;
  c26_jb_y = c26_ib_y;
  c26_kb_y = c26_p_x / c26_jb_y;
  c26_o_a = -c26_b_m_car;
  c26_j_b = c26_gb_y + c26_kb_y;
  c26_lb_y = c26_o_a * c26_j_b;
  c26_p_a = c26_b_h_cg;
  c26_k_b = c26_a_y;
  c26_mb_y = c26_p_a * c26_k_b;
  c26_q_a = c26_b_l_tread;
  c26_nb_y = c26_q_a * -9.81;
  c26_i_A = c26_mb_y;
  c26_i_B = c26_nb_y;
  c26_q_x = c26_i_A;
  c26_ob_y = c26_i_B;
  c26_r_x = c26_q_x;
  c26_pb_y = c26_ob_y;
  c26_qb_y = c26_r_x / c26_pb_y;
  c26_r_a = c26_lb_y;
  c26_l_b = 0.5 - c26_qb_y;
  c26_Fz_rl = c26_r_a * c26_l_b;
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 12);
  c26_s_a = c26_b_l_front;
  c26_rb_y = c26_s_a * -9.81;
  c26_j_A = c26_rb_y;
  c26_j_B = c26_b_l_car;
  c26_s_x = c26_j_A;
  c26_sb_y = c26_j_B;
  c26_t_x = c26_s_x;
  c26_tb_y = c26_sb_y;
  c26_ub_y = c26_t_x / c26_tb_y;
  c26_t_a = c26_b_h_cg;
  c26_m_b = c26_a_x;
  c26_vb_y = c26_t_a * c26_m_b;
  c26_k_A = c26_vb_y;
  c26_k_B = c26_b_l_car;
  c26_u_x = c26_k_A;
  c26_wb_y = c26_k_B;
  c26_v_x = c26_u_x;
  c26_xb_y = c26_wb_y;
  c26_yb_y = c26_v_x / c26_xb_y;
  c26_u_a = -c26_b_m_car;
  c26_n_b = c26_ub_y + c26_yb_y;
  c26_ac_y = c26_u_a * c26_n_b;
  c26_v_a = c26_b_h_cg;
  c26_o_b = c26_a_y;
  c26_bc_y = c26_v_a * c26_o_b;
  c26_w_a = c26_b_l_tread;
  c26_cc_y = c26_w_a * -9.81;
  c26_l_A = c26_bc_y;
  c26_l_B = c26_cc_y;
  c26_w_x = c26_l_A;
  c26_dc_y = c26_l_B;
  c26_x_x = c26_w_x;
  c26_ec_y = c26_dc_y;
  c26_fc_y = c26_x_x / c26_ec_y;
  c26_x_a = c26_ac_y;
  c26_p_b = 0.5 + c26_fc_y;
  c26_Fz_rr = c26_x_a * c26_p_b;
  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, 14);
  c26_b_Fz_fl[0] = c26_Fz_fl;
  c26_b_Fz_fl[1] = c26_Fz_fr;
  c26_b_Fz_fl[2] = c26_Fz_rl;
  c26_b_Fz_fl[3] = c26_Fz_rr;
  for (c26_i5 = 0; c26_i5 < 4; c26_i5++) {
    c26_Fz_wheel[c26_i5] = c26_b_Fz_fl[c26_i5];
  }

  _SFD_EML_CALL(0U, chartInstance->c26_sfEvent, -14);
  sf_debug_symbol_scope_pop();
  for (c26_i6 = 0; c26_i6 < 4; c26_i6++) {
    (*c26_b_Fz_wheel)[c26_i6] = c26_Fz_wheel[c26_i6];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 14U, chartInstance->c26_sfEvent);
}

static void initSimStructsc26_carsim(SFc26_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c26_machineNumber, uint32_T
  c26_chartNumber)
{
}

static const mxArray *c26_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData)
{
  const mxArray *c26_mxArrayOutData = NULL;
  int32_T c26_i7;
  real_T c26_b_inData[4];
  int32_T c26_i8;
  real_T c26_u[4];
  const mxArray *c26_y = NULL;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_mxArrayOutData = NULL;
  for (c26_i7 = 0; c26_i7 < 4; c26_i7++) {
    c26_b_inData[c26_i7] = (*(real_T (*)[4])c26_inData)[c26_i7];
  }

  for (c26_i8 = 0; c26_i8 < 4; c26_i8++) {
    c26_u[c26_i8] = c26_b_inData[c26_i8];
  }

  c26_y = NULL;
  sf_mex_assign(&c26_y, sf_mex_create("y", c26_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c26_mxArrayOutData, c26_y, FALSE);
  return c26_mxArrayOutData;
}

static void c26_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_Fz_wheel, const char_T *c26_identifier, real_T c26_y[4])
{
  emlrtMsgIdentifier c26_thisId;
  c26_thisId.fIdentifier = c26_identifier;
  c26_thisId.fParent = NULL;
  c26_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c26_Fz_wheel), &c26_thisId,
    c26_y);
  sf_mex_destroy(&c26_Fz_wheel);
}

static void c26_b_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId, real_T c26_y[4])
{
  real_T c26_dv1[4];
  int32_T c26_i9;
  sf_mex_import(c26_parentId, sf_mex_dup(c26_u), c26_dv1, 1, 0, 0U, 1, 0U, 1, 4);
  for (c26_i9 = 0; c26_i9 < 4; c26_i9++) {
    c26_y[c26_i9] = c26_dv1[c26_i9];
  }

  sf_mex_destroy(&c26_u);
}

static void c26_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c26_mxArrayInData, const char_T *c26_varName, void *c26_outData)
{
  const mxArray *c26_Fz_wheel;
  const char_T *c26_identifier;
  emlrtMsgIdentifier c26_thisId;
  real_T c26_y[4];
  int32_T c26_i10;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_Fz_wheel = sf_mex_dup(c26_mxArrayInData);
  c26_identifier = c26_varName;
  c26_thisId.fIdentifier = c26_identifier;
  c26_thisId.fParent = NULL;
  c26_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c26_Fz_wheel), &c26_thisId,
    c26_y);
  sf_mex_destroy(&c26_Fz_wheel);
  for (c26_i10 = 0; c26_i10 < 4; c26_i10++) {
    (*(real_T (*)[4])c26_outData)[c26_i10] = c26_y[c26_i10];
  }

  sf_mex_destroy(&c26_mxArrayInData);
}

static const mxArray *c26_b_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData)
{
  const mxArray *c26_mxArrayOutData = NULL;
  real_T c26_u;
  const mxArray *c26_y = NULL;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_mxArrayOutData = NULL;
  c26_u = *(real_T *)c26_inData;
  c26_y = NULL;
  sf_mex_assign(&c26_y, sf_mex_create("y", &c26_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c26_mxArrayOutData, c26_y, FALSE);
  return c26_mxArrayOutData;
}

static real_T c26_c_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId)
{
  real_T c26_y;
  real_T c26_d6;
  sf_mex_import(c26_parentId, sf_mex_dup(c26_u), &c26_d6, 1, 0, 0U, 0, 0U, 0);
  c26_y = c26_d6;
  sf_mex_destroy(&c26_u);
  return c26_y;
}

static void c26_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c26_mxArrayInData, const char_T *c26_varName, void *c26_outData)
{
  const mxArray *c26_b_l_car;
  const char_T *c26_identifier;
  emlrtMsgIdentifier c26_thisId;
  real_T c26_y;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_b_l_car = sf_mex_dup(c26_mxArrayInData);
  c26_identifier = c26_varName;
  c26_thisId.fIdentifier = c26_identifier;
  c26_thisId.fParent = NULL;
  c26_y = c26_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c26_b_l_car),
    &c26_thisId);
  sf_mex_destroy(&c26_b_l_car);
  *(real_T *)c26_outData = c26_y;
  sf_mex_destroy(&c26_mxArrayInData);
}

static const mxArray *c26_c_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData)
{
  const mxArray *c26_mxArrayOutData = NULL;
  int32_T c26_i11;
  real_T c26_b_inData[3];
  int32_T c26_i12;
  real_T c26_u[3];
  const mxArray *c26_y = NULL;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_mxArrayOutData = NULL;
  for (c26_i11 = 0; c26_i11 < 3; c26_i11++) {
    c26_b_inData[c26_i11] = (*(real_T (*)[3])c26_inData)[c26_i11];
  }

  for (c26_i12 = 0; c26_i12 < 3; c26_i12++) {
    c26_u[c26_i12] = c26_b_inData[c26_i12];
  }

  c26_y = NULL;
  sf_mex_assign(&c26_y, sf_mex_create("y", c26_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c26_mxArrayOutData, c26_y, FALSE);
  return c26_mxArrayOutData;
}

const mxArray *sf_c26_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c26_nameCaptureInfo;
  c26_ResolvedFunctionInfo c26_info[4];
  c26_ResolvedFunctionInfo (*c26_b_info)[4];
  const mxArray *c26_m0 = NULL;
  int32_T c26_i13;
  c26_ResolvedFunctionInfo *c26_r0;
  c26_nameCaptureInfo = NULL;
  c26_nameCaptureInfo = NULL;
  c26_b_info = (c26_ResolvedFunctionInfo (*)[4])c26_info;
  (*c26_b_info)[0].context = "";
  (*c26_b_info)[0].name = "mtimes";
  (*c26_b_info)[0].dominantType = "double";
  (*c26_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c26_b_info)[0].fileTimeLo = 1289519692U;
  (*c26_b_info)[0].fileTimeHi = 0U;
  (*c26_b_info)[0].mFileTimeLo = 0U;
  (*c26_b_info)[0].mFileTimeHi = 0U;
  (*c26_b_info)[1].context = "";
  (*c26_b_info)[1].name = "mrdivide";
  (*c26_b_info)[1].dominantType = "double";
  (*c26_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c26_b_info)[1].fileTimeLo = 1310137456U;
  (*c26_b_info)[1].fileTimeHi = 0U;
  (*c26_b_info)[1].mFileTimeLo = 1289519692U;
  (*c26_b_info)[1].mFileTimeHi = 0U;
  (*c26_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c26_b_info)[2].name = "rdivide";
  (*c26_b_info)[2].dominantType = "double";
  (*c26_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c26_b_info)[2].fileTimeLo = 1286818844U;
  (*c26_b_info)[2].fileTimeHi = 0U;
  (*c26_b_info)[2].mFileTimeLo = 0U;
  (*c26_b_info)[2].mFileTimeHi = 0U;
  (*c26_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c26_b_info)[3].name = "eml_div";
  (*c26_b_info)[3].dominantType = "double";
  (*c26_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c26_b_info)[3].fileTimeLo = 1305318000U;
  (*c26_b_info)[3].fileTimeHi = 0U;
  (*c26_b_info)[3].mFileTimeLo = 0U;
  (*c26_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c26_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4), FALSE);
  for (c26_i13 = 0; c26_i13 < 4; c26_i13++) {
    c26_r0 = &c26_info[c26_i13];
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo", c26_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c26_r0->context)), "context", "nameCaptureInfo",
                    c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo", c26_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c26_r0->name)), "name", "nameCaptureInfo",
                    c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo",
      c26_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c26_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo", c26_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c26_r0->resolved)), "resolved",
                    "nameCaptureInfo", c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo", &c26_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo", &c26_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo",
      &c26_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c26_i13);
    sf_mex_addfield(c26_m0, sf_mex_create("nameCaptureInfo",
      &c26_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c26_i13);
  }

  sf_mex_assign(&c26_nameCaptureInfo, c26_m0, FALSE);
  return c26_nameCaptureInfo;
}

static const mxArray *c26_d_sf_marshallOut(void *chartInstanceVoid, void
  *c26_inData)
{
  const mxArray *c26_mxArrayOutData = NULL;
  int32_T c26_u;
  const mxArray *c26_y = NULL;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_mxArrayOutData = NULL;
  c26_u = *(int32_T *)c26_inData;
  c26_y = NULL;
  sf_mex_assign(&c26_y, sf_mex_create("y", &c26_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c26_mxArrayOutData, c26_y, FALSE);
  return c26_mxArrayOutData;
}

static int32_T c26_d_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId)
{
  int32_T c26_y;
  int32_T c26_i14;
  sf_mex_import(c26_parentId, sf_mex_dup(c26_u), &c26_i14, 1, 6, 0U, 0, 0U, 0);
  c26_y = c26_i14;
  sf_mex_destroy(&c26_u);
  return c26_y;
}

static void c26_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c26_mxArrayInData, const char_T *c26_varName, void *c26_outData)
{
  const mxArray *c26_b_sfEvent;
  const char_T *c26_identifier;
  emlrtMsgIdentifier c26_thisId;
  int32_T c26_y;
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)chartInstanceVoid;
  c26_b_sfEvent = sf_mex_dup(c26_mxArrayInData);
  c26_identifier = c26_varName;
  c26_thisId.fIdentifier = c26_identifier;
  c26_thisId.fParent = NULL;
  c26_y = c26_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c26_b_sfEvent),
    &c26_thisId);
  sf_mex_destroy(&c26_b_sfEvent);
  *(int32_T *)c26_outData = c26_y;
  sf_mex_destroy(&c26_mxArrayInData);
}

static uint8_T c26_e_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_b_is_active_c26_carsim, const char_T *c26_identifier)
{
  uint8_T c26_y;
  emlrtMsgIdentifier c26_thisId;
  c26_thisId.fIdentifier = c26_identifier;
  c26_thisId.fParent = NULL;
  c26_y = c26_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c26_b_is_active_c26_carsim), &c26_thisId);
  sf_mex_destroy(&c26_b_is_active_c26_carsim);
  return c26_y;
}

static uint8_T c26_f_emlrt_marshallIn(SFc26_carsimInstanceStruct *chartInstance,
  const mxArray *c26_u, const emlrtMsgIdentifier *c26_parentId)
{
  uint8_T c26_y;
  uint8_T c26_u0;
  sf_mex_import(c26_parentId, sf_mex_dup(c26_u), &c26_u0, 1, 3, 0U, 0, 0U, 0);
  c26_y = c26_u0;
  sf_mex_destroy(&c26_u);
  return c26_y;
}

static void init_dsm_address_info(SFc26_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c26_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2495189196U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(796658505U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3224883105U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(870234242U);
}

mxArray *sf_c26_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("qhHDpdbqfiIgxwS63MhXUD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c26_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"Fz_wheel\",},{M[8],M[0],T\"is_active_c26_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c26_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc26_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc26_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          26,
          1,
          1,
          8,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"a_xyz");
          _SFD_SET_DATA_PROPS(1,2,0,1,"Fz_wheel");
          _SFD_SET_DATA_PROPS(2,10,0,0,"l_front");
          _SFD_SET_DATA_PROPS(3,10,0,0,"l_rear");
          _SFD_SET_DATA_PROPS(4,10,0,0,"l_tread");
          _SFD_SET_DATA_PROPS(5,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(6,10,0,0,"h_cg");
          _SFD_SET_DATA_PROPS(7,10,0,0,"l_car");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,536);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c26_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c26_sf_marshallOut,(MexInFcnForType)
            c26_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c26_b_sf_marshallOut,(MexInFcnForType)
          c26_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c26_b_sf_marshallOut,(MexInFcnForType)
          c26_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c26_b_sf_marshallOut,(MexInFcnForType)
          c26_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c26_b_sf_marshallOut,(MexInFcnForType)
          c26_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c26_b_sf_marshallOut,(MexInFcnForType)
          c26_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c26_b_sf_marshallOut,(MexInFcnForType)
          c26_b_sf_marshallIn);

        {
          real_T (*c26_a_xyz)[3];
          real_T (*c26_Fz_wheel)[4];
          c26_Fz_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
            1);
          c26_a_xyz = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c26_a_xyz);
          _SFD_SET_DATA_VALUE_PTR(1U, *c26_Fz_wheel);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c26_l_front);
          _SFD_SET_DATA_VALUE_PTR(3U, &chartInstance->c26_l_rear);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c26_l_tread);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c26_m_car);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance->c26_h_cg);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance->c26_l_car);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c26_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc26_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
  initialize_c26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c26_carsim(void *chartInstanceVar)
{
  enable_c26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c26_carsim(void *chartInstanceVar)
{
  disable_c26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c26_carsim(void *chartInstanceVar)
{
  sf_c26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c26_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c26_carsim((SFc26_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c26_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c26_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c26_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c26_carsim((SFc26_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c26_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c26_carsim(S);
}

static void sf_opaque_set_sim_state_c26_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c26_carsim(S, st);
}

static void sf_opaque_terminate_c26_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc26_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc26_carsim((SFc26_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c26_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c26_carsim((SFc26_carsimInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c26_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     h_cg l_car l_front l_rear l_tread m_car
   */
  const char_T *rtParamNames[] = { "p1", "p2", "p3", "p4", "p5", "p6" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for h_cg*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for l_car*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for l_front*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for l_rear*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for l_tread*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,26);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,26,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,26,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,26,1);
      sf_mark_chart_reusable_outputs(S,infoStruct,26,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,26);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3688920086U));
  ssSetChecksum1(S,(2896326949U));
  ssSetChecksum2(S,(544295602U));
  ssSetChecksum3(S,(2495581568U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c26_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c26_carsim(SimStruct *S)
{
  SFc26_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc26_carsimInstanceStruct *)malloc(sizeof
    (SFc26_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc26_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c26_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c26_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c26_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c26_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c26_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c26_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c26_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c26_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c26_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c26_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c26_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c26_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c26_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c26_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c26_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c26_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
