#ifndef __c27_carsim_h__
#define __c27_carsim_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c27_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  real_T c27_l_front;
  real_T c27_l_rear;
  real_T c27_l_tread;
  real_T c27_r_wheel;
  int32_T c27_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c27_doneDoubleBufferReInit;
  boolean_T c27_isStable;
  uint8_T c27_is_active_c27_carsim;
  ChartInfoStruct chartInfo;
} SFc27_carsimInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c27_carsim_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c27_carsim_get_check_sum(mxArray *plhs[]);
extern void c27_carsim_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
