#ifndef __c28_carsim_h__
#define __c28_carsim_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c28_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  real_T c28_I_motor;
  real_T c28_I_wheel;
  real_T c28_diff_lock;
  real_T c28_r_wheel;
  real_T c28_wheel_drive;
  int32_T c28_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c28_doneDoubleBufferReInit;
  boolean_T c28_isStable;
  uint8_T c28_is_active_c28_carsim;
  ChartInfoStruct chartInfo;
} SFc28_carsimInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c28_carsim_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c28_carsim_get_check_sum(mxArray *plhs[]);
extern void c28_carsim_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
