/* Include files */

#include "blascompat32.h"
#include "carsim_sfun.h"
#include "c7_carsim.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "carsim_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c7_debug_family_names[19] = { "R_z", "v_body", "beta",
  "nargin", "nargout", "psi", "chi_d", "beta_d", "v_inertial", "psi0",
  "psidot_d", "betadot_d", "chidot_d", "chidot", "psiddot_d", "betaprev_d",
  "chiprev_d", "chiprev", "psidotprev_d" };

/* Function Declarations */
static void initialize_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void initialize_params_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void enable_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void disable_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void c7_update_debugger_state_c7_carsim(SFc7_carsimInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c7_carsim(SFc7_carsimInstanceStruct
  *chartInstance);
static void set_sim_state_c7_carsim(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_st);
static void finalize_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void sf_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void c7_chartstep_c7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void initSimStructsc7_carsim(SFc7_carsimInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber);
static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData);
static real_T c7_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_psidotprev_d, const char_T *c7_identifier);
static real_T c7_b_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_c_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_chiprev, const char_T *c7_identifier);
static real_T c7_d_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_e_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_chiprev_d, const char_T *c7_identifier);
static real_T c7_f_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_g_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_betaprev_d, const char_T *c7_identifier);
static real_T c7_h_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_e_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_i_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_psiddot_d, const char_T *c7_identifier);
static real_T c7_j_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_f_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static void c7_k_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[3]);
static void c7_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_g_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static void c7_l_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[9]);
static void c7_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static void c7_info_helper(c7_ResolvedFunctionInfo c7_info[16]);
static void c7_eml_scalar_eg(SFc7_carsimInstanceStruct *chartInstance);
static const mxArray *c7_h_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static int32_T c7_m_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static uint8_T c7_n_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_is_active_c7_carsim, const char_T *c7_identifier);
static uint8_T c7_o_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void init_dsm_address_info(SFc7_carsimInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
  chartInstance->c7_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c7_betaprev_d_not_empty = FALSE;
  chartInstance->c7_chiprev_d_not_empty = FALSE;
  chartInstance->c7_chiprev_not_empty = FALSE;
  chartInstance->c7_psidotprev_d_not_empty = FALSE;
  chartInstance->c7_is_active_c7_carsim = 0U;
}

static void initialize_params_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
  real_T c7_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'psi0' in the parent workspace.\n");
  sf_mex_import_named("psi0", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c7_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_psi0 = c7_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c7_update_debugger_state_c7_carsim(SFc7_carsimInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c7_carsim(SFc7_carsimInstanceStruct
  *chartInstance)
{
  const mxArray *c7_st;
  const mxArray *c7_y = NULL;
  real_T c7_hoistedGlobal;
  real_T c7_u;
  const mxArray *c7_b_y = NULL;
  real_T c7_b_hoistedGlobal;
  real_T c7_b_u;
  const mxArray *c7_c_y = NULL;
  real_T c7_c_hoistedGlobal;
  real_T c7_c_u;
  const mxArray *c7_d_y = NULL;
  real_T c7_d_hoistedGlobal;
  real_T c7_d_u;
  const mxArray *c7_e_y = NULL;
  real_T c7_e_hoistedGlobal;
  real_T c7_e_u;
  const mxArray *c7_f_y = NULL;
  real_T c7_f_hoistedGlobal;
  real_T c7_f_u;
  const mxArray *c7_g_y = NULL;
  real_T c7_g_hoistedGlobal;
  real_T c7_g_u;
  const mxArray *c7_h_y = NULL;
  real_T c7_h_hoistedGlobal;
  real_T c7_h_u;
  const mxArray *c7_i_y = NULL;
  uint8_T c7_i_hoistedGlobal;
  uint8_T c7_i_u;
  const mxArray *c7_j_y = NULL;
  real_T *c7_betadot_d;
  real_T *c7_chidot;
  real_T *c7_chidot_d;
  real_T *c7_psiddot_d;
  c7_psiddot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c7_chidot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c7_chidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c7_betadot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c7_st = NULL;
  c7_st = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_createcellarray(9), FALSE);
  c7_hoistedGlobal = *c7_betadot_d;
  c7_u = c7_hoistedGlobal;
  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 0, c7_b_y);
  c7_b_hoistedGlobal = *c7_chidot;
  c7_b_u = c7_b_hoistedGlobal;
  c7_c_y = NULL;
  sf_mex_assign(&c7_c_y, sf_mex_create("y", &c7_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 1, c7_c_y);
  c7_c_hoistedGlobal = *c7_chidot_d;
  c7_c_u = c7_c_hoistedGlobal;
  c7_d_y = NULL;
  sf_mex_assign(&c7_d_y, sf_mex_create("y", &c7_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 2, c7_d_y);
  c7_d_hoistedGlobal = *c7_psiddot_d;
  c7_d_u = c7_d_hoistedGlobal;
  c7_e_y = NULL;
  sf_mex_assign(&c7_e_y, sf_mex_create("y", &c7_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 3, c7_e_y);
  c7_e_hoistedGlobal = chartInstance->c7_betaprev_d;
  c7_e_u = c7_e_hoistedGlobal;
  c7_f_y = NULL;
  if (!chartInstance->c7_betaprev_d_not_empty) {
    sf_mex_assign(&c7_f_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c7_f_y, sf_mex_create("y", &c7_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c7_y, 4, c7_f_y);
  c7_f_hoistedGlobal = chartInstance->c7_chiprev;
  c7_f_u = c7_f_hoistedGlobal;
  c7_g_y = NULL;
  if (!chartInstance->c7_chiprev_not_empty) {
    sf_mex_assign(&c7_g_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c7_g_y, sf_mex_create("y", &c7_f_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c7_y, 5, c7_g_y);
  c7_g_hoistedGlobal = chartInstance->c7_chiprev_d;
  c7_g_u = c7_g_hoistedGlobal;
  c7_h_y = NULL;
  if (!chartInstance->c7_chiprev_d_not_empty) {
    sf_mex_assign(&c7_h_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c7_h_y, sf_mex_create("y", &c7_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c7_y, 6, c7_h_y);
  c7_h_hoistedGlobal = chartInstance->c7_psidotprev_d;
  c7_h_u = c7_h_hoistedGlobal;
  c7_i_y = NULL;
  if (!chartInstance->c7_psidotprev_d_not_empty) {
    sf_mex_assign(&c7_i_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c7_i_y, sf_mex_create("y", &c7_h_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c7_y, 7, c7_i_y);
  c7_i_hoistedGlobal = chartInstance->c7_is_active_c7_carsim;
  c7_i_u = c7_i_hoistedGlobal;
  c7_j_y = NULL;
  sf_mex_assign(&c7_j_y, sf_mex_create("y", &c7_i_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 8, c7_j_y);
  sf_mex_assign(&c7_st, c7_y, FALSE);
  return c7_st;
}

static void set_sim_state_c7_carsim(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_st)
{
  const mxArray *c7_u;
  real_T *c7_betadot_d;
  real_T *c7_chidot;
  real_T *c7_chidot_d;
  real_T *c7_psiddot_d;
  c7_psiddot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c7_chidot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c7_chidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c7_betadot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c7_doneDoubleBufferReInit = TRUE;
  c7_u = sf_mex_dup(c7_st);
  *c7_betadot_d = c7_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c7_u, 0)), "betadot_d");
  *c7_chidot = c7_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c7_u, 1)), "chidot");
  *c7_chidot_d = c7_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c7_u, 2)), "chidot_d");
  *c7_psiddot_d = c7_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c7_u, 3)), "psiddot_d");
  chartInstance->c7_betaprev_d = c7_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c7_u, 4)), "betaprev_d");
  chartInstance->c7_chiprev = c7_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c7_u, 5)), "chiprev");
  chartInstance->c7_chiprev_d = c7_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c7_u, 6)), "chiprev_d");
  chartInstance->c7_psidotprev_d = c7_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c7_u, 7)), "psidotprev_d");
  chartInstance->c7_is_active_c7_carsim = c7_n_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c7_u, 8)), "is_active_c7_carsim");
  sf_mex_destroy(&c7_u);
  c7_update_debugger_state_c7_carsim(chartInstance);
  sf_mex_destroy(&c7_st);
}

static void finalize_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
}

static void sf_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
  int32_T c7_i0;
  real_T *c7_psi;
  real_T *c7_chi_d;
  real_T *c7_betadot_d;
  real_T *c7_chidot_d;
  real_T *c7_beta_d;
  real_T *c7_chidot;
  real_T *c7_psiddot_d;
  real_T *c7_psidot_d;
  real_T (*c7_v_inertial)[3];
  c7_psidot_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c7_psiddot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c7_chidot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c7_v_inertial = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c7_beta_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c7_chidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c7_betadot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c7_chi_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c7_psi = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 4U, chartInstance->c7_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c7_psi, 0U);
  _SFD_DATA_RANGE_CHECK(*c7_chi_d, 1U);
  _SFD_DATA_RANGE_CHECK(*c7_betadot_d, 2U);
  _SFD_DATA_RANGE_CHECK(*c7_chidot_d, 3U);
  _SFD_DATA_RANGE_CHECK(*c7_beta_d, 4U);
  for (c7_i0 = 0; c7_i0 < 3; c7_i0++) {
    _SFD_DATA_RANGE_CHECK((*c7_v_inertial)[c7_i0], 5U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c7_psi0, 6U);
  _SFD_DATA_RANGE_CHECK(*c7_chidot, 7U);
  _SFD_DATA_RANGE_CHECK(*c7_psiddot_d, 8U);
  _SFD_DATA_RANGE_CHECK(*c7_psidot_d, 9U);
  chartInstance->c7_sfEvent = CALL_EVENT;
  c7_chartstep_c7_carsim(chartInstance);
  sf_debug_check_for_state_inconsistency(_carsimMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c7_chartstep_c7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
  real_T c7_hoistedGlobal;
  real_T c7_b_hoistedGlobal;
  real_T c7_c_hoistedGlobal;
  real_T c7_d_hoistedGlobal;
  real_T c7_e_hoistedGlobal;
  real_T c7_psi;
  real_T c7_chi_d;
  real_T c7_beta_d;
  int32_T c7_i1;
  real_T c7_v_inertial[3];
  real_T c7_b_psi0;
  real_T c7_psidot_d;
  uint32_T c7_debug_family_var_map[19];
  real_T c7_R_z[9];
  real_T c7_v_body[3];
  real_T c7_beta;
  real_T c7_nargin = 6.0;
  real_T c7_nargout = 4.0;
  real_T c7_betadot_d;
  real_T c7_chidot_d;
  real_T c7_chidot;
  real_T c7_psiddot_d;
  real_T c7_x;
  real_T c7_b_x;
  real_T c7_c_x;
  real_T c7_d_x;
  real_T c7_e_x;
  real_T c7_f_x;
  real_T c7_g_x;
  real_T c7_h_x;
  int32_T c7_i2;
  int32_T c7_i3;
  real_T c7_a[9];
  int32_T c7_i4;
  real_T c7_b[3];
  int32_T c7_i5;
  int32_T c7_i6;
  int32_T c7_i7;
  real_T c7_C[3];
  int32_T c7_i8;
  int32_T c7_i9;
  int32_T c7_i10;
  int32_T c7_i11;
  int32_T c7_i12;
  int32_T c7_i13;
  real_T c7_y;
  real_T c7_i_x;
  real_T c7_b_y;
  real_T c7_j_x;
  real_T c7_f_hoistedGlobal;
  real_T c7_A;
  real_T c7_k_x;
  real_T c7_l_x;
  real_T c7_g_hoistedGlobal;
  real_T c7_b_A;
  real_T c7_m_x;
  real_T c7_n_x;
  real_T c7_h_hoistedGlobal;
  real_T c7_c_A;
  real_T c7_o_x;
  real_T c7_p_x;
  real_T c7_i_hoistedGlobal;
  real_T c7_d_A;
  real_T c7_q_x;
  real_T c7_r_x;
  real_T *c7_b_psi;
  real_T *c7_b_chi_d;
  real_T *c7_b_beta_d;
  real_T *c7_b_psidot_d;
  real_T *c7_b_betadot_d;
  real_T *c7_b_chidot_d;
  real_T *c7_b_chidot;
  real_T *c7_b_psiddot_d;
  real_T (*c7_b_v_inertial)[3];
  c7_b_psidot_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c7_b_psiddot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c7_b_chidot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c7_b_v_inertial = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c7_b_beta_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c7_b_chidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c7_b_betadot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c7_b_chi_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c7_b_psi = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 4U, chartInstance->c7_sfEvent);
  c7_hoistedGlobal = *c7_b_psi;
  c7_b_hoistedGlobal = *c7_b_chi_d;
  c7_c_hoistedGlobal = *c7_b_beta_d;
  c7_d_hoistedGlobal = chartInstance->c7_psi0;
  c7_e_hoistedGlobal = *c7_b_psidot_d;
  c7_psi = c7_hoistedGlobal;
  c7_chi_d = c7_b_hoistedGlobal;
  c7_beta_d = c7_c_hoistedGlobal;
  for (c7_i1 = 0; c7_i1 < 3; c7_i1++) {
    c7_v_inertial[c7_i1] = (*c7_b_v_inertial)[c7_i1];
  }

  c7_b_psi0 = c7_d_hoistedGlobal;
  c7_psidot_d = c7_e_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 19U, 19U, c7_debug_family_names,
    c7_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c7_R_z, 0U, c7_g_sf_marshallOut,
    c7_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_v_body, 1U, c7_f_sf_marshallOut,
    c7_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_beta, 2U, c7_e_sf_marshallOut,
    c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargin, 3U, c7_e_sf_marshallOut,
    c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargout, 4U, c7_e_sf_marshallOut,
    c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c7_psi, 5U, c7_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c7_chi_d, 6U, c7_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c7_beta_d, 7U, c7_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c7_v_inertial, 8U, c7_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_psi0, 9U, c7_e_sf_marshallOut,
    c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c7_psidot_d, 10U, c7_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c7_betadot_d, 11U,
    c7_e_sf_marshallOut, c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_chidot_d, 12U,
    c7_e_sf_marshallOut, c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_chidot, 13U, c7_e_sf_marshallOut,
    c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_psiddot_d, 14U,
    c7_e_sf_marshallOut, c7_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c7_betaprev_d, 15U,
    c7_d_sf_marshallOut, c7_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c7_chiprev_d, 16U,
    c7_c_sf_marshallOut, c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c7_chiprev, 17U,
    c7_b_sf_marshallOut, c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c7_psidotprev_d, 18U,
    c7_sf_marshallOut, c7_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 7);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c7_betaprev_d_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 8);
    chartInstance->c7_betaprev_d = 0.0;
    chartInstance->c7_betaprev_d_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 9);
    chartInstance->c7_chiprev_d = c7_b_psi0;
    chartInstance->c7_chiprev_d_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 10);
    chartInstance->c7_chiprev = c7_b_psi0;
    chartInstance->c7_chiprev_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 11);
    chartInstance->c7_psidotprev_d = 0.0;
    chartInstance->c7_psidotprev_d_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 15);
  c7_x = c7_psi;
  c7_b_x = c7_x;
  c7_b_x = muDoubleScalarCos(c7_b_x);
  c7_c_x = c7_psi;
  c7_d_x = c7_c_x;
  c7_d_x = muDoubleScalarSin(c7_d_x);
  c7_e_x = c7_psi;
  c7_f_x = c7_e_x;
  c7_f_x = muDoubleScalarSin(c7_f_x);
  c7_g_x = c7_psi;
  c7_h_x = c7_g_x;
  c7_h_x = muDoubleScalarCos(c7_h_x);
  c7_R_z[0] = c7_b_x;
  c7_R_z[1] = -c7_d_x;
  c7_R_z[2] = 0.0;
  c7_R_z[3] = c7_f_x;
  c7_R_z[4] = c7_h_x;
  c7_R_z[5] = 0.0;
  for (c7_i2 = 0; c7_i2 < 3; c7_i2++) {
    c7_R_z[c7_i2 + 6] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 20);
  for (c7_i3 = 0; c7_i3 < 9; c7_i3++) {
    c7_a[c7_i3] = c7_R_z[c7_i3];
  }

  for (c7_i4 = 0; c7_i4 < 3; c7_i4++) {
    c7_b[c7_i4] = c7_v_inertial[c7_i4];
  }

  c7_eml_scalar_eg(chartInstance);
  c7_eml_scalar_eg(chartInstance);
  for (c7_i5 = 0; c7_i5 < 3; c7_i5++) {
    c7_v_body[c7_i5] = 0.0;
  }

  for (c7_i6 = 0; c7_i6 < 3; c7_i6++) {
    c7_v_body[c7_i6] = 0.0;
  }

  for (c7_i7 = 0; c7_i7 < 3; c7_i7++) {
    c7_C[c7_i7] = c7_v_body[c7_i7];
  }

  for (c7_i8 = 0; c7_i8 < 3; c7_i8++) {
    c7_v_body[c7_i8] = c7_C[c7_i8];
  }

  for (c7_i9 = 0; c7_i9 < 3; c7_i9++) {
    c7_C[c7_i9] = c7_v_body[c7_i9];
  }

  for (c7_i10 = 0; c7_i10 < 3; c7_i10++) {
    c7_v_body[c7_i10] = c7_C[c7_i10];
  }

  for (c7_i11 = 0; c7_i11 < 3; c7_i11++) {
    c7_v_body[c7_i11] = 0.0;
    c7_i12 = 0;
    for (c7_i13 = 0; c7_i13 < 3; c7_i13++) {
      c7_v_body[c7_i11] += c7_a[c7_i12 + c7_i11] * c7_b[c7_i13];
      c7_i12 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 23);
  c7_y = c7_v_body[1];
  c7_i_x = c7_v_body[0];
  c7_b_y = c7_y;
  c7_j_x = c7_i_x;
  c7_beta = muDoubleScalarAtan2(c7_b_y, c7_j_x);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 26);
  c7_f_hoistedGlobal = chartInstance->c7_betaprev_d;
  c7_A = c7_beta_d - c7_f_hoistedGlobal;
  c7_k_x = c7_A;
  c7_l_x = c7_k_x;
  c7_betadot_d = c7_l_x / 0.001;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 27);
  c7_g_hoistedGlobal = chartInstance->c7_chiprev_d;
  c7_b_A = c7_chi_d - c7_g_hoistedGlobal;
  c7_m_x = c7_b_A;
  c7_n_x = c7_m_x;
  c7_chidot_d = c7_n_x / 0.001;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 28);
  c7_h_hoistedGlobal = chartInstance->c7_chiprev;
  c7_c_A = (c7_psi + c7_beta) - c7_h_hoistedGlobal;
  c7_o_x = c7_c_A;
  c7_p_x = c7_o_x;
  c7_chidot = c7_p_x / 0.001;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 29);
  c7_i_hoistedGlobal = chartInstance->c7_psidotprev_d;
  c7_d_A = c7_psidot_d - c7_i_hoistedGlobal;
  c7_q_x = c7_d_A;
  c7_r_x = c7_q_x;
  c7_psiddot_d = c7_r_x / 0.001;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 32);
  chartInstance->c7_betaprev_d = c7_beta_d;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 33);
  chartInstance->c7_chiprev_d = c7_chi_d;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 34);
  chartInstance->c7_chiprev = c7_psi + c7_beta;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 35);
  chartInstance->c7_psidotprev_d = c7_psidot_d;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, -35);
  sf_debug_symbol_scope_pop();
  *c7_b_betadot_d = c7_betadot_d;
  *c7_b_chidot_d = c7_chidot_d;
  *c7_b_chidot = c7_chidot;
  *c7_b_psiddot_d = c7_psiddot_d;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 4U, chartInstance->c7_sfEvent);
}

static void initSimStructsc7_carsim(SFc7_carsimInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber)
{
}

static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  if (!chartInstance->c7_psidotprev_d_not_empty) {
    sf_mex_assign(&c7_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_psidotprev_d, const char_T *c7_identifier)
{
  real_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_psidotprev_d),
    &c7_thisId);
  sf_mex_destroy(&c7_b_psidotprev_d);
  return c7_y;
}

static real_T c7_b_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d1;
  if (mxIsEmpty(c7_u)) {
    chartInstance->c7_psidotprev_d_not_empty = FALSE;
  } else {
    chartInstance->c7_psidotprev_d_not_empty = TRUE;
    sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d1, 1, 0, 0U, 0, 0U, 0);
    c7_y = c7_d1;
  }

  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_psidotprev_d;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_b_psidotprev_d = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_psidotprev_d),
    &c7_thisId);
  sf_mex_destroy(&c7_b_psidotprev_d);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  if (!chartInstance->c7_chiprev_not_empty) {
    sf_mex_assign(&c7_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_c_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_chiprev, const char_T *c7_identifier)
{
  real_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_chiprev),
    &c7_thisId);
  sf_mex_destroy(&c7_b_chiprev);
  return c7_y;
}

static real_T c7_d_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d2;
  if (mxIsEmpty(c7_u)) {
    chartInstance->c7_chiprev_not_empty = FALSE;
  } else {
    chartInstance->c7_chiprev_not_empty = TRUE;
    sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d2, 1, 0, 0U, 0, 0U, 0);
    c7_y = c7_d2;
  }

  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_chiprev;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_b_chiprev = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_chiprev),
    &c7_thisId);
  sf_mex_destroy(&c7_b_chiprev);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  if (!chartInstance->c7_chiprev_d_not_empty) {
    sf_mex_assign(&c7_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_e_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_chiprev_d, const char_T *c7_identifier)
{
  real_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_chiprev_d),
    &c7_thisId);
  sf_mex_destroy(&c7_b_chiprev_d);
  return c7_y;
}

static real_T c7_f_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d3;
  if (mxIsEmpty(c7_u)) {
    chartInstance->c7_chiprev_d_not_empty = FALSE;
  } else {
    chartInstance->c7_chiprev_d_not_empty = TRUE;
    sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d3, 1, 0, 0U, 0, 0U, 0);
    c7_y = c7_d3;
  }

  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_chiprev_d;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_b_chiprev_d = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_chiprev_d),
    &c7_thisId);
  sf_mex_destroy(&c7_b_chiprev_d);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  if (!chartInstance->c7_betaprev_d_not_empty) {
    sf_mex_assign(&c7_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_g_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_betaprev_d, const char_T *c7_identifier)
{
  real_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_betaprev_d),
    &c7_thisId);
  sf_mex_destroy(&c7_b_betaprev_d);
  return c7_y;
}

static real_T c7_h_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d4;
  if (mxIsEmpty(c7_u)) {
    chartInstance->c7_betaprev_d_not_empty = FALSE;
  } else {
    chartInstance->c7_betaprev_d_not_empty = TRUE;
    sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d4, 1, 0, 0U, 0, 0U, 0);
    c7_y = c7_d4;
  }

  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_betaprev_d;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_b_betaprev_d = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_betaprev_d),
    &c7_thisId);
  sf_mex_destroy(&c7_b_betaprev_d);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_e_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_i_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_psiddot_d, const char_T *c7_identifier)
{
  real_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_psiddot_d),
    &c7_thisId);
  sf_mex_destroy(&c7_psiddot_d);
  return c7_y;
}

static real_T c7_j_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d5;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d5, 1, 0, 0U, 0, 0U, 0);
  c7_y = c7_d5;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_psiddot_d;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_psiddot_d = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_psiddot_d),
    &c7_thisId);
  sf_mex_destroy(&c7_psiddot_d);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_f_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i14;
  real_T c7_b_inData[3];
  int32_T c7_i15;
  real_T c7_u[3];
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i14 = 0; c7_i14 < 3; c7_i14++) {
    c7_b_inData[c7_i14] = (*(real_T (*)[3])c7_inData)[c7_i14];
  }

  for (c7_i15 = 0; c7_i15 < 3; c7_i15++) {
    c7_u[c7_i15] = c7_b_inData[c7_i15];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_k_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[3])
{
  real_T c7_dv0[3];
  int32_T c7_i16;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv0, 1, 0, 0U, 1, 0U, 1, 3);
  for (c7_i16 = 0; c7_i16 < 3; c7_i16++) {
    c7_y[c7_i16] = c7_dv0[c7_i16];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_v_body;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[3];
  int32_T c7_i17;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_v_body = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_k_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_v_body), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_v_body);
  for (c7_i17 = 0; c7_i17 < 3; c7_i17++) {
    (*(real_T (*)[3])c7_outData)[c7_i17] = c7_y[c7_i17];
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_g_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i18;
  int32_T c7_i19;
  int32_T c7_i20;
  real_T c7_b_inData[9];
  int32_T c7_i21;
  int32_T c7_i22;
  int32_T c7_i23;
  real_T c7_u[9];
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i18 = 0;
  for (c7_i19 = 0; c7_i19 < 3; c7_i19++) {
    for (c7_i20 = 0; c7_i20 < 3; c7_i20++) {
      c7_b_inData[c7_i20 + c7_i18] = (*(real_T (*)[9])c7_inData)[c7_i20 + c7_i18];
    }

    c7_i18 += 3;
  }

  c7_i21 = 0;
  for (c7_i22 = 0; c7_i22 < 3; c7_i22++) {
    for (c7_i23 = 0; c7_i23 < 3; c7_i23++) {
      c7_u[c7_i23 + c7_i21] = c7_b_inData[c7_i23 + c7_i21];
    }

    c7_i21 += 3;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_l_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[9])
{
  real_T c7_dv1[9];
  int32_T c7_i24;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv1, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c7_i24 = 0; c7_i24 < 9; c7_i24++) {
    c7_y[c7_i24] = c7_dv1[c7_i24];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_R_z;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[9];
  int32_T c7_i25;
  int32_T c7_i26;
  int32_T c7_i27;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_R_z = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_R_z), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_R_z);
  c7_i25 = 0;
  for (c7_i26 = 0; c7_i26 < 3; c7_i26++) {
    for (c7_i27 = 0; c7_i27 < 3; c7_i27++) {
      (*(real_T (*)[9])c7_outData)[c7_i27 + c7_i25] = c7_y[c7_i27 + c7_i25];
    }

    c7_i25 += 3;
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

const mxArray *sf_c7_carsim_get_eml_resolved_functions_info(void)
{
  const mxArray *c7_nameCaptureInfo;
  c7_ResolvedFunctionInfo c7_info[16];
  const mxArray *c7_m0 = NULL;
  int32_T c7_i28;
  c7_ResolvedFunctionInfo *c7_r0;
  c7_nameCaptureInfo = NULL;
  c7_nameCaptureInfo = NULL;
  c7_info_helper(c7_info);
  sf_mex_assign(&c7_m0, sf_mex_createstruct("nameCaptureInfo", 1, 16), FALSE);
  for (c7_i28 = 0; c7_i28 < 16; c7_i28++) {
    c7_r0 = &c7_info[c7_i28];
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->context)), "context", "nameCaptureInfo",
                    c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c7_r0->name)), "name", "nameCaptureInfo", c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c7_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->resolved)), "resolved", "nameCaptureInfo",
                    c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c7_i28);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c7_i28);
  }

  sf_mex_assign(&c7_nameCaptureInfo, c7_m0, FALSE);
  return c7_nameCaptureInfo;
}

static void c7_info_helper(c7_ResolvedFunctionInfo c7_info[16])
{
  c7_info[0].context = "";
  c7_info[0].name = "cos";
  c7_info[0].dominantType = "double";
  c7_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c7_info[0].fileTimeLo = 1286818706U;
  c7_info[0].fileTimeHi = 0U;
  c7_info[0].mFileTimeLo = 0U;
  c7_info[0].mFileTimeHi = 0U;
  c7_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c7_info[1].name = "eml_scalar_cos";
  c7_info[1].dominantType = "double";
  c7_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c7_info[1].fileTimeLo = 1286818722U;
  c7_info[1].fileTimeHi = 0U;
  c7_info[1].mFileTimeLo = 0U;
  c7_info[1].mFileTimeHi = 0U;
  c7_info[2].context = "";
  c7_info[2].name = "sin";
  c7_info[2].dominantType = "double";
  c7_info[2].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c7_info[2].fileTimeLo = 1286818750U;
  c7_info[2].fileTimeHi = 0U;
  c7_info[2].mFileTimeLo = 0U;
  c7_info[2].mFileTimeHi = 0U;
  c7_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c7_info[3].name = "eml_scalar_sin";
  c7_info[3].dominantType = "double";
  c7_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c7_info[3].fileTimeLo = 1286818736U;
  c7_info[3].fileTimeHi = 0U;
  c7_info[3].mFileTimeLo = 0U;
  c7_info[3].mFileTimeHi = 0U;
  c7_info[4].context = "";
  c7_info[4].name = "mtimes";
  c7_info[4].dominantType = "double";
  c7_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[4].fileTimeLo = 1289519692U;
  c7_info[4].fileTimeHi = 0U;
  c7_info[4].mFileTimeLo = 0U;
  c7_info[4].mFileTimeHi = 0U;
  c7_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[5].name = "eml_index_class";
  c7_info[5].dominantType = "";
  c7_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[5].fileTimeLo = 1286818778U;
  c7_info[5].fileTimeHi = 0U;
  c7_info[5].mFileTimeLo = 0U;
  c7_info[5].mFileTimeHi = 0U;
  c7_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[6].name = "eml_scalar_eg";
  c7_info[6].dominantType = "double";
  c7_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[6].fileTimeLo = 1286818796U;
  c7_info[6].fileTimeHi = 0U;
  c7_info[6].mFileTimeLo = 0U;
  c7_info[6].mFileTimeHi = 0U;
  c7_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[7].name = "eml_xgemm";
  c7_info[7].dominantType = "int32";
  c7_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c7_info[7].fileTimeLo = 1299076772U;
  c7_info[7].fileTimeHi = 0U;
  c7_info[7].mFileTimeLo = 0U;
  c7_info[7].mFileTimeHi = 0U;
  c7_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c7_info[8].name = "eml_blas_inline";
  c7_info[8].dominantType = "";
  c7_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c7_info[8].fileTimeLo = 1299076768U;
  c7_info[8].fileTimeHi = 0U;
  c7_info[8].mFileTimeLo = 0U;
  c7_info[8].mFileTimeHi = 0U;
  c7_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c7_info[9].name = "eml_refblas_xgemm";
  c7_info[9].dominantType = "int32";
  c7_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c7_info[9].fileTimeLo = 1299076774U;
  c7_info[9].fileTimeHi = 0U;
  c7_info[9].mFileTimeLo = 0U;
  c7_info[9].mFileTimeHi = 0U;
  c7_info[10].context = "";
  c7_info[10].name = "atan2";
  c7_info[10].dominantType = "double";
  c7_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c7_info[10].fileTimeLo = 1286818704U;
  c7_info[10].fileTimeHi = 0U;
  c7_info[10].mFileTimeLo = 0U;
  c7_info[10].mFileTimeHi = 0U;
  c7_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c7_info[11].name = "eml_scalexp_alloc";
  c7_info[11].dominantType = "double";
  c7_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c7_info[11].fileTimeLo = 1286818796U;
  c7_info[11].fileTimeHi = 0U;
  c7_info[11].mFileTimeLo = 0U;
  c7_info[11].mFileTimeHi = 0U;
  c7_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c7_info[12].name = "eml_scalar_atan2";
  c7_info[12].dominantType = "double";
  c7_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c7_info[12].fileTimeLo = 1286818720U;
  c7_info[12].fileTimeHi = 0U;
  c7_info[12].mFileTimeLo = 0U;
  c7_info[12].mFileTimeHi = 0U;
  c7_info[13].context = "";
  c7_info[13].name = "mrdivide";
  c7_info[13].dominantType = "double";
  c7_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c7_info[13].fileTimeLo = 1310137456U;
  c7_info[13].fileTimeHi = 0U;
  c7_info[13].mFileTimeLo = 1289519692U;
  c7_info[13].mFileTimeHi = 0U;
  c7_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c7_info[14].name = "rdivide";
  c7_info[14].dominantType = "double";
  c7_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c7_info[14].fileTimeLo = 1286818844U;
  c7_info[14].fileTimeHi = 0U;
  c7_info[14].mFileTimeLo = 0U;
  c7_info[14].mFileTimeHi = 0U;
  c7_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c7_info[15].name = "eml_div";
  c7_info[15].dominantType = "double";
  c7_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c7_info[15].fileTimeLo = 1305318000U;
  c7_info[15].fileTimeHi = 0U;
  c7_info[15].mFileTimeLo = 0U;
  c7_info[15].mFileTimeHi = 0U;
}

static void c7_eml_scalar_eg(SFc7_carsimInstanceStruct *chartInstance)
{
}

static const mxArray *c7_h_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(int32_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static int32_T c7_m_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  int32_T c7_y;
  int32_T c7_i29;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_i29, 1, 6, 0U, 0, 0U, 0);
  c7_y = c7_i29;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_sfEvent;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  int32_T c7_y;
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)chartInstanceVoid;
  c7_b_sfEvent = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_m_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_sfEvent),
    &c7_thisId);
  sf_mex_destroy(&c7_b_sfEvent);
  *(int32_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static uint8_T c7_n_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_b_is_active_c7_carsim, const char_T *c7_identifier)
{
  uint8_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_o_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c7_b_is_active_c7_carsim), &c7_thisId);
  sf_mex_destroy(&c7_b_is_active_c7_carsim);
  return c7_y;
}

static uint8_T c7_o_emlrt_marshallIn(SFc7_carsimInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  uint8_T c7_y;
  uint8_T c7_u0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_u0, 1, 3, 0U, 0, 0U, 0);
  c7_y = c7_u0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void init_dsm_address_info(SFc7_carsimInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c7_carsim_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2451666628U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(523793284U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(465329210U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2517167471U);
}

mxArray *sf_c7_carsim_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("YaOCJSfjcto0CvAlkIIQMB");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c7_carsim(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x9'type','srcId','name','auxInfo'{{M[1],M[33],T\"betadot_d\",},{M[1],M[76],T\"chidot\",},{M[1],M[90],T\"chidot_d\",},{M[1],M[87],T\"psiddot_d\",},{M[4],M[0],T\"betaprev_d\",S'l','i','p'{{M1x2[124 134],M[0],}}},{M[4],M[0],T\"chiprev\",S'l','i','p'{{M1x2[167 174],M[0],}}},{M[4],M[0],T\"chiprev_d\",S'l','i','p'{{M1x2[146 155],M[0],}}},{M[4],M[0],T\"psidotprev_d\",S'l','i','p'{{M1x2[186 198],M[0],}}},{M[8],M[0],T\"is_active_c7_carsim\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 9, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c7_carsim_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc7_carsimInstanceStruct *chartInstance;
    chartInstance = (SFc7_carsimInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_carsimMachineNumber_,
          7,
          1,
          1,
          10,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_carsimMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_carsimMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_carsimMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"psi");
          _SFD_SET_DATA_PROPS(1,1,1,0,"chi_d");
          _SFD_SET_DATA_PROPS(2,2,0,1,"betadot_d");
          _SFD_SET_DATA_PROPS(3,2,0,1,"chidot_d");
          _SFD_SET_DATA_PROPS(4,1,1,0,"beta_d");
          _SFD_SET_DATA_PROPS(5,1,1,0,"v_inertial");
          _SFD_SET_DATA_PROPS(6,10,0,0,"psi0");
          _SFD_SET_DATA_PROPS(7,2,0,1,"chidot");
          _SFD_SET_DATA_PROPS(8,2,0,1,"psiddot_d");
          _SFD_SET_DATA_PROPS(9,1,1,0,"psidot_d");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,925);
        _SFD_CV_INIT_EML_IF(0,1,0,199,221,-1,309);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)c7_e_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)c7_e_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)c7_e_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)c7_e_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)c7_e_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c7_psi;
          real_T *c7_chi_d;
          real_T *c7_betadot_d;
          real_T *c7_chidot_d;
          real_T *c7_beta_d;
          real_T *c7_chidot;
          real_T *c7_psiddot_d;
          real_T *c7_psidot_d;
          real_T (*c7_v_inertial)[3];
          c7_psidot_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c7_psiddot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c7_chidot = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c7_v_inertial = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S,
            3);
          c7_beta_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c7_chidot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c7_betadot_d = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c7_chi_d = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c7_psi = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c7_psi);
          _SFD_SET_DATA_VALUE_PTR(1U, c7_chi_d);
          _SFD_SET_DATA_VALUE_PTR(2U, c7_betadot_d);
          _SFD_SET_DATA_VALUE_PTR(3U, c7_chidot_d);
          _SFD_SET_DATA_VALUE_PTR(4U, c7_beta_d);
          _SFD_SET_DATA_VALUE_PTR(5U, *c7_v_inertial);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance->c7_psi0);
          _SFD_SET_DATA_VALUE_PTR(7U, c7_chidot);
          _SFD_SET_DATA_VALUE_PTR(8U, c7_psiddot_d);
          _SFD_SET_DATA_VALUE_PTR(9U, c7_psidot_d);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_carsimMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c7_carsim(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc7_carsimInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
  initialize_c7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c7_carsim(void *chartInstanceVar)
{
  enable_c7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c7_carsim(void *chartInstanceVar)
{
  disable_c7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c7_carsim(void *chartInstanceVar)
{
  sf_c7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c7_carsim(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c7_carsim((SFc7_carsimInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c7_carsim(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_carsim();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c7_carsim((SFc7_carsimInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c7_carsim(SimStruct* S)
{
  return sf_internal_get_sim_state_c7_carsim(S);
}

static void sf_opaque_set_sim_state_c7_carsim(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c7_carsim(S, st);
}

static void sf_opaque_terminate_c7_carsim(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc7_carsimInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_carsim_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc7_carsim((SFc7_carsimInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c7_carsim(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c7_carsim((SFc7_carsimInstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c7_carsim(SimStruct *S)
{
  /* Actual parameters from chart:
     psi0
   */
  const char_T *rtParamNames[] = { "p1" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for psi0*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_carsim_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,7);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,7,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,7,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,7,5);
      sf_mark_chart_reusable_outputs(S,infoStruct,7,4);
    }

    sf_set_rtw_dwork_info(S,infoStruct,7);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(600120470U));
  ssSetChecksum1(S,(2992348925U));
  ssSetChecksum2(S,(3272286393U));
  ssSetChecksum3(S,(3737037796U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c7_carsim(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c7_carsim(SimStruct *S)
{
  SFc7_carsimInstanceStruct *chartInstance;
  chartInstance = (SFc7_carsimInstanceStruct *)malloc(sizeof
    (SFc7_carsimInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc7_carsimInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c7_carsim;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c7_carsim;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c7_carsim;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c7_carsim;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c7_carsim;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c7_carsim;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c7_carsim;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c7_carsim;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c7_carsim;
  chartInstance->chartInfo.mdlStart = mdlStart_c7_carsim;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c7_carsim;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c7_carsim_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c7_carsim(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c7_carsim(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c7_carsim(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c7_carsim_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
