#ifndef __c9_carsim_h__
#define __c9_carsim_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c9_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  real_T c9_I_x;
  real_T c9_I_y;
  real_T c9_I_z;
  real_T c9_a1prev;
  int32_T c9_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c9_a1prev_not_empty;
  boolean_T c9_doneDoubleBufferReInit;
  boolean_T c9_isStable;
  uint8_T c9_is_active_c9_carsim;
  ChartInfoStruct chartInfo;
} SFc9_carsimInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c9_carsim_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c9_carsim_get_check_sum(mxArray *plhs[]);
extern void c9_carsim_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
