/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c10_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c10_debug_family_names[32] = { "Fz_fl", "Fz_fr", "Fz_rl",
  "Fz_rr", "my_long_fl", "my_long_fr", "my_long_rl", "my_long_rr", "my_lat_fl",
  "my_lat_fr", "my_lat_rl", "my_lat_rr", "alpha_fl", "alpha_fr", "alpha_rl",
  "alpha_rr", "R_fl", "R_fr", "R_rl", "R_rr", "F_friction_fl", "F_friction_fr",
  "F_friction_rl", "F_friction_rr", "nargin", "nargout", "Fz_wheel", "my_long",
  "my_lat", "alpha", "Fx_wheel", "Fy_wheel" };

/* Function Declarations */
static void initialize_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void initialize_params_c10_ref_gen(SFc10_ref_genInstanceStruct
  *chartInstance);
static void enable_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void disable_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void c10_update_debugger_state_c10_ref_gen(SFc10_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c10_ref_gen(SFc10_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_st);
static void finalize_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void sf_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void c10_chartstep_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void initSimStructsc10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber);
static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_Fy_wheel, const char_T *c10_identifier, real_T c10_y[4]);
static void c10_b_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[4]);
static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static real_T c10_c_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_d_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[2]);
static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_d_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_e_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[4]);
static void c10_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static void c10_eml_scalar_eg(SFc10_ref_genInstanceStruct *chartInstance);
static const mxArray *c10_e_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static int32_T c10_f_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static uint8_T c10_g_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_b_is_active_c10_ref_gen, const char_T *c10_identifier);
static uint8_T c10_h_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void init_dsm_address_info(SFc10_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c10_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c10_is_active_c10_ref_gen = 0U;
}

static void initialize_params_c10_ref_gen(SFc10_ref_genInstanceStruct
  *chartInstance)
{
}

static void enable_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c10_update_debugger_state_c10_ref_gen(SFc10_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c10_ref_gen(SFc10_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c10_st;
  const mxArray *c10_y = NULL;
  int32_T c10_i0;
  real_T c10_u[4];
  const mxArray *c10_b_y = NULL;
  int32_T c10_i1;
  real_T c10_b_u[4];
  const mxArray *c10_c_y = NULL;
  uint8_T c10_hoistedGlobal;
  uint8_T c10_c_u;
  const mxArray *c10_d_y = NULL;
  real_T (*c10_Fy_wheel)[4];
  real_T (*c10_Fx_wheel)[4];
  c10_Fy_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_Fx_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_st = NULL;
  c10_st = NULL;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_createcellarray(3), FALSE);
  for (c10_i0 = 0; c10_i0 < 4; c10_i0++) {
    c10_u[c10_i0] = (*c10_Fx_wheel)[c10_i0];
  }

  c10_b_y = NULL;
  sf_mex_assign(&c10_b_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c10_y, 0, c10_b_y);
  for (c10_i1 = 0; c10_i1 < 4; c10_i1++) {
    c10_b_u[c10_i1] = (*c10_Fy_wheel)[c10_i1];
  }

  c10_c_y = NULL;
  sf_mex_assign(&c10_c_y, sf_mex_create("y", c10_b_u, 0, 0U, 1U, 0U, 1, 4),
                FALSE);
  sf_mex_setcell(c10_y, 1, c10_c_y);
  c10_hoistedGlobal = chartInstance->c10_is_active_c10_ref_gen;
  c10_c_u = c10_hoistedGlobal;
  c10_d_y = NULL;
  sf_mex_assign(&c10_d_y, sf_mex_create("y", &c10_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c10_y, 2, c10_d_y);
  sf_mex_assign(&c10_st, c10_y, FALSE);
  return c10_st;
}

static void set_sim_state_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_st)
{
  const mxArray *c10_u;
  real_T c10_dv0[4];
  int32_T c10_i2;
  real_T c10_dv1[4];
  int32_T c10_i3;
  real_T (*c10_Fx_wheel)[4];
  real_T (*c10_Fy_wheel)[4];
  c10_Fy_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_Fx_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c10_doneDoubleBufferReInit = TRUE;
  c10_u = sf_mex_dup(c10_st);
  c10_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 0)),
                       "Fx_wheel", c10_dv0);
  for (c10_i2 = 0; c10_i2 < 4; c10_i2++) {
    (*c10_Fx_wheel)[c10_i2] = c10_dv0[c10_i2];
  }

  c10_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 1)),
                       "Fy_wheel", c10_dv1);
  for (c10_i3 = 0; c10_i3 < 4; c10_i3++) {
    (*c10_Fy_wheel)[c10_i3] = c10_dv1[c10_i3];
  }

  chartInstance->c10_is_active_c10_ref_gen = c10_g_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 2)),
     "is_active_c10_ref_gen");
  sf_mex_destroy(&c10_u);
  c10_update_debugger_state_c10_ref_gen(chartInstance);
  sf_mex_destroy(&c10_st);
}

static void finalize_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
  int32_T c10_i4;
  int32_T c10_i5;
  int32_T c10_i6;
  int32_T c10_i7;
  int32_T c10_i8;
  int32_T c10_i9;
  real_T (*c10_alpha)[4];
  real_T (*c10_Fy_wheel)[4];
  real_T (*c10_Fx_wheel)[4];
  real_T (*c10_my_lat)[4];
  real_T (*c10_my_long)[4];
  real_T (*c10_Fz_wheel)[4];
  c10_alpha = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c10_Fy_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_Fx_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_my_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c10_my_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c10_Fz_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 8U, chartInstance->c10_sfEvent);
  for (c10_i4 = 0; c10_i4 < 4; c10_i4++) {
    _SFD_DATA_RANGE_CHECK((*c10_Fz_wheel)[c10_i4], 0U);
  }

  for (c10_i5 = 0; c10_i5 < 4; c10_i5++) {
    _SFD_DATA_RANGE_CHECK((*c10_my_long)[c10_i5], 1U);
  }

  for (c10_i6 = 0; c10_i6 < 4; c10_i6++) {
    _SFD_DATA_RANGE_CHECK((*c10_my_lat)[c10_i6], 2U);
  }

  for (c10_i7 = 0; c10_i7 < 4; c10_i7++) {
    _SFD_DATA_RANGE_CHECK((*c10_Fx_wheel)[c10_i7], 3U);
  }

  for (c10_i8 = 0; c10_i8 < 4; c10_i8++) {
    _SFD_DATA_RANGE_CHECK((*c10_Fy_wheel)[c10_i8], 4U);
  }

  for (c10_i9 = 0; c10_i9 < 4; c10_i9++) {
    _SFD_DATA_RANGE_CHECK((*c10_alpha)[c10_i9], 5U);
  }

  chartInstance->c10_sfEvent = CALL_EVENT;
  c10_chartstep_c10_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c10_chartstep_c10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
  int32_T c10_i10;
  real_T c10_Fz_wheel[4];
  int32_T c10_i11;
  real_T c10_my_long[4];
  int32_T c10_i12;
  real_T c10_my_lat[4];
  int32_T c10_i13;
  real_T c10_alpha[4];
  uint32_T c10_debug_family_var_map[32];
  real_T c10_Fz_fl;
  real_T c10_Fz_fr;
  real_T c10_Fz_rl;
  real_T c10_Fz_rr;
  real_T c10_my_long_fl;
  real_T c10_my_long_fr;
  real_T c10_my_long_rl;
  real_T c10_my_long_rr;
  real_T c10_my_lat_fl;
  real_T c10_my_lat_fr;
  real_T c10_my_lat_rl;
  real_T c10_my_lat_rr;
  real_T c10_alpha_fl;
  real_T c10_alpha_fr;
  real_T c10_alpha_rl;
  real_T c10_alpha_rr;
  real_T c10_R_fl[4];
  real_T c10_R_fr[4];
  real_T c10_R_rl[4];
  real_T c10_R_rr[4];
  real_T c10_F_friction_fl[2];
  real_T c10_F_friction_fr[2];
  real_T c10_F_friction_rl[2];
  real_T c10_F_friction_rr[2];
  real_T c10_nargin = 4.0;
  real_T c10_nargout = 2.0;
  real_T c10_Fx_wheel[4];
  real_T c10_Fy_wheel[4];
  real_T c10_x;
  real_T c10_b_x;
  real_T c10_c_x;
  real_T c10_d_x;
  real_T c10_e_x;
  real_T c10_f_x;
  real_T c10_g_x;
  real_T c10_h_x;
  real_T c10_i_x;
  real_T c10_j_x;
  real_T c10_k_x;
  real_T c10_l_x;
  real_T c10_m_x;
  real_T c10_n_x;
  real_T c10_o_x;
  real_T c10_p_x;
  real_T c10_q_x;
  real_T c10_r_x;
  real_T c10_s_x;
  real_T c10_t_x;
  real_T c10_u_x;
  real_T c10_v_x;
  real_T c10_w_x;
  real_T c10_x_x;
  real_T c10_y_x;
  real_T c10_ab_x;
  real_T c10_bb_x;
  real_T c10_cb_x;
  real_T c10_db_x;
  real_T c10_eb_x;
  real_T c10_fb_x;
  real_T c10_gb_x;
  real_T c10_a;
  real_T c10_b;
  real_T c10_y;
  real_T c10_b_a;
  real_T c10_b_b;
  real_T c10_b_y;
  int32_T c10_i14;
  real_T c10_c_a[4];
  real_T c10_c_y[2];
  int32_T c10_i15;
  real_T c10_c_b[2];
  int32_T c10_i16;
  int32_T c10_i17;
  int32_T c10_i18;
  real_T c10_C[2];
  int32_T c10_i19;
  int32_T c10_i20;
  int32_T c10_i21;
  int32_T c10_i22;
  int32_T c10_i23;
  int32_T c10_i24;
  real_T c10_d_a;
  real_T c10_d_b;
  real_T c10_d_y;
  real_T c10_e_a;
  real_T c10_e_b;
  real_T c10_e_y;
  int32_T c10_i25;
  real_T c10_f_y[2];
  int32_T c10_i26;
  int32_T c10_i27;
  int32_T c10_i28;
  int32_T c10_i29;
  int32_T c10_i30;
  int32_T c10_i31;
  int32_T c10_i32;
  int32_T c10_i33;
  int32_T c10_i34;
  int32_T c10_i35;
  real_T c10_f_a;
  real_T c10_f_b;
  real_T c10_g_y;
  real_T c10_g_a;
  real_T c10_g_b;
  real_T c10_h_y;
  int32_T c10_i36;
  real_T c10_i_y[2];
  int32_T c10_i37;
  int32_T c10_i38;
  int32_T c10_i39;
  int32_T c10_i40;
  int32_T c10_i41;
  int32_T c10_i42;
  int32_T c10_i43;
  int32_T c10_i44;
  int32_T c10_i45;
  int32_T c10_i46;
  real_T c10_h_a;
  real_T c10_h_b;
  real_T c10_j_y;
  real_T c10_i_a;
  real_T c10_i_b;
  real_T c10_k_y;
  int32_T c10_i47;
  real_T c10_l_y[2];
  int32_T c10_i48;
  int32_T c10_i49;
  int32_T c10_i50;
  int32_T c10_i51;
  int32_T c10_i52;
  int32_T c10_i53;
  int32_T c10_i54;
  int32_T c10_i55;
  int32_T c10_i56;
  int32_T c10_i57;
  real_T c10_b_F_friction_fl[4];
  int32_T c10_i58;
  real_T c10_c_F_friction_fl[4];
  int32_T c10_i59;
  int32_T c10_i60;
  int32_T c10_i61;
  real_T (*c10_b_Fx_wheel)[4];
  real_T (*c10_b_Fy_wheel)[4];
  real_T (*c10_b_alpha)[4];
  real_T (*c10_b_my_lat)[4];
  real_T (*c10_b_my_long)[4];
  real_T (*c10_b_Fz_wheel)[4];
  c10_b_alpha = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
  c10_b_Fy_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_b_Fx_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_b_my_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c10_b_my_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c10_b_Fz_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 8U, chartInstance->c10_sfEvent);
  for (c10_i10 = 0; c10_i10 < 4; c10_i10++) {
    c10_Fz_wheel[c10_i10] = (*c10_b_Fz_wheel)[c10_i10];
  }

  for (c10_i11 = 0; c10_i11 < 4; c10_i11++) {
    c10_my_long[c10_i11] = (*c10_b_my_long)[c10_i11];
  }

  for (c10_i12 = 0; c10_i12 < 4; c10_i12++) {
    c10_my_lat[c10_i12] = (*c10_b_my_lat)[c10_i12];
  }

  for (c10_i13 = 0; c10_i13 < 4; c10_i13++) {
    c10_alpha[c10_i13] = (*c10_b_alpha)[c10_i13];
  }

  sf_debug_symbol_scope_push_eml(0U, 32U, 32U, c10_debug_family_names,
    c10_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c10_Fz_fl, 0U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_Fz_fr, 1U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_Fz_rl, 2U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_Fz_rr, 3U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_long_fl, 4U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_long_fr, 5U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_long_rl, 6U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_long_rr, 7U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_lat_fl, 8U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_lat_fr, 9U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_lat_rl, 10U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_my_lat_rr, 11U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_alpha_fl, 12U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_alpha_fr, 13U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_alpha_rl, 14U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_alpha_rr, 15U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_R_fl, 16U, c10_d_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_R_fr, 17U, c10_d_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_R_rl, 18U, c10_d_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_R_rr, 19U, c10_d_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_F_friction_fl, 20U,
    c10_c_sf_marshallOut, c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_F_friction_fr, 21U,
    c10_c_sf_marshallOut, c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_F_friction_rl, 22U,
    c10_c_sf_marshallOut, c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_F_friction_rr, 23U,
    c10_c_sf_marshallOut, c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargin, 24U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargout, 25U,
    c10_b_sf_marshallOut, c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c10_Fz_wheel, 26U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_my_long, 27U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_my_lat, 28U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_alpha, 29U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c10_Fx_wheel, 30U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_Fy_wheel, 31U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 4);
  c10_Fz_fl = c10_Fz_wheel[0];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 5);
  c10_Fz_fr = c10_Fz_wheel[1];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 6);
  c10_Fz_rl = c10_Fz_wheel[2];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 7);
  c10_Fz_rr = c10_Fz_wheel[3];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 10);
  c10_my_long_fl = c10_my_long[0];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 11);
  c10_my_long_fr = c10_my_long[1];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 12);
  c10_my_long_rl = c10_my_long[2];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 13);
  c10_my_long_rr = c10_my_long[3];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 16);
  c10_my_lat_fl = c10_my_lat[0];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 17);
  c10_my_lat_fr = c10_my_lat[1];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 18);
  c10_my_lat_rl = c10_my_lat[2];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 19);
  c10_my_lat_rr = c10_my_lat[3];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 22);
  c10_alpha_fl = c10_alpha[0];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 23);
  c10_alpha_fr = c10_alpha[1];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 24);
  c10_alpha_rl = c10_alpha[2];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 25);
  c10_alpha_rr = c10_alpha[3];
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 28);
  c10_x = c10_alpha_fl;
  c10_b_x = c10_x;
  c10_b_x = muDoubleScalarCos(c10_b_x);
  c10_c_x = c10_alpha_fl;
  c10_d_x = c10_c_x;
  c10_d_x = muDoubleScalarSin(c10_d_x);
  c10_e_x = c10_alpha_fl;
  c10_f_x = c10_e_x;
  c10_f_x = muDoubleScalarSin(c10_f_x);
  c10_g_x = c10_alpha_fl;
  c10_h_x = c10_g_x;
  c10_h_x = muDoubleScalarCos(c10_h_x);
  c10_R_fl[0] = c10_b_x;
  c10_R_fl[2] = c10_d_x;
  c10_R_fl[1] = -c10_f_x;
  c10_R_fl[3] = c10_h_x;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 30);
  c10_i_x = c10_alpha_fr;
  c10_j_x = c10_i_x;
  c10_j_x = muDoubleScalarCos(c10_j_x);
  c10_k_x = c10_alpha_fr;
  c10_l_x = c10_k_x;
  c10_l_x = muDoubleScalarSin(c10_l_x);
  c10_m_x = c10_alpha_fr;
  c10_n_x = c10_m_x;
  c10_n_x = muDoubleScalarSin(c10_n_x);
  c10_o_x = c10_alpha_fr;
  c10_p_x = c10_o_x;
  c10_p_x = muDoubleScalarCos(c10_p_x);
  c10_R_fr[0] = c10_j_x;
  c10_R_fr[2] = c10_l_x;
  c10_R_fr[1] = -c10_n_x;
  c10_R_fr[3] = c10_p_x;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 32);
  c10_q_x = c10_alpha_rl;
  c10_r_x = c10_q_x;
  c10_r_x = muDoubleScalarCos(c10_r_x);
  c10_s_x = c10_alpha_rl;
  c10_t_x = c10_s_x;
  c10_t_x = muDoubleScalarSin(c10_t_x);
  c10_u_x = c10_alpha_rl;
  c10_v_x = c10_u_x;
  c10_v_x = muDoubleScalarSin(c10_v_x);
  c10_w_x = c10_alpha_rl;
  c10_x_x = c10_w_x;
  c10_x_x = muDoubleScalarCos(c10_x_x);
  c10_R_rl[0] = c10_r_x;
  c10_R_rl[2] = c10_t_x;
  c10_R_rl[1] = -c10_v_x;
  c10_R_rl[3] = c10_x_x;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 34);
  c10_y_x = c10_alpha_rr;
  c10_ab_x = c10_y_x;
  c10_ab_x = muDoubleScalarCos(c10_ab_x);
  c10_bb_x = c10_alpha_rr;
  c10_cb_x = c10_bb_x;
  c10_cb_x = muDoubleScalarSin(c10_cb_x);
  c10_db_x = c10_alpha_rr;
  c10_eb_x = c10_db_x;
  c10_eb_x = muDoubleScalarSin(c10_eb_x);
  c10_fb_x = c10_alpha_rr;
  c10_gb_x = c10_fb_x;
  c10_gb_x = muDoubleScalarCos(c10_gb_x);
  c10_R_rr[0] = c10_ab_x;
  c10_R_rr[2] = c10_cb_x;
  c10_R_rr[1] = -c10_eb_x;
  c10_R_rr[3] = c10_gb_x;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 38);
  c10_a = c10_my_long_fl;
  c10_b = c10_Fz_fl;
  c10_y = c10_a * c10_b;
  c10_b_a = c10_my_lat_fl;
  c10_b_b = c10_Fz_fl;
  c10_b_y = c10_b_a * c10_b_b;
  for (c10_i14 = 0; c10_i14 < 4; c10_i14++) {
    c10_c_a[c10_i14] = c10_R_fl[c10_i14];
  }

  c10_c_y[0] = c10_y;
  c10_c_y[1] = c10_b_y;
  for (c10_i15 = 0; c10_i15 < 2; c10_i15++) {
    c10_c_b[c10_i15] = c10_c_y[c10_i15];
  }

  c10_eml_scalar_eg(chartInstance);
  c10_eml_scalar_eg(chartInstance);
  for (c10_i16 = 0; c10_i16 < 2; c10_i16++) {
    c10_F_friction_fl[c10_i16] = 0.0;
  }

  for (c10_i17 = 0; c10_i17 < 2; c10_i17++) {
    c10_F_friction_fl[c10_i17] = 0.0;
  }

  for (c10_i18 = 0; c10_i18 < 2; c10_i18++) {
    c10_C[c10_i18] = c10_F_friction_fl[c10_i18];
  }

  for (c10_i19 = 0; c10_i19 < 2; c10_i19++) {
    c10_F_friction_fl[c10_i19] = c10_C[c10_i19];
  }

  for (c10_i20 = 0; c10_i20 < 2; c10_i20++) {
    c10_C[c10_i20] = c10_F_friction_fl[c10_i20];
  }

  for (c10_i21 = 0; c10_i21 < 2; c10_i21++) {
    c10_F_friction_fl[c10_i21] = c10_C[c10_i21];
  }

  for (c10_i22 = 0; c10_i22 < 2; c10_i22++) {
    c10_F_friction_fl[c10_i22] = 0.0;
    c10_i23 = 0;
    for (c10_i24 = 0; c10_i24 < 2; c10_i24++) {
      c10_F_friction_fl[c10_i22] += c10_c_a[c10_i23 + c10_i22] * c10_c_b[c10_i24];
      c10_i23 += 2;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 39);
  c10_d_a = c10_my_long_fr;
  c10_d_b = c10_Fz_fr;
  c10_d_y = c10_d_a * c10_d_b;
  c10_e_a = c10_my_lat_fr;
  c10_e_b = c10_Fz_fr;
  c10_e_y = c10_e_a * c10_e_b;
  for (c10_i25 = 0; c10_i25 < 4; c10_i25++) {
    c10_c_a[c10_i25] = c10_R_fr[c10_i25];
  }

  c10_f_y[0] = c10_d_y;
  c10_f_y[1] = c10_e_y;
  for (c10_i26 = 0; c10_i26 < 2; c10_i26++) {
    c10_c_b[c10_i26] = c10_f_y[c10_i26];
  }

  c10_eml_scalar_eg(chartInstance);
  c10_eml_scalar_eg(chartInstance);
  for (c10_i27 = 0; c10_i27 < 2; c10_i27++) {
    c10_F_friction_fr[c10_i27] = 0.0;
  }

  for (c10_i28 = 0; c10_i28 < 2; c10_i28++) {
    c10_F_friction_fr[c10_i28] = 0.0;
  }

  for (c10_i29 = 0; c10_i29 < 2; c10_i29++) {
    c10_C[c10_i29] = c10_F_friction_fr[c10_i29];
  }

  for (c10_i30 = 0; c10_i30 < 2; c10_i30++) {
    c10_F_friction_fr[c10_i30] = c10_C[c10_i30];
  }

  for (c10_i31 = 0; c10_i31 < 2; c10_i31++) {
    c10_C[c10_i31] = c10_F_friction_fr[c10_i31];
  }

  for (c10_i32 = 0; c10_i32 < 2; c10_i32++) {
    c10_F_friction_fr[c10_i32] = c10_C[c10_i32];
  }

  for (c10_i33 = 0; c10_i33 < 2; c10_i33++) {
    c10_F_friction_fr[c10_i33] = 0.0;
    c10_i34 = 0;
    for (c10_i35 = 0; c10_i35 < 2; c10_i35++) {
      c10_F_friction_fr[c10_i33] += c10_c_a[c10_i34 + c10_i33] * c10_c_b[c10_i35];
      c10_i34 += 2;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 40);
  c10_f_a = c10_my_long_rl;
  c10_f_b = c10_Fz_rl;
  c10_g_y = c10_f_a * c10_f_b;
  c10_g_a = c10_my_lat_rl;
  c10_g_b = c10_Fz_rl;
  c10_h_y = c10_g_a * c10_g_b;
  for (c10_i36 = 0; c10_i36 < 4; c10_i36++) {
    c10_c_a[c10_i36] = c10_R_rl[c10_i36];
  }

  c10_i_y[0] = c10_g_y;
  c10_i_y[1] = c10_h_y;
  for (c10_i37 = 0; c10_i37 < 2; c10_i37++) {
    c10_c_b[c10_i37] = c10_i_y[c10_i37];
  }

  c10_eml_scalar_eg(chartInstance);
  c10_eml_scalar_eg(chartInstance);
  for (c10_i38 = 0; c10_i38 < 2; c10_i38++) {
    c10_F_friction_rl[c10_i38] = 0.0;
  }

  for (c10_i39 = 0; c10_i39 < 2; c10_i39++) {
    c10_F_friction_rl[c10_i39] = 0.0;
  }

  for (c10_i40 = 0; c10_i40 < 2; c10_i40++) {
    c10_C[c10_i40] = c10_F_friction_rl[c10_i40];
  }

  for (c10_i41 = 0; c10_i41 < 2; c10_i41++) {
    c10_F_friction_rl[c10_i41] = c10_C[c10_i41];
  }

  for (c10_i42 = 0; c10_i42 < 2; c10_i42++) {
    c10_C[c10_i42] = c10_F_friction_rl[c10_i42];
  }

  for (c10_i43 = 0; c10_i43 < 2; c10_i43++) {
    c10_F_friction_rl[c10_i43] = c10_C[c10_i43];
  }

  for (c10_i44 = 0; c10_i44 < 2; c10_i44++) {
    c10_F_friction_rl[c10_i44] = 0.0;
    c10_i45 = 0;
    for (c10_i46 = 0; c10_i46 < 2; c10_i46++) {
      c10_F_friction_rl[c10_i44] += c10_c_a[c10_i45 + c10_i44] * c10_c_b[c10_i46];
      c10_i45 += 2;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 41);
  c10_h_a = c10_my_long_rr;
  c10_h_b = c10_Fz_rr;
  c10_j_y = c10_h_a * c10_h_b;
  c10_i_a = c10_my_lat_rr;
  c10_i_b = c10_Fz_rr;
  c10_k_y = c10_i_a * c10_i_b;
  for (c10_i47 = 0; c10_i47 < 4; c10_i47++) {
    c10_c_a[c10_i47] = c10_R_rr[c10_i47];
  }

  c10_l_y[0] = c10_j_y;
  c10_l_y[1] = c10_k_y;
  for (c10_i48 = 0; c10_i48 < 2; c10_i48++) {
    c10_c_b[c10_i48] = c10_l_y[c10_i48];
  }

  c10_eml_scalar_eg(chartInstance);
  c10_eml_scalar_eg(chartInstance);
  for (c10_i49 = 0; c10_i49 < 2; c10_i49++) {
    c10_F_friction_rr[c10_i49] = 0.0;
  }

  for (c10_i50 = 0; c10_i50 < 2; c10_i50++) {
    c10_F_friction_rr[c10_i50] = 0.0;
  }

  for (c10_i51 = 0; c10_i51 < 2; c10_i51++) {
    c10_C[c10_i51] = c10_F_friction_rr[c10_i51];
  }

  for (c10_i52 = 0; c10_i52 < 2; c10_i52++) {
    c10_F_friction_rr[c10_i52] = c10_C[c10_i52];
  }

  for (c10_i53 = 0; c10_i53 < 2; c10_i53++) {
    c10_C[c10_i53] = c10_F_friction_rr[c10_i53];
  }

  for (c10_i54 = 0; c10_i54 < 2; c10_i54++) {
    c10_F_friction_rr[c10_i54] = c10_C[c10_i54];
  }

  for (c10_i55 = 0; c10_i55 < 2; c10_i55++) {
    c10_F_friction_rr[c10_i55] = 0.0;
    c10_i56 = 0;
    for (c10_i57 = 0; c10_i57 < 2; c10_i57++) {
      c10_F_friction_rr[c10_i55] += c10_c_a[c10_i56 + c10_i55] * c10_c_b[c10_i57];
      c10_i56 += 2;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 44);
  c10_b_F_friction_fl[0] = c10_F_friction_fl[0];
  c10_b_F_friction_fl[1] = c10_F_friction_fr[0];
  c10_b_F_friction_fl[2] = c10_F_friction_rl[0];
  c10_b_F_friction_fl[3] = c10_F_friction_rr[0];
  for (c10_i58 = 0; c10_i58 < 4; c10_i58++) {
    c10_Fx_wheel[c10_i58] = c10_b_F_friction_fl[c10_i58];
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 45);
  c10_c_F_friction_fl[0] = c10_F_friction_fl[1];
  c10_c_F_friction_fl[1] = c10_F_friction_fr[1];
  c10_c_F_friction_fl[2] = c10_F_friction_rl[1];
  c10_c_F_friction_fl[3] = c10_F_friction_rr[1];
  for (c10_i59 = 0; c10_i59 < 4; c10_i59++) {
    c10_Fy_wheel[c10_i59] = c10_c_F_friction_fl[c10_i59];
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, -45);
  sf_debug_symbol_scope_pop();
  for (c10_i60 = 0; c10_i60 < 4; c10_i60++) {
    (*c10_b_Fx_wheel)[c10_i60] = c10_Fx_wheel[c10_i60];
  }

  for (c10_i61 = 0; c10_i61 < 4; c10_i61++) {
    (*c10_b_Fy_wheel)[c10_i61] = c10_Fy_wheel[c10_i61];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 8U, chartInstance->c10_sfEvent);
}

static void initSimStructsc10_ref_gen(SFc10_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber)
{
}

static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i62;
  real_T c10_b_inData[4];
  int32_T c10_i63;
  real_T c10_u[4];
  const mxArray *c10_y = NULL;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i62 = 0; c10_i62 < 4; c10_i62++) {
    c10_b_inData[c10_i62] = (*(real_T (*)[4])c10_inData)[c10_i62];
  }

  for (c10_i63 = 0; c10_i63 < 4; c10_i63++) {
    c10_u[c10_i63] = c10_b_inData[c10_i63];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_Fy_wheel, const char_T *c10_identifier, real_T c10_y[4])
{
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_Fy_wheel), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_Fy_wheel);
}

static void c10_b_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[4])
{
  real_T c10_dv2[4];
  int32_T c10_i64;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv2, 1, 0, 0U, 1, 0U, 1, 4);
  for (c10_i64 = 0; c10_i64 < 4; c10_i64++) {
    c10_y[c10_i64] = c10_dv2[c10_i64];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_Fy_wheel;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[4];
  int32_T c10_i65;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_Fy_wheel = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_Fy_wheel), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_Fy_wheel);
  for (c10_i65 = 0; c10_i65 < 4; c10_i65++) {
    (*(real_T (*)[4])c10_outData)[c10_i65] = c10_y[c10_i65];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  real_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(real_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static real_T c10_c_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  real_T c10_y;
  real_T c10_d0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_d0, 1, 0, 0U, 0, 0U, 0);
  c10_y = c10_d0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_nargout;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_nargout = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_nargout),
    &c10_thisId);
  sf_mex_destroy(&c10_nargout);
  *(real_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i66;
  real_T c10_b_inData[2];
  int32_T c10_i67;
  real_T c10_u[2];
  const mxArray *c10_y = NULL;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i66 = 0; c10_i66 < 2; c10_i66++) {
    c10_b_inData[c10_i66] = (*(real_T (*)[2])c10_inData)[c10_i66];
  }

  for (c10_i67 = 0; c10_i67 < 2; c10_i67++) {
    c10_u[c10_i67] = c10_b_inData[c10_i67];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_d_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[2])
{
  real_T c10_dv3[2];
  int32_T c10_i68;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv3, 1, 0, 0U, 1, 0U, 1, 2);
  for (c10_i68 = 0; c10_i68 < 2; c10_i68++) {
    c10_y[c10_i68] = c10_dv3[c10_i68];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_F_friction_rr;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[2];
  int32_T c10_i69;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_F_friction_rr = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_F_friction_rr),
    &c10_thisId, c10_y);
  sf_mex_destroy(&c10_F_friction_rr);
  for (c10_i69 = 0; c10_i69 < 2; c10_i69++) {
    (*(real_T (*)[2])c10_outData)[c10_i69] = c10_y[c10_i69];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_d_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i70;
  int32_T c10_i71;
  int32_T c10_i72;
  real_T c10_b_inData[4];
  int32_T c10_i73;
  int32_T c10_i74;
  int32_T c10_i75;
  real_T c10_u[4];
  const mxArray *c10_y = NULL;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_i70 = 0;
  for (c10_i71 = 0; c10_i71 < 2; c10_i71++) {
    for (c10_i72 = 0; c10_i72 < 2; c10_i72++) {
      c10_b_inData[c10_i72 + c10_i70] = (*(real_T (*)[4])c10_inData)[c10_i72 +
        c10_i70];
    }

    c10_i70 += 2;
  }

  c10_i73 = 0;
  for (c10_i74 = 0; c10_i74 < 2; c10_i74++) {
    for (c10_i75 = 0; c10_i75 < 2; c10_i75++) {
      c10_u[c10_i75 + c10_i73] = c10_b_inData[c10_i75 + c10_i73];
    }

    c10_i73 += 2;
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_e_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[4])
{
  real_T c10_dv4[4];
  int32_T c10_i76;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv4, 1, 0, 0U, 1, 0U, 2, 2,
                2);
  for (c10_i76 = 0; c10_i76 < 4; c10_i76++) {
    c10_y[c10_i76] = c10_dv4[c10_i76];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_R_rr;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[4];
  int32_T c10_i77;
  int32_T c10_i78;
  int32_T c10_i79;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_R_rr = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_R_rr), &c10_thisId, c10_y);
  sf_mex_destroy(&c10_R_rr);
  c10_i77 = 0;
  for (c10_i78 = 0; c10_i78 < 2; c10_i78++) {
    for (c10_i79 = 0; c10_i79 < 2; c10_i79++) {
      (*(real_T (*)[4])c10_outData)[c10_i79 + c10_i77] = c10_y[c10_i79 + c10_i77];
    }

    c10_i77 += 2;
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

const mxArray *sf_c10_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c10_nameCaptureInfo;
  c10_ResolvedFunctionInfo c10_info[10];
  c10_ResolvedFunctionInfo (*c10_b_info)[10];
  const mxArray *c10_m0 = NULL;
  int32_T c10_i80;
  c10_ResolvedFunctionInfo *c10_r0;
  c10_nameCaptureInfo = NULL;
  c10_nameCaptureInfo = NULL;
  c10_b_info = (c10_ResolvedFunctionInfo (*)[10])c10_info;
  (*c10_b_info)[0].context = "";
  (*c10_b_info)[0].name = "cos";
  (*c10_b_info)[0].dominantType = "double";
  (*c10_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  (*c10_b_info)[0].fileTimeLo = 1286818706U;
  (*c10_b_info)[0].fileTimeHi = 0U;
  (*c10_b_info)[0].mFileTimeLo = 0U;
  (*c10_b_info)[0].mFileTimeHi = 0U;
  (*c10_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  (*c10_b_info)[1].name = "eml_scalar_cos";
  (*c10_b_info)[1].dominantType = "double";
  (*c10_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  (*c10_b_info)[1].fileTimeLo = 1286818722U;
  (*c10_b_info)[1].fileTimeHi = 0U;
  (*c10_b_info)[1].mFileTimeLo = 0U;
  (*c10_b_info)[1].mFileTimeHi = 0U;
  (*c10_b_info)[2].context = "";
  (*c10_b_info)[2].name = "sin";
  (*c10_b_info)[2].dominantType = "double";
  (*c10_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  (*c10_b_info)[2].fileTimeLo = 1286818750U;
  (*c10_b_info)[2].fileTimeHi = 0U;
  (*c10_b_info)[2].mFileTimeLo = 0U;
  (*c10_b_info)[2].mFileTimeHi = 0U;
  (*c10_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  (*c10_b_info)[3].name = "eml_scalar_sin";
  (*c10_b_info)[3].dominantType = "double";
  (*c10_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  (*c10_b_info)[3].fileTimeLo = 1286818736U;
  (*c10_b_info)[3].fileTimeHi = 0U;
  (*c10_b_info)[3].mFileTimeLo = 0U;
  (*c10_b_info)[3].mFileTimeHi = 0U;
  (*c10_b_info)[4].context = "";
  (*c10_b_info)[4].name = "mtimes";
  (*c10_b_info)[4].dominantType = "double";
  (*c10_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c10_b_info)[4].fileTimeLo = 1289519692U;
  (*c10_b_info)[4].fileTimeHi = 0U;
  (*c10_b_info)[4].mFileTimeLo = 0U;
  (*c10_b_info)[4].mFileTimeHi = 0U;
  (*c10_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c10_b_info)[5].name = "eml_index_class";
  (*c10_b_info)[5].dominantType = "";
  (*c10_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  (*c10_b_info)[5].fileTimeLo = 1286818778U;
  (*c10_b_info)[5].fileTimeHi = 0U;
  (*c10_b_info)[5].mFileTimeLo = 0U;
  (*c10_b_info)[5].mFileTimeHi = 0U;
  (*c10_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c10_b_info)[6].name = "eml_scalar_eg";
  (*c10_b_info)[6].dominantType = "double";
  (*c10_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c10_b_info)[6].fileTimeLo = 1286818796U;
  (*c10_b_info)[6].fileTimeHi = 0U;
  (*c10_b_info)[6].mFileTimeLo = 0U;
  (*c10_b_info)[6].mFileTimeHi = 0U;
  (*c10_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c10_b_info)[7].name = "eml_xgemm";
  (*c10_b_info)[7].dominantType = "int32";
  (*c10_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  (*c10_b_info)[7].fileTimeLo = 1299076772U;
  (*c10_b_info)[7].fileTimeHi = 0U;
  (*c10_b_info)[7].mFileTimeLo = 0U;
  (*c10_b_info)[7].mFileTimeHi = 0U;
  (*c10_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  (*c10_b_info)[8].name = "eml_blas_inline";
  (*c10_b_info)[8].dominantType = "";
  (*c10_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  (*c10_b_info)[8].fileTimeLo = 1299076768U;
  (*c10_b_info)[8].fileTimeHi = 0U;
  (*c10_b_info)[8].mFileTimeLo = 0U;
  (*c10_b_info)[8].mFileTimeHi = 0U;
  (*c10_b_info)[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c10_b_info)[9].name = "eml_refblas_xgemm";
  (*c10_b_info)[9].dominantType = "int32";
  (*c10_b_info)[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  (*c10_b_info)[9].fileTimeLo = 1299076774U;
  (*c10_b_info)[9].fileTimeHi = 0U;
  (*c10_b_info)[9].mFileTimeLo = 0U;
  (*c10_b_info)[9].mFileTimeHi = 0U;
  sf_mex_assign(&c10_m0, sf_mex_createstruct("nameCaptureInfo", 1, 10), FALSE);
  for (c10_i80 = 0; c10_i80 < 10; c10_i80++) {
    c10_r0 = &c10_info[c10_i80];
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->context)), "context", "nameCaptureInfo",
                    c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->name)), "name", "nameCaptureInfo",
                    c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      c10_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->resolved)), "resolved",
                    "nameCaptureInfo", c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c10_i80);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c10_i80);
  }

  sf_mex_assign(&c10_nameCaptureInfo, c10_m0, FALSE);
  return c10_nameCaptureInfo;
}

static void c10_eml_scalar_eg(SFc10_ref_genInstanceStruct *chartInstance)
{
}

static const mxArray *c10_e_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(int32_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static int32_T c10_f_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  int32_T c10_y;
  int32_T c10_i81;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_i81, 1, 6, 0U, 0, 0U, 0);
  c10_y = c10_i81;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_sfEvent;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  int32_T c10_y;
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)chartInstanceVoid;
  c10_b_sfEvent = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_sfEvent),
    &c10_thisId);
  sf_mex_destroy(&c10_b_sfEvent);
  *(int32_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static uint8_T c10_g_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_b_is_active_c10_ref_gen, const char_T *c10_identifier)
{
  uint8_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c10_b_is_active_c10_ref_gen), &c10_thisId);
  sf_mex_destroy(&c10_b_is_active_c10_ref_gen);
  return c10_y;
}

static uint8_T c10_h_emlrt_marshallIn(SFc10_ref_genInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  uint8_T c10_y;
  uint8_T c10_u0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_u0, 1, 3, 0U, 0, 0U, 0);
  c10_y = c10_u0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void init_dsm_address_info(SFc10_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c10_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(672073189U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(895493781U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3877514445U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1512893498U);
}

mxArray *sf_c10_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("jhzqnMKpt0ePSyCqahOMZD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c10_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"Fx_wheel\",},{M[1],M[6],T\"Fy_wheel\",},{M[8],M[0],T\"is_active_c10_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c10_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc10_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc10_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          10,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"Fz_wheel");
          _SFD_SET_DATA_PROPS(1,1,1,0,"my_long");
          _SFD_SET_DATA_PROPS(2,1,1,0,"my_lat");
          _SFD_SET_DATA_PROPS(3,2,0,1,"Fx_wheel");
          _SFD_SET_DATA_PROPS(4,2,0,1,"Fy_wheel");
          _SFD_SET_DATA_PROPS(5,1,1,0,"alpha");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1301);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)
            c10_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)
            c10_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c10_Fz_wheel)[4];
          real_T (*c10_my_long)[4];
          real_T (*c10_my_lat)[4];
          real_T (*c10_Fx_wheel)[4];
          real_T (*c10_Fy_wheel)[4];
          real_T (*c10_alpha)[4];
          c10_alpha = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 3);
          c10_Fy_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
            2);
          c10_Fx_wheel = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
            1);
          c10_my_lat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
          c10_my_long = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c10_Fz_wheel = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c10_Fz_wheel);
          _SFD_SET_DATA_VALUE_PTR(1U, *c10_my_long);
          _SFD_SET_DATA_VALUE_PTR(2U, *c10_my_lat);
          _SFD_SET_DATA_VALUE_PTR(3U, *c10_Fx_wheel);
          _SFD_SET_DATA_VALUE_PTR(4U, *c10_Fy_wheel);
          _SFD_SET_DATA_VALUE_PTR(5U, *c10_alpha);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c10_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc10_ref_genInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c10_ref_gen(void *chartInstanceVar)
{
  enable_c10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c10_ref_gen(void *chartInstanceVar)
{
  disable_c10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c10_ref_gen(void *chartInstanceVar)
{
  sf_c10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c10_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c10_ref_gen((SFc10_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c10_ref_gen(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c10_ref_gen((SFc10_ref_genInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c10_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c10_ref_gen(S);
}

static void sf_opaque_set_sim_state_c10_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c10_ref_gen(S, st);
}

static void sf_opaque_terminate_c10_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc10_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc10_ref_gen((SFc10_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c10_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c10_ref_gen((SFc10_ref_genInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c10_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,10,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,10,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,10,4);
      sf_mark_chart_reusable_outputs(S,infoStruct,10,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,10);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1785912725U));
  ssSetChecksum1(S,(70690020U));
  ssSetChecksum2(S,(3532626821U));
  ssSetChecksum3(S,(3223959413U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c10_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c10_ref_gen(SimStruct *S)
{
  SFc10_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc10_ref_genInstanceStruct *)malloc(sizeof
    (SFc10_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc10_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c10_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c10_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c10_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c10_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c10_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c10_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c10_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c10_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c10_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c10_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c10_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c10_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c10_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
