/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c14_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c14_debug_family_names[11] = { "dist", "nargin", "nargout",
  "north", "west", "wpn", "wpl", "v_ref", "ref_heading", "psi_dot_ref", "next" };

/* Function Declarations */
static void initialize_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance);
static void initialize_params_c14_ref_gen(SFc14_ref_genInstanceStruct
  *chartInstance);
static void enable_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance);
static void disable_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance);
static void c14_update_debugger_state_c14_ref_gen(SFc14_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c14_ref_gen(SFc14_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_st);
static void finalize_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance);
static void sf_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance);
static void initSimStructsc14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c14_machineNumber, uint32_T
  c14_chartNumber);
static const mxArray *c14_sf_marshallOut(void *chartInstanceVoid, void
  *c14_inData);
static real_T c14_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_next, const char_T *c14_identifier);
static real_T c14_b_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_u, const emlrtMsgIdentifier *c14_parentId);
static void c14_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c14_mxArrayInData, const char_T *c14_varName, void *c14_outData);
static const mxArray *c14_b_sf_marshallOut(void *chartInstanceVoid, void
  *c14_inData);
static void c14_info_helper(c14_ResolvedFunctionInfo c14_info[14]);
static void c14_eml_scalar_eg(SFc14_ref_genInstanceStruct *chartInstance);
static real_T c14_mpower(SFc14_ref_genInstanceStruct *chartInstance, real_T
  c14_a);
static void c14_eml_error(SFc14_ref_genInstanceStruct *chartInstance);
static const mxArray *c14_c_sf_marshallOut(void *chartInstanceVoid, void
  *c14_inData);
static int32_T c14_c_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_u, const emlrtMsgIdentifier *c14_parentId);
static void c14_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c14_mxArrayInData, const char_T *c14_varName, void *c14_outData);
static uint8_T c14_d_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_b_is_active_c14_ref_gen, const char_T *c14_identifier);
static uint8_T c14_e_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_u, const emlrtMsgIdentifier *c14_parentId);
static void init_dsm_address_info(SFc14_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c14_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c14_is_active_c14_ref_gen = 0U;
}

static void initialize_params_c14_ref_gen(SFc14_ref_genInstanceStruct
  *chartInstance)
{
}

static void enable_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c14_update_debugger_state_c14_ref_gen(SFc14_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c14_ref_gen(SFc14_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c14_st;
  const mxArray *c14_y = NULL;
  real_T c14_hoistedGlobal;
  real_T c14_u;
  const mxArray *c14_b_y = NULL;
  real_T c14_b_hoistedGlobal;
  real_T c14_b_u;
  const mxArray *c14_c_y = NULL;
  real_T c14_c_hoistedGlobal;
  real_T c14_c_u;
  const mxArray *c14_d_y = NULL;
  real_T c14_d_hoistedGlobal;
  real_T c14_d_u;
  const mxArray *c14_e_y = NULL;
  uint8_T c14_e_hoistedGlobal;
  uint8_T c14_e_u;
  const mxArray *c14_f_y = NULL;
  real_T *c14_next;
  real_T *c14_psi_dot_ref;
  real_T *c14_ref_heading;
  real_T *c14_v_ref;
  c14_next = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c14_psi_dot_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c14_ref_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c14_v_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c14_st = NULL;
  c14_st = NULL;
  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_createcellarray(5), FALSE);
  c14_hoistedGlobal = *c14_next;
  c14_u = c14_hoistedGlobal;
  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_create("y", &c14_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c14_y, 0, c14_b_y);
  c14_b_hoistedGlobal = *c14_psi_dot_ref;
  c14_b_u = c14_b_hoistedGlobal;
  c14_c_y = NULL;
  sf_mex_assign(&c14_c_y, sf_mex_create("y", &c14_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c14_y, 1, c14_c_y);
  c14_c_hoistedGlobal = *c14_ref_heading;
  c14_c_u = c14_c_hoistedGlobal;
  c14_d_y = NULL;
  sf_mex_assign(&c14_d_y, sf_mex_create("y", &c14_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c14_y, 2, c14_d_y);
  c14_d_hoistedGlobal = *c14_v_ref;
  c14_d_u = c14_d_hoistedGlobal;
  c14_e_y = NULL;
  sf_mex_assign(&c14_e_y, sf_mex_create("y", &c14_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c14_y, 3, c14_e_y);
  c14_e_hoistedGlobal = chartInstance->c14_is_active_c14_ref_gen;
  c14_e_u = c14_e_hoistedGlobal;
  c14_f_y = NULL;
  sf_mex_assign(&c14_f_y, sf_mex_create("y", &c14_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c14_y, 4, c14_f_y);
  sf_mex_assign(&c14_st, c14_y, FALSE);
  return c14_st;
}

static void set_sim_state_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_st)
{
  const mxArray *c14_u;
  real_T *c14_next;
  real_T *c14_psi_dot_ref;
  real_T *c14_ref_heading;
  real_T *c14_v_ref;
  c14_next = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c14_psi_dot_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c14_ref_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c14_v_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c14_doneDoubleBufferReInit = TRUE;
  c14_u = sf_mex_dup(c14_st);
  *c14_next = c14_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c14_u, 0)), "next");
  *c14_psi_dot_ref = c14_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c14_u, 1)), "psi_dot_ref");
  *c14_ref_heading = c14_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c14_u, 2)), "ref_heading");
  *c14_v_ref = c14_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c14_u, 3)), "v_ref");
  chartInstance->c14_is_active_c14_ref_gen = c14_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c14_u, 4)),
     "is_active_c14_ref_gen");
  sf_mex_destroy(&c14_u);
  c14_update_debugger_state_c14_ref_gen(chartInstance);
  sf_mex_destroy(&c14_st);
}

static void finalize_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance)
{
  int32_T c14_i0;
  int32_T c14_i1;
  real_T c14_hoistedGlobal;
  real_T c14_b_hoistedGlobal;
  real_T c14_north;
  real_T c14_west;
  int32_T c14_i2;
  real_T c14_wpn[5];
  int32_T c14_i3;
  real_T c14_wpl[5];
  uint32_T c14_debug_family_var_map[11];
  real_T c14_dist;
  real_T c14_nargin = 4.0;
  real_T c14_nargout = 4.0;
  real_T c14_v_ref;
  real_T c14_ref_heading;
  real_T c14_psi_dot_ref;
  real_T c14_next;
  real_T c14_y;
  real_T c14_x;
  real_T c14_b_y;
  real_T c14_b_x;
  real_T c14_r;
  real_T c14_a;
  real_T c14_c_y;
  real_T c14_A;
  real_T c14_c_x;
  real_T c14_d_x;
  real_T c14_e_x;
  real_T c14_f_x;
  real_T *c14_b_next;
  real_T *c14_b_psi_dot_ref;
  real_T *c14_b_ref_heading;
  real_T *c14_b_v_ref;
  real_T *c14_b_west;
  real_T *c14_b_north;
  real_T (*c14_b_wpl)[5];
  real_T (*c14_b_wpn)[5];
  c14_b_next = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c14_b_psi_dot_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c14_b_wpl = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 3);
  c14_b_ref_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c14_b_wpn = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 2);
  c14_b_west = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c14_b_north = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c14_b_v_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 11U, chartInstance->c14_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c14_b_v_ref, 0U);
  _SFD_DATA_RANGE_CHECK(*c14_b_north, 1U);
  _SFD_DATA_RANGE_CHECK(*c14_b_west, 2U);
  for (c14_i0 = 0; c14_i0 < 5; c14_i0++) {
    _SFD_DATA_RANGE_CHECK((*c14_b_wpn)[c14_i0], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c14_b_ref_heading, 4U);
  for (c14_i1 = 0; c14_i1 < 5; c14_i1++) {
    _SFD_DATA_RANGE_CHECK((*c14_b_wpl)[c14_i1], 5U);
  }

  _SFD_DATA_RANGE_CHECK(*c14_b_psi_dot_ref, 6U);
  _SFD_DATA_RANGE_CHECK(*c14_b_next, 7U);
  chartInstance->c14_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 11U, chartInstance->c14_sfEvent);
  c14_hoistedGlobal = *c14_b_north;
  c14_b_hoistedGlobal = *c14_b_west;
  c14_north = c14_hoistedGlobal;
  c14_west = c14_b_hoistedGlobal;
  for (c14_i2 = 0; c14_i2 < 5; c14_i2++) {
    c14_wpn[c14_i2] = (*c14_b_wpn)[c14_i2];
  }

  for (c14_i3 = 0; c14_i3 < 5; c14_i3++) {
    c14_wpl[c14_i3] = (*c14_b_wpl)[c14_i3];
  }

  sf_debug_symbol_scope_push_eml(0U, 11U, 11U, c14_debug_family_names,
    c14_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c14_dist, 0U, c14_sf_marshallOut,
    c14_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c14_nargin, 1U, c14_sf_marshallOut,
    c14_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c14_nargout, 2U, c14_sf_marshallOut,
    c14_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c14_north, 3U, c14_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c14_west, 4U, c14_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c14_wpn, 5U, c14_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c14_wpl, 6U, c14_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c14_v_ref, 7U, c14_sf_marshallOut,
    c14_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c14_ref_heading, 8U,
    c14_sf_marshallOut, c14_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c14_psi_dot_ref, 9U,
    c14_sf_marshallOut, c14_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c14_next, 10U, c14_sf_marshallOut,
    c14_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 4);
  c14_y = c14_wpn[1] - c14_west;
  c14_x = c14_wpn[0] - c14_north;
  c14_eml_scalar_eg(chartInstance);
  c14_b_y = c14_y;
  c14_b_x = c14_x;
  c14_r = muDoubleScalarAtan2(c14_b_y, c14_b_x);
  c14_a = c14_r;
  c14_c_y = c14_a * 180.0;
  c14_A = c14_c_y;
  c14_c_x = c14_A;
  c14_d_x = c14_c_x;
  c14_ref_heading = c14_d_x / 3.1415926535897931;
  _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 7);
  c14_e_x = c14_mpower(chartInstance, c14_wpn[0] - c14_north) + c14_mpower
    (chartInstance, c14_wpn[1] - c14_west);
  c14_dist = c14_e_x;
  if (c14_dist < 0.0) {
    c14_eml_error(chartInstance);
  }

  c14_f_x = c14_dist;
  c14_dist = c14_f_x;
  c14_dist = muDoubleScalarSqrt(c14_dist);
  _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 10);
  if (CV_EML_IF(0, 1, 0, c14_dist <= c14_wpn[2])) {
    _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 11);
    c14_next = 1.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 13);
    c14_next = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 17);
  c14_v_ref = c14_wpn[3];
  _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, 20);
  c14_psi_dot_ref = c14_wpn[4];
  _SFD_EML_CALL(0U, chartInstance->c14_sfEvent, -20);
  sf_debug_symbol_scope_pop();
  *c14_b_v_ref = c14_v_ref;
  *c14_b_ref_heading = c14_ref_heading;
  *c14_b_psi_dot_ref = c14_psi_dot_ref;
  *c14_b_next = c14_next;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 11U, chartInstance->c14_sfEvent);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc14_ref_gen(SFc14_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c14_machineNumber, uint32_T
  c14_chartNumber)
{
}

static const mxArray *c14_sf_marshallOut(void *chartInstanceVoid, void
  *c14_inData)
{
  const mxArray *c14_mxArrayOutData = NULL;
  real_T c14_u;
  const mxArray *c14_y = NULL;
  SFc14_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc14_ref_genInstanceStruct *)chartInstanceVoid;
  c14_mxArrayOutData = NULL;
  c14_u = *(real_T *)c14_inData;
  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_create("y", &c14_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c14_mxArrayOutData, c14_y, FALSE);
  return c14_mxArrayOutData;
}

static real_T c14_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_next, const char_T *c14_identifier)
{
  real_T c14_y;
  emlrtMsgIdentifier c14_thisId;
  c14_thisId.fIdentifier = c14_identifier;
  c14_thisId.fParent = NULL;
  c14_y = c14_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c14_next),
    &c14_thisId);
  sf_mex_destroy(&c14_next);
  return c14_y;
}

static real_T c14_b_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_u, const emlrtMsgIdentifier *c14_parentId)
{
  real_T c14_y;
  real_T c14_d0;
  sf_mex_import(c14_parentId, sf_mex_dup(c14_u), &c14_d0, 1, 0, 0U, 0, 0U, 0);
  c14_y = c14_d0;
  sf_mex_destroy(&c14_u);
  return c14_y;
}

static void c14_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c14_mxArrayInData, const char_T *c14_varName, void *c14_outData)
{
  const mxArray *c14_next;
  const char_T *c14_identifier;
  emlrtMsgIdentifier c14_thisId;
  real_T c14_y;
  SFc14_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc14_ref_genInstanceStruct *)chartInstanceVoid;
  c14_next = sf_mex_dup(c14_mxArrayInData);
  c14_identifier = c14_varName;
  c14_thisId.fIdentifier = c14_identifier;
  c14_thisId.fParent = NULL;
  c14_y = c14_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c14_next),
    &c14_thisId);
  sf_mex_destroy(&c14_next);
  *(real_T *)c14_outData = c14_y;
  sf_mex_destroy(&c14_mxArrayInData);
}

static const mxArray *c14_b_sf_marshallOut(void *chartInstanceVoid, void
  *c14_inData)
{
  const mxArray *c14_mxArrayOutData = NULL;
  int32_T c14_i4;
  real_T c14_b_inData[5];
  int32_T c14_i5;
  real_T c14_u[5];
  const mxArray *c14_y = NULL;
  SFc14_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc14_ref_genInstanceStruct *)chartInstanceVoid;
  c14_mxArrayOutData = NULL;
  for (c14_i4 = 0; c14_i4 < 5; c14_i4++) {
    c14_b_inData[c14_i4] = (*(real_T (*)[5])c14_inData)[c14_i4];
  }

  for (c14_i5 = 0; c14_i5 < 5; c14_i5++) {
    c14_u[c14_i5] = c14_b_inData[c14_i5];
  }

  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_create("y", c14_u, 0, 0U, 1U, 0U, 1, 5), FALSE);
  sf_mex_assign(&c14_mxArrayOutData, c14_y, FALSE);
  return c14_mxArrayOutData;
}

const mxArray *sf_c14_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c14_nameCaptureInfo;
  c14_ResolvedFunctionInfo c14_info[14];
  const mxArray *c14_m0 = NULL;
  int32_T c14_i6;
  c14_ResolvedFunctionInfo *c14_r0;
  c14_nameCaptureInfo = NULL;
  c14_nameCaptureInfo = NULL;
  c14_info_helper(c14_info);
  sf_mex_assign(&c14_m0, sf_mex_createstruct("nameCaptureInfo", 1, 14), FALSE);
  for (c14_i6 = 0; c14_i6 < 14; c14_i6++) {
    c14_r0 = &c14_info[c14_i6];
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c14_r0->context)), "context", "nameCaptureInfo",
                    c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c14_r0->name)), "name", "nameCaptureInfo", c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo",
      c14_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c14_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c14_r0->resolved)), "resolved",
                    "nameCaptureInfo", c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo",
      &c14_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c14_i6);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo",
      &c14_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c14_i6);
  }

  sf_mex_assign(&c14_nameCaptureInfo, c14_m0, FALSE);
  return c14_nameCaptureInfo;
}

static void c14_info_helper(c14_ResolvedFunctionInfo c14_info[14])
{
  c14_info[0].context = "";
  c14_info[0].name = "atan2";
  c14_info[0].dominantType = "double";
  c14_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c14_info[0].fileTimeLo = 1286818704U;
  c14_info[0].fileTimeHi = 0U;
  c14_info[0].mFileTimeLo = 0U;
  c14_info[0].mFileTimeHi = 0U;
  c14_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c14_info[1].name = "eml_scalar_eg";
  c14_info[1].dominantType = "double";
  c14_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c14_info[1].fileTimeLo = 1286818796U;
  c14_info[1].fileTimeHi = 0U;
  c14_info[1].mFileTimeLo = 0U;
  c14_info[1].mFileTimeHi = 0U;
  c14_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c14_info[2].name = "eml_scalexp_alloc";
  c14_info[2].dominantType = "double";
  c14_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c14_info[2].fileTimeLo = 1286818796U;
  c14_info[2].fileTimeHi = 0U;
  c14_info[2].mFileTimeLo = 0U;
  c14_info[2].mFileTimeHi = 0U;
  c14_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c14_info[3].name = "eml_scalar_atan2";
  c14_info[3].dominantType = "double";
  c14_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c14_info[3].fileTimeLo = 1286818720U;
  c14_info[3].fileTimeHi = 0U;
  c14_info[3].mFileTimeLo = 0U;
  c14_info[3].mFileTimeHi = 0U;
  c14_info[4].context = "";
  c14_info[4].name = "mtimes";
  c14_info[4].dominantType = "double";
  c14_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c14_info[4].fileTimeLo = 1289519692U;
  c14_info[4].fileTimeHi = 0U;
  c14_info[4].mFileTimeLo = 0U;
  c14_info[4].mFileTimeHi = 0U;
  c14_info[5].context = "";
  c14_info[5].name = "mrdivide";
  c14_info[5].dominantType = "double";
  c14_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c14_info[5].fileTimeLo = 1310137456U;
  c14_info[5].fileTimeHi = 0U;
  c14_info[5].mFileTimeLo = 1289519692U;
  c14_info[5].mFileTimeHi = 0U;
  c14_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c14_info[6].name = "rdivide";
  c14_info[6].dominantType = "double";
  c14_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[6].fileTimeLo = 1286818844U;
  c14_info[6].fileTimeHi = 0U;
  c14_info[6].mFileTimeLo = 0U;
  c14_info[6].mFileTimeHi = 0U;
  c14_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c14_info[7].name = "eml_div";
  c14_info[7].dominantType = "double";
  c14_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c14_info[7].fileTimeLo = 1305318000U;
  c14_info[7].fileTimeHi = 0U;
  c14_info[7].mFileTimeLo = 0U;
  c14_info[7].mFileTimeHi = 0U;
  c14_info[8].context = "";
  c14_info[8].name = "mpower";
  c14_info[8].dominantType = "double";
  c14_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c14_info[8].fileTimeLo = 1286818842U;
  c14_info[8].fileTimeHi = 0U;
  c14_info[8].mFileTimeLo = 0U;
  c14_info[8].mFileTimeHi = 0U;
  c14_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c14_info[9].name = "power";
  c14_info[9].dominantType = "double";
  c14_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c14_info[9].fileTimeLo = 1294067944U;
  c14_info[9].fileTimeHi = 0U;
  c14_info[9].mFileTimeLo = 0U;
  c14_info[9].mFileTimeHi = 0U;
  c14_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c14_info[10].name = "eml_scalar_floor";
  c14_info[10].dominantType = "double";
  c14_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c14_info[10].fileTimeLo = 1286818726U;
  c14_info[10].fileTimeHi = 0U;
  c14_info[10].mFileTimeLo = 0U;
  c14_info[10].mFileTimeHi = 0U;
  c14_info[11].context = "";
  c14_info[11].name = "sqrt";
  c14_info[11].dominantType = "double";
  c14_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c14_info[11].fileTimeLo = 1286818752U;
  c14_info[11].fileTimeHi = 0U;
  c14_info[11].mFileTimeLo = 0U;
  c14_info[11].mFileTimeHi = 0U;
  c14_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c14_info[12].name = "eml_error";
  c14_info[12].dominantType = "char";
  c14_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c14_info[12].fileTimeLo = 1305318000U;
  c14_info[12].fileTimeHi = 0U;
  c14_info[12].mFileTimeLo = 0U;
  c14_info[12].mFileTimeHi = 0U;
  c14_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c14_info[13].name = "eml_scalar_sqrt";
  c14_info[13].dominantType = "double";
  c14_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c14_info[13].fileTimeLo = 1286818738U;
  c14_info[13].fileTimeHi = 0U;
  c14_info[13].mFileTimeLo = 0U;
  c14_info[13].mFileTimeHi = 0U;
}

static void c14_eml_scalar_eg(SFc14_ref_genInstanceStruct *chartInstance)
{
}

static real_T c14_mpower(SFc14_ref_genInstanceStruct *chartInstance, real_T
  c14_a)
{
  real_T c14_b_a;
  real_T c14_ak;
  c14_b_a = c14_a;
  c14_eml_scalar_eg(chartInstance);
  c14_ak = c14_b_a;
  return muDoubleScalarPower(c14_ak, 2.0);
}

static void c14_eml_error(SFc14_ref_genInstanceStruct *chartInstance)
{
  int32_T c14_i7;
  static char_T c14_varargin_1[30] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 's', 'q', 'r', 't', '_', 'd', 'o', 'm', 'a',
    'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c14_u[30];
  const mxArray *c14_y = NULL;
  for (c14_i7 = 0; c14_i7 < 30; c14_i7++) {
    c14_u[c14_i7] = c14_varargin_1[c14_i7];
  }

  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_create("y", c14_u, 10, 0U, 1U, 0U, 2, 1, 30),
                FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c14_y));
}

static const mxArray *c14_c_sf_marshallOut(void *chartInstanceVoid, void
  *c14_inData)
{
  const mxArray *c14_mxArrayOutData = NULL;
  int32_T c14_u;
  const mxArray *c14_y = NULL;
  SFc14_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc14_ref_genInstanceStruct *)chartInstanceVoid;
  c14_mxArrayOutData = NULL;
  c14_u = *(int32_T *)c14_inData;
  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_create("y", &c14_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c14_mxArrayOutData, c14_y, FALSE);
  return c14_mxArrayOutData;
}

static int32_T c14_c_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_u, const emlrtMsgIdentifier *c14_parentId)
{
  int32_T c14_y;
  int32_T c14_i8;
  sf_mex_import(c14_parentId, sf_mex_dup(c14_u), &c14_i8, 1, 6, 0U, 0, 0U, 0);
  c14_y = c14_i8;
  sf_mex_destroy(&c14_u);
  return c14_y;
}

static void c14_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c14_mxArrayInData, const char_T *c14_varName, void *c14_outData)
{
  const mxArray *c14_b_sfEvent;
  const char_T *c14_identifier;
  emlrtMsgIdentifier c14_thisId;
  int32_T c14_y;
  SFc14_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc14_ref_genInstanceStruct *)chartInstanceVoid;
  c14_b_sfEvent = sf_mex_dup(c14_mxArrayInData);
  c14_identifier = c14_varName;
  c14_thisId.fIdentifier = c14_identifier;
  c14_thisId.fParent = NULL;
  c14_y = c14_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c14_b_sfEvent),
    &c14_thisId);
  sf_mex_destroy(&c14_b_sfEvent);
  *(int32_T *)c14_outData = c14_y;
  sf_mex_destroy(&c14_mxArrayInData);
}

static uint8_T c14_d_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_b_is_active_c14_ref_gen, const char_T *c14_identifier)
{
  uint8_T c14_y;
  emlrtMsgIdentifier c14_thisId;
  c14_thisId.fIdentifier = c14_identifier;
  c14_thisId.fParent = NULL;
  c14_y = c14_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c14_b_is_active_c14_ref_gen), &c14_thisId);
  sf_mex_destroy(&c14_b_is_active_c14_ref_gen);
  return c14_y;
}

static uint8_T c14_e_emlrt_marshallIn(SFc14_ref_genInstanceStruct *chartInstance,
  const mxArray *c14_u, const emlrtMsgIdentifier *c14_parentId)
{
  uint8_T c14_y;
  uint8_T c14_u0;
  sf_mex_import(c14_parentId, sf_mex_dup(c14_u), &c14_u0, 1, 3, 0U, 0, 0U, 0);
  c14_y = c14_u0;
  sf_mex_destroy(&c14_u);
  return c14_y;
}

static void init_dsm_address_info(SFc14_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c14_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3669009910U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3638909675U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(628328762U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3877982781U);
}

mxArray *sf_c14_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("I1u6OxTJvgUF7BbHDO27fF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c14_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[11],T\"next\",},{M[1],M[16],T\"psi_dot_ref\",},{M[1],M[5],T\"ref_heading\",},{M[1],M[10],T\"v_ref\",},{M[8],M[0],T\"is_active_c14_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c14_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc14_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc14_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          14,
          1,
          1,
          8,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"v_ref");
          _SFD_SET_DATA_PROPS(1,1,1,0,"north");
          _SFD_SET_DATA_PROPS(2,1,1,0,"west");
          _SFD_SET_DATA_PROPS(3,1,1,0,"wpn");
          _SFD_SET_DATA_PROPS(4,2,0,1,"ref_heading");
          _SFD_SET_DATA_PROPS(5,1,1,0,"wpl");
          _SFD_SET_DATA_PROPS(6,2,0,1,"psi_dot_ref");
          _SFD_SET_DATA_PROPS(7,2,0,1,"next");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,448);
        _SFD_CV_INIT_EML_IF(0,1,0,320,337,350,370);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c14_sf_marshallOut,(MexInFcnForType)c14_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c14_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c14_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 5;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c14_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c14_sf_marshallOut,(MexInFcnForType)c14_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 5;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c14_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c14_sf_marshallOut,(MexInFcnForType)c14_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c14_sf_marshallOut,(MexInFcnForType)c14_sf_marshallIn);

        {
          real_T *c14_v_ref;
          real_T *c14_north;
          real_T *c14_west;
          real_T *c14_ref_heading;
          real_T *c14_psi_dot_ref;
          real_T *c14_next;
          real_T (*c14_wpn)[5];
          real_T (*c14_wpl)[5];
          c14_next = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c14_psi_dot_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c14_wpl = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 3);
          c14_ref_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c14_wpn = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 2);
          c14_west = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c14_north = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          c14_v_ref = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c14_v_ref);
          _SFD_SET_DATA_VALUE_PTR(1U, c14_north);
          _SFD_SET_DATA_VALUE_PTR(2U, c14_west);
          _SFD_SET_DATA_VALUE_PTR(3U, *c14_wpn);
          _SFD_SET_DATA_VALUE_PTR(4U, c14_ref_heading);
          _SFD_SET_DATA_VALUE_PTR(5U, *c14_wpl);
          _SFD_SET_DATA_VALUE_PTR(6U, c14_psi_dot_ref);
          _SFD_SET_DATA_VALUE_PTR(7U, c14_next);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c14_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc14_ref_genInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c14_ref_gen(void *chartInstanceVar)
{
  enable_c14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c14_ref_gen(void *chartInstanceVar)
{
  disable_c14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c14_ref_gen(void *chartInstanceVar)
{
  sf_c14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c14_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c14_ref_gen((SFc14_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c14_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c14_ref_gen(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c14_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c14_ref_gen((SFc14_ref_genInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c14_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c14_ref_gen(S);
}

static void sf_opaque_set_sim_state_c14_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c14_ref_gen(S, st);
}

static void sf_opaque_terminate_c14_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc14_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc14_ref_gen((SFc14_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c14_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c14_ref_gen((SFc14_ref_genInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c14_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,14);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,14,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,14,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,14,4);
      sf_mark_chart_reusable_outputs(S,infoStruct,14,4);
    }

    sf_set_rtw_dwork_info(S,infoStruct,14);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2185556109U));
  ssSetChecksum1(S,(1916775663U));
  ssSetChecksum2(S,(3671893163U));
  ssSetChecksum3(S,(866776163U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c14_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c14_ref_gen(SimStruct *S)
{
  SFc14_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc14_ref_genInstanceStruct *)malloc(sizeof
    (SFc14_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc14_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c14_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c14_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c14_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c14_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c14_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c14_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c14_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c14_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c14_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c14_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c14_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c14_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c14_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c14_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c14_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c14_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
