/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c15_ref_gen.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c15_debug_family_names[7] = { "nargin", "nargout", "wp",
  "next", "wpout", "i", "last" };

/* Function Declarations */
static void initialize_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance);
static void initialize_params_c15_ref_gen(SFc15_ref_genInstanceStruct
  *chartInstance);
static void enable_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance);
static void disable_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance);
static void c15_update_debugger_state_c15_ref_gen(SFc15_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c15_ref_gen(SFc15_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_st);
static void finalize_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance);
static void sf_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance);
static void initSimStructsc15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c15_machineNumber, uint32_T
  c15_chartNumber);
static const mxArray *c15_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static real_T c15_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_b_last, const char_T *c15_identifier);
static real_T c15_b_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_b_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static real_T c15_c_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_b_i, const char_T *c15_identifier);
static real_T c15_d_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_c_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_e_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_wpout, const char_T *c15_identifier, real_T c15_y[10]);
static void c15_f_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[10]);
static void c15_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_d_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static const mxArray *c15_e_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static real_T c15_g_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_f_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static int32_T c15_h_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static uint8_T c15_i_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_b_is_active_c15_ref_gen, const char_T *c15_identifier);
static uint8_T c15_j_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void init_dsm_address_info(SFc15_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c15_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c15_i_not_empty = FALSE;
  chartInstance->c15_last_not_empty = FALSE;
  chartInstance->c15_is_active_c15_ref_gen = 0U;
}

static void initialize_params_c15_ref_gen(SFc15_ref_genInstanceStruct
  *chartInstance)
{
}

static void enable_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c15_update_debugger_state_c15_ref_gen(SFc15_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c15_ref_gen(SFc15_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c15_st;
  const mxArray *c15_y = NULL;
  int32_T c15_i0;
  real_T c15_u[10];
  const mxArray *c15_b_y = NULL;
  real_T c15_hoistedGlobal;
  real_T c15_b_u;
  const mxArray *c15_c_y = NULL;
  real_T c15_b_hoistedGlobal;
  real_T c15_c_u;
  const mxArray *c15_d_y = NULL;
  uint8_T c15_c_hoistedGlobal;
  uint8_T c15_d_u;
  const mxArray *c15_e_y = NULL;
  real_T (*c15_wpout)[10];
  c15_wpout = (real_T (*)[10])ssGetOutputPortSignal(chartInstance->S, 1);
  c15_st = NULL;
  c15_st = NULL;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_createcellarray(4), FALSE);
  for (c15_i0 = 0; c15_i0 < 10; c15_i0++) {
    c15_u[c15_i0] = (*c15_wpout)[c15_i0];
  }

  c15_b_y = NULL;
  sf_mex_assign(&c15_b_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 1, 10),
                FALSE);
  sf_mex_setcell(c15_y, 0, c15_b_y);
  c15_hoistedGlobal = chartInstance->c15_i;
  c15_b_u = c15_hoistedGlobal;
  c15_c_y = NULL;
  if (!chartInstance->c15_i_not_empty) {
    sf_mex_assign(&c15_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_c_y, sf_mex_create("y", &c15_b_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c15_y, 1, c15_c_y);
  c15_b_hoistedGlobal = chartInstance->c15_last;
  c15_c_u = c15_b_hoistedGlobal;
  c15_d_y = NULL;
  if (!chartInstance->c15_last_not_empty) {
    sf_mex_assign(&c15_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_d_y, sf_mex_create("y", &c15_c_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c15_y, 2, c15_d_y);
  c15_c_hoistedGlobal = chartInstance->c15_is_active_c15_ref_gen;
  c15_d_u = c15_c_hoistedGlobal;
  c15_e_y = NULL;
  sf_mex_assign(&c15_e_y, sf_mex_create("y", &c15_d_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c15_y, 3, c15_e_y);
  sf_mex_assign(&c15_st, c15_y, FALSE);
  return c15_st;
}

static void set_sim_state_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_st)
{
  const mxArray *c15_u;
  real_T c15_dv0[10];
  int32_T c15_i1;
  real_T (*c15_wpout)[10];
  c15_wpout = (real_T (*)[10])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c15_doneDoubleBufferReInit = TRUE;
  c15_u = sf_mex_dup(c15_st);
  c15_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 0)),
    "wpout", c15_dv0);
  for (c15_i1 = 0; c15_i1 < 10; c15_i1++) {
    (*c15_wpout)[c15_i1] = c15_dv0[c15_i1];
  }

  chartInstance->c15_i = c15_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c15_u, 1)), "i");
  chartInstance->c15_last = c15_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c15_u, 2)), "last");
  chartInstance->c15_is_active_c15_ref_gen = c15_i_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 3)),
     "is_active_c15_ref_gen");
  sf_mex_destroy(&c15_u);
  c15_update_debugger_state_c15_ref_gen(chartInstance);
  sf_mex_destroy(&c15_st);
}

static void finalize_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance)
{
  int32_T c15_i2;
  int32_T c15_i3;
  real_T c15_hoistedGlobal;
  int32_T c15_i4;
  real_T c15_wp[25];
  real_T c15_next;
  uint32_T c15_debug_family_var_map[7];
  real_T c15_nargin = 2.0;
  real_T c15_nargout = 1.0;
  real_T c15_wpout[10];
  int32_T c15_i5;
  real_T *c15_b_next;
  real_T (*c15_b_wpout)[10];
  real_T (*c15_b_wp)[25];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  c15_b_next = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c15_b_wpout = (real_T (*)[10])ssGetOutputPortSignal(chartInstance->S, 1);
  c15_b_wp = (real_T (*)[25])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 12U, chartInstance->c15_sfEvent);
  for (c15_i2 = 0; c15_i2 < 25; c15_i2++) {
    _SFD_DATA_RANGE_CHECK((*c15_b_wp)[c15_i2], 0U);
  }

  for (c15_i3 = 0; c15_i3 < 10; c15_i3++) {
    _SFD_DATA_RANGE_CHECK((*c15_b_wpout)[c15_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c15_b_next, 2U);
  chartInstance->c15_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 12U, chartInstance->c15_sfEvent);
  c15_hoistedGlobal = *c15_b_next;
  for (c15_i4 = 0; c15_i4 < 25; c15_i4++) {
    c15_wp[c15_i4] = (*c15_b_wp)[c15_i4];
  }

  c15_next = c15_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 7U, 7U, c15_debug_family_names,
    c15_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c15_nargin, 0U, c15_d_sf_marshallOut,
    c15_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c15_nargout, 1U,
    c15_d_sf_marshallOut, c15_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c15_wp, 2U, c15_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c15_next, 3U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c15_wpout, 4U, c15_c_sf_marshallOut,
    c15_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c15_i, 5U,
    c15_b_sf_marshallOut, c15_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c15_last, 6U,
    c15_sf_marshallOut, c15_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 4);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c15_i_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 5);
    chartInstance->c15_i = 1.0;
    chartInstance->c15_i_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 6);
    chartInstance->c15_last = 0.0;
    chartInstance->c15_last_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 9);
  guard3 = FALSE;
  guard4 = FALSE;
  if (CV_EML_COND(0, 1, 0, c15_next == 1.0)) {
    if (CV_EML_COND(0, 1, 1, chartInstance->c15_i < 15.0)) {
      if (CV_EML_COND(0, 1, 2, chartInstance->c15_last == 0.0)) {
        CV_EML_MCDC(0, 1, 0, TRUE);
        CV_EML_IF(0, 1, 1, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 10);
        chartInstance->c15_i += 5.0;
        _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 11);
        chartInstance->c15_last = 1.0;
      } else {
        guard3 = TRUE;
      }
    } else {
      guard4 = TRUE;
    }
  } else {
    guard4 = TRUE;
  }

  if (guard4 == TRUE) {
    guard3 = TRUE;
  }

  if (guard3 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 15);
  if (CV_EML_IF(0, 1, 2, c15_next == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 16);
    chartInstance->c15_last = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 19);
  c15_wpout[0] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+5", chartInstance->c15_i + 5.0), 1, 25, 1, 0) - 1];
  c15_wpout[1] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+6", chartInstance->c15_i + 6.0), 1, 25, 1, 0) - 1];
  c15_wpout[2] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+7", chartInstance->c15_i + 7.0), 1, 25, 1, 0) - 1];
  c15_wpout[3] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+8", chartInstance->c15_i + 8.0), 1, 25, 1, 0) - 1];
  c15_wpout[4] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+9", chartInstance->c15_i + 9.0), 1, 25, 1, 0) - 1];
  c15_wpout[5] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i", chartInstance->c15_i), 1, 25, 1, 0) - 1];
  c15_wpout[6] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+1", chartInstance->c15_i + 1.0), 1, 25, 1, 0) - 1];
  c15_wpout[7] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+2", chartInstance->c15_i + 2.0), 1, 25, 1, 0) - 1];
  c15_wpout[8] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+3", chartInstance->c15_i + 3.0), 1, 25, 1, 0) - 1];
  c15_wpout[9] = c15_wp[_SFD_EML_ARRAY_BOUNDS_CHECK("wp", (int32_T)
    _SFD_INTEGER_CHECK("i+4", chartInstance->c15_i + 4.0), 1, 25, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 21);
  guard1 = FALSE;
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 3, c15_next == 1.0)) {
    if (CV_EML_COND(0, 1, 4, chartInstance->c15_i > 15.0)) {
      if (CV_EML_COND(0, 1, 5, chartInstance->c15_last == 0.0)) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 3, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 22);
        chartInstance->c15_i = 1.0;
        _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 23);
        chartInstance->c15_last = 1.0;
      } else {
        guard1 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 1, FALSE);
    CV_EML_IF(0, 1, 3, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, -23);
  sf_debug_symbol_scope_pop();
  for (c15_i5 = 0; c15_i5 < 10; c15_i5++) {
    (*c15_b_wpout)[c15_i5] = c15_wpout[c15_i5];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 12U, chartInstance->c15_sfEvent);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc15_ref_gen(SFc15_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c15_machineNumber, uint32_T
  c15_chartNumber)
{
}

static const mxArray *c15_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  real_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(real_T *)c15_inData;
  c15_y = NULL;
  if (!chartInstance->c15_last_not_empty) {
    sf_mex_assign(&c15_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static real_T c15_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_b_last, const char_T *c15_identifier)
{
  real_T c15_y;
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_last),
    &c15_thisId);
  sf_mex_destroy(&c15_b_last);
  return c15_y;
}

static real_T c15_b_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  real_T c15_y;
  real_T c15_d0;
  if (mxIsEmpty(c15_u)) {
    chartInstance->c15_last_not_empty = FALSE;
  } else {
    chartInstance->c15_last_not_empty = TRUE;
    sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_d0, 1, 0, 0U, 0, 0U, 0);
    c15_y = c15_d0;
  }

  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_b_last;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_b_last = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_last),
    &c15_thisId);
  sf_mex_destroy(&c15_b_last);
  *(real_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_b_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  real_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(real_T *)c15_inData;
  c15_y = NULL;
  if (!chartInstance->c15_i_not_empty) {
    sf_mex_assign(&c15_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static real_T c15_c_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_b_i, const char_T *c15_identifier)
{
  real_T c15_y;
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_i), &c15_thisId);
  sf_mex_destroy(&c15_b_i);
  return c15_y;
}

static real_T c15_d_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  real_T c15_y;
  real_T c15_d1;
  if (mxIsEmpty(c15_u)) {
    chartInstance->c15_i_not_empty = FALSE;
  } else {
    chartInstance->c15_i_not_empty = TRUE;
    sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_d1, 1, 0, 0U, 0, 0U, 0);
    c15_y = c15_d1;
  }

  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_b_i;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_b_i = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_i), &c15_thisId);
  sf_mex_destroy(&c15_b_i);
  *(real_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_c_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i6;
  real_T c15_b_inData[10];
  int32_T c15_i7;
  real_T c15_u[10];
  const mxArray *c15_y = NULL;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i6 = 0; c15_i6 < 10; c15_i6++) {
    c15_b_inData[c15_i6] = (*(real_T (*)[10])c15_inData)[c15_i6];
  }

  for (c15_i7 = 0; c15_i7 < 10; c15_i7++) {
    c15_u[c15_i7] = c15_b_inData[c15_i7];
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 1, 10),
                FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_e_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_wpout, const char_T *c15_identifier, real_T c15_y[10])
{
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_wpout), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_wpout);
}

static void c15_f_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[10])
{
  real_T c15_dv1[10];
  int32_T c15_i8;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv1, 1, 0, 0U, 1, 0U, 2, 1,
                10);
  for (c15_i8 = 0; c15_i8 < 10; c15_i8++) {
    c15_y[c15_i8] = c15_dv1[c15_i8];
  }

  sf_mex_destroy(&c15_u);
}

static void c15_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_wpout;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[10];
  int32_T c15_i9;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_wpout = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_wpout), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_wpout);
  for (c15_i9 = 0; c15_i9 < 10; c15_i9++) {
    (*(real_T (*)[10])c15_outData)[c15_i9] = c15_y[c15_i9];
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_d_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  real_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(real_T *)c15_inData;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static const mxArray *c15_e_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i10;
  real_T c15_b_inData[25];
  int32_T c15_i11;
  real_T c15_u[25];
  const mxArray *c15_y = NULL;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i10 = 0; c15_i10 < 25; c15_i10++) {
    c15_b_inData[c15_i10] = (*(real_T (*)[25])c15_inData)[c15_i10];
  }

  for (c15_i11 = 0; c15_i11 < 25; c15_i11++) {
    c15_u[c15_i11] = c15_b_inData[c15_i11];
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 1, 25), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static real_T c15_g_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  real_T c15_y;
  real_T c15_d2;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_d2, 1, 0, 0U, 0, 0U, 0);
  c15_y = c15_d2;
  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_nargout;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_nargout = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_nargout),
    &c15_thisId);
  sf_mex_destroy(&c15_nargout);
  *(real_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

const mxArray *sf_c15_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c15_nameCaptureInfo;
  c15_ResolvedFunctionInfo c15_info[1];
  c15_ResolvedFunctionInfo (*c15_b_info)[1];
  const mxArray *c15_m0 = NULL;
  int32_T c15_i12;
  c15_ResolvedFunctionInfo *c15_r0;
  c15_nameCaptureInfo = NULL;
  c15_nameCaptureInfo = NULL;
  c15_b_info = (c15_ResolvedFunctionInfo (*)[1])c15_info;
  (*c15_b_info)[0].context = "";
  (*c15_b_info)[0].name = "length";
  (*c15_b_info)[0].dominantType = "double";
  (*c15_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  (*c15_b_info)[0].fileTimeLo = 1303146206U;
  (*c15_b_info)[0].fileTimeHi = 0U;
  (*c15_b_info)[0].mFileTimeLo = 0U;
  (*c15_b_info)[0].mFileTimeHi = 0U;
  sf_mex_assign(&c15_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1), FALSE);
  for (c15_i12 = 0; c15_i12 < 1; c15_i12++) {
    c15_r0 = &c15_info[c15_i12];
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c15_r0->context)), "context", "nameCaptureInfo",
                    c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c15_r0->name)), "name", "nameCaptureInfo",
                    c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      c15_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c15_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c15_r0->resolved)), "resolved",
                    "nameCaptureInfo", c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      &c15_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c15_i12);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      &c15_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c15_i12);
  }

  sf_mex_assign(&c15_nameCaptureInfo, c15_m0, FALSE);
  return c15_nameCaptureInfo;
}

static const mxArray *c15_f_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(int32_T *)c15_inData;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static int32_T c15_h_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  int32_T c15_y;
  int32_T c15_i13;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_i13, 1, 6, 0U, 0, 0U, 0);
  c15_y = c15_i13;
  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_b_sfEvent;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  int32_T c15_y;
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)chartInstanceVoid;
  c15_b_sfEvent = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_sfEvent),
    &c15_thisId);
  sf_mex_destroy(&c15_b_sfEvent);
  *(int32_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

static uint8_T c15_i_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_b_is_active_c15_ref_gen, const char_T *c15_identifier)
{
  uint8_T c15_y;
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c15_b_is_active_c15_ref_gen), &c15_thisId);
  sf_mex_destroy(&c15_b_is_active_c15_ref_gen);
  return c15_y;
}

static uint8_T c15_j_emlrt_marshallIn(SFc15_ref_genInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  uint8_T c15_y;
  uint8_T c15_u0;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_u0, 1, 3, 0U, 0, 0U, 0);
  c15_y = c15_u0;
  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void init_dsm_address_info(SFc15_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c15_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2742857134U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(897910936U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1925810701U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1203832487U);
}

mxArray *sf_c15_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("xmciLv5KQlbHdf5OBvdiLH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(25);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(10);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c15_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[5],T\"wpout\",},{M[4],M[0],T\"i\",S'l','i','p'{{M1x2[45 46],M[0],}}},{M[4],M[0],T\"last\",S'l','i','p'{{M1x2[63 67],M[0],}}},{M[8],M[0],T\"is_active_c15_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c15_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc15_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc15_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          15,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"wp");
          _SFD_SET_DATA_PROPS(1,2,0,1,"wpout");
          _SFD_SET_DATA_PROPS(2,1,1,0,"next");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,6,2);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,471);
        _SFD_CV_INIT_EML_IF(0,1,0,73,86,-1,127);
        _SFD_CV_INIT_EML_IF(0,1,1,140,180,-1,226);
        _SFD_CV_INIT_EML_IF(0,1,2,240,252,-1,278);
        _SFD_CV_INIT_EML_IF(0,1,3,382,422,-1,471);

        {
          static int condStart[] = { 143, 154, 173 };

          static int condEnd[] = { 150, 169, 180 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,143,180,3,0,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 385, 396, 415 };

          static int condEnd[] = { 392, 411, 422 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,385,422,3,3,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 25;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_e_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 10;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_c_sf_marshallOut,(MexInFcnForType)
            c15_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c15_next;
          real_T (*c15_wp)[25];
          real_T (*c15_wpout)[10];
          c15_next = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c15_wpout = (real_T (*)[10])ssGetOutputPortSignal(chartInstance->S, 1);
          c15_wp = (real_T (*)[25])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c15_wp);
          _SFD_SET_DATA_VALUE_PTR(1U, *c15_wpout);
          _SFD_SET_DATA_VALUE_PTR(2U, c15_next);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c15_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc15_ref_genInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c15_ref_gen(void *chartInstanceVar)
{
  enable_c15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c15_ref_gen(void *chartInstanceVar)
{
  disable_c15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c15_ref_gen(void *chartInstanceVar)
{
  sf_c15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c15_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c15_ref_gen((SFc15_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c15_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c15_ref_gen(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c15_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c15_ref_gen((SFc15_ref_genInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c15_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c15_ref_gen(S);
}

static void sf_opaque_set_sim_state_c15_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c15_ref_gen(S, st);
}

static void sf_opaque_terminate_c15_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc15_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc15_ref_gen((SFc15_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c15_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c15_ref_gen((SFc15_ref_genInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c15_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,15);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,15,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,15,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,15,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,15,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,15);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1546369526U));
  ssSetChecksum1(S,(2642418013U));
  ssSetChecksum2(S,(1483519536U));
  ssSetChecksum3(S,(1875337466U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c15_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c15_ref_gen(SimStruct *S)
{
  SFc15_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc15_ref_genInstanceStruct *)malloc(sizeof
    (SFc15_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc15_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c15_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c15_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c15_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c15_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c15_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c15_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c15_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c15_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c15_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c15_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c15_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c15_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c15_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c15_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c15_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c15_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
