/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c1_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c1_debug_family_names[15] = { "v_body", "omega_body", "I_g",
  "M_RB", "C_RB", "D_RB", "g", "nargin", "nargout", "nu_body", "tau", "m_car",
  "I_car", "nu_body_dot", "a_body" };

static const char * c1_b_debug_family_names[4] = { "nargin", "nargout", "r", "S"
};

/* Function Declarations */
static void initialize_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void initialize_params_c1_ref_gen(SFc1_ref_genInstanceStruct
  *chartInstance);
static void enable_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void disable_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_update_debugger_state_c1_ref_gen(SFc1_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c1_ref_gen(SFc1_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_st);
static void finalize_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void sf_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_chartstep_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void initSimStructsc1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData);
static void c1_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance, const
  mxArray *c1_a_body, const char_T *c1_identifier, real_T c1_y[6]);
static void c1_b_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[6]);
static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_c_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[3]);
static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static real_T c1_d_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_d_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_e_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[36]);
static void c1_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_e_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_f_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[9]);
static void c1_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_f_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_g_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[3]);
static void c1_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[50]);
static void c1_diag(SFc1_ref_genInstanceStruct *chartInstance, real_T c1_v[3],
                    real_T c1_d[9]);
static void c1_Smtrx(SFc1_ref_genInstanceStruct *chartInstance, real_T c1_r[3],
                     real_T c1_S[9]);
static void c1_eml_scalar_eg(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_b_eml_scalar_eg(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_mldivide(SFc1_ref_genInstanceStruct *chartInstance, real_T c1_A
  [36], real_T c1_B[6], real_T c1_Y[6]);
static void c1_eps(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_eml_matlab_zgetrf(SFc1_ref_genInstanceStruct *chartInstance,
  real_T c1_A[36], real_T c1_b_A[36], int32_T c1_ipiv[6], int32_T *c1_info);
static int32_T c1_eml_ixamax(SFc1_ref_genInstanceStruct *chartInstance, int32_T
  c1_n, real_T c1_x[36], int32_T c1_ix0);
static void c1_eml_warning(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_below_threshold(SFc1_ref_genInstanceStruct *chartInstance);
static void c1_c_eml_scalar_eg(SFc1_ref_genInstanceStruct *chartInstance);
static const mxArray *c1_g_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static int32_T c1_h_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static uint8_T c1_i_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_b_is_active_c1_ref_gen, const char_T *c1_identifier);
static uint8_T c1_j_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_b_eml_matlab_zgetrf(SFc1_ref_genInstanceStruct *chartInstance,
  real_T c1_A[36], int32_T c1_ipiv[6], int32_T *c1_info);
static void init_dsm_address_info(SFc1_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c1_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c1_is_active_c1_ref_gen = 0U;
}

static void initialize_params_c1_ref_gen(SFc1_ref_genInstanceStruct
  *chartInstance)
{
  real_T c1_d0;
  real_T c1_dv0[3];
  int32_T c1_i0;
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c1_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c1_m_car = c1_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_car' in the parent workspace.\n");
  sf_mex_import_named("I_car", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c1_dv0, 0, 0, 0U, 1, 0U, 2, 1, 3);
  for (c1_i0 = 0; c1_i0 < 3; c1_i0++) {
    chartInstance->c1_I_car[c1_i0] = c1_dv0[c1_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c1_update_debugger_state_c1_ref_gen(SFc1_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c1_ref_gen(SFc1_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c1_st;
  const mxArray *c1_y = NULL;
  int32_T c1_i1;
  real_T c1_u[6];
  const mxArray *c1_b_y = NULL;
  int32_T c1_i2;
  real_T c1_b_u[6];
  const mxArray *c1_c_y = NULL;
  uint8_T c1_hoistedGlobal;
  uint8_T c1_c_u;
  const mxArray *c1_d_y = NULL;
  real_T (*c1_nu_body_dot)[6];
  real_T (*c1_a_body)[6];
  c1_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c1_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c1_st = NULL;
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(3), FALSE);
  for (c1_i1 = 0; c1_i1 < 6; c1_i1++) {
    c1_u[c1_i1] = (*c1_a_body)[c1_i1];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c1_y, 0, c1_b_y);
  for (c1_i2 = 0; c1_i2 < 6; c1_i2++) {
    c1_b_u[c1_i2] = (*c1_nu_body_dot)[c1_i2];
  }

  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", c1_b_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c1_y, 1, c1_c_y);
  c1_hoistedGlobal = chartInstance->c1_is_active_c1_ref_gen;
  c1_c_u = c1_hoistedGlobal;
  c1_d_y = NULL;
  sf_mex_assign(&c1_d_y, sf_mex_create("y", &c1_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 2, c1_d_y);
  sf_mex_assign(&c1_st, c1_y, FALSE);
  return c1_st;
}

static void set_sim_state_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_st)
{
  const mxArray *c1_u;
  real_T c1_dv1[6];
  int32_T c1_i3;
  real_T c1_dv2[6];
  int32_T c1_i4;
  real_T (*c1_a_body)[6];
  real_T (*c1_nu_body_dot)[6];
  c1_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c1_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c1_doneDoubleBufferReInit = TRUE;
  c1_u = sf_mex_dup(c1_st);
  c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 0)),
                      "a_body", c1_dv1);
  for (c1_i3 = 0; c1_i3 < 6; c1_i3++) {
    (*c1_a_body)[c1_i3] = c1_dv1[c1_i3];
  }

  c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 1)),
                      "nu_body_dot", c1_dv2);
  for (c1_i4 = 0; c1_i4 < 6; c1_i4++) {
    (*c1_nu_body_dot)[c1_i4] = c1_dv2[c1_i4];
  }

  chartInstance->c1_is_active_c1_ref_gen = c1_i_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c1_u, 2)), "is_active_c1_ref_gen");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_ref_gen(chartInstance);
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
  int32_T c1_i5;
  int32_T c1_i6;
  int32_T c1_i7;
  int32_T c1_i8;
  int32_T c1_i9;
  real_T (*c1_a_body)[6];
  real_T (*c1_nu_body_dot)[6];
  real_T (*c1_tau)[6];
  real_T (*c1_nu_body)[6];
  c1_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c1_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c1_tau = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c1_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  for (c1_i5 = 0; c1_i5 < 6; c1_i5++) {
    _SFD_DATA_RANGE_CHECK((*c1_nu_body)[c1_i5], 0U);
  }

  for (c1_i6 = 0; c1_i6 < 6; c1_i6++) {
    _SFD_DATA_RANGE_CHECK((*c1_tau)[c1_i6], 1U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c1_m_car, 2U);
  for (c1_i7 = 0; c1_i7 < 3; c1_i7++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c1_I_car[c1_i7], 3U);
  }

  for (c1_i8 = 0; c1_i8 < 6; c1_i8++) {
    _SFD_DATA_RANGE_CHECK((*c1_nu_body_dot)[c1_i8], 4U);
  }

  for (c1_i9 = 0; c1_i9 < 6; c1_i9++) {
    _SFD_DATA_RANGE_CHECK((*c1_a_body)[c1_i9], 5U);
  }

  chartInstance->c1_sfEvent = CALL_EVENT;
  c1_chartstep_c1_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c1_chartstep_c1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
  real_T c1_hoistedGlobal;
  int32_T c1_i10;
  real_T c1_nu_body[6];
  int32_T c1_i11;
  real_T c1_tau[6];
  real_T c1_b_m_car;
  int32_T c1_i12;
  real_T c1_b_I_car[3];
  uint32_T c1_debug_family_var_map[15];
  real_T c1_v_body[3];
  real_T c1_omega_body[3];
  real_T c1_I_g[9];
  real_T c1_M_RB[36];
  real_T c1_C_RB[36];
  real_T c1_D_RB[36];
  real_T c1_g[6];
  real_T c1_nargin = 4.0;
  real_T c1_nargout = 2.0;
  real_T c1_nu_body_dot[6];
  real_T c1_a_body[6];
  int32_T c1_i13;
  int32_T c1_i14;
  int32_T c1_i15;
  real_T c1_c_I_car[3];
  real_T c1_dv3[9];
  int32_T c1_i16;
  real_T c1_a;
  int32_T c1_i17;
  static real_T c1_b[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0 };

  real_T c1_y[9];
  int32_T c1_i18;
  real_T c1_d_I_car[3];
  real_T c1_dv4[9];
  int32_T c1_i19;
  int32_T c1_i20;
  int32_T c1_i21;
  int32_T c1_i22;
  int32_T c1_i23;
  int32_T c1_i24;
  int32_T c1_i25;
  int32_T c1_i26;
  int32_T c1_i27;
  int32_T c1_i28;
  int32_T c1_i29;
  int32_T c1_i30;
  int32_T c1_i31;
  int32_T c1_i32;
  real_T c1_b_a;
  int32_T c1_i33;
  real_T c1_b_omega_body[3];
  real_T c1_b_b[9];
  int32_T c1_i34;
  int32_T c1_i35;
  int32_T c1_i36;
  real_T c1_c_b[3];
  int32_T c1_i37;
  real_T c1_b_y[3];
  int32_T c1_i38;
  int32_T c1_i39;
  int32_T c1_i40;
  real_T c1_c_y[3];
  int32_T c1_i41;
  int32_T c1_i42;
  int32_T c1_i43;
  int32_T c1_i44;
  int32_T c1_i45;
  int32_T c1_i46;
  int32_T c1_i47;
  int32_T c1_i48;
  int32_T c1_i49;
  int32_T c1_i50;
  int32_T c1_i51;
  int32_T c1_i52;
  int32_T c1_i53;
  int32_T c1_i54;
  int32_T c1_i55;
  real_T c1_c_a;
  real_T c1_d_y;
  real_T c1_dv5[6];
  int32_T c1_i56;
  int32_T c1_i57;
  real_T c1_d_a[36];
  int32_T c1_i58;
  real_T c1_d_b[6];
  int32_T c1_i59;
  real_T c1_e_y[6];
  int32_T c1_i60;
  int32_T c1_i61;
  int32_T c1_i62;
  int32_T c1_i63;
  real_T c1_f_y[6];
  int32_T c1_i64;
  int32_T c1_i65;
  real_T c1_b_M_RB[36];
  int32_T c1_i66;
  real_T c1_b_tau[6];
  real_T c1_dv6[6];
  int32_T c1_i67;
  int32_T c1_i68;
  real_T c1_c_omega_body[3];
  int32_T c1_i69;
  int32_T c1_i70;
  int32_T c1_i71;
  int32_T c1_i72;
  int32_T c1_i73;
  real_T c1_r[3];
  uint32_T c1_b_debug_family_var_map[4];
  real_T c1_b_nargin = 1.0;
  real_T c1_b_nargout = 1.0;
  real_T c1_S[9];
  int32_T c1_i74;
  int32_T c1_i75;
  int32_T c1_i76;
  real_T c1_g_y[3];
  int32_T c1_i77;
  int32_T c1_i78;
  int32_T c1_i79;
  real_T c1_h_y[6];
  int32_T c1_i80;
  int32_T c1_i81;
  int32_T c1_i82;
  int32_T c1_i83;
  int32_T c1_i84;
  real_T (*c1_b_nu_body_dot)[6];
  real_T (*c1_b_a_body)[6];
  real_T (*c1_c_tau)[6];
  real_T (*c1_b_nu_body)[6];
  c1_b_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c1_b_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c1_c_tau = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c1_b_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  c1_hoistedGlobal = chartInstance->c1_m_car;
  for (c1_i10 = 0; c1_i10 < 6; c1_i10++) {
    c1_nu_body[c1_i10] = (*c1_b_nu_body)[c1_i10];
  }

  for (c1_i11 = 0; c1_i11 < 6; c1_i11++) {
    c1_tau[c1_i11] = (*c1_c_tau)[c1_i11];
  }

  c1_b_m_car = c1_hoistedGlobal;
  for (c1_i12 = 0; c1_i12 < 3; c1_i12++) {
    c1_b_I_car[c1_i12] = chartInstance->c1_I_car[c1_i12];
  }

  sf_debug_symbol_scope_push_eml(0U, 15U, 15U, c1_debug_family_names,
    c1_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c1_v_body, 0U, c1_f_sf_marshallOut,
    c1_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_omega_body, 1U,
    c1_f_sf_marshallOut, c1_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_I_g, 2U, c1_e_sf_marshallOut,
    c1_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_M_RB, 3U, c1_d_sf_marshallOut,
    c1_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_C_RB, 4U, c1_d_sf_marshallOut,
    c1_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c1_D_RB, 5U, c1_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c1_g, 6U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_nargin, 7U, c1_c_sf_marshallOut,
    c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_nargout, 8U, c1_c_sf_marshallOut,
    c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c1_nu_body, 9U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c1_tau, 10U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c1_b_m_car, 11U, c1_c_sf_marshallOut,
    c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_b_I_car, 12U, c1_b_sf_marshallOut,
    c1_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_nu_body_dot, 13U,
    c1_sf_marshallOut, c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_a_body, 14U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 3);
  for (c1_i13 = 0; c1_i13 < 3; c1_i13++) {
    c1_v_body[c1_i13] = c1_nu_body[c1_i13];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 4);
  for (c1_i14 = 0; c1_i14 < 3; c1_i14++) {
    c1_omega_body[c1_i14] = c1_nu_body[c1_i14 + 3];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 7);
  for (c1_i15 = 0; c1_i15 < 3; c1_i15++) {
    c1_c_I_car[c1_i15] = c1_b_I_car[c1_i15];
  }

  c1_diag(chartInstance, c1_c_I_car, c1_dv3);
  for (c1_i16 = 0; c1_i16 < 9; c1_i16++) {
    c1_I_g[c1_i16] = c1_dv3[c1_i16];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 10);
  c1_a = c1_b_m_car;
  for (c1_i17 = 0; c1_i17 < 9; c1_i17++) {
    c1_y[c1_i17] = c1_a * c1_b[c1_i17];
  }

  for (c1_i18 = 0; c1_i18 < 3; c1_i18++) {
    c1_d_I_car[c1_i18] = c1_b_I_car[c1_i18];
  }

  c1_diag(chartInstance, c1_d_I_car, c1_dv4);
  c1_i19 = 0;
  c1_i20 = 0;
  for (c1_i21 = 0; c1_i21 < 3; c1_i21++) {
    for (c1_i22 = 0; c1_i22 < 3; c1_i22++) {
      c1_M_RB[c1_i22 + c1_i19] = c1_y[c1_i22 + c1_i20];
    }

    c1_i19 += 6;
    c1_i20 += 3;
  }

  c1_i23 = 0;
  for (c1_i24 = 0; c1_i24 < 3; c1_i24++) {
    for (c1_i25 = 0; c1_i25 < 3; c1_i25++) {
      c1_M_RB[(c1_i25 + c1_i23) + 18] = 0.0;
    }

    c1_i23 += 6;
  }

  c1_i26 = 0;
  for (c1_i27 = 0; c1_i27 < 3; c1_i27++) {
    for (c1_i28 = 0; c1_i28 < 3; c1_i28++) {
      c1_M_RB[(c1_i28 + c1_i26) + 3] = 0.0;
    }

    c1_i26 += 6;
  }

  c1_i29 = 0;
  c1_i30 = 0;
  for (c1_i31 = 0; c1_i31 < 3; c1_i31++) {
    for (c1_i32 = 0; c1_i32 < 3; c1_i32++) {
      c1_M_RB[(c1_i32 + c1_i29) + 21] = c1_dv4[c1_i32 + c1_i30];
    }

    c1_i29 += 6;
    c1_i30 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 14);
  c1_b_a = c1_b_m_car;
  for (c1_i33 = 0; c1_i33 < 3; c1_i33++) {
    c1_b_omega_body[c1_i33] = c1_omega_body[c1_i33];
  }

  c1_Smtrx(chartInstance, c1_b_omega_body, c1_b_b);
  for (c1_i34 = 0; c1_i34 < 9; c1_i34++) {
    c1_b_b[c1_i34] *= c1_b_a;
  }

  for (c1_i35 = 0; c1_i35 < 9; c1_i35++) {
    c1_y[c1_i35] = c1_I_g[c1_i35];
  }

  for (c1_i36 = 0; c1_i36 < 3; c1_i36++) {
    c1_c_b[c1_i36] = c1_omega_body[c1_i36];
  }

  c1_eml_scalar_eg(chartInstance);
  c1_eml_scalar_eg(chartInstance);
  for (c1_i37 = 0; c1_i37 < 3; c1_i37++) {
    c1_b_y[c1_i37] = 0.0;
    c1_i38 = 0;
    for (c1_i39 = 0; c1_i39 < 3; c1_i39++) {
      c1_b_y[c1_i37] += c1_y[c1_i38 + c1_i37] * c1_c_b[c1_i39];
      c1_i38 += 3;
    }
  }

  for (c1_i40 = 0; c1_i40 < 3; c1_i40++) {
    c1_c_y[c1_i40] = c1_b_y[c1_i40];
  }

  c1_Smtrx(chartInstance, c1_c_y, c1_dv4);
  c1_i41 = 0;
  c1_i42 = 0;
  for (c1_i43 = 0; c1_i43 < 3; c1_i43++) {
    for (c1_i44 = 0; c1_i44 < 3; c1_i44++) {
      c1_C_RB[c1_i44 + c1_i41] = c1_b_b[c1_i44 + c1_i42];
    }

    c1_i41 += 6;
    c1_i42 += 3;
  }

  c1_i45 = 0;
  for (c1_i46 = 0; c1_i46 < 3; c1_i46++) {
    for (c1_i47 = 0; c1_i47 < 3; c1_i47++) {
      c1_C_RB[(c1_i47 + c1_i45) + 18] = 0.0;
    }

    c1_i45 += 6;
  }

  c1_i48 = 0;
  for (c1_i49 = 0; c1_i49 < 3; c1_i49++) {
    for (c1_i50 = 0; c1_i50 < 3; c1_i50++) {
      c1_C_RB[(c1_i50 + c1_i48) + 3] = 0.0;
    }

    c1_i48 += 6;
  }

  c1_i51 = 0;
  c1_i52 = 0;
  for (c1_i53 = 0; c1_i53 < 3; c1_i53++) {
    for (c1_i54 = 0; c1_i54 < 3; c1_i54++) {
      c1_C_RB[(c1_i54 + c1_i51) + 21] = -c1_dv4[c1_i54 + c1_i52];
    }

    c1_i51 += 6;
    c1_i52 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 18);
  for (c1_i55 = 0; c1_i55 < 36; c1_i55++) {
    c1_D_RB[c1_i55] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 21);
  c1_c_a = -c1_b_m_car;
  c1_d_y = c1_c_a * 9.81;
  c1_dv5[0] = 0.0;
  c1_dv5[1] = 0.0;
  c1_dv5[2] = c1_d_y;
  c1_dv5[3] = 0.0;
  c1_dv5[4] = 0.0;
  c1_dv5[5] = 0.0;
  for (c1_i56 = 0; c1_i56 < 6; c1_i56++) {
    c1_g[c1_i56] = c1_dv5[c1_i56];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 24);
  for (c1_i57 = 0; c1_i57 < 36; c1_i57++) {
    c1_d_a[c1_i57] = c1_C_RB[c1_i57];
  }

  for (c1_i58 = 0; c1_i58 < 6; c1_i58++) {
    c1_d_b[c1_i58] = c1_nu_body[c1_i58];
  }

  c1_b_eml_scalar_eg(chartInstance);
  c1_b_eml_scalar_eg(chartInstance);
  for (c1_i59 = 0; c1_i59 < 6; c1_i59++) {
    c1_e_y[c1_i59] = 0.0;
    c1_i60 = 0;
    for (c1_i61 = 0; c1_i61 < 6; c1_i61++) {
      c1_e_y[c1_i59] += c1_d_a[c1_i60 + c1_i59] * c1_d_b[c1_i61];
      c1_i60 += 6;
    }
  }

  for (c1_i62 = 0; c1_i62 < 6; c1_i62++) {
    c1_d_b[c1_i62] = c1_nu_body[c1_i62];
  }

  c1_b_eml_scalar_eg(chartInstance);
  c1_b_eml_scalar_eg(chartInstance);
  for (c1_i63 = 0; c1_i63 < 6; c1_i63++) {
    c1_f_y[c1_i63] = 0.0;
    for (c1_i64 = 0; c1_i64 < 6; c1_i64++) {
      c1_f_y[c1_i63] += 0.0 * c1_d_b[c1_i64];
    }
  }

  for (c1_i65 = 0; c1_i65 < 36; c1_i65++) {
    c1_b_M_RB[c1_i65] = c1_M_RB[c1_i65];
  }

  for (c1_i66 = 0; c1_i66 < 6; c1_i66++) {
    c1_b_tau[c1_i66] = ((c1_tau[c1_i66] - c1_e_y[c1_i66]) - c1_f_y[c1_i66]) -
      c1_g[c1_i66];
  }

  c1_mldivide(chartInstance, c1_b_M_RB, c1_b_tau, c1_dv6);
  for (c1_i67 = 0; c1_i67 < 6; c1_i67++) {
    c1_nu_body_dot[c1_i67] = c1_dv6[c1_i67];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 27);
  for (c1_i68 = 0; c1_i68 < 3; c1_i68++) {
    c1_c_omega_body[c1_i68] = c1_omega_body[c1_i68];
  }

  c1_Smtrx(chartInstance, c1_c_omega_body, c1_y);
  for (c1_i69 = 0; c1_i69 < 3; c1_i69++) {
    c1_c_b[c1_i69] = c1_v_body[c1_i69];
  }

  c1_eml_scalar_eg(chartInstance);
  c1_eml_scalar_eg(chartInstance);
  for (c1_i70 = 0; c1_i70 < 3; c1_i70++) {
    c1_b_y[c1_i70] = 0.0;
    c1_i71 = 0;
    for (c1_i72 = 0; c1_i72 < 3; c1_i72++) {
      c1_b_y[c1_i70] += c1_y[c1_i71 + c1_i70] * c1_c_b[c1_i72];
      c1_i71 += 3;
    }
  }

  for (c1_i73 = 0; c1_i73 < 3; c1_i73++) {
    c1_r[c1_i73] = c1_omega_body[c1_i73];
  }

  sf_debug_symbol_scope_push_eml(0U, 4U, 4U, c1_b_debug_family_names,
    c1_b_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c1_b_nargin, 0U, c1_c_sf_marshallOut,
    c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_b_nargout, 1U,
    c1_c_sf_marshallOut, c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_r, 2U, c1_f_sf_marshallOut,
    c1_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_S, 3U, c1_e_sf_marshallOut,
    c1_e_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 32);
  c1_S[0] = 0.0;
  c1_S[3] = -c1_r[2];
  c1_S[6] = c1_r[1];
  c1_S[1] = c1_r[2];
  c1_S[4] = 0.0;
  c1_S[7] = -c1_r[0];
  c1_S[2] = -c1_r[1];
  c1_S[5] = c1_r[0];
  c1_S[8] = 0.0;
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, -32);
  sf_debug_symbol_scope_pop();
  for (c1_i74 = 0; c1_i74 < 9; c1_i74++) {
    c1_y[c1_i74] = -c1_S[c1_i74];
  }

  for (c1_i75 = 0; c1_i75 < 3; c1_i75++) {
    c1_c_b[c1_i75] = c1_omega_body[c1_i75];
  }

  c1_eml_scalar_eg(chartInstance);
  c1_eml_scalar_eg(chartInstance);
  for (c1_i76 = 0; c1_i76 < 3; c1_i76++) {
    c1_g_y[c1_i76] = 0.0;
    c1_i77 = 0;
    for (c1_i78 = 0; c1_i78 < 3; c1_i78++) {
      c1_g_y[c1_i76] += c1_y[c1_i77 + c1_i76] * c1_c_b[c1_i78];
      c1_i77 += 3;
    }
  }

  for (c1_i79 = 0; c1_i79 < 3; c1_i79++) {
    c1_h_y[c1_i79] = c1_b_y[c1_i79];
  }

  for (c1_i80 = 0; c1_i80 < 3; c1_i80++) {
    c1_h_y[c1_i80 + 3] = c1_g_y[c1_i80];
  }

  for (c1_i81 = 0; c1_i81 < 6; c1_i81++) {
    c1_a_body[c1_i81] = c1_nu_body_dot[c1_i81] + c1_h_y[c1_i81];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 31);
  for (c1_i82 = 0; c1_i82 < 3; c1_i82++) {
    c1_nu_body_dot[c1_i82 + 2] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, -31);
  sf_debug_symbol_scope_pop();
  for (c1_i83 = 0; c1_i83 < 6; c1_i83++) {
    (*c1_b_nu_body_dot)[c1_i83] = c1_nu_body_dot[c1_i83];
  }

  for (c1_i84 = 0; c1_i84 < 6; c1_i84++) {
    (*c1_b_a_body)[c1_i84] = c1_a_body[c1_i84];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
}

static void initSimStructsc1_ref_gen(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
  _SFD_SCRIPT_TRANSLATION(c1_chartNumber, 0U, sf_debug_get_script_id(
    "C:/Users/stianell/Desktop/Oppgave/test forenklet simulator og states/Smtrx.m"));
}

static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i85;
  real_T c1_b_inData[6];
  int32_T c1_i86;
  real_T c1_u[6];
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i85 = 0; c1_i85 < 6; c1_i85++) {
    c1_b_inData[c1_i85] = (*(real_T (*)[6])c1_inData)[c1_i85];
  }

  for (c1_i86 = 0; c1_i86 < 6; c1_i86++) {
    c1_u[c1_i86] = c1_b_inData[c1_i86];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance, const
  mxArray *c1_a_body, const char_T *c1_identifier, real_T c1_y[6])
{
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_a_body), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_a_body);
}

static void c1_b_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[6])
{
  real_T c1_dv7[6];
  int32_T c1_i87;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv7, 1, 0, 0U, 1, 0U, 1, 6);
  for (c1_i87 = 0; c1_i87 < 6; c1_i87++) {
    c1_y[c1_i87] = c1_dv7[c1_i87];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_a_body;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[6];
  int32_T c1_i88;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_a_body = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_a_body), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_a_body);
  for (c1_i88 = 0; c1_i88 < 6; c1_i88++) {
    (*(real_T (*)[6])c1_outData)[c1_i88] = c1_y[c1_i88];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i89;
  real_T c1_b_inData[3];
  int32_T c1_i90;
  real_T c1_u[3];
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i89 = 0; c1_i89 < 3; c1_i89++) {
    c1_b_inData[c1_i89] = (*(real_T (*)[3])c1_inData)[c1_i89];
  }

  for (c1_i90 = 0; c1_i90 < 3; c1_i90++) {
    c1_u[c1_i90] = c1_b_inData[c1_i90];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_c_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[3])
{
  real_T c1_dv8[3];
  int32_T c1_i91;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv8, 1, 0, 0U, 1, 0U, 2, 1, 3);
  for (c1_i91 = 0; c1_i91 < 3; c1_i91++) {
    c1_y[c1_i91] = c1_dv8[c1_i91];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_I_car;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[3];
  int32_T c1_i92;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_b_I_car = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_I_car), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_b_I_car);
  for (c1_i92 = 0; c1_i92 < 3; c1_i92++) {
    (*(real_T (*)[3])c1_outData)[c1_i92] = c1_y[c1_i92];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  real_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(real_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static real_T c1_d_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  real_T c1_y;
  real_T c1_d1;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_d1, 1, 0, 0U, 0, 0U, 0);
  c1_y = c1_d1;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_m_car;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_b_m_car = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_m_car), &c1_thisId);
  sf_mex_destroy(&c1_b_m_car);
  *(real_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_d_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i93;
  int32_T c1_i94;
  int32_T c1_i95;
  real_T c1_b_inData[36];
  int32_T c1_i96;
  int32_T c1_i97;
  int32_T c1_i98;
  real_T c1_u[36];
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_i93 = 0;
  for (c1_i94 = 0; c1_i94 < 6; c1_i94++) {
    for (c1_i95 = 0; c1_i95 < 6; c1_i95++) {
      c1_b_inData[c1_i95 + c1_i93] = (*(real_T (*)[36])c1_inData)[c1_i95 +
        c1_i93];
    }

    c1_i93 += 6;
  }

  c1_i96 = 0;
  for (c1_i97 = 0; c1_i97 < 6; c1_i97++) {
    for (c1_i98 = 0; c1_i98 < 6; c1_i98++) {
      c1_u[c1_i98 + c1_i96] = c1_b_inData[c1_i98 + c1_i96];
    }

    c1_i96 += 6;
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_e_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[36])
{
  real_T c1_dv9[36];
  int32_T c1_i99;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv9, 1, 0, 0U, 1, 0U, 2, 6, 6);
  for (c1_i99 = 0; c1_i99 < 36; c1_i99++) {
    c1_y[c1_i99] = c1_dv9[c1_i99];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_C_RB;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[36];
  int32_T c1_i100;
  int32_T c1_i101;
  int32_T c1_i102;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_C_RB = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_C_RB), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_C_RB);
  c1_i100 = 0;
  for (c1_i101 = 0; c1_i101 < 6; c1_i101++) {
    for (c1_i102 = 0; c1_i102 < 6; c1_i102++) {
      (*(real_T (*)[36])c1_outData)[c1_i102 + c1_i100] = c1_y[c1_i102 + c1_i100];
    }

    c1_i100 += 6;
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_e_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i103;
  int32_T c1_i104;
  int32_T c1_i105;
  real_T c1_b_inData[9];
  int32_T c1_i106;
  int32_T c1_i107;
  int32_T c1_i108;
  real_T c1_u[9];
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_i103 = 0;
  for (c1_i104 = 0; c1_i104 < 3; c1_i104++) {
    for (c1_i105 = 0; c1_i105 < 3; c1_i105++) {
      c1_b_inData[c1_i105 + c1_i103] = (*(real_T (*)[9])c1_inData)[c1_i105 +
        c1_i103];
    }

    c1_i103 += 3;
  }

  c1_i106 = 0;
  for (c1_i107 = 0; c1_i107 < 3; c1_i107++) {
    for (c1_i108 = 0; c1_i108 < 3; c1_i108++) {
      c1_u[c1_i108 + c1_i106] = c1_b_inData[c1_i108 + c1_i106];
    }

    c1_i106 += 3;
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_f_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[9])
{
  real_T c1_dv10[9];
  int32_T c1_i109;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv10, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c1_i109 = 0; c1_i109 < 9; c1_i109++) {
    c1_y[c1_i109] = c1_dv10[c1_i109];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_I_g;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[9];
  int32_T c1_i110;
  int32_T c1_i111;
  int32_T c1_i112;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_I_g = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_I_g), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_I_g);
  c1_i110 = 0;
  for (c1_i111 = 0; c1_i111 < 3; c1_i111++) {
    for (c1_i112 = 0; c1_i112 < 3; c1_i112++) {
      (*(real_T (*)[9])c1_outData)[c1_i112 + c1_i110] = c1_y[c1_i112 + c1_i110];
    }

    c1_i110 += 3;
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_f_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i113;
  real_T c1_b_inData[3];
  int32_T c1_i114;
  real_T c1_u[3];
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i113 = 0; c1_i113 < 3; c1_i113++) {
    c1_b_inData[c1_i113] = (*(real_T (*)[3])c1_inData)[c1_i113];
  }

  for (c1_i114 = 0; c1_i114 < 3; c1_i114++) {
    c1_u[c1_i114] = c1_b_inData[c1_i114];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_g_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[3])
{
  real_T c1_dv11[3];
  int32_T c1_i115;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv11, 1, 0, 0U, 1, 0U, 1, 3);
  for (c1_i115 = 0; c1_i115 < 3; c1_i115++) {
    c1_y[c1_i115] = c1_dv11[c1_i115];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_omega_body;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[3];
  int32_T c1_i116;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_omega_body = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_omega_body), &c1_thisId,
                        c1_y);
  sf_mex_destroy(&c1_omega_body);
  for (c1_i116 = 0; c1_i116 < 3; c1_i116++) {
    (*(real_T (*)[3])c1_outData)[c1_i116] = c1_y[c1_i116];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

const mxArray *sf_c1_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo;
  c1_ResolvedFunctionInfo c1_info[50];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i117;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 50), FALSE);
  for (c1_i117 = 0; c1_i117 < 50; c1_i117++) {
    c1_r0 = &c1_info[c1_i117];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context", "nameCaptureInfo",
                    c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name", "nameCaptureInfo", c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved", "nameCaptureInfo",
                    c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c1_i117);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c1_i117);
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0, FALSE);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[50])
{
  c1_info[0].context = "";
  c1_info[0].name = "diag";
  c1_info[0].dominantType = "double";
  c1_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[0].fileTimeLo = 1286818686U;
  c1_info[0].fileTimeHi = 0U;
  c1_info[0].mFileTimeLo = 0U;
  c1_info[0].mFileTimeHi = 0U;
  c1_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[1].name = "eml_index_class";
  c1_info[1].dominantType = "";
  c1_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[1].fileTimeLo = 1286818778U;
  c1_info[1].fileTimeHi = 0U;
  c1_info[1].mFileTimeLo = 0U;
  c1_info[1].mFileTimeHi = 0U;
  c1_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[2].name = "eml_index_plus";
  c1_info[2].dominantType = "int32";
  c1_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[2].fileTimeLo = 1286818778U;
  c1_info[2].fileTimeHi = 0U;
  c1_info[2].mFileTimeLo = 0U;
  c1_info[2].mFileTimeHi = 0U;
  c1_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[3].name = "eml_scalar_eg";
  c1_info[3].dominantType = "double";
  c1_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[3].fileTimeLo = 1286818796U;
  c1_info[3].fileTimeHi = 0U;
  c1_info[3].mFileTimeLo = 0U;
  c1_info[3].mFileTimeHi = 0U;
  c1_info[4].context = "";
  c1_info[4].name = "eye";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c1_info[4].fileTimeLo = 1286818688U;
  c1_info[4].fileTimeHi = 0U;
  c1_info[4].mFileTimeLo = 0U;
  c1_info[4].mFileTimeHi = 0U;
  c1_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c1_info[5].name = "eml_assert_valid_size_arg";
  c1_info[5].dominantType = "double";
  c1_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c1_info[5].fileTimeLo = 1286818694U;
  c1_info[5].fileTimeHi = 0U;
  c1_info[5].mFileTimeLo = 0U;
  c1_info[5].mFileTimeHi = 0U;
  c1_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!isintegral";
  c1_info[6].name = "isinf";
  c1_info[6].dominantType = "double";
  c1_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c1_info[6].fileTimeLo = 1286818760U;
  c1_info[6].fileTimeHi = 0U;
  c1_info[6].mFileTimeLo = 0U;
  c1_info[6].mFileTimeHi = 0U;
  c1_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!numel_for_size";
  c1_info[7].name = "mtimes";
  c1_info[7].dominantType = "double";
  c1_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[7].fileTimeLo = 1289519692U;
  c1_info[7].fileTimeHi = 0U;
  c1_info[7].mFileTimeLo = 0U;
  c1_info[7].mFileTimeHi = 0U;
  c1_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c1_info[8].name = "intmax";
  c1_info[8].dominantType = "char";
  c1_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c1_info[8].fileTimeLo = 1286818756U;
  c1_info[8].fileTimeHi = 0U;
  c1_info[8].mFileTimeLo = 0U;
  c1_info[8].mFileTimeHi = 0U;
  c1_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c1_info[9].name = "eml_is_float_class";
  c1_info[9].dominantType = "char";
  c1_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c1_info[9].fileTimeLo = 1286818782U;
  c1_info[9].fileTimeHi = 0U;
  c1_info[9].mFileTimeLo = 0U;
  c1_info[9].mFileTimeHi = 0U;
  c1_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c1_info[10].name = "min";
  c1_info[10].dominantType = "double";
  c1_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c1_info[10].fileTimeLo = 1308747330U;
  c1_info[10].fileTimeHi = 0U;
  c1_info[10].mFileTimeLo = 0U;
  c1_info[10].mFileTimeHi = 0U;
  c1_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c1_info[11].name = "eml_min_or_max";
  c1_info[11].dominantType = "char";
  c1_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c1_info[11].fileTimeLo = 1303146212U;
  c1_info[11].fileTimeHi = 0U;
  c1_info[11].mFileTimeLo = 0U;
  c1_info[11].mFileTimeHi = 0U;
  c1_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c1_info[12].name = "eml_scalexp_alloc";
  c1_info[12].dominantType = "double";
  c1_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c1_info[12].fileTimeLo = 1286818796U;
  c1_info[12].fileTimeHi = 0U;
  c1_info[12].mFileTimeLo = 0U;
  c1_info[12].mFileTimeHi = 0U;
  c1_info[13].context = "";
  c1_info[13].name = "Smtrx";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved =
    "[E]C:/Users/stianell/Desktop/Oppgave/test forenklet simulator og states/Smtrx.m";
  c1_info[13].fileTimeLo = 1326438618U;
  c1_info[13].fileTimeHi = 0U;
  c1_info[13].mFileTimeLo = 0U;
  c1_info[13].mFileTimeHi = 0U;
  c1_info[14].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[14].name = "eml_xgemm";
  c1_info[14].dominantType = "int32";
  c1_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c1_info[14].fileTimeLo = 1299076772U;
  c1_info[14].fileTimeHi = 0U;
  c1_info[14].mFileTimeLo = 0U;
  c1_info[14].mFileTimeHi = 0U;
  c1_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c1_info[15].name = "eml_blas_inline";
  c1_info[15].dominantType = "";
  c1_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c1_info[15].fileTimeLo = 1299076768U;
  c1_info[15].fileTimeHi = 0U;
  c1_info[15].mFileTimeLo = 0U;
  c1_info[15].mFileTimeHi = 0U;
  c1_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c1_info[16].name = "eml_refblas_xgemm";
  c1_info[16].dominantType = "int32";
  c1_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c1_info[16].fileTimeLo = 1299076774U;
  c1_info[16].fileTimeHi = 0U;
  c1_info[16].mFileTimeLo = 0U;
  c1_info[16].mFileTimeHi = 0U;
  c1_info[17].context = "";
  c1_info[17].name = "mldivide";
  c1_info[17].dominantType = "double";
  c1_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c1_info[17].fileTimeLo = 1310137456U;
  c1_info[17].fileTimeHi = 0U;
  c1_info[17].mFileTimeLo = 1289519690U;
  c1_info[17].mFileTimeHi = 0U;
  c1_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c1_info[18].name = "eml_lusolve";
  c1_info[18].dominantType = "double";
  c1_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c1_info[18].fileTimeLo = 1305318000U;
  c1_info[18].fileTimeHi = 0U;
  c1_info[18].mFileTimeLo = 0U;
  c1_info[18].mFileTimeHi = 0U;
  c1_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolveNxN";
  c1_info[19].name = "eml_xgetrf";
  c1_info[19].dominantType = "int32";
  c1_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/eml_xgetrf.m";
  c1_info[19].fileTimeLo = 1286818806U;
  c1_info[19].fileTimeHi = 0U;
  c1_info[19].mFileTimeLo = 0U;
  c1_info[19].mFileTimeHi = 0U;
  c1_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/eml_xgetrf.m";
  c1_info[20].name = "eml_lapack_xgetrf";
  c1_info[20].dominantType = "int32";
  c1_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/internal/eml_lapack_xgetrf.m";
  c1_info[20].fileTimeLo = 1286818810U;
  c1_info[20].fileTimeHi = 0U;
  c1_info[20].mFileTimeLo = 0U;
  c1_info[20].mFileTimeHi = 0U;
  c1_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/internal/eml_lapack_xgetrf.m";
  c1_info[21].name = "eml_matlab_zgetrf";
  c1_info[21].dominantType = "int32";
  c1_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[21].fileTimeLo = 1302688994U;
  c1_info[21].fileTimeHi = 0U;
  c1_info[21].mFileTimeLo = 0U;
  c1_info[21].mFileTimeHi = 0U;
  c1_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[22].name = "realmin";
  c1_info[22].dominantType = "char";
  c1_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c1_info[22].fileTimeLo = 1286818768U;
  c1_info[22].fileTimeHi = 0U;
  c1_info[22].mFileTimeLo = 0U;
  c1_info[22].mFileTimeHi = 0U;
  c1_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmin.m";
  c1_info[23].name = "mpower";
  c1_info[23].dominantType = "double";
  c1_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[23].fileTimeLo = 1286818842U;
  c1_info[23].fileTimeHi = 0U;
  c1_info[23].mFileTimeLo = 0U;
  c1_info[23].mFileTimeHi = 0U;
  c1_info[24].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[24].name = "power";
  c1_info[24].dominantType = "double";
  c1_info[24].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[24].fileTimeLo = 1294067944U;
  c1_info[24].fileTimeHi = 0U;
  c1_info[24].mFileTimeLo = 0U;
  c1_info[24].mFileTimeHi = 0U;
  c1_info[25].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[25].name = "eml_scalar_floor";
  c1_info[25].dominantType = "double";
  c1_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c1_info[25].fileTimeLo = 1286818726U;
  c1_info[25].fileTimeHi = 0U;
  c1_info[25].mFileTimeLo = 0U;
  c1_info[25].mFileTimeHi = 0U;
  c1_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[26].name = "eps";
  c1_info[26].dominantType = "char";
  c1_info[26].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c1_info[26].fileTimeLo = 1286818686U;
  c1_info[26].fileTimeHi = 0U;
  c1_info[26].mFileTimeLo = 0U;
  c1_info[26].mFileTimeHi = 0U;
  c1_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[27].name = "colon";
  c1_info[27].dominantType = "int32";
  c1_info[27].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m";
  c1_info[27].fileTimeLo = 1286818838U;
  c1_info[27].fileTimeHi = 0U;
  c1_info[27].mFileTimeLo = 0U;
  c1_info[27].mFileTimeHi = 0U;
  c1_info[28].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m";
  c1_info[28].name = "floor";
  c1_info[28].dominantType = "double";
  c1_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c1_info[28].fileTimeLo = 1286818742U;
  c1_info[28].fileTimeHi = 0U;
  c1_info[28].mFileTimeLo = 0U;
  c1_info[28].mFileTimeHi = 0U;
  c1_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!checkrange";
  c1_info[29].name = "intmin";
  c1_info[29].dominantType = "char";
  c1_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmin.m";
  c1_info[29].fileTimeLo = 1286818756U;
  c1_info[29].fileTimeHi = 0U;
  c1_info[29].mFileTimeLo = 0U;
  c1_info[29].mFileTimeHi = 0U;
  c1_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/colon.m!eml_integer_colon";
  c1_info[30].name = "mrdivide";
  c1_info[30].dominantType = "double";
  c1_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[30].fileTimeLo = 1310137456U;
  c1_info[30].fileTimeHi = 0U;
  c1_info[30].mFileTimeLo = 1289519692U;
  c1_info[30].mFileTimeHi = 0U;
  c1_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[31].name = "rdivide";
  c1_info[31].dominantType = "double";
  c1_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[31].fileTimeLo = 1286818844U;
  c1_info[31].fileTimeHi = 0U;
  c1_info[31].mFileTimeLo = 0U;
  c1_info[31].mFileTimeHi = 0U;
  c1_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[32].name = "eml_div";
  c1_info[32].dominantType = "double";
  c1_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c1_info[32].fileTimeLo = 1305318000U;
  c1_info[32].fileTimeHi = 0U;
  c1_info[32].mFileTimeLo = 0U;
  c1_info[32].mFileTimeHi = 0U;
  c1_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[33].name = "eml_index_minus";
  c1_info[33].dominantType = "int32";
  c1_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c1_info[33].fileTimeLo = 1286818778U;
  c1_info[33].fileTimeHi = 0U;
  c1_info[33].mFileTimeLo = 0U;
  c1_info[33].mFileTimeHi = 0U;
  c1_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[34].name = "eml_index_times";
  c1_info[34].dominantType = "int32";
  c1_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c1_info[34].fileTimeLo = 1286818780U;
  c1_info[34].fileTimeHi = 0U;
  c1_info[34].mFileTimeLo = 0U;
  c1_info[34].mFileTimeHi = 0U;
  c1_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[35].name = "eml_ixamax";
  c1_info[35].dominantType = "int32";
  c1_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_ixamax.m";
  c1_info[35].fileTimeLo = 1299076770U;
  c1_info[35].fileTimeHi = 0U;
  c1_info[35].mFileTimeLo = 0U;
  c1_info[35].mFileTimeHi = 0U;
  c1_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_ixamax.m!below_threshold";
  c1_info[36].name = "length";
  c1_info[36].dominantType = "double";
  c1_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c1_info[36].fileTimeLo = 1303146206U;
  c1_info[36].fileTimeHi = 0U;
  c1_info[36].mFileTimeLo = 0U;
  c1_info[36].mFileTimeHi = 0U;
  c1_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_ixamax.m";
  c1_info[37].name = "eml_refblas_ixamax";
  c1_info[37].dominantType = "int32";
  c1_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_ixamax.m";
  c1_info[37].fileTimeLo = 1299076770U;
  c1_info[37].fileTimeHi = 0U;
  c1_info[37].mFileTimeLo = 0U;
  c1_info[37].mFileTimeHi = 0U;
  c1_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_ixamax.m";
  c1_info[38].name = "eml_xcabs1";
  c1_info[38].dominantType = "double";
  c1_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c1_info[38].fileTimeLo = 1286818706U;
  c1_info[38].fileTimeHi = 0U;
  c1_info[38].mFileTimeLo = 0U;
  c1_info[38].mFileTimeHi = 0U;
  c1_info[39].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c1_info[39].name = "abs";
  c1_info[39].dominantType = "double";
  c1_info[39].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[39].fileTimeLo = 1286818694U;
  c1_info[39].fileTimeHi = 0U;
  c1_info[39].mFileTimeLo = 0U;
  c1_info[39].mFileTimeHi = 0U;
  c1_info[40].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[40].name = "eml_scalar_abs";
  c1_info[40].dominantType = "double";
  c1_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c1_info[40].fileTimeLo = 1286818712U;
  c1_info[40].fileTimeHi = 0U;
  c1_info[40].mFileTimeLo = 0U;
  c1_info[40].mFileTimeHi = 0U;
  c1_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[41].name = "eml_xswap";
  c1_info[41].dominantType = "int32";
  c1_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xswap.m";
  c1_info[41].fileTimeLo = 1299076778U;
  c1_info[41].fileTimeHi = 0U;
  c1_info[41].mFileTimeLo = 0U;
  c1_info[41].mFileTimeHi = 0U;
  c1_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xswap.m";
  c1_info[42].name = "eml_refblas_xswap";
  c1_info[42].dominantType = "int32";
  c1_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xswap.m";
  c1_info[42].fileTimeLo = 1299076786U;
  c1_info[42].fileTimeHi = 0U;
  c1_info[42].mFileTimeLo = 0U;
  c1_info[42].mFileTimeHi = 0U;
  c1_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/lapack/matlab/eml_matlab_zgetrf.m";
  c1_info[43].name = "eml_xgeru";
  c1_info[43].dominantType = "int32";
  c1_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgeru.m";
  c1_info[43].fileTimeLo = 1299076774U;
  c1_info[43].fileTimeHi = 0U;
  c1_info[43].mFileTimeLo = 0U;
  c1_info[43].mFileTimeHi = 0U;
  c1_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgeru.m";
  c1_info[44].name = "eml_xger";
  c1_info[44].dominantType = "int32";
  c1_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xger.m";
  c1_info[44].fileTimeLo = 1299076774U;
  c1_info[44].fileTimeHi = 0U;
  c1_info[44].mFileTimeLo = 0U;
  c1_info[44].mFileTimeHi = 0U;
  c1_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xger.m";
  c1_info[45].name = "eml_refblas_xger";
  c1_info[45].dominantType = "int32";
  c1_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xger.m";
  c1_info[45].fileTimeLo = 1299076776U;
  c1_info[45].fileTimeHi = 0U;
  c1_info[45].mFileTimeLo = 0U;
  c1_info[45].mFileTimeHi = 0U;
  c1_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xger.m";
  c1_info[46].name = "eml_refblas_xgerx";
  c1_info[46].dominantType = "int32";
  c1_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgerx.m";
  c1_info[46].fileTimeLo = 1299076778U;
  c1_info[46].fileTimeHi = 0U;
  c1_info[46].mFileTimeLo = 0U;
  c1_info[46].mFileTimeHi = 0U;
  c1_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!warn_singular";
  c1_info[47].name = "eml_warning";
  c1_info[47].dominantType = "char";
  c1_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c1_info[47].fileTimeLo = 1286818802U;
  c1_info[47].fileTimeHi = 0U;
  c1_info[47].mFileTimeLo = 0U;
  c1_info[47].mFileTimeHi = 0U;
  c1_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolveNxN";
  c1_info[48].name = "eml_xtrsm";
  c1_info[48].dominantType = "int32";
  c1_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xtrsm.m";
  c1_info[48].fileTimeLo = 1299076778U;
  c1_info[48].fileTimeHi = 0U;
  c1_info[48].mFileTimeLo = 0U;
  c1_info[48].mFileTimeHi = 0U;
  c1_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xtrsm.m";
  c1_info[49].name = "eml_refblas_xtrsm";
  c1_info[49].dominantType = "int32";
  c1_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xtrsm.m";
  c1_info[49].fileTimeLo = 1299076786U;
  c1_info[49].fileTimeHi = 0U;
  c1_info[49].mFileTimeLo = 0U;
  c1_info[49].mFileTimeHi = 0U;
}

static void c1_diag(SFc1_ref_genInstanceStruct *chartInstance, real_T c1_v[3],
                    real_T c1_d[9])
{
  int32_T c1_i118;
  int32_T c1_j;
  int32_T c1_b_j;
  int32_T c1_a;
  int32_T c1_c;
  for (c1_i118 = 0; c1_i118 < 9; c1_i118++) {
    c1_d[c1_i118] = 0.0;
  }

  for (c1_j = 1; c1_j < 4; c1_j++) {
    c1_b_j = c1_j;
    c1_a = c1_b_j;
    c1_c = c1_a;
    c1_d[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c1_b_j), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("",
            (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_c), 1, 3, 2, 0) - 1)) - 1]
      = c1_v[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c1_b_j), 1, 3, 1, 0) - 1];
  }
}

static void c1_Smtrx(SFc1_ref_genInstanceStruct *chartInstance, real_T c1_r[3],
                     real_T c1_S[9])
{
  uint32_T c1_debug_family_var_map[4];
  real_T c1_nargin = 1.0;
  real_T c1_nargout = 1.0;
  sf_debug_symbol_scope_push_eml(0U, 4U, 4U, c1_b_debug_family_names,
    c1_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c1_nargin, 0U, c1_c_sf_marshallOut,
    c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_nargout, 1U, c1_c_sf_marshallOut,
    c1_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_r, 2U, c1_f_sf_marshallOut,
    c1_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c1_S, 3U, c1_e_sf_marshallOut,
    c1_e_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 32);
  c1_S[0] = 0.0;
  c1_S[3] = -c1_r[2];
  c1_S[6] = c1_r[1];
  c1_S[1] = c1_r[2];
  c1_S[4] = 0.0;
  c1_S[7] = -c1_r[0];
  c1_S[2] = -c1_r[1];
  c1_S[5] = c1_r[0];
  c1_S[8] = 0.0;
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, -32);
  sf_debug_symbol_scope_pop();
}

static void c1_eml_scalar_eg(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static void c1_b_eml_scalar_eg(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static void c1_mldivide(SFc1_ref_genInstanceStruct *chartInstance, real_T c1_A
  [36], real_T c1_B[6], real_T c1_Y[6])
{
  int32_T c1_i119;
  real_T c1_b_A[36];
  int32_T c1_info;
  int32_T c1_ipiv[6];
  int32_T c1_b_info;
  int32_T c1_c_info;
  int32_T c1_d_info;
  int32_T c1_i120;
  int32_T c1_i;
  int32_T c1_b_i;
  int32_T c1_ip;
  real_T c1_temp;
  int32_T c1_k;
  int32_T c1_b_k;
  int32_T c1_a;
  int32_T c1_c;
  int32_T c1_b;
  int32_T c1_b_c;
  int32_T c1_b_b;
  int32_T c1_kAcol;
  int32_T c1_b_a;
  int32_T c1_c_c;
  int32_T c1_c_a;
  int32_T c1_i121;
  int32_T c1_c_i;
  int32_T c1_d_i;
  int32_T c1_d_a;
  int32_T c1_d_c;
  int32_T c1_e_a;
  int32_T c1_e_c;
  int32_T c1_f_a;
  int32_T c1_f_c;
  int32_T c1_g_a;
  int32_T c1_c_b;
  int32_T c1_g_c;
  int32_T c1_c_k;
  int32_T c1_d_k;
  int32_T c1_h_a;
  int32_T c1_h_c;
  int32_T c1_d_b;
  int32_T c1_i_c;
  int32_T c1_e_b;
  int32_T c1_b_kAcol;
  int32_T c1_i_a;
  int32_T c1_j_c;
  int32_T c1_j_a;
  int32_T c1_k_c;
  int32_T c1_k_a;
  int32_T c1_l_c;
  int32_T c1_l_a;
  int32_T c1_f_b;
  int32_T c1_m_c;
  real_T c1_x;
  real_T c1_y;
  real_T c1_z;
  int32_T c1_m_a;
  int32_T c1_i122;
  int32_T c1_e_i;
  int32_T c1_f_i;
  int32_T c1_n_a;
  int32_T c1_n_c;
  int32_T c1_o_a;
  int32_T c1_o_c;
  int32_T c1_p_a;
  int32_T c1_p_c;
  int32_T c1_q_a;
  int32_T c1_g_b;
  int32_T c1_q_c;
  for (c1_i119 = 0; c1_i119 < 36; c1_i119++) {
    c1_b_A[c1_i119] = c1_A[c1_i119];
  }

  c1_b_eml_matlab_zgetrf(chartInstance, c1_b_A, c1_ipiv, &c1_info);
  c1_b_info = c1_info;
  c1_c_info = c1_b_info;
  c1_d_info = c1_c_info;
  if ((real_T)c1_d_info > 0.0) {
    c1_eml_warning(chartInstance);
  }

  c1_b_eml_scalar_eg(chartInstance);
  for (c1_i120 = 0; c1_i120 < 6; c1_i120++) {
    c1_Y[c1_i120] = c1_B[c1_i120];
  }

  for (c1_i = 1; c1_i < 7; c1_i++) {
    c1_b_i = c1_i;
    if (c1_ipiv[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_b_i), 1, 6, 1, 0) - 1] != c1_b_i) {
      c1_ip = c1_ipiv[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c1_b_i), 1, 6, 1, 0) - 1];
      c1_temp = c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
        ("", (real_T)c1_b_i), 1, 6, 1, 0) - 1];
      c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c1_b_i), 1, 6, 1, 0) - 1] = c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("",
        (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_ip), 1, 6, 1, 0) - 1];
      c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c1_ip), 1, 6, 1, 0) - 1] = c1_temp;
    }
  }

  c1_below_threshold(chartInstance);
  c1_c_eml_scalar_eg(chartInstance);
  for (c1_k = 1; c1_k < 7; c1_k++) {
    c1_b_k = c1_k;
    c1_a = c1_b_k;
    c1_c = c1_a;
    c1_b = c1_c - 1;
    c1_b_c = 6 * c1_b;
    c1_b_b = c1_b_c;
    c1_kAcol = c1_b_b;
    c1_b_a = c1_b_k;
    c1_c_c = c1_b_a;
    if (c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_c_c), 1, 6, 1, 0) - 1] != 0.0) {
      c1_c_a = c1_b_k;
      c1_i121 = c1_c_a;
      for (c1_c_i = c1_i121 + 1; c1_c_i < 7; c1_c_i++) {
        c1_d_i = c1_c_i;
        c1_d_a = c1_d_i;
        c1_d_c = c1_d_a;
        c1_e_a = c1_d_i;
        c1_e_c = c1_e_a;
        c1_f_a = c1_b_k;
        c1_f_c = c1_f_a;
        c1_g_a = c1_d_i;
        c1_c_b = c1_kAcol;
        c1_g_c = c1_g_a + c1_c_b;
        c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_d_c), 1, 6, 1, 0) - 1] = c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_e_c), 1, 6, 1, 0) - 1]
          - c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_f_c), 1, 6, 1, 0) - 1] * c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK
          ("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_g_c), 1, 36, 1, 0) - 1];
      }
    }
  }

  c1_below_threshold(chartInstance);
  c1_c_eml_scalar_eg(chartInstance);
  for (c1_c_k = 6; c1_c_k > 0; c1_c_k--) {
    c1_d_k = c1_c_k;
    c1_h_a = c1_d_k;
    c1_h_c = c1_h_a;
    c1_d_b = c1_h_c - 1;
    c1_i_c = 6 * c1_d_b;
    c1_e_b = c1_i_c;
    c1_b_kAcol = c1_e_b;
    c1_i_a = c1_d_k;
    c1_j_c = c1_i_a;
    if (c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_j_c), 1, 6, 1, 0) - 1] != 0.0) {
      c1_j_a = c1_d_k;
      c1_k_c = c1_j_a;
      c1_k_a = c1_d_k;
      c1_l_c = c1_k_a;
      c1_l_a = c1_d_k;
      c1_f_b = c1_b_kAcol;
      c1_m_c = c1_l_a + c1_f_b;
      c1_x = c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c1_l_c), 1, 6, 1, 0) - 1];
      c1_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c1_m_c), 1, 36, 1, 0) - 1];
      c1_z = c1_x / c1_y;
      c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c1_k_c), 1, 6, 1, 0) - 1] = c1_z;
      c1_m_a = c1_d_k;
      c1_i122 = c1_m_a;
      for (c1_e_i = 1; c1_e_i <= c1_i122 - 1; c1_e_i++) {
        c1_f_i = c1_e_i;
        c1_n_a = c1_f_i;
        c1_n_c = c1_n_a;
        c1_o_a = c1_f_i;
        c1_o_c = c1_o_a;
        c1_p_a = c1_d_k;
        c1_p_c = c1_p_a;
        c1_q_a = c1_f_i;
        c1_g_b = c1_b_kAcol;
        c1_q_c = c1_q_a + c1_g_b;
        c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_n_c), 1, 6, 1, 0) - 1] = c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK(
          "", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_o_c), 1, 6, 1, 0) - 1]
          - c1_Y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_p_c), 1, 6, 1, 0) - 1] * c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK
          ("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_q_c), 1, 36, 1, 0) - 1];
      }
    }
  }
}

static void c1_eps(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static void c1_eml_matlab_zgetrf(SFc1_ref_genInstanceStruct *chartInstance,
  real_T c1_A[36], real_T c1_b_A[36], int32_T c1_ipiv[6], int32_T *c1_info)
{
  int32_T c1_i123;
  for (c1_i123 = 0; c1_i123 < 36; c1_i123++) {
    c1_b_A[c1_i123] = c1_A[c1_i123];
  }

  c1_b_eml_matlab_zgetrf(chartInstance, c1_b_A, c1_ipiv, c1_info);
}

static int32_T c1_eml_ixamax(SFc1_ref_genInstanceStruct *chartInstance, int32_T
  c1_n, real_T c1_x[36], int32_T c1_ix0)
{
  int32_T c1_idxmax;
  int32_T c1_b_n;
  int32_T c1_b_ix0;
  int32_T c1_c_n;
  int32_T c1_c_ix0;
  int32_T c1_ix;
  real_T c1_b_x;
  real_T c1_c_x;
  real_T c1_d_x;
  real_T c1_y;
  real_T c1_e_x;
  real_T c1_f_x;
  real_T c1_b_y;
  real_T c1_smax;
  int32_T c1_loop_ub;
  int32_T c1_k;
  int32_T c1_b_k;
  int32_T c1_a;
  real_T c1_g_x;
  real_T c1_h_x;
  real_T c1_i_x;
  real_T c1_c_y;
  real_T c1_j_x;
  real_T c1_k_x;
  real_T c1_d_y;
  real_T c1_s;
  c1_b_n = c1_n;
  c1_b_ix0 = c1_ix0;
  c1_c_n = c1_b_n;
  c1_c_ix0 = c1_b_ix0;
  if ((real_T)c1_c_n < 1.0) {
    c1_idxmax = 0;
  } else {
    c1_idxmax = 1;
    if ((real_T)c1_c_n > 1.0) {
      c1_ix = c1_c_ix0;
      c1_b_x = c1_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c1_ix), 1, 36, 1, 0) - 1];
      c1_c_x = c1_b_x;
      c1_d_x = c1_c_x;
      c1_y = muDoubleScalarAbs(c1_d_x);
      c1_e_x = 0.0;
      c1_f_x = c1_e_x;
      c1_b_y = muDoubleScalarAbs(c1_f_x);
      c1_smax = c1_y + c1_b_y;
      c1_loop_ub = c1_c_n;
      for (c1_k = 2; c1_k <= c1_loop_ub; c1_k++) {
        c1_b_k = c1_k;
        c1_a = c1_ix + 1;
        c1_ix = c1_a;
        c1_g_x = c1_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c1_ix), 1, 36, 1, 0) - 1];
        c1_h_x = c1_g_x;
        c1_i_x = c1_h_x;
        c1_c_y = muDoubleScalarAbs(c1_i_x);
        c1_j_x = 0.0;
        c1_k_x = c1_j_x;
        c1_d_y = muDoubleScalarAbs(c1_k_x);
        c1_s = c1_c_y + c1_d_y;
        if (c1_s > c1_smax) {
          c1_idxmax = c1_b_k;
          c1_smax = c1_s;
        }
      }
    }
  }

  return c1_idxmax;
}

static void c1_eml_warning(SFc1_ref_genInstanceStruct *chartInstance)
{
  int32_T c1_i124;
  static char_T c1_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c1_u[27];
  const mxArray *c1_y = NULL;
  for (c1_i124 = 0; c1_i124 < 27; c1_i124++) {
    c1_u[c1_i124] = c1_varargin_1[c1_i124];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 10, 0U, 1U, 0U, 2, 1, 27), FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c1_y));
}

static void c1_below_threshold(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static void c1_c_eml_scalar_eg(SFc1_ref_genInstanceStruct *chartInstance)
{
}

static const mxArray *c1_g_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(int32_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static int32_T c1_h_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  int32_T c1_y;
  int32_T c1_i125;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_i125, 1, 6, 0U, 0, 0U, 0);
  c1_y = c1_i125;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_sfEvent;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  int32_T c1_y;
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)chartInstanceVoid;
  c1_b_sfEvent = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_sfEvent),
    &c1_thisId);
  sf_mex_destroy(&c1_b_sfEvent);
  *(int32_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static uint8_T c1_i_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_b_is_active_c1_ref_gen, const char_T *c1_identifier)
{
  uint8_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c1_b_is_active_c1_ref_gen), &c1_thisId);
  sf_mex_destroy(&c1_b_is_active_c1_ref_gen);
  return c1_y;
}

static uint8_T c1_j_emlrt_marshallIn(SFc1_ref_genInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_u0, 1, 3, 0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_b_eml_matlab_zgetrf(SFc1_ref_genInstanceStruct *chartInstance,
  real_T c1_A[36], int32_T c1_ipiv[6], int32_T *c1_info)
{
  int32_T c1_i126;
  int32_T c1_j;
  int32_T c1_b_j;
  int32_T c1_a;
  int32_T c1_jm1;
  int32_T c1_b;
  int32_T c1_mmj;
  int32_T c1_b_a;
  int32_T c1_c;
  int32_T c1_b_b;
  int32_T c1_jj;
  int32_T c1_c_a;
  int32_T c1_jp1j;
  int32_T c1_d_a;
  int32_T c1_b_c;
  int32_T c1_i127;
  int32_T c1_i128;
  int32_T c1_i129;
  real_T c1_b_A[36];
  int32_T c1_e_a;
  int32_T c1_jpiv_offset;
  int32_T c1_f_a;
  int32_T c1_c_b;
  int32_T c1_jpiv;
  int32_T c1_g_a;
  int32_T c1_d_b;
  int32_T c1_c_c;
  int32_T c1_e_b;
  int32_T c1_jrow;
  int32_T c1_h_a;
  int32_T c1_f_b;
  int32_T c1_jprow;
  int32_T c1_ix0;
  int32_T c1_iy0;
  int32_T c1_b_ix0;
  int32_T c1_b_iy0;
  int32_T c1_c_ix0;
  int32_T c1_c_iy0;
  int32_T c1_ix;
  int32_T c1_iy;
  int32_T c1_k;
  real_T c1_temp;
  int32_T c1_i_a;
  int32_T c1_j_a;
  int32_T c1_b_jp1j;
  int32_T c1_k_a;
  int32_T c1_d_c;
  int32_T c1_l_a;
  int32_T c1_g_b;
  int32_T c1_i130;
  int32_T c1_i;
  int32_T c1_b_i;
  real_T c1_x;
  real_T c1_y;
  real_T c1_z;
  int32_T c1_h_b;
  int32_T c1_e_c;
  int32_T c1_m_a;
  int32_T c1_f_c;
  int32_T c1_n_a;
  int32_T c1_g_c;
  int32_T c1_m;
  int32_T c1_n;
  int32_T c1_d_ix0;
  int32_T c1_d_iy0;
  int32_T c1_ia0;
  int32_T c1_b_m;
  int32_T c1_b_n;
  int32_T c1_e_ix0;
  int32_T c1_e_iy0;
  int32_T c1_b_ia0;
  int32_T c1_c_m;
  int32_T c1_c_n;
  int32_T c1_f_ix0;
  int32_T c1_f_iy0;
  int32_T c1_c_ia0;
  int32_T c1_d_m;
  int32_T c1_d_n;
  int32_T c1_g_ix0;
  int32_T c1_g_iy0;
  int32_T c1_d_ia0;
  int32_T c1_e_m;
  int32_T c1_e_n;
  int32_T c1_h_ix0;
  int32_T c1_h_iy0;
  int32_T c1_e_ia0;
  int32_T c1_ixstart;
  int32_T c1_o_a;
  int32_T c1_jA;
  int32_T c1_jy;
  int32_T c1_loop_ub;
  int32_T c1_c_j;
  real_T c1_yjy;
  real_T c1_b_temp;
  int32_T c1_b_ix;
  int32_T c1_i_b;
  int32_T c1_i131;
  int32_T c1_p_a;
  int32_T c1_j_b;
  int32_T c1_i132;
  int32_T c1_ijA;
  int32_T c1_b_ijA;
  int32_T c1_q_a;
  int32_T c1_r_a;
  int32_T c1_s_a;
  c1_eps(chartInstance);
  for (c1_i126 = 0; c1_i126 < 6; c1_i126++) {
    c1_ipiv[c1_i126] = 1 + c1_i126;
  }

  *c1_info = 0;
  for (c1_j = 1; c1_j < 6; c1_j++) {
    c1_b_j = c1_j;
    c1_a = c1_b_j - 1;
    c1_jm1 = c1_a;
    c1_b = c1_b_j;
    c1_mmj = 6 - c1_b;
    c1_b_a = c1_jm1;
    c1_c = c1_b_a * 7;
    c1_b_b = c1_c + 1;
    c1_jj = c1_b_b;
    c1_c_a = c1_jj + 1;
    c1_jp1j = c1_c_a;
    c1_d_a = c1_mmj;
    c1_b_c = c1_d_a;
    c1_i127 = 0;
    for (c1_i128 = 0; c1_i128 < 6; c1_i128++) {
      for (c1_i129 = 0; c1_i129 < 6; c1_i129++) {
        c1_b_A[c1_i129 + c1_i127] = c1_A[c1_i129 + c1_i127];
      }

      c1_i127 += 6;
    }

    c1_e_a = c1_eml_ixamax(chartInstance, c1_b_c + 1, c1_b_A, c1_jj) - 1;
    c1_jpiv_offset = c1_e_a;
    c1_f_a = c1_jj;
    c1_c_b = c1_jpiv_offset;
    c1_jpiv = c1_f_a + c1_c_b;
    if (c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_jpiv), 1, 36, 1, 0) - 1] != 0.0) {
      if ((real_T)c1_jpiv_offset != 0.0) {
        c1_g_a = c1_b_j;
        c1_d_b = c1_jpiv_offset;
        c1_c_c = c1_g_a + c1_d_b;
        c1_ipiv[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_b_j), 1, 6, 1, 0) - 1] = c1_c_c;
        c1_e_b = c1_jm1 + 1;
        c1_jrow = c1_e_b;
        c1_h_a = c1_jrow;
        c1_f_b = c1_jpiv_offset;
        c1_jprow = c1_h_a + c1_f_b;
        c1_ix0 = c1_jrow;
        c1_iy0 = c1_jprow;
        c1_b_ix0 = c1_ix0;
        c1_b_iy0 = c1_iy0;
        c1_c_ix0 = c1_b_ix0;
        c1_c_iy0 = c1_b_iy0;
        c1_ix = c1_c_ix0;
        c1_iy = c1_c_iy0;
        for (c1_k = 1; c1_k < 7; c1_k++) {
          c1_temp = c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c1_ix), 1, 36, 1, 0) - 1];
          c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c1_ix), 1, 36, 1, 0) - 1] = c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK
            ("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c1_iy), 1, 36, 1, 0) -
            1];
          c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c1_iy), 1, 36, 1, 0) - 1] = c1_temp;
          c1_i_a = c1_ix + 6;
          c1_ix = c1_i_a;
          c1_j_a = c1_iy + 6;
          c1_iy = c1_j_a;
        }
      }

      c1_b_jp1j = c1_jp1j;
      c1_k_a = c1_mmj;
      c1_d_c = c1_k_a;
      c1_l_a = c1_jp1j;
      c1_g_b = c1_d_c - 1;
      c1_i130 = c1_l_a + c1_g_b;
      for (c1_i = c1_b_jp1j; c1_i <= c1_i130; c1_i++) {
        c1_b_i = c1_i;
        c1_x = c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
          "", (real_T)c1_b_i), 1, 36, 1, 0) - 1];
        c1_y = c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
          "", (real_T)c1_jj), 1, 36, 1, 0) - 1];
        c1_z = c1_x / c1_y;
        c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_b_i), 1, 36, 1, 0) - 1] = c1_z;
      }
    } else {
      *c1_info = c1_b_j;
    }

    c1_h_b = c1_b_j;
    c1_e_c = 6 - c1_h_b;
    c1_m_a = c1_jj;
    c1_f_c = c1_m_a;
    c1_n_a = c1_jj;
    c1_g_c = c1_n_a;
    c1_m = c1_mmj;
    c1_n = c1_e_c;
    c1_d_ix0 = c1_jp1j;
    c1_d_iy0 = c1_f_c + 6;
    c1_ia0 = c1_g_c + 7;
    c1_b_m = c1_m;
    c1_b_n = c1_n;
    c1_e_ix0 = c1_d_ix0;
    c1_e_iy0 = c1_d_iy0;
    c1_b_ia0 = c1_ia0;
    c1_c_m = c1_b_m;
    c1_c_n = c1_b_n;
    c1_f_ix0 = c1_e_ix0;
    c1_f_iy0 = c1_e_iy0;
    c1_c_ia0 = c1_b_ia0;
    c1_d_m = c1_c_m;
    c1_d_n = c1_c_n;
    c1_g_ix0 = c1_f_ix0;
    c1_g_iy0 = c1_f_iy0;
    c1_d_ia0 = c1_c_ia0;
    c1_e_m = c1_d_m;
    c1_e_n = c1_d_n;
    c1_h_ix0 = c1_g_ix0;
    c1_h_iy0 = c1_g_iy0;
    c1_e_ia0 = c1_d_ia0;
    c1_ixstart = c1_h_ix0;
    c1_o_a = c1_e_ia0 - 1;
    c1_jA = c1_o_a;
    c1_jy = c1_h_iy0;
    c1_loop_ub = c1_e_n;
    for (c1_c_j = 1; c1_c_j <= c1_loop_ub; c1_c_j++) {
      c1_yjy = c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c1_jy), 1, 36, 1, 0) - 1];
      if (c1_yjy != 0.0) {
        c1_b_temp = -c1_yjy;
        c1_b_ix = c1_ixstart;
        c1_i_b = c1_jA;
        c1_i131 = c1_i_b;
        c1_p_a = c1_e_m;
        c1_j_b = c1_jA;
        c1_i132 = c1_p_a + c1_j_b;
        for (c1_ijA = c1_i131 + 1; c1_ijA <= c1_i132; c1_ijA++) {
          c1_b_ijA = c1_ijA;
          c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c1_b_ijA), 1, 36, 1, 0) - 1] =
            c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c1_b_ijA), 1, 36, 1, 0) - 1] +
            c1_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c1_b_ix), 1, 36, 1, 0) - 1] * c1_b_temp;
          c1_q_a = c1_b_ix + 1;
          c1_b_ix = c1_q_a;
        }
      }

      c1_r_a = c1_jy + 6;
      c1_jy = c1_r_a;
      c1_s_a = c1_jA + 6;
      c1_jA = c1_s_a;
    }
  }

  if ((real_T)*c1_info == 0.0) {
    if (!(c1_A[35] != 0.0)) {
      *c1_info = 6;
    }
  }
}

static void init_dsm_address_info(SFc1_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c1_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1415330588U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(983780636U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(597437974U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1444605651U);
}

mxArray *sf_c1_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("utghAvj5A4FEKERCNFO8CE");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c1_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[16],T\"a_body\",},{M[1],M[15],T\"nu_body_dot\",},{M[8],M[0],T\"is_active_c1_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc1_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc1_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          1,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          1,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"nu_body");
          _SFD_SET_DATA_PROPS(1,1,1,0,"tau");
          _SFD_SET_DATA_PROPS(2,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(3,10,0,0,"I_car");
          _SFD_SET_DATA_PROPS(4,2,0,1,"nu_body_dot");
          _SFD_SET_DATA_PROPS(5,2,0,1,"a_body");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,738);
        _SFD_CV_INIT_SCRIPT(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_SCRIPT_FCN(0,0,"Smtrx",0,-1,1277);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_c_sf_marshallOut,(MexInFcnForType)c1_c_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_b_sf_marshallOut,(MexInFcnForType)
            c1_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)
            c1_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)
            c1_sf_marshallIn);
        }

        {
          real_T (*c1_nu_body)[6];
          real_T (*c1_tau)[6];
          real_T (*c1_nu_body_dot)[6];
          real_T (*c1_a_body)[6];
          c1_a_body = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
          c1_nu_body_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
            1);
          c1_tau = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
          c1_nu_body = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c1_nu_body);
          _SFD_SET_DATA_VALUE_PTR(1U, *c1_tau);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c1_m_car);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c1_I_car);
          _SFD_SET_DATA_VALUE_PTR(4U, *c1_nu_body_dot);
          _SFD_SET_DATA_VALUE_PTR(5U, *c1_a_body);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c1_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc1_ref_genInstanceStruct*) chartInstanceVar)->S,
    0);
  initialize_params_c1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c1_ref_gen(void *chartInstanceVar)
{
  enable_c1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c1_ref_gen(void *chartInstanceVar)
{
  disable_c1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c1_ref_gen(void *chartInstanceVar)
{
  sf_c1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c1_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c1_ref_gen((SFc1_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c1_ref_gen(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c1_ref_gen((SFc1_ref_genInstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c1_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c1_ref_gen(S);
}

static void sf_opaque_set_sim_state_c1_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c1_ref_gen(S, st);
}

static void sf_opaque_terminate_c1_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc1_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc1_ref_gen((SFc1_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_ref_gen((SFc1_ref_genInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c1_ref_gen(SimStruct *S)
{
  /* Actual parameters from chart:
     I_car m_car
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for I_car*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,1,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,1,2);
      sf_mark_chart_reusable_outputs(S,infoStruct,1,2);
    }

    sf_set_rtw_dwork_info(S,infoStruct,1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4108891886U));
  ssSetChecksum1(S,(3442270419U));
  ssSetChecksum2(S,(3247590596U));
  ssSetChecksum3(S,(1241451055U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_ref_gen(SimStruct *S)
{
  SFc1_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc1_ref_genInstanceStruct *)malloc(sizeof
    (SFc1_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc1_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c1_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c1_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c1_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c1_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c1_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c1_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c1_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c1_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c1_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c1_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c1_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
