/* Include files */

#include "blascompat32.h"
#include "ref_gen_sfun.h"
#include "c21_ref_gen.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ref_gen_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c21_debug_family_names[17] = { "m", "mv", "g", "f", "kp_v",
  "kp_b", "v", "nargin", "nargout", "speed", "beta", "psi_dot", "speed_ref",
  "psi_dot_ref", "m_car", "I_z", "tau" };

/* Function Declarations */
static void initialize_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void initialize_params_c21_ref_gen(SFc21_ref_genInstanceStruct
  *chartInstance);
static void enable_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void disable_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void c21_update_debugger_state_c21_ref_gen(SFc21_ref_genInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c21_ref_gen(SFc21_ref_genInstanceStruct
  *chartInstance);
static void set_sim_state_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_st);
static void finalize_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void sf_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void c21_chartstep_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void initSimStructsc21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c21_machineNumber, uint32_T
  c21_chartNumber);
static const mxArray *c21_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_tau, const char_T *c21_identifier, real_T c21_y[3]);
static void c21_b_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[3]);
static void c21_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_b_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static real_T c21_c_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId);
static void c21_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static const mxArray *c21_c_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static void c21_d_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[9]);
static void c21_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static void c21_info_helper(c21_ResolvedFunctionInfo c21_info[24]);
static void c21_inv3x3(SFc21_ref_genInstanceStruct *chartInstance, real_T c21_x
  [9], real_T c21_y[9]);
static real_T c21_norm(SFc21_ref_genInstanceStruct *chartInstance, real_T c21_x
  [9]);
static void c21_eml_warning(SFc21_ref_genInstanceStruct *chartInstance);
static void c21_b_eml_warning(SFc21_ref_genInstanceStruct *chartInstance, char_T
  c21_varargin_2[14]);
static void c21_eml_scalar_eg(SFc21_ref_genInstanceStruct *chartInstance);
static void c21_e_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_sprintf, const char_T *c21_identifier, char_T c21_y[14]);
static void c21_f_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, char_T c21_y[14]);
static const mxArray *c21_d_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData);
static int32_T c21_g_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId);
static void c21_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData);
static uint8_T c21_h_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_b_is_active_c21_ref_gen, const char_T *c21_identifier);
static uint8_T c21_i_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId);
static void init_dsm_address_info(SFc21_ref_genInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
  chartInstance->c21_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c21_is_active_c21_ref_gen = 0U;
}

static void initialize_params_c21_ref_gen(SFc21_ref_genInstanceStruct
  *chartInstance)
{
  real_T c21_d0;
  real_T c21_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'm_car' in the parent workspace.\n");
  sf_mex_import_named("m_car", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c21_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c21_m_car = c21_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'I_z' in the parent workspace.\n");
  sf_mex_import_named("I_z", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c21_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c21_I_z = c21_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c21_update_debugger_state_c21_ref_gen(SFc21_ref_genInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c21_ref_gen(SFc21_ref_genInstanceStruct
  *chartInstance)
{
  const mxArray *c21_st;
  const mxArray *c21_y = NULL;
  int32_T c21_i0;
  real_T c21_u[3];
  const mxArray *c21_b_y = NULL;
  uint8_T c21_hoistedGlobal;
  uint8_T c21_b_u;
  const mxArray *c21_c_y = NULL;
  real_T (*c21_tau)[3];
  c21_tau = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c21_st = NULL;
  c21_st = NULL;
  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_createcellarray(2), FALSE);
  for (c21_i0 = 0; c21_i0 < 3; c21_i0++) {
    c21_u[c21_i0] = (*c21_tau)[c21_i0];
  }

  c21_b_y = NULL;
  sf_mex_assign(&c21_b_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c21_y, 0, c21_b_y);
  c21_hoistedGlobal = chartInstance->c21_is_active_c21_ref_gen;
  c21_b_u = c21_hoistedGlobal;
  c21_c_y = NULL;
  sf_mex_assign(&c21_c_y, sf_mex_create("y", &c21_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c21_y, 1, c21_c_y);
  sf_mex_assign(&c21_st, c21_y, FALSE);
  return c21_st;
}

static void set_sim_state_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_st)
{
  const mxArray *c21_u;
  real_T c21_dv0[3];
  int32_T c21_i1;
  real_T (*c21_tau)[3];
  c21_tau = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c21_doneDoubleBufferReInit = TRUE;
  c21_u = sf_mex_dup(c21_st);
  c21_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c21_u, 0)),
                       "tau", c21_dv0);
  for (c21_i1 = 0; c21_i1 < 3; c21_i1++) {
    (*c21_tau)[c21_i1] = c21_dv0[c21_i1];
  }

  chartInstance->c21_is_active_c21_ref_gen = c21_h_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c21_u, 1)),
     "is_active_c21_ref_gen");
  sf_mex_destroy(&c21_u);
  c21_update_debugger_state_c21_ref_gen(chartInstance);
  sf_mex_destroy(&c21_st);
}

static void finalize_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
}

static void sf_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
  int32_T c21_i2;
  real_T *c21_speed;
  real_T *c21_beta;
  real_T *c21_psi_dot;
  real_T *c21_speed_ref;
  real_T *c21_psi_dot_ref;
  real_T (*c21_tau)[3];
  c21_tau = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c21_psi_dot_ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c21_speed_ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c21_psi_dot = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c21_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c21_speed = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 15U, chartInstance->c21_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c21_speed, 0U);
  _SFD_DATA_RANGE_CHECK(*c21_beta, 1U);
  _SFD_DATA_RANGE_CHECK(*c21_psi_dot, 2U);
  _SFD_DATA_RANGE_CHECK(*c21_speed_ref, 3U);
  _SFD_DATA_RANGE_CHECK(*c21_psi_dot_ref, 4U);
  for (c21_i2 = 0; c21_i2 < 3; c21_i2++) {
    _SFD_DATA_RANGE_CHECK((*c21_tau)[c21_i2], 5U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c21_m_car, 6U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c21_I_z, 7U);
  chartInstance->c21_sfEvent = CALL_EVENT;
  c21_chartstep_c21_ref_gen(chartInstance);
  sf_debug_check_for_state_inconsistency(_ref_genMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c21_chartstep_c21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
  real_T c21_hoistedGlobal;
  real_T c21_b_hoistedGlobal;
  real_T c21_c_hoistedGlobal;
  real_T c21_d_hoistedGlobal;
  real_T c21_e_hoistedGlobal;
  real_T c21_f_hoistedGlobal;
  real_T c21_g_hoistedGlobal;
  real_T c21_speed;
  real_T c21_beta;
  real_T c21_psi_dot;
  real_T c21_speed_ref;
  real_T c21_psi_dot_ref;
  real_T c21_b_m_car;
  real_T c21_b_I_z;
  uint32_T c21_debug_family_var_map[17];
  real_T c21_m;
  real_T c21_mv;
  real_T c21_g[9];
  real_T c21_f[3];
  real_T c21_kp_v;
  real_T c21_kp_b;
  real_T c21_v[3];
  real_T c21_nargin = 7.0;
  real_T c21_nargout = 1.0;
  real_T c21_tau[3];
  real_T c21_a;
  real_T c21_b;
  real_T c21_x;
  real_T c21_b_x;
  real_T c21_A;
  real_T c21_B;
  real_T c21_c_x;
  real_T c21_y;
  real_T c21_d_x;
  real_T c21_b_y;
  real_T c21_c_y;
  real_T c21_e_x;
  real_T c21_f_x;
  real_T c21_b_A;
  real_T c21_b_B;
  real_T c21_g_x;
  real_T c21_d_y;
  real_T c21_h_x;
  real_T c21_e_y;
  real_T c21_f_y;
  real_T c21_i_x;
  real_T c21_j_x;
  real_T c21_c_A;
  real_T c21_c_B;
  real_T c21_k_x;
  real_T c21_g_y;
  real_T c21_l_x;
  real_T c21_h_y;
  real_T c21_i_y;
  real_T c21_m_x;
  real_T c21_n_x;
  real_T c21_d_A;
  real_T c21_d_B;
  real_T c21_o_x;
  real_T c21_j_y;
  real_T c21_p_x;
  real_T c21_k_y;
  real_T c21_l_y;
  real_T c21_e_B;
  real_T c21_m_y;
  real_T c21_n_y;
  real_T c21_o_y;
  real_T c21_dv1[3];
  int32_T c21_i3;
  real_T c21_b_b;
  real_T c21_p_y;
  real_T c21_c_b;
  real_T c21_q_y;
  int32_T c21_i4;
  real_T c21_q_x[9];
  int32_T c21_i5;
  real_T c21_r_x[9];
  real_T c21_r_y[9];
  int32_T c21_i6;
  real_T c21_s_x[9];
  real_T c21_n1x;
  int32_T c21_i7;
  real_T c21_s_y[9];
  real_T c21_n1xinv;
  real_T c21_b_a;
  real_T c21_d_b;
  real_T c21_t_y;
  real_T c21_rc;
  real_T c21_t_x;
  boolean_T c21_e_b;
  real_T c21_u_x;
  int32_T c21_i8;
  static char_T c21_cv0[8] = { '%', '%', '%', 'd', '.', '%', 'd', 'e' };

  char_T c21_u[8];
  const mxArray *c21_u_y = NULL;
  real_T c21_b_u;
  const mxArray *c21_v_y = NULL;
  real_T c21_c_u;
  const mxArray *c21_w_y = NULL;
  real_T c21_d_u;
  const mxArray *c21_x_y = NULL;
  char_T c21_str[14];
  int32_T c21_i9;
  char_T c21_b_str[14];
  int32_T c21_i10;
  real_T c21_f_b[3];
  int32_T c21_i11;
  int32_T c21_i12;
  int32_T c21_i13;
  real_T c21_C[3];
  int32_T c21_i14;
  int32_T c21_i15;
  int32_T c21_i16;
  int32_T c21_i17;
  int32_T c21_i18;
  int32_T c21_i19;
  int32_T c21_i20;
  real_T (*c21_b_tau)[3];
  real_T *c21_b_psi_dot_ref;
  real_T *c21_b_speed_ref;
  real_T *c21_b_psi_dot;
  real_T *c21_b_beta;
  real_T *c21_b_speed;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  c21_b_tau = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c21_b_psi_dot_ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c21_b_speed_ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c21_b_psi_dot = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c21_b_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c21_b_speed = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 15U, chartInstance->c21_sfEvent);
  c21_hoistedGlobal = *c21_b_speed;
  c21_b_hoistedGlobal = *c21_b_beta;
  c21_c_hoistedGlobal = *c21_b_psi_dot;
  c21_d_hoistedGlobal = *c21_b_speed_ref;
  c21_e_hoistedGlobal = *c21_b_psi_dot_ref;
  c21_f_hoistedGlobal = chartInstance->c21_m_car;
  c21_g_hoistedGlobal = chartInstance->c21_I_z;
  c21_speed = c21_hoistedGlobal;
  c21_beta = c21_b_hoistedGlobal;
  c21_psi_dot = c21_c_hoistedGlobal;
  c21_speed_ref = c21_d_hoistedGlobal;
  c21_psi_dot_ref = c21_e_hoistedGlobal;
  c21_b_m_car = c21_f_hoistedGlobal;
  c21_b_I_z = c21_g_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 17U, 17U, c21_debug_family_names,
    c21_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c21_m, 0U, c21_b_sf_marshallOut,
    c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_mv, 1U, c21_b_sf_marshallOut,
    c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_g, 2U, c21_c_sf_marshallOut,
    c21_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_f, 3U, c21_sf_marshallOut,
    c21_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c21_kp_v, 4U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c21_kp_b, 5U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c21_v, 6U, c21_sf_marshallOut,
    c21_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_nargin, 7U, c21_b_sf_marshallOut,
    c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_nargout, 8U,
    c21_b_sf_marshallOut, c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c21_speed, 9U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c21_beta, 10U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c21_psi_dot, 11U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c21_speed_ref, 12U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c21_psi_dot_ref, 13U, c21_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c21_b_m_car, 14U,
    c21_b_sf_marshallOut, c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c21_b_I_z, 15U, c21_b_sf_marshallOut,
    c21_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c21_tau, 16U, c21_sf_marshallOut,
    c21_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 3);
  c21_m = c21_b_m_car;
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 4);
  c21_a = c21_b_m_car;
  c21_b = c21_speed;
  c21_mv = c21_a * c21_b;
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 7);
  c21_x = c21_beta;
  c21_b_x = c21_x;
  c21_b_x = muDoubleScalarCos(c21_b_x);
  c21_A = c21_b_x;
  c21_B = c21_m;
  c21_c_x = c21_A;
  c21_y = c21_B;
  c21_d_x = c21_c_x;
  c21_b_y = c21_y;
  c21_c_y = c21_d_x / c21_b_y;
  c21_e_x = c21_beta;
  c21_f_x = c21_e_x;
  c21_f_x = muDoubleScalarSin(c21_f_x);
  c21_b_A = c21_f_x;
  c21_b_B = c21_m;
  c21_g_x = c21_b_A;
  c21_d_y = c21_b_B;
  c21_h_x = c21_g_x;
  c21_e_y = c21_d_y;
  c21_f_y = c21_h_x / c21_e_y;
  c21_i_x = c21_beta;
  c21_j_x = c21_i_x;
  c21_j_x = muDoubleScalarSin(c21_j_x);
  c21_c_A = -c21_j_x;
  c21_c_B = c21_mv;
  c21_k_x = c21_c_A;
  c21_g_y = c21_c_B;
  c21_l_x = c21_k_x;
  c21_h_y = c21_g_y;
  c21_i_y = c21_l_x / c21_h_y;
  c21_m_x = c21_beta;
  c21_n_x = c21_m_x;
  c21_n_x = muDoubleScalarCos(c21_n_x);
  c21_d_A = c21_n_x;
  c21_d_B = c21_mv;
  c21_o_x = c21_d_A;
  c21_j_y = c21_d_B;
  c21_p_x = c21_o_x;
  c21_k_y = c21_j_y;
  c21_l_y = c21_p_x / c21_k_y;
  c21_e_B = c21_b_I_z;
  c21_m_y = c21_e_B;
  c21_n_y = c21_m_y;
  c21_o_y = 1.0 / c21_n_y;
  c21_g[0] = c21_c_y;
  c21_g[3] = c21_f_y;
  c21_g[6] = 0.0;
  c21_g[1] = c21_i_y;
  c21_g[4] = c21_l_y;
  c21_g[7] = 0.0;
  c21_g[2] = 0.0;
  c21_g[5] = 0.0;
  c21_g[8] = c21_o_y;
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 10);
  c21_dv1[0] = 0.0;
  c21_dv1[1] = -c21_psi_dot;
  c21_dv1[2] = 0.0;
  for (c21_i3 = 0; c21_i3 < 3; c21_i3++) {
    c21_f[c21_i3] = c21_dv1[c21_i3];
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 13);
  c21_kp_v = 4.0;
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 14);
  c21_kp_b = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 16);
  c21_b_b = c21_speed - c21_speed_ref;
  c21_p_y = -4.0 * c21_b_b;
  c21_c_b = c21_psi_dot - c21_psi_dot_ref;
  c21_q_y = -100.0 * c21_c_b;
  c21_v[0] = c21_p_y;
  c21_v[1] = c21_q_y;
  c21_v[2] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, 20);
  for (c21_i4 = 0; c21_i4 < 9; c21_i4++) {
    c21_q_x[c21_i4] = c21_g[c21_i4];
  }

  for (c21_i5 = 0; c21_i5 < 9; c21_i5++) {
    c21_r_x[c21_i5] = c21_q_x[c21_i5];
  }

  c21_inv3x3(chartInstance, c21_r_x, c21_r_y);
  for (c21_i6 = 0; c21_i6 < 9; c21_i6++) {
    c21_s_x[c21_i6] = c21_q_x[c21_i6];
  }

  c21_n1x = c21_norm(chartInstance, c21_s_x);
  for (c21_i7 = 0; c21_i7 < 9; c21_i7++) {
    c21_s_y[c21_i7] = c21_r_y[c21_i7];
  }

  c21_n1xinv = c21_norm(chartInstance, c21_s_y);
  c21_b_a = c21_n1x;
  c21_d_b = c21_n1xinv;
  c21_t_y = c21_b_a * c21_d_b;
  c21_rc = 1.0 / c21_t_y;
  guard1 = FALSE;
  guard2 = FALSE;
  if (c21_n1x == 0.0) {
    guard2 = TRUE;
  } else if (c21_n1xinv == 0.0) {
    guard2 = TRUE;
  } else if (c21_rc == 0.0) {
    guard1 = TRUE;
  } else {
    c21_t_x = c21_rc;
    c21_e_b = muDoubleScalarIsNaN(c21_t_x);
    guard3 = FALSE;
    if (c21_e_b) {
      guard3 = TRUE;
    } else {
      if (c21_rc < 2.2204460492503131E-16) {
        guard3 = TRUE;
      }
    }

    if (guard3 == TRUE) {
      c21_u_x = c21_rc;
      for (c21_i8 = 0; c21_i8 < 8; c21_i8++) {
        c21_u[c21_i8] = c21_cv0[c21_i8];
      }

      c21_u_y = NULL;
      sf_mex_assign(&c21_u_y, sf_mex_create("y", c21_u, 10, 0U, 1U, 0U, 2, 1, 8),
                    FALSE);
      c21_b_u = 14.0;
      c21_v_y = NULL;
      sf_mex_assign(&c21_v_y, sf_mex_create("y", &c21_b_u, 0, 0U, 0U, 0U, 0),
                    FALSE);
      c21_c_u = 6.0;
      c21_w_y = NULL;
      sf_mex_assign(&c21_w_y, sf_mex_create("y", &c21_c_u, 0, 0U, 0U, 0U, 0),
                    FALSE);
      c21_d_u = c21_u_x;
      c21_x_y = NULL;
      sf_mex_assign(&c21_x_y, sf_mex_create("y", &c21_d_u, 0, 0U, 0U, 0U, 0),
                    FALSE);
      c21_e_emlrt_marshallIn(chartInstance, sf_mex_call_debug("sprintf", 1U, 2U,
        14, sf_mex_call_debug("sprintf", 1U, 3U, 14, c21_u_y, 14, c21_v_y, 14,
        c21_w_y), 14, c21_x_y), "sprintf", c21_str);
      for (c21_i9 = 0; c21_i9 < 14; c21_i9++) {
        c21_b_str[c21_i9] = c21_str[c21_i9];
      }

      c21_b_eml_warning(chartInstance, c21_b_str);
    }
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    c21_eml_warning(chartInstance);
  }

  for (c21_i10 = 0; c21_i10 < 3; c21_i10++) {
    c21_f_b[c21_i10] = -c21_f[c21_i10] + c21_v[c21_i10];
  }

  c21_eml_scalar_eg(chartInstance);
  c21_eml_scalar_eg(chartInstance);
  for (c21_i11 = 0; c21_i11 < 3; c21_i11++) {
    c21_tau[c21_i11] = 0.0;
  }

  for (c21_i12 = 0; c21_i12 < 3; c21_i12++) {
    c21_tau[c21_i12] = 0.0;
  }

  for (c21_i13 = 0; c21_i13 < 3; c21_i13++) {
    c21_C[c21_i13] = c21_tau[c21_i13];
  }

  for (c21_i14 = 0; c21_i14 < 3; c21_i14++) {
    c21_tau[c21_i14] = c21_C[c21_i14];
  }

  for (c21_i15 = 0; c21_i15 < 3; c21_i15++) {
    c21_C[c21_i15] = c21_tau[c21_i15];
  }

  for (c21_i16 = 0; c21_i16 < 3; c21_i16++) {
    c21_tau[c21_i16] = c21_C[c21_i16];
  }

  for (c21_i17 = 0; c21_i17 < 3; c21_i17++) {
    c21_tau[c21_i17] = 0.0;
    c21_i18 = 0;
    for (c21_i19 = 0; c21_i19 < 3; c21_i19++) {
      c21_tau[c21_i17] += c21_r_y[c21_i18 + c21_i17] * c21_f_b[c21_i19];
      c21_i18 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c21_sfEvent, -20);
  sf_debug_symbol_scope_pop();
  for (c21_i20 = 0; c21_i20 < 3; c21_i20++) {
    (*c21_b_tau)[c21_i20] = c21_tau[c21_i20];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 15U, chartInstance->c21_sfEvent);
}

static void initSimStructsc21_ref_gen(SFc21_ref_genInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c21_machineNumber, uint32_T
  c21_chartNumber)
{
}

static const mxArray *c21_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i21;
  real_T c21_b_inData[3];
  int32_T c21_i22;
  real_T c21_u[3];
  const mxArray *c21_y = NULL;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  for (c21_i21 = 0; c21_i21 < 3; c21_i21++) {
    c21_b_inData[c21_i21] = (*(real_T (*)[3])c21_inData)[c21_i21];
  }

  for (c21_i22 = 0; c21_i22 < 3; c21_i22++) {
    c21_u[c21_i22] = c21_b_inData[c21_i22];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_tau, const char_T *c21_identifier, real_T c21_y[3])
{
  emlrtMsgIdentifier c21_thisId;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_tau), &c21_thisId, c21_y);
  sf_mex_destroy(&c21_tau);
}

static void c21_b_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[3])
{
  real_T c21_dv2[3];
  int32_T c21_i23;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv2, 1, 0, 0U, 1, 0U, 1, 3);
  for (c21_i23 = 0; c21_i23 < 3; c21_i23++) {
    c21_y[c21_i23] = c21_dv2[c21_i23];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_tau;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[3];
  int32_T c21_i24;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_tau = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_tau), &c21_thisId, c21_y);
  sf_mex_destroy(&c21_tau);
  for (c21_i24 = 0; c21_i24 < 3; c21_i24++) {
    (*(real_T (*)[3])c21_outData)[c21_i24] = c21_y[c21_i24];
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_b_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  real_T c21_u;
  const mxArray *c21_y = NULL;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_u = *(real_T *)c21_inData;
  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", &c21_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static real_T c21_c_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId)
{
  real_T c21_y;
  real_T c21_d2;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), &c21_d2, 1, 0, 0U, 0, 0U, 0);
  c21_y = c21_d2;
  sf_mex_destroy(&c21_u);
  return c21_y;
}

static void c21_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_b_I_z;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_b_I_z = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_y = c21_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_b_I_z),
    &c21_thisId);
  sf_mex_destroy(&c21_b_I_z);
  *(real_T *)c21_outData = c21_y;
  sf_mex_destroy(&c21_mxArrayInData);
}

static const mxArray *c21_c_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_i25;
  int32_T c21_i26;
  int32_T c21_i27;
  real_T c21_b_inData[9];
  int32_T c21_i28;
  int32_T c21_i29;
  int32_T c21_i30;
  real_T c21_u[9];
  const mxArray *c21_y = NULL;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_i25 = 0;
  for (c21_i26 = 0; c21_i26 < 3; c21_i26++) {
    for (c21_i27 = 0; c21_i27 < 3; c21_i27++) {
      c21_b_inData[c21_i27 + c21_i25] = (*(real_T (*)[9])c21_inData)[c21_i27 +
        c21_i25];
    }

    c21_i25 += 3;
  }

  c21_i28 = 0;
  for (c21_i29 = 0; c21_i29 < 3; c21_i29++) {
    for (c21_i30 = 0; c21_i30 < 3; c21_i30++) {
      c21_u[c21_i30 + c21_i28] = c21_b_inData[c21_i30 + c21_i28];
    }

    c21_i28 += 3;
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static void c21_d_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, real_T c21_y[9])
{
  real_T c21_dv3[9];
  int32_T c21_i31;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_dv3, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c21_i31 = 0; c21_i31 < 9; c21_i31++) {
    c21_y[c21_i31] = c21_dv3[c21_i31];
  }

  sf_mex_destroy(&c21_u);
}

static void c21_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_g;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  real_T c21_y[9];
  int32_T c21_i32;
  int32_T c21_i33;
  int32_T c21_i34;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_g = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_g), &c21_thisId, c21_y);
  sf_mex_destroy(&c21_g);
  c21_i32 = 0;
  for (c21_i33 = 0; c21_i33 < 3; c21_i33++) {
    for (c21_i34 = 0; c21_i34 < 3; c21_i34++) {
      (*(real_T (*)[9])c21_outData)[c21_i34 + c21_i32] = c21_y[c21_i34 + c21_i32];
    }

    c21_i32 += 3;
  }

  sf_mex_destroy(&c21_mxArrayInData);
}

const mxArray *sf_c21_ref_gen_get_eml_resolved_functions_info(void)
{
  const mxArray *c21_nameCaptureInfo;
  c21_ResolvedFunctionInfo c21_info[24];
  const mxArray *c21_m0 = NULL;
  int32_T c21_i35;
  c21_ResolvedFunctionInfo *c21_r0;
  c21_nameCaptureInfo = NULL;
  c21_nameCaptureInfo = NULL;
  c21_info_helper(c21_info);
  sf_mex_assign(&c21_m0, sf_mex_createstruct("nameCaptureInfo", 1, 24), FALSE);
  for (c21_i35 = 0; c21_i35 < 24; c21_i35++) {
    c21_r0 = &c21_info[c21_i35];
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", c21_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c21_r0->context)), "context", "nameCaptureInfo",
                    c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", c21_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c21_r0->name)), "name", "nameCaptureInfo",
                    c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo",
      c21_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c21_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", c21_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c21_r0->resolved)), "resolved",
                    "nameCaptureInfo", c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", &c21_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo", &c21_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo",
      &c21_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c21_i35);
    sf_mex_addfield(c21_m0, sf_mex_create("nameCaptureInfo",
      &c21_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c21_i35);
  }

  sf_mex_assign(&c21_nameCaptureInfo, c21_m0, FALSE);
  return c21_nameCaptureInfo;
}

static void c21_info_helper(c21_ResolvedFunctionInfo c21_info[24])
{
  c21_info[0].context = "";
  c21_info[0].name = "mtimes";
  c21_info[0].dominantType = "double";
  c21_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c21_info[0].fileTimeLo = 1289519692U;
  c21_info[0].fileTimeHi = 0U;
  c21_info[0].mFileTimeLo = 0U;
  c21_info[0].mFileTimeHi = 0U;
  c21_info[1].context = "";
  c21_info[1].name = "cos";
  c21_info[1].dominantType = "double";
  c21_info[1].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c21_info[1].fileTimeLo = 1286818706U;
  c21_info[1].fileTimeHi = 0U;
  c21_info[1].mFileTimeLo = 0U;
  c21_info[1].mFileTimeHi = 0U;
  c21_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c21_info[2].name = "eml_scalar_cos";
  c21_info[2].dominantType = "double";
  c21_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c21_info[2].fileTimeLo = 1286818722U;
  c21_info[2].fileTimeHi = 0U;
  c21_info[2].mFileTimeLo = 0U;
  c21_info[2].mFileTimeHi = 0U;
  c21_info[3].context = "";
  c21_info[3].name = "mrdivide";
  c21_info[3].dominantType = "double";
  c21_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c21_info[3].fileTimeLo = 1310137456U;
  c21_info[3].fileTimeHi = 0U;
  c21_info[3].mFileTimeLo = 1289519692U;
  c21_info[3].mFileTimeHi = 0U;
  c21_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c21_info[4].name = "rdivide";
  c21_info[4].dominantType = "double";
  c21_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c21_info[4].fileTimeLo = 1286818844U;
  c21_info[4].fileTimeHi = 0U;
  c21_info[4].mFileTimeLo = 0U;
  c21_info[4].mFileTimeHi = 0U;
  c21_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c21_info[5].name = "eml_div";
  c21_info[5].dominantType = "double";
  c21_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c21_info[5].fileTimeLo = 1305318000U;
  c21_info[5].fileTimeHi = 0U;
  c21_info[5].mFileTimeLo = 0U;
  c21_info[5].mFileTimeHi = 0U;
  c21_info[6].context = "";
  c21_info[6].name = "sin";
  c21_info[6].dominantType = "double";
  c21_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c21_info[6].fileTimeLo = 1286818750U;
  c21_info[6].fileTimeHi = 0U;
  c21_info[6].mFileTimeLo = 0U;
  c21_info[6].mFileTimeHi = 0U;
  c21_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c21_info[7].name = "eml_scalar_sin";
  c21_info[7].dominantType = "double";
  c21_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c21_info[7].fileTimeLo = 1286818736U;
  c21_info[7].fileTimeHi = 0U;
  c21_info[7].mFileTimeLo = 0U;
  c21_info[7].mFileTimeHi = 0U;
  c21_info[8].context = "";
  c21_info[8].name = "inv";
  c21_info[8].dominantType = "double";
  c21_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m";
  c21_info[8].fileTimeLo = 1305318000U;
  c21_info[8].fileTimeHi = 0U;
  c21_info[8].mFileTimeLo = 0U;
  c21_info[8].mFileTimeHi = 0U;
  c21_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!inv3x3";
  c21_info[9].name = "eml_index_class";
  c21_info[9].dominantType = "";
  c21_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c21_info[9].fileTimeLo = 1286818778U;
  c21_info[9].fileTimeHi = 0U;
  c21_info[9].mFileTimeLo = 0U;
  c21_info[9].mFileTimeHi = 0U;
  c21_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!inv3x3";
  c21_info[10].name = "abs";
  c21_info[10].dominantType = "double";
  c21_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c21_info[10].fileTimeLo = 1286818694U;
  c21_info[10].fileTimeHi = 0U;
  c21_info[10].mFileTimeLo = 0U;
  c21_info[10].mFileTimeHi = 0U;
  c21_info[11].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c21_info[11].name = "eml_scalar_abs";
  c21_info[11].dominantType = "double";
  c21_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c21_info[11].fileTimeLo = 1286818712U;
  c21_info[11].fileTimeHi = 0U;
  c21_info[11].mFileTimeLo = 0U;
  c21_info[11].mFileTimeHi = 0U;
  c21_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!inv3x3";
  c21_info[12].name = "eml_index_plus";
  c21_info[12].dominantType = "int32";
  c21_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c21_info[12].fileTimeLo = 1286818778U;
  c21_info[12].fileTimeHi = 0U;
  c21_info[12].mFileTimeLo = 0U;
  c21_info[12].mFileTimeHi = 0U;
  c21_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c21_info[13].name = "norm";
  c21_info[13].dominantType = "double";
  c21_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m";
  c21_info[13].fileTimeLo = 1286818826U;
  c21_info[13].fileTimeHi = 0U;
  c21_info[13].mFileTimeLo = 0U;
  c21_info[13].mFileTimeHi = 0U;
  c21_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!mat1norm";
  c21_info[14].name = "isnan";
  c21_info[14].dominantType = "double";
  c21_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c21_info[14].fileTimeLo = 1286818760U;
  c21_info[14].fileTimeHi = 0U;
  c21_info[14].mFileTimeLo = 0U;
  c21_info[14].mFileTimeHi = 0U;
  c21_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/norm.m!mat1norm";
  c21_info[15].name = "eml_guarded_nan";
  c21_info[15].dominantType = "char";
  c21_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c21_info[15].fileTimeLo = 1286818776U;
  c21_info[15].fileTimeHi = 0U;
  c21_info[15].mFileTimeLo = 0U;
  c21_info[15].mFileTimeHi = 0U;
  c21_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c21_info[16].name = "eml_is_float_class";
  c21_info[16].dominantType = "char";
  c21_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c21_info[16].fileTimeLo = 1286818782U;
  c21_info[16].fileTimeHi = 0U;
  c21_info[16].mFileTimeLo = 0U;
  c21_info[16].mFileTimeHi = 0U;
  c21_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c21_info[17].name = "eml_warning";
  c21_info[17].dominantType = "char";
  c21_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c21_info[17].fileTimeLo = 1286818802U;
  c21_info[17].fileTimeHi = 0U;
  c21_info[17].mFileTimeLo = 0U;
  c21_info[17].mFileTimeHi = 0U;
  c21_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c21_info[18].name = "eps";
  c21_info[18].dominantType = "char";
  c21_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c21_info[18].fileTimeLo = 1286818686U;
  c21_info[18].fileTimeHi = 0U;
  c21_info[18].mFileTimeLo = 0U;
  c21_info[18].mFileTimeHi = 0U;
  c21_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/matfun/inv.m!checkcond";
  c21_info[19].name = "eml_flt2str";
  c21_info[19].dominantType = "double";
  c21_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_flt2str.m";
  c21_info[19].fileTimeLo = 1286818776U;
  c21_info[19].fileTimeHi = 0U;
  c21_info[19].mFileTimeLo = 0U;
  c21_info[19].mFileTimeHi = 0U;
  c21_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c21_info[20].name = "eml_scalar_eg";
  c21_info[20].dominantType = "double";
  c21_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c21_info[20].fileTimeLo = 1286818796U;
  c21_info[20].fileTimeHi = 0U;
  c21_info[20].mFileTimeLo = 0U;
  c21_info[20].mFileTimeHi = 0U;
  c21_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c21_info[21].name = "eml_xgemm";
  c21_info[21].dominantType = "int32";
  c21_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c21_info[21].fileTimeLo = 1299076772U;
  c21_info[21].fileTimeHi = 0U;
  c21_info[21].mFileTimeLo = 0U;
  c21_info[21].mFileTimeHi = 0U;
  c21_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c21_info[22].name = "eml_blas_inline";
  c21_info[22].dominantType = "";
  c21_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c21_info[22].fileTimeLo = 1299076768U;
  c21_info[22].fileTimeHi = 0U;
  c21_info[22].mFileTimeLo = 0U;
  c21_info[22].mFileTimeHi = 0U;
  c21_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c21_info[23].name = "eml_refblas_xgemm";
  c21_info[23].dominantType = "int32";
  c21_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c21_info[23].fileTimeLo = 1299076774U;
  c21_info[23].fileTimeHi = 0U;
  c21_info[23].mFileTimeLo = 0U;
  c21_info[23].mFileTimeHi = 0U;
}

static void c21_inv3x3(SFc21_ref_genInstanceStruct *chartInstance, real_T c21_x
  [9], real_T c21_y[9])
{
  int32_T c21_p1;
  int32_T c21_p2;
  int32_T c21_p3;
  real_T c21_b_x;
  real_T c21_c_x;
  real_T c21_absx11;
  real_T c21_d_x;
  real_T c21_e_x;
  real_T c21_absx21;
  real_T c21_f_x;
  real_T c21_g_x;
  real_T c21_absx31;
  real_T c21_t1;
  real_T c21_h_x;
  real_T c21_b_y;
  real_T c21_z;
  real_T c21_i_x;
  real_T c21_c_y;
  real_T c21_b_z;
  real_T c21_a;
  real_T c21_b;
  real_T c21_d_y;
  real_T c21_b_a;
  real_T c21_b_b;
  real_T c21_e_y;
  real_T c21_c_a;
  real_T c21_c_b;
  real_T c21_f_y;
  real_T c21_d_a;
  real_T c21_d_b;
  real_T c21_g_y;
  real_T c21_j_x;
  real_T c21_k_x;
  real_T c21_h_y;
  real_T c21_l_x;
  real_T c21_m_x;
  real_T c21_i_y;
  int32_T c21_itmp;
  real_T c21_n_x;
  real_T c21_j_y;
  real_T c21_c_z;
  real_T c21_e_a;
  real_T c21_e_b;
  real_T c21_k_y;
  real_T c21_f_a;
  real_T c21_f_b;
  real_T c21_l_y;
  real_T c21_o_x;
  real_T c21_m_y;
  real_T c21_t3;
  real_T c21_g_a;
  real_T c21_g_b;
  real_T c21_n_y;
  real_T c21_p_x;
  real_T c21_o_y;
  real_T c21_t2;
  int32_T c21_h_a;
  int32_T c21_c;
  real_T c21_i_a;
  real_T c21_h_b;
  real_T c21_p_y;
  real_T c21_j_a;
  real_T c21_i_b;
  real_T c21_q_y;
  real_T c21_q_x;
  real_T c21_r_y;
  real_T c21_d_z;
  int32_T c21_k_a;
  int32_T c21_b_c;
  int32_T c21_l_a;
  int32_T c21_c_c;
  real_T c21_r_x;
  real_T c21_s_y;
  real_T c21_m_a;
  real_T c21_j_b;
  real_T c21_t_y;
  real_T c21_s_x;
  real_T c21_u_y;
  int32_T c21_n_a;
  int32_T c21_d_c;
  real_T c21_o_a;
  real_T c21_k_b;
  real_T c21_v_y;
  real_T c21_p_a;
  real_T c21_l_b;
  real_T c21_w_y;
  real_T c21_t_x;
  real_T c21_x_y;
  real_T c21_e_z;
  int32_T c21_q_a;
  int32_T c21_e_c;
  int32_T c21_r_a;
  int32_T c21_f_c;
  real_T c21_y_y;
  real_T c21_s_a;
  real_T c21_m_b;
  real_T c21_ab_y;
  real_T c21_u_x;
  real_T c21_bb_y;
  int32_T c21_t_a;
  int32_T c21_g_c;
  real_T c21_u_a;
  real_T c21_n_b;
  real_T c21_cb_y;
  real_T c21_v_a;
  real_T c21_o_b;
  real_T c21_db_y;
  real_T c21_v_x;
  real_T c21_eb_y;
  real_T c21_f_z;
  int32_T c21_w_a;
  int32_T c21_h_c;
  int32_T c21_x_a;
  int32_T c21_i_c;
  boolean_T guard1 = FALSE;
  c21_p1 = 0;
  c21_p2 = 3;
  c21_p3 = 6;
  c21_b_x = c21_x[0];
  c21_c_x = c21_b_x;
  c21_absx11 = muDoubleScalarAbs(c21_c_x);
  c21_d_x = c21_x[1];
  c21_e_x = c21_d_x;
  c21_absx21 = muDoubleScalarAbs(c21_e_x);
  c21_f_x = c21_x[2];
  c21_g_x = c21_f_x;
  c21_absx31 = muDoubleScalarAbs(c21_g_x);
  guard1 = FALSE;
  if (c21_absx21 > c21_absx11) {
    if (c21_absx21 > c21_absx31) {
      c21_p1 = 3;
      c21_p2 = 0;
      c21_t1 = c21_x[0];
      c21_x[0] = c21_x[1];
      c21_x[1] = c21_t1;
      c21_t1 = c21_x[3];
      c21_x[3] = c21_x[4];
      c21_x[4] = c21_t1;
      c21_t1 = c21_x[6];
      c21_x[6] = c21_x[7];
      c21_x[7] = c21_t1;
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    if (c21_absx31 > c21_absx11) {
      c21_p1 = 6;
      c21_p3 = 0;
      c21_t1 = c21_x[0];
      c21_x[0] = c21_x[2];
      c21_x[2] = c21_t1;
      c21_t1 = c21_x[3];
      c21_x[3] = c21_x[5];
      c21_x[5] = c21_t1;
      c21_t1 = c21_x[6];
      c21_x[6] = c21_x[8];
      c21_x[8] = c21_t1;
    }
  }

  c21_h_x = c21_x[1];
  c21_b_y = c21_x[0];
  c21_z = c21_h_x / c21_b_y;
  c21_x[1] = c21_z;
  c21_i_x = c21_x[2];
  c21_c_y = c21_x[0];
  c21_b_z = c21_i_x / c21_c_y;
  c21_x[2] = c21_b_z;
  c21_a = c21_x[1];
  c21_b = c21_x[3];
  c21_d_y = c21_a * c21_b;
  c21_x[4] -= c21_d_y;
  c21_b_a = c21_x[2];
  c21_b_b = c21_x[3];
  c21_e_y = c21_b_a * c21_b_b;
  c21_x[5] -= c21_e_y;
  c21_c_a = c21_x[1];
  c21_c_b = c21_x[6];
  c21_f_y = c21_c_a * c21_c_b;
  c21_x[7] -= c21_f_y;
  c21_d_a = c21_x[2];
  c21_d_b = c21_x[6];
  c21_g_y = c21_d_a * c21_d_b;
  c21_x[8] -= c21_g_y;
  c21_j_x = c21_x[5];
  c21_k_x = c21_j_x;
  c21_h_y = muDoubleScalarAbs(c21_k_x);
  c21_l_x = c21_x[4];
  c21_m_x = c21_l_x;
  c21_i_y = muDoubleScalarAbs(c21_m_x);
  if (c21_h_y > c21_i_y) {
    c21_itmp = c21_p2;
    c21_p2 = c21_p3;
    c21_p3 = c21_itmp;
    c21_t1 = c21_x[1];
    c21_x[1] = c21_x[2];
    c21_x[2] = c21_t1;
    c21_t1 = c21_x[4];
    c21_x[4] = c21_x[5];
    c21_x[5] = c21_t1;
    c21_t1 = c21_x[7];
    c21_x[7] = c21_x[8];
    c21_x[8] = c21_t1;
  }

  c21_n_x = c21_x[5];
  c21_j_y = c21_x[4];
  c21_c_z = c21_n_x / c21_j_y;
  c21_x[5] = c21_c_z;
  c21_e_a = c21_x[5];
  c21_e_b = c21_x[7];
  c21_k_y = c21_e_a * c21_e_b;
  c21_x[8] -= c21_k_y;
  c21_f_a = c21_x[5];
  c21_f_b = c21_x[1];
  c21_l_y = c21_f_a * c21_f_b;
  c21_o_x = c21_l_y - c21_x[2];
  c21_m_y = c21_x[8];
  c21_t3 = c21_o_x / c21_m_y;
  c21_g_a = c21_x[7];
  c21_g_b = c21_t3;
  c21_n_y = c21_g_a * c21_g_b;
  c21_p_x = -(c21_x[1] + c21_n_y);
  c21_o_y = c21_x[4];
  c21_t2 = c21_p_x / c21_o_y;
  c21_h_a = c21_p1 + 1;
  c21_c = c21_h_a;
  c21_i_a = c21_x[3];
  c21_h_b = c21_t2;
  c21_p_y = c21_i_a * c21_h_b;
  c21_j_a = c21_x[6];
  c21_i_b = c21_t3;
  c21_q_y = c21_j_a * c21_i_b;
  c21_q_x = (1.0 - c21_p_y) - c21_q_y;
  c21_r_y = c21_x[0];
  c21_d_z = c21_q_x / c21_r_y;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_c), 1, 9, 1, 0) - 1] = c21_d_z;
  c21_k_a = c21_p1 + 2;
  c21_b_c = c21_k_a;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_b_c), 1, 9, 1, 0) - 1] = c21_t2;
  c21_l_a = c21_p1 + 3;
  c21_c_c = c21_l_a;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_c_c), 1, 9, 1, 0) - 1] = c21_t3;
  c21_r_x = -c21_x[5];
  c21_s_y = c21_x[8];
  c21_t3 = c21_r_x / c21_s_y;
  c21_m_a = c21_x[7];
  c21_j_b = c21_t3;
  c21_t_y = c21_m_a * c21_j_b;
  c21_s_x = 1.0 - c21_t_y;
  c21_u_y = c21_x[4];
  c21_t2 = c21_s_x / c21_u_y;
  c21_n_a = c21_p2 + 1;
  c21_d_c = c21_n_a;
  c21_o_a = c21_x[3];
  c21_k_b = c21_t2;
  c21_v_y = c21_o_a * c21_k_b;
  c21_p_a = c21_x[6];
  c21_l_b = c21_t3;
  c21_w_y = c21_p_a * c21_l_b;
  c21_t_x = -(c21_v_y + c21_w_y);
  c21_x_y = c21_x[0];
  c21_e_z = c21_t_x / c21_x_y;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_d_c), 1, 9, 1, 0) - 1] = c21_e_z;
  c21_q_a = c21_p2 + 2;
  c21_e_c = c21_q_a;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_e_c), 1, 9, 1, 0) - 1] = c21_t2;
  c21_r_a = c21_p2 + 3;
  c21_f_c = c21_r_a;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_f_c), 1, 9, 1, 0) - 1] = c21_t3;
  c21_y_y = c21_x[8];
  c21_t3 = 1.0 / c21_y_y;
  c21_s_a = -c21_x[7];
  c21_m_b = c21_t3;
  c21_ab_y = c21_s_a * c21_m_b;
  c21_u_x = c21_ab_y;
  c21_bb_y = c21_x[4];
  c21_t2 = c21_u_x / c21_bb_y;
  c21_t_a = c21_p3 + 1;
  c21_g_c = c21_t_a;
  c21_u_a = c21_x[3];
  c21_n_b = c21_t2;
  c21_cb_y = c21_u_a * c21_n_b;
  c21_v_a = c21_x[6];
  c21_o_b = c21_t3;
  c21_db_y = c21_v_a * c21_o_b;
  c21_v_x = -(c21_cb_y + c21_db_y);
  c21_eb_y = c21_x[0];
  c21_f_z = c21_v_x / c21_eb_y;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_g_c), 1, 9, 1, 0) - 1] = c21_f_z;
  c21_w_a = c21_p3 + 2;
  c21_h_c = c21_w_a;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_h_c), 1, 9, 1, 0) - 1] = c21_t2;
  c21_x_a = c21_p3 + 3;
  c21_i_c = c21_x_a;
  c21_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c21_i_c), 1, 9, 1, 0) - 1] = c21_t3;
}

static real_T c21_norm(SFc21_ref_genInstanceStruct *chartInstance, real_T c21_x
  [9])
{
  real_T c21_y;
  int32_T c21_j;
  real_T c21_b_j;
  real_T c21_s;
  int32_T c21_i;
  real_T c21_b_i;
  real_T c21_b_x;
  real_T c21_c_x;
  real_T c21_b_y;
  real_T c21_d_x;
  boolean_T c21_b;
  boolean_T exitg1;
  c21_y = 0.0;
  c21_j = 0;
  exitg1 = 0U;
  while ((exitg1 == 0U) && (c21_j < 3)) {
    c21_b_j = 1.0 + (real_T)c21_j;
    c21_s = 0.0;
    for (c21_i = 0; c21_i < 3; c21_i++) {
      c21_b_i = 1.0 + (real_T)c21_i;
      c21_b_x = c21_x[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", c21_b_i), 1, 3, 1, 0) + 3 *
                       (_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", c21_b_j), 1, 3, 2, 0) - 1)) - 1];
      c21_c_x = c21_b_x;
      c21_b_y = muDoubleScalarAbs(c21_c_x);
      c21_s += c21_b_y;
    }

    c21_d_x = c21_s;
    c21_b = muDoubleScalarIsNaN(c21_d_x);
    if (c21_b) {
      c21_y = rtNaN;
      exitg1 = 1U;
    } else {
      if (c21_s > c21_y) {
        c21_y = c21_s;
      }

      c21_j++;
    }
  }

  return c21_y;
}

static void c21_eml_warning(SFc21_ref_genInstanceStruct *chartInstance)
{
  int32_T c21_i36;
  static char_T c21_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c21_u[27];
  const mxArray *c21_y = NULL;
  for (c21_i36 = 0; c21_i36 < 27; c21_i36++) {
    c21_u[c21_i36] = c21_varargin_1[c21_i36];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 10, 0U, 1U, 0U, 2, 1, 27),
                FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c21_y));
}

static void c21_b_eml_warning(SFc21_ref_genInstanceStruct *chartInstance, char_T
  c21_varargin_2[14])
{
  int32_T c21_i37;
  static char_T c21_varargin_1[33] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 'i', 'l', 'l', 'C', 'o', 'n', 'd', 'i', 't', 'i',
    'o', 'n', 'e', 'd', 'M', 'a', 't', 'r', 'i', 'x' };

  char_T c21_u[33];
  const mxArray *c21_y = NULL;
  int32_T c21_i38;
  char_T c21_b_u[14];
  const mxArray *c21_b_y = NULL;
  for (c21_i37 = 0; c21_i37 < 33; c21_i37++) {
    c21_u[c21_i37] = c21_varargin_1[c21_i37];
  }

  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", c21_u, 10, 0U, 1U, 0U, 2, 1, 33),
                FALSE);
  for (c21_i38 = 0; c21_i38 < 14; c21_i38++) {
    c21_b_u[c21_i38] = c21_varargin_2[c21_i38];
  }

  c21_b_y = NULL;
  sf_mex_assign(&c21_b_y, sf_mex_create("y", c21_b_u, 10, 0U, 1U, 0U, 2, 1, 14),
                FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 2U,
    14, c21_y, 14, c21_b_y));
}

static void c21_eml_scalar_eg(SFc21_ref_genInstanceStruct *chartInstance)
{
}

static void c21_e_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_sprintf, const char_T *c21_identifier, char_T c21_y[14])
{
  emlrtMsgIdentifier c21_thisId;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_sprintf), &c21_thisId,
    c21_y);
  sf_mex_destroy(&c21_sprintf);
}

static void c21_f_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId, char_T c21_y[14])
{
  char_T c21_cv1[14];
  int32_T c21_i39;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), c21_cv1, 1, 10, 0U, 1, 0U, 2, 1,
                14);
  for (c21_i39 = 0; c21_i39 < 14; c21_i39++) {
    c21_y[c21_i39] = c21_cv1[c21_i39];
  }

  sf_mex_destroy(&c21_u);
}

static const mxArray *c21_d_sf_marshallOut(void *chartInstanceVoid, void
  *c21_inData)
{
  const mxArray *c21_mxArrayOutData = NULL;
  int32_T c21_u;
  const mxArray *c21_y = NULL;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_mxArrayOutData = NULL;
  c21_u = *(int32_T *)c21_inData;
  c21_y = NULL;
  sf_mex_assign(&c21_y, sf_mex_create("y", &c21_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c21_mxArrayOutData, c21_y, FALSE);
  return c21_mxArrayOutData;
}

static int32_T c21_g_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId)
{
  int32_T c21_y;
  int32_T c21_i40;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), &c21_i40, 1, 6, 0U, 0, 0U, 0);
  c21_y = c21_i40;
  sf_mex_destroy(&c21_u);
  return c21_y;
}

static void c21_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c21_mxArrayInData, const char_T *c21_varName, void *c21_outData)
{
  const mxArray *c21_b_sfEvent;
  const char_T *c21_identifier;
  emlrtMsgIdentifier c21_thisId;
  int32_T c21_y;
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)chartInstanceVoid;
  c21_b_sfEvent = sf_mex_dup(c21_mxArrayInData);
  c21_identifier = c21_varName;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_y = c21_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c21_b_sfEvent),
    &c21_thisId);
  sf_mex_destroy(&c21_b_sfEvent);
  *(int32_T *)c21_outData = c21_y;
  sf_mex_destroy(&c21_mxArrayInData);
}

static uint8_T c21_h_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_b_is_active_c21_ref_gen, const char_T *c21_identifier)
{
  uint8_T c21_y;
  emlrtMsgIdentifier c21_thisId;
  c21_thisId.fIdentifier = c21_identifier;
  c21_thisId.fParent = NULL;
  c21_y = c21_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c21_b_is_active_c21_ref_gen), &c21_thisId);
  sf_mex_destroy(&c21_b_is_active_c21_ref_gen);
  return c21_y;
}

static uint8_T c21_i_emlrt_marshallIn(SFc21_ref_genInstanceStruct *chartInstance,
  const mxArray *c21_u, const emlrtMsgIdentifier *c21_parentId)
{
  uint8_T c21_y;
  uint8_T c21_u0;
  sf_mex_import(c21_parentId, sf_mex_dup(c21_u), &c21_u0, 1, 3, 0U, 0, 0U, 0);
  c21_y = c21_u0;
  sf_mex_destroy(&c21_u);
  return c21_y;
}

static void init_dsm_address_info(SFc21_ref_genInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c21_ref_gen_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2318119133U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(728012199U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3869769807U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2874808918U);
}

mxArray *sf_c21_ref_gen_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("ThggUF7hNyEjIaSUGKDFOC");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c21_ref_gen(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"tau\",},{M[8],M[0],T\"is_active_c21_ref_gen\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c21_ref_gen_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc21_ref_genInstanceStruct *chartInstance;
    chartInstance = (SFc21_ref_genInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_ref_genMachineNumber_,
          21,
          1,
          1,
          8,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ref_genMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ref_genMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ref_genMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"speed");
          _SFD_SET_DATA_PROPS(1,1,1,0,"beta");
          _SFD_SET_DATA_PROPS(2,1,1,0,"psi_dot");
          _SFD_SET_DATA_PROPS(3,1,1,0,"speed_ref");
          _SFD_SET_DATA_PROPS(4,1,1,0,"psi_dot_ref");
          _SFD_SET_DATA_PROPS(5,2,0,1,"tau");
          _SFD_SET_DATA_PROPS(6,10,0,0,"m_car");
          _SFD_SET_DATA_PROPS(7,10,0,0,"I_z");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,418);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c21_sf_marshallOut,(MexInFcnForType)
            c21_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)
          c21_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c21_b_sf_marshallOut,(MexInFcnForType)
          c21_b_sf_marshallIn);

        {
          real_T *c21_speed;
          real_T *c21_beta;
          real_T *c21_psi_dot;
          real_T *c21_speed_ref;
          real_T *c21_psi_dot_ref;
          real_T (*c21_tau)[3];
          c21_tau = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c21_psi_dot_ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c21_speed_ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c21_psi_dot = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c21_beta = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c21_speed = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c21_speed);
          _SFD_SET_DATA_VALUE_PTR(1U, c21_beta);
          _SFD_SET_DATA_VALUE_PTR(2U, c21_psi_dot);
          _SFD_SET_DATA_VALUE_PTR(3U, c21_speed_ref);
          _SFD_SET_DATA_VALUE_PTR(4U, c21_psi_dot_ref);
          _SFD_SET_DATA_VALUE_PTR(5U, *c21_tau);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance->c21_m_car);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance->c21_I_z);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ref_genMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c21_ref_gen(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc21_ref_genInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
  initialize_c21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c21_ref_gen(void *chartInstanceVar)
{
  enable_c21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c21_ref_gen(void *chartInstanceVar)
{
  disable_c21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c21_ref_gen(void *chartInstanceVar)
{
  sf_c21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c21_ref_gen(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c21_ref_gen((SFc21_ref_genInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c21_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c21_ref_gen(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c21_ref_gen();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c21_ref_gen((SFc21_ref_genInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c21_ref_gen(SimStruct* S)
{
  return sf_internal_get_sim_state_c21_ref_gen(S);
}

static void sf_opaque_set_sim_state_c21_ref_gen(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c21_ref_gen(S, st);
}

static void sf_opaque_terminate_c21_ref_gen(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc21_ref_genInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_ref_gen_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc21_ref_gen((SFc21_ref_genInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c21_ref_gen(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c21_ref_gen((SFc21_ref_genInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c21_ref_gen(SimStruct *S)
{
  /* Actual parameters from chart:
     I_z m_car
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for I_z*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for m_car*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_ref_gen_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,infoStruct,21);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,infoStruct,21,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,infoStruct,21,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,infoStruct,21,5);
      sf_mark_chart_reusable_outputs(S,infoStruct,21,1);
    }

    sf_set_rtw_dwork_info(S,infoStruct,21);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2929703222U));
  ssSetChecksum1(S,(2623580582U));
  ssSetChecksum2(S,(2161863694U));
  ssSetChecksum3(S,(2115611577U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c21_ref_gen(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c21_ref_gen(SimStruct *S)
{
  SFc21_ref_genInstanceStruct *chartInstance;
  chartInstance = (SFc21_ref_genInstanceStruct *)malloc(sizeof
    (SFc21_ref_genInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc21_ref_genInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c21_ref_gen;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c21_ref_gen;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c21_ref_gen;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c21_ref_gen;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c21_ref_gen;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c21_ref_gen;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c21_ref_gen;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c21_ref_gen;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c21_ref_gen;
  chartInstance->chartInfo.mdlStart = mdlStart_c21_ref_gen;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c21_ref_gen;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c21_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c21_ref_gen(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c21_ref_gen(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c21_ref_gen(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c21_ref_gen_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
