#ifndef __c3_ref_gen_h__
#define __c3_ref_gen_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c3_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  real_T c3_I_motor;
  real_T c3_I_wheel;
  real_T c3_diff_lock;
  real_T c3_r_wheel;
  real_T c3_wheel_drive;
  int32_T c3_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c3_doneDoubleBufferReInit;
  boolean_T c3_isStable;
  uint8_T c3_is_active_c3_ref_gen;
  ChartInfoStruct chartInfo;
} SFc3_ref_genInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c3_ref_gen_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c3_ref_gen_get_check_sum(mxArray *plhs[]);
extern void c3_ref_gen_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
